// chrome/browser/media/feeds/media_feeds_store.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/browser/media/feeds/media_feeds_store.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/media/feeds/media_feeds_store.mojom-params-data.h"
#include "chrome/browser/media/feeds/media_feeds_store.mojom-shared-message-ids.h"

#include "chrome/browser/media/feeds/media_feeds_store.mojom-import-headers.h"


#ifndef CHROME_BROWSER_MEDIA_FEEDS_MEDIA_FEEDS_STORE_MOJOM_JUMBO_H_
#define CHROME_BROWSER_MEDIA_FEEDS_MEDIA_FEEDS_STORE_MOJOM_JUMBO_H_
#include "services/media_session/public/cpp/media_session_mojom_traits.h"
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#endif
namespace media_feeds {
namespace mojom {
MediaFeed::MediaFeed()
    : id(),
      url(),
      last_discovery_time(),
      last_fetch_time(),
      user_status(),
      last_fetch_result(),
      fetch_failed_count(),
      cache_expiry_time(),
      last_fetch_item_count(),
      last_fetch_play_next_count(),
      last_fetch_content_types(),
      logos(),
      display_name() {}

MediaFeed::MediaFeed(
    int64_t id_in,
    const ::GURL& url_in,
    ::base::Time last_discovery_time_in,
    base::Optional<::base::Time> last_fetch_time_in,
    FeedUserStatus user_status_in,
    FetchResult last_fetch_result_in,
    int64_t fetch_failed_count_in,
    base::Optional<::base::Time> cache_expiry_time_in,
    int64_t last_fetch_item_count_in,
    int64_t last_fetch_play_next_count_in,
    int64_t last_fetch_content_types_in,
    std::vector<::media_session::MediaImage> logos_in,
    const std::string& display_name_in)
    : id(std::move(id_in)),
      url(std::move(url_in)),
      last_discovery_time(std::move(last_discovery_time_in)),
      last_fetch_time(std::move(last_fetch_time_in)),
      user_status(std::move(user_status_in)),
      last_fetch_result(std::move(last_fetch_result_in)),
      fetch_failed_count(std::move(fetch_failed_count_in)),
      cache_expiry_time(std::move(cache_expiry_time_in)),
      last_fetch_item_count(std::move(last_fetch_item_count_in)),
      last_fetch_play_next_count(std::move(last_fetch_play_next_count_in)),
      last_fetch_content_types(std::move(last_fetch_content_types_in)),
      logos(std::move(logos_in)),
      display_name(std::move(display_name_in)) {}

MediaFeed::~MediaFeed() = default;

bool MediaFeed::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ContentRating::ContentRating()
    : agency(),
      value() {}

ContentRating::ContentRating(
    const std::string& agency_in,
    const std::string& value_in)
    : agency(std::move(agency_in)),
      value(std::move(value_in)) {}

ContentRating::~ContentRating() = default;
size_t ContentRating::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->agency);
  seed = mojo::internal::Hash(seed, this->value);
  return seed;
}

bool ContentRating::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Author::Author()
    : name(),
      url() {}

Author::Author(
    const std::string& name_in,
    const ::GURL& url_in)
    : name(std::move(name_in)),
      url(std::move(url_in)) {}

Author::~Author() = default;

bool Author::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Identifier::Identifier()
    : type(),
      value() {}

Identifier::Identifier(
    Identifier::Type type_in,
    const std::string& value_in)
    : type(std::move(type_in)),
      value(std::move(value_in)) {}

Identifier::~Identifier() = default;
size_t Identifier::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->type);
  seed = mojo::internal::Hash(seed, this->value);
  return seed;
}

bool Identifier::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Action::Action()
    : url(),
      start_time() {}

Action::Action(
    const ::GURL& url_in,
    base::Optional<::base::TimeDelta> start_time_in)
    : url(std::move(url_in)),
      start_time(std::move(start_time_in)) {}

Action::~Action() = default;

bool Action::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PlayNextCandidate::PlayNextCandidate()
    : name(),
      season_number(),
      episode_number(),
      action(),
      duration(),
      identifiers() {}

PlayNextCandidate::PlayNextCandidate(
    const std::string& name_in,
    int64_t season_number_in,
    int64_t episode_number_in,
    ActionPtr action_in,
    ::base::TimeDelta duration_in,
    std::vector<IdentifierPtr> identifiers_in)
    : name(std::move(name_in)),
      season_number(std::move(season_number_in)),
      episode_number(std::move(episode_number_in)),
      action(std::move(action_in)),
      duration(std::move(duration_in)),
      identifiers(std::move(identifiers_in)) {}

PlayNextCandidate::~PlayNextCandidate() = default;

bool PlayNextCandidate::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TVEpisode::TVEpisode()
    : name(),
      episode_number(),
      season_number(),
      identifiers() {}

TVEpisode::TVEpisode(
    const std::string& name_in,
    int64_t episode_number_in,
    int64_t season_number_in,
    std::vector<IdentifierPtr> identifiers_in)
    : name(std::move(name_in)),
      episode_number(std::move(episode_number_in)),
      season_number(std::move(season_number_in)),
      identifiers(std::move(identifiers_in)) {}

TVEpisode::~TVEpisode() = default;

bool TVEpisode::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
LiveDetails::LiveDetails()
    : start_time(),
      end_time() {}

LiveDetails::LiveDetails(
    base::Optional<::base::Time> start_time_in,
    base::Optional<::base::Time> end_time_in)
    : start_time(std::move(start_time_in)),
      end_time(std::move(end_time_in)) {}

LiveDetails::~LiveDetails() = default;

bool LiveDetails::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MediaFeedItem::MediaFeedItem()
    : type(),
      name(),
      author(),
      date_published(),
      is_family_friendly(),
      action_status(),
      action(),
      interaction_counters(),
      content_ratings(),
      genre(),
      duration(),
      live(),
      tv_episode(),
      play_next_candidate(),
      identifiers(),
      shown_count(),
      clicked(),
      images(),
      safe_search_result() {}

MediaFeedItem::MediaFeedItem(
    MediaFeedItemType type_in,
    const ::base::string16& name_in,
    AuthorPtr author_in,
    ::base::Time date_published_in,
    bool is_family_friendly_in,
    MediaFeedItemActionStatus action_status_in,
    ActionPtr action_in,
    const base::flat_map<InteractionCounterType, uint64_t>& interaction_counters_in,
    std::vector<ContentRatingPtr> content_ratings_in,
    std::vector<std::string> genre_in,
    base::Optional<::base::TimeDelta> duration_in,
    LiveDetailsPtr live_in,
    TVEpisodePtr tv_episode_in,
    PlayNextCandidatePtr play_next_candidate_in,
    std::vector<IdentifierPtr> identifiers_in,
    uint64_t shown_count_in,
    bool clicked_in,
    std::vector<::media_session::MediaImage> images_in,
    SafeSearchResult safe_search_result_in)
    : type(std::move(type_in)),
      name(std::move(name_in)),
      author(std::move(author_in)),
      date_published(std::move(date_published_in)),
      is_family_friendly(std::move(is_family_friendly_in)),
      action_status(std::move(action_status_in)),
      action(std::move(action_in)),
      interaction_counters(std::move(interaction_counters_in)),
      content_ratings(std::move(content_ratings_in)),
      genre(std::move(genre_in)),
      duration(std::move(duration_in)),
      live(std::move(live_in)),
      tv_episode(std::move(tv_episode_in)),
      play_next_candidate(std::move(play_next_candidate_in)),
      identifiers(std::move(identifiers_in)),
      shown_count(std::move(shown_count_in)),
      clicked(std::move(clicked_in)),
      images(std::move(images_in)),
      safe_search_result(std::move(safe_search_result_in)) {}

MediaFeedItem::~MediaFeedItem() = default;

bool MediaFeedItem::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char MediaFeedsStore::Name_[] = "media_feeds.mojom.MediaFeedsStore";

class MediaFeedsStore_GetMediaFeeds_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaFeedsStore_GetMediaFeeds_ForwardToCallback(
      MediaFeedsStore::GetMediaFeedsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaFeedsStore::GetMediaFeedsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaFeedsStore_GetMediaFeeds_ForwardToCallback);
};

class MediaFeedsStore_GetItemsForMediaFeed_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaFeedsStore_GetItemsForMediaFeed_ForwardToCallback(
      MediaFeedsStore::GetItemsForMediaFeedCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaFeedsStore::GetItemsForMediaFeedCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaFeedsStore_GetItemsForMediaFeed_ForwardToCallback);
};

MediaFeedsStoreProxy::MediaFeedsStoreProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MediaFeedsStoreProxy::GetMediaFeeds(
    GetMediaFeedsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_feeds::mojom::MediaFeedsStore::GetMediaFeeds");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaFeedsStore_GetMediaFeeds_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_feeds::mojom::internal::MediaFeedsStore_GetMediaFeeds_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaFeedsStore::Name_);
  message.set_method_name("GetMediaFeeds");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaFeedsStore_GetMediaFeeds_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void MediaFeedsStoreProxy::GetItemsForMediaFeed(
    int64_t in_feed_id, GetItemsForMediaFeedCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_feeds::mojom::MediaFeedsStore::GetItemsForMediaFeed");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaFeedsStore_GetItemsForMediaFeed_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_feeds::mojom::internal::MediaFeedsStore_GetItemsForMediaFeed_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->feed_id = in_feed_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaFeedsStore::Name_);
  message.set_method_name("GetItemsForMediaFeed");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaFeedsStore_GetItemsForMediaFeed_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class MediaFeedsStore_GetMediaFeeds_ProxyToResponder {
 public:
  static MediaFeedsStore::GetMediaFeedsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaFeedsStore_GetMediaFeeds_ProxyToResponder> proxy(
        new MediaFeedsStore_GetMediaFeeds_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaFeedsStore_GetMediaFeeds_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaFeedsStore_GetMediaFeeds_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaFeedsStore_GetMediaFeeds_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaFeedsStore::GetMediaFeedsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<MediaFeedPtr> in_feeds);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaFeedsStore_GetMediaFeeds_ProxyToResponder);
};

bool MediaFeedsStore_GetMediaFeeds_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_feeds::mojom::MediaFeedsStore::GetMediaFeedsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaFeedsStore_GetMediaFeeds_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaFeedsStore_GetMediaFeeds_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<MediaFeedPtr> p_feeds{};
  MediaFeedsStore_GetMediaFeeds_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadFeeds(&p_feeds))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaFeedsStore::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_feeds));
  return true;
}

void MediaFeedsStore_GetMediaFeeds_ProxyToResponder::Run(
    std::vector<MediaFeedPtr> in_feeds) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaFeedsStore_GetMediaFeeds_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_feeds::mojom::internal::MediaFeedsStore_GetMediaFeeds_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->feeds)::BaseType::BufferWriter
      feeds_writer;
  const mojo::internal::ContainerValidateParams feeds_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::media_feeds::mojom::MediaFeedDataView>>(
      in_feeds, buffer, &feeds_writer, &feeds_validate_params,
      &serialization_context);
  params->feeds.Set(
      feeds_writer.is_null() ? nullptr : feeds_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->feeds.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null feeds in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_feeds::mojom::MediaFeedsStore::GetMediaFeedsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaFeedsStore::Name_);
  message.set_method_name("GetMediaFeeds");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder {
 public:
  static MediaFeedsStore::GetItemsForMediaFeedCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder> proxy(
        new MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaFeedsStore::GetItemsForMediaFeedCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<MediaFeedItemPtr> in_items);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder);
};

bool MediaFeedsStore_GetItemsForMediaFeed_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_feeds::mojom::MediaFeedsStore::GetItemsForMediaFeedCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaFeedsStore_GetItemsForMediaFeed_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaFeedsStore_GetItemsForMediaFeed_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<MediaFeedItemPtr> p_items{};
  MediaFeedsStore_GetItemsForMediaFeed_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadItems(&p_items))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaFeedsStore::Name_, 671222093, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_items));
  return true;
}

void MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder::Run(
    std::vector<MediaFeedItemPtr> in_items) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaFeedsStore_GetItemsForMediaFeed_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_feeds::mojom::internal::MediaFeedsStore_GetItemsForMediaFeed_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->items)::BaseType::BufferWriter
      items_writer;
  const mojo::internal::ContainerValidateParams items_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::media_feeds::mojom::MediaFeedItemDataView>>(
      in_items, buffer, &items_writer, &items_validate_params,
      &serialization_context);
  params->items.Set(
      items_writer.is_null() ? nullptr : items_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->items.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null items in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_feeds::mojom::MediaFeedsStore::GetItemsForMediaFeedCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaFeedsStore::Name_);
  message.set_method_name("GetItemsForMediaFeed");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool MediaFeedsStoreStubDispatch::Accept(
    MediaFeedsStore* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kMediaFeedsStore_GetMediaFeeds_Name: {
      break;
    }
    case internal::kMediaFeedsStore_GetItemsForMediaFeed_Name: {
      break;
    }
  }
  return false;
}

// static
bool MediaFeedsStoreStubDispatch::AcceptWithResponder(
    MediaFeedsStore* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kMediaFeedsStore_GetMediaFeeds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_feeds::mojom::MediaFeedsStore::GetMediaFeeds",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_feeds::mojom::MediaFeedsStore::GetMediaFeeds");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaFeedsStore_GetMediaFeeds_Params_Data* params =
          reinterpret_cast<
              internal::MediaFeedsStore_GetMediaFeeds_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      MediaFeedsStore_GetMediaFeeds_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaFeedsStore::Name_, 0, false);
        return false;
      }
      MediaFeedsStore::GetMediaFeedsCallback callback =
          MediaFeedsStore_GetMediaFeeds_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaFeeds(std::move(callback));
      return true;
    }
    case internal::kMediaFeedsStore_GetItemsForMediaFeed_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_feeds::mojom::MediaFeedsStore::GetItemsForMediaFeed",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_feeds::mojom::MediaFeedsStore::GetItemsForMediaFeed");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaFeedsStore_GetItemsForMediaFeed_Params_Data* params =
          reinterpret_cast<
              internal::MediaFeedsStore_GetItemsForMediaFeed_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      int64_t p_feed_id{};
      MediaFeedsStore_GetItemsForMediaFeed_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_feed_id = input_data_view.feed_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaFeedsStore::Name_, 671222093, false);
        return false;
      }
      MediaFeedsStore::GetItemsForMediaFeedCallback callback =
          MediaFeedsStore_GetItemsForMediaFeed_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetItemsForMediaFeed(
std::move(p_feed_id), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kMediaFeedsStoreValidationInfo[] = {
    {internal::kMediaFeedsStore_GetMediaFeeds_Name,
     {&internal::MediaFeedsStore_GetMediaFeeds_Params_Data::Validate,
      &internal::MediaFeedsStore_GetMediaFeeds_ResponseParams_Data::Validate}},
    {internal::kMediaFeedsStore_GetItemsForMediaFeed_Name,
     {&internal::MediaFeedsStore_GetItemsForMediaFeed_Params_Data::Validate,
      &internal::MediaFeedsStore_GetItemsForMediaFeed_ResponseParams_Data::Validate}},
};

bool MediaFeedsStoreRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::media_feeds::mojom::MediaFeedsStore::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kMediaFeedsStoreValidationInfo);
}

bool MediaFeedsStoreResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::media_feeds::mojom::MediaFeedsStore::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kMediaFeedsStoreValidationInfo);

}
}  // namespace mojom
}  // namespace media_feeds

namespace mojo {


// static
bool StructTraits<::media_feeds::mojom::MediaFeed::DataView, ::media_feeds::mojom::MediaFeedPtr>::Read(
    ::media_feeds::mojom::MediaFeed::DataView input,
    ::media_feeds::mojom::MediaFeedPtr* output) {
  bool success = true;
  ::media_feeds::mojom::MediaFeedPtr result(::media_feeds::mojom::MediaFeed::New());
  
      if (success)
        result->id = input.id();
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadLastDiscoveryTime(&result->last_discovery_time))
        success = false;
      if (success && !input.ReadLastFetchTime(&result->last_fetch_time))
        success = false;
      if (success && !input.ReadUserStatus(&result->user_status))
        success = false;
      if (success && !input.ReadLastFetchResult(&result->last_fetch_result))
        success = false;
      if (success)
        result->fetch_failed_count = input.fetch_failed_count();
      if (success && !input.ReadCacheExpiryTime(&result->cache_expiry_time))
        success = false;
      if (success)
        result->last_fetch_item_count = input.last_fetch_item_count();
      if (success)
        result->last_fetch_play_next_count = input.last_fetch_play_next_count();
      if (success)
        result->last_fetch_content_types = input.last_fetch_content_types();
      if (success && !input.ReadLogos(&result->logos))
        success = false;
      if (success && !input.ReadDisplayName(&result->display_name))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::ContentRating::DataView, ::media_feeds::mojom::ContentRatingPtr>::Read(
    ::media_feeds::mojom::ContentRating::DataView input,
    ::media_feeds::mojom::ContentRatingPtr* output) {
  bool success = true;
  ::media_feeds::mojom::ContentRatingPtr result(::media_feeds::mojom::ContentRating::New());
  
      if (success && !input.ReadAgency(&result->agency))
        success = false;
      if (success && !input.ReadValue(&result->value))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::Author::DataView, ::media_feeds::mojom::AuthorPtr>::Read(
    ::media_feeds::mojom::Author::DataView input,
    ::media_feeds::mojom::AuthorPtr* output) {
  bool success = true;
  ::media_feeds::mojom::AuthorPtr result(::media_feeds::mojom::Author::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadUrl(&result->url))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::Identifier::DataView, ::media_feeds::mojom::IdentifierPtr>::Read(
    ::media_feeds::mojom::Identifier::DataView input,
    ::media_feeds::mojom::IdentifierPtr* output) {
  bool success = true;
  ::media_feeds::mojom::IdentifierPtr result(::media_feeds::mojom::Identifier::New());
  
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success && !input.ReadValue(&result->value))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::Action::DataView, ::media_feeds::mojom::ActionPtr>::Read(
    ::media_feeds::mojom::Action::DataView input,
    ::media_feeds::mojom::ActionPtr* output) {
  bool success = true;
  ::media_feeds::mojom::ActionPtr result(::media_feeds::mojom::Action::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadStartTime(&result->start_time))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::PlayNextCandidate::DataView, ::media_feeds::mojom::PlayNextCandidatePtr>::Read(
    ::media_feeds::mojom::PlayNextCandidate::DataView input,
    ::media_feeds::mojom::PlayNextCandidatePtr* output) {
  bool success = true;
  ::media_feeds::mojom::PlayNextCandidatePtr result(::media_feeds::mojom::PlayNextCandidate::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success)
        result->season_number = input.season_number();
      if (success)
        result->episode_number = input.episode_number();
      if (success && !input.ReadAction(&result->action))
        success = false;
      if (success && !input.ReadDuration(&result->duration))
        success = false;
      if (success && !input.ReadIdentifiers(&result->identifiers))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::TVEpisode::DataView, ::media_feeds::mojom::TVEpisodePtr>::Read(
    ::media_feeds::mojom::TVEpisode::DataView input,
    ::media_feeds::mojom::TVEpisodePtr* output) {
  bool success = true;
  ::media_feeds::mojom::TVEpisodePtr result(::media_feeds::mojom::TVEpisode::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success)
        result->episode_number = input.episode_number();
      if (success)
        result->season_number = input.season_number();
      if (success && !input.ReadIdentifiers(&result->identifiers))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::LiveDetails::DataView, ::media_feeds::mojom::LiveDetailsPtr>::Read(
    ::media_feeds::mojom::LiveDetails::DataView input,
    ::media_feeds::mojom::LiveDetailsPtr* output) {
  bool success = true;
  ::media_feeds::mojom::LiveDetailsPtr result(::media_feeds::mojom::LiveDetails::New());
  
      if (success && !input.ReadStartTime(&result->start_time))
        success = false;
      if (success && !input.ReadEndTime(&result->end_time))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_feeds::mojom::MediaFeedItem::DataView, ::media_feeds::mojom::MediaFeedItemPtr>::Read(
    ::media_feeds::mojom::MediaFeedItem::DataView input,
    ::media_feeds::mojom::MediaFeedItemPtr* output) {
  bool success = true;
  ::media_feeds::mojom::MediaFeedItemPtr result(::media_feeds::mojom::MediaFeedItem::New());
  
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadAuthor(&result->author))
        success = false;
      if (success && !input.ReadDatePublished(&result->date_published))
        success = false;
      if (success)
        result->is_family_friendly = input.is_family_friendly();
      if (success && !input.ReadActionStatus(&result->action_status))
        success = false;
      if (success && !input.ReadAction(&result->action))
        success = false;
      if (success && !input.ReadInteractionCounters(&result->interaction_counters))
        success = false;
      if (success && !input.ReadContentRatings(&result->content_ratings))
        success = false;
      if (success && !input.ReadGenre(&result->genre))
        success = false;
      if (success && !input.ReadDuration(&result->duration))
        success = false;
      if (success && !input.ReadLive(&result->live))
        success = false;
      if (success && !input.ReadTvEpisode(&result->tv_episode))
        success = false;
      if (success && !input.ReadPlayNextCandidate(&result->play_next_candidate))
        success = false;
      if (success && !input.ReadIdentifiers(&result->identifiers))
        success = false;
      if (success)
        result->shown_count = input.shown_count();
      if (success)
        result->clicked = input.clicked();
      if (success && !input.ReadImages(&result->images))
        success = false;
      if (success && !input.ReadSafeSearchResult(&result->safe_search_result))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif