// chrome/browser/media/feeds/media_feeds_store.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_MEDIA_FEEDS_MEDIA_FEEDS_STORE_MOJOM_H_
#define CHROME_BROWSER_MEDIA_FEEDS_MEDIA_FEEDS_STORE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/media/feeds/media_feeds_store.mojom-shared.h"
#include "chrome/browser/media/feeds/media_feeds_store.mojom-forward.h"
#include "services/media_session/public/mojom/media_session.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace media_feeds {
namespace mojom {

class MediaFeedsStoreProxy;

template <typename ImplRefTraits>
class MediaFeedsStoreStub;

class MediaFeedsStoreRequestValidator;
class MediaFeedsStoreResponseValidator;


class  MediaFeedsStore
    : public MediaFeedsStoreInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = MediaFeedsStoreInterfaceBase;
  using Proxy_ = MediaFeedsStoreProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaFeedsStoreStub<ImplRefTraits>;

  using RequestValidator_ = MediaFeedsStoreRequestValidator;
  using ResponseValidator_ = MediaFeedsStoreResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetMediaFeedsMinVersion = 0,
    kGetItemsForMediaFeedMinVersion = 0,
  };
  virtual ~MediaFeedsStore() {}


  using GetMediaFeedsCallback = base::OnceCallback<void(std::vector<MediaFeedPtr>)>;
  
  virtual void GetMediaFeeds(GetMediaFeedsCallback callback) = 0;


  using GetItemsForMediaFeedCallback = base::OnceCallback<void(std::vector<MediaFeedItemPtr>)>;
  
  virtual void GetItemsForMediaFeed(int64_t feed_id, GetItemsForMediaFeedCallback callback) = 0;
};



class  MediaFeedsStoreProxy
    : public MediaFeedsStore {
 public:
  using InterfaceType = MediaFeedsStore;

  explicit MediaFeedsStoreProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetMediaFeeds(GetMediaFeedsCallback callback) final;
  
  void GetItemsForMediaFeed(int64_t feed_id, GetItemsForMediaFeedCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MediaFeedsStoreStubDispatch {
 public:
  static bool Accept(MediaFeedsStore* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaFeedsStore* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaFeedsStore>>
class MediaFeedsStoreStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaFeedsStoreStub() {}
  ~MediaFeedsStoreStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaFeedsStoreStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaFeedsStoreStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MediaFeedsStoreRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MediaFeedsStoreResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class  ContentRating {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ContentRating, T>::value>;
  using DataView = ContentRatingDataView;
  using Data_ = internal::ContentRating_Data;

  template <typename... Args>
  static ContentRatingPtr New(Args&&... args) {
    return ContentRatingPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ContentRatingPtr From(const U& u) {
    return mojo::TypeConverter<ContentRatingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ContentRating>::Convert(*this);
  }


  ContentRating();

  ContentRating(
      const std::string& agency,
      const std::string& value);

  ~ContentRating();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ContentRatingPtr>
  ContentRatingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ContentRating::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ContentRating::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ContentRating::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ContentRating_UnserializedMessageContext<
            UserType, ContentRating::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ContentRating::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ContentRating::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ContentRating_UnserializedMessageContext<
            UserType, ContentRating::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ContentRating::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string agency;
  
  std::string value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ContentRating::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ContentRating::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ContentRating::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ContentRating::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Identifier {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Identifier, T>::value>;
  using DataView = IdentifierDataView;
  using Data_ = internal::Identifier_Data;
  using Type = Identifier_Type;

  template <typename... Args>
  static IdentifierPtr New(Args&&... args) {
    return IdentifierPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentifierPtr From(const U& u) {
    return mojo::TypeConverter<IdentifierPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Identifier>::Convert(*this);
  }


  Identifier();

  Identifier(
      Identifier::Type type,
      const std::string& value);

  ~Identifier();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentifierPtr>
  IdentifierPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Identifier::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Identifier::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Identifier::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Identifier_UnserializedMessageContext<
            UserType, Identifier::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Identifier::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Identifier::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Identifier_UnserializedMessageContext<
            UserType, Identifier::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Identifier::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  Identifier::Type type;
  
  std::string value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Identifier::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Identifier::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Identifier::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Identifier::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}












class  MediaFeed {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MediaFeed, T>::value>;
  using DataView = MediaFeedDataView;
  using Data_ = internal::MediaFeed_Data;

  template <typename... Args>
  static MediaFeedPtr New(Args&&... args) {
    return MediaFeedPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MediaFeedPtr From(const U& u) {
    return mojo::TypeConverter<MediaFeedPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MediaFeed>::Convert(*this);
  }


  MediaFeed();

  MediaFeed(
      int64_t id,
      const ::GURL& url,
      ::base::Time last_discovery_time,
      base::Optional<::base::Time> last_fetch_time,
      FeedUserStatus user_status,
      FetchResult last_fetch_result,
      int64_t fetch_failed_count,
      base::Optional<::base::Time> cache_expiry_time,
      int64_t last_fetch_item_count,
      int64_t last_fetch_play_next_count,
      int64_t last_fetch_content_types,
      std::vector<::media_session::MediaImage> logos,
      const std::string& display_name);

  ~MediaFeed();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MediaFeedPtr>
  MediaFeedPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MediaFeed::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MediaFeed::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MediaFeed::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MediaFeed_UnserializedMessageContext<
            UserType, MediaFeed::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MediaFeed::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MediaFeed::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MediaFeed_UnserializedMessageContext<
            UserType, MediaFeed::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MediaFeed::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int64_t id;
  
  ::GURL url;
  
  ::base::Time last_discovery_time;
  
  base::Optional<::base::Time> last_fetch_time;
  
  FeedUserStatus user_status;
  
  FetchResult last_fetch_result;
  
  int64_t fetch_failed_count;
  
  base::Optional<::base::Time> cache_expiry_time;
  
  int64_t last_fetch_item_count;
  
  int64_t last_fetch_play_next_count;
  
  int64_t last_fetch_content_types;
  
  std::vector<::media_session::MediaImage> logos;
  
  std::string display_name;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MediaFeed::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MediaFeed::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MediaFeed::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MediaFeed::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Author {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Author, T>::value>;
  using DataView = AuthorDataView;
  using Data_ = internal::Author_Data;

  template <typename... Args>
  static AuthorPtr New(Args&&... args) {
    return AuthorPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AuthorPtr From(const U& u) {
    return mojo::TypeConverter<AuthorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Author>::Convert(*this);
  }


  Author();

  Author(
      const std::string& name,
      const ::GURL& url);

  ~Author();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AuthorPtr>
  AuthorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Author::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Author::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Author::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Author_UnserializedMessageContext<
            UserType, Author::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Author::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Author::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Author_UnserializedMessageContext<
            UserType, Author::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Author::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  ::GURL url;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Author::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Author::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Author::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Author::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Action {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Action, T>::value>;
  using DataView = ActionDataView;
  using Data_ = internal::Action_Data;

  template <typename... Args>
  static ActionPtr New(Args&&... args) {
    return ActionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ActionPtr From(const U& u) {
    return mojo::TypeConverter<ActionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Action>::Convert(*this);
  }


  Action();

  Action(
      const ::GURL& url,
      base::Optional<::base::TimeDelta> start_time);

  ~Action();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ActionPtr>
  ActionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Action::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Action::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Action::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Action_UnserializedMessageContext<
            UserType, Action::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Action::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Action::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Action_UnserializedMessageContext<
            UserType, Action::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Action::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::GURL url;
  
  base::Optional<::base::TimeDelta> start_time;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Action::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Action::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Action::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Action::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  PlayNextCandidate {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PlayNextCandidate, T>::value>;
  using DataView = PlayNextCandidateDataView;
  using Data_ = internal::PlayNextCandidate_Data;

  template <typename... Args>
  static PlayNextCandidatePtr New(Args&&... args) {
    return PlayNextCandidatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PlayNextCandidatePtr From(const U& u) {
    return mojo::TypeConverter<PlayNextCandidatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PlayNextCandidate>::Convert(*this);
  }


  PlayNextCandidate();

  PlayNextCandidate(
      const std::string& name,
      int64_t season_number,
      int64_t episode_number,
      ActionPtr action,
      ::base::TimeDelta duration,
      std::vector<IdentifierPtr> identifiers);

  ~PlayNextCandidate();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PlayNextCandidatePtr>
  PlayNextCandidatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PlayNextCandidate::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PlayNextCandidate::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PlayNextCandidate::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PlayNextCandidate_UnserializedMessageContext<
            UserType, PlayNextCandidate::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PlayNextCandidate::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PlayNextCandidate::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PlayNextCandidate_UnserializedMessageContext<
            UserType, PlayNextCandidate::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PlayNextCandidate::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  int64_t season_number;
  
  int64_t episode_number;
  
  ActionPtr action;
  
  ::base::TimeDelta duration;
  
  std::vector<IdentifierPtr> identifiers;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PlayNextCandidate);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PlayNextCandidate::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PlayNextCandidate::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PlayNextCandidate::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PlayNextCandidate::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  TVEpisode {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TVEpisode, T>::value>;
  using DataView = TVEpisodeDataView;
  using Data_ = internal::TVEpisode_Data;

  template <typename... Args>
  static TVEpisodePtr New(Args&&... args) {
    return TVEpisodePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TVEpisodePtr From(const U& u) {
    return mojo::TypeConverter<TVEpisodePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TVEpisode>::Convert(*this);
  }


  TVEpisode();

  TVEpisode(
      const std::string& name,
      int64_t episode_number,
      int64_t season_number,
      std::vector<IdentifierPtr> identifiers);

  ~TVEpisode();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TVEpisodePtr>
  TVEpisodePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TVEpisode::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TVEpisode::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TVEpisode::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TVEpisode_UnserializedMessageContext<
            UserType, TVEpisode::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TVEpisode::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TVEpisode::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TVEpisode_UnserializedMessageContext<
            UserType, TVEpisode::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TVEpisode::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  int64_t episode_number;
  
  int64_t season_number;
  
  std::vector<IdentifierPtr> identifiers;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(TVEpisode);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TVEpisode::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TVEpisode::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TVEpisode::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TVEpisode::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  LiveDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LiveDetails, T>::value>;
  using DataView = LiveDetailsDataView;
  using Data_ = internal::LiveDetails_Data;

  template <typename... Args>
  static LiveDetailsPtr New(Args&&... args) {
    return LiveDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LiveDetailsPtr From(const U& u) {
    return mojo::TypeConverter<LiveDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LiveDetails>::Convert(*this);
  }


  LiveDetails();

  LiveDetails(
      base::Optional<::base::Time> start_time,
      base::Optional<::base::Time> end_time);

  ~LiveDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LiveDetailsPtr>
  LiveDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LiveDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LiveDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LiveDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LiveDetails_UnserializedMessageContext<
            UserType, LiveDetails::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<LiveDetails::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return LiveDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LiveDetails_UnserializedMessageContext<
            UserType, LiveDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LiveDetails::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  base::Optional<::base::Time> start_time;
  
  base::Optional<::base::Time> end_time;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LiveDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LiveDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LiveDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LiveDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  MediaFeedItem {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MediaFeedItem, T>::value>;
  using DataView = MediaFeedItemDataView;
  using Data_ = internal::MediaFeedItem_Data;

  template <typename... Args>
  static MediaFeedItemPtr New(Args&&... args) {
    return MediaFeedItemPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MediaFeedItemPtr From(const U& u) {
    return mojo::TypeConverter<MediaFeedItemPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MediaFeedItem>::Convert(*this);
  }


  MediaFeedItem();

  MediaFeedItem(
      MediaFeedItemType type,
      const ::base::string16& name,
      AuthorPtr author,
      ::base::Time date_published,
      bool is_family_friendly,
      MediaFeedItemActionStatus action_status,
      ActionPtr action,
      const base::flat_map<InteractionCounterType, uint64_t>& interaction_counters,
      std::vector<ContentRatingPtr> content_ratings,
      std::vector<std::string> genre,
      base::Optional<::base::TimeDelta> duration,
      LiveDetailsPtr live,
      TVEpisodePtr tv_episode,
      PlayNextCandidatePtr play_next_candidate,
      std::vector<IdentifierPtr> identifiers,
      uint64_t shown_count,
      bool clicked,
      std::vector<::media_session::MediaImage> images,
      SafeSearchResult safe_search_result);

  ~MediaFeedItem();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MediaFeedItemPtr>
  MediaFeedItemPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MediaFeedItem::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MediaFeedItem::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MediaFeedItem::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MediaFeedItem_UnserializedMessageContext<
            UserType, MediaFeedItem::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MediaFeedItem::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MediaFeedItem::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MediaFeedItem_UnserializedMessageContext<
            UserType, MediaFeedItem::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MediaFeedItem::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  MediaFeedItemType type;
  
  ::base::string16 name;
  
  AuthorPtr author;
  
  ::base::Time date_published;
  
  bool is_family_friendly;
  
  MediaFeedItemActionStatus action_status;
  
  ActionPtr action;
  
  base::flat_map<InteractionCounterType, uint64_t> interaction_counters;
  
  std::vector<ContentRatingPtr> content_ratings;
  
  std::vector<std::string> genre;
  
  base::Optional<::base::TimeDelta> duration;
  
  LiveDetailsPtr live;
  
  TVEpisodePtr tv_episode;
  
  PlayNextCandidatePtr play_next_candidate;
  
  std::vector<IdentifierPtr> identifiers;
  
  uint64_t shown_count;
  
  bool clicked;
  
  std::vector<::media_session::MediaImage> images;
  
  SafeSearchResult safe_search_result;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(MediaFeedItem);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MediaFeedItem::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MediaFeedItem::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MediaFeedItem::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MediaFeedItem::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
MediaFeedPtr MediaFeed::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(url),
      mojo::Clone(last_discovery_time),
      mojo::Clone(last_fetch_time),
      mojo::Clone(user_status),
      mojo::Clone(last_fetch_result),
      mojo::Clone(fetch_failed_count),
      mojo::Clone(cache_expiry_time),
      mojo::Clone(last_fetch_item_count),
      mojo::Clone(last_fetch_play_next_count),
      mojo::Clone(last_fetch_content_types),
      mojo::Clone(logos),
      mojo::Clone(display_name)
  );
}

template <typename T, MediaFeed::EnableIfSame<T>*>
bool MediaFeed::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->last_discovery_time, other_struct.last_discovery_time))
    return false;
  if (!mojo::Equals(this->last_fetch_time, other_struct.last_fetch_time))
    return false;
  if (!mojo::Equals(this->user_status, other_struct.user_status))
    return false;
  if (!mojo::Equals(this->last_fetch_result, other_struct.last_fetch_result))
    return false;
  if (!mojo::Equals(this->fetch_failed_count, other_struct.fetch_failed_count))
    return false;
  if (!mojo::Equals(this->cache_expiry_time, other_struct.cache_expiry_time))
    return false;
  if (!mojo::Equals(this->last_fetch_item_count, other_struct.last_fetch_item_count))
    return false;
  if (!mojo::Equals(this->last_fetch_play_next_count, other_struct.last_fetch_play_next_count))
    return false;
  if (!mojo::Equals(this->last_fetch_content_types, other_struct.last_fetch_content_types))
    return false;
  if (!mojo::Equals(this->logos, other_struct.logos))
    return false;
  if (!mojo::Equals(this->display_name, other_struct.display_name))
    return false;
  return true;
}

template <typename T, MediaFeed::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.last_discovery_time < rhs.last_discovery_time)
    return true;
  if (rhs.last_discovery_time < lhs.last_discovery_time)
    return false;
  if (lhs.last_fetch_time < rhs.last_fetch_time)
    return true;
  if (rhs.last_fetch_time < lhs.last_fetch_time)
    return false;
  if (lhs.user_status < rhs.user_status)
    return true;
  if (rhs.user_status < lhs.user_status)
    return false;
  if (lhs.last_fetch_result < rhs.last_fetch_result)
    return true;
  if (rhs.last_fetch_result < lhs.last_fetch_result)
    return false;
  if (lhs.fetch_failed_count < rhs.fetch_failed_count)
    return true;
  if (rhs.fetch_failed_count < lhs.fetch_failed_count)
    return false;
  if (lhs.cache_expiry_time < rhs.cache_expiry_time)
    return true;
  if (rhs.cache_expiry_time < lhs.cache_expiry_time)
    return false;
  if (lhs.last_fetch_item_count < rhs.last_fetch_item_count)
    return true;
  if (rhs.last_fetch_item_count < lhs.last_fetch_item_count)
    return false;
  if (lhs.last_fetch_play_next_count < rhs.last_fetch_play_next_count)
    return true;
  if (rhs.last_fetch_play_next_count < lhs.last_fetch_play_next_count)
    return false;
  if (lhs.last_fetch_content_types < rhs.last_fetch_content_types)
    return true;
  if (rhs.last_fetch_content_types < lhs.last_fetch_content_types)
    return false;
  if (lhs.logos < rhs.logos)
    return true;
  if (rhs.logos < lhs.logos)
    return false;
  if (lhs.display_name < rhs.display_name)
    return true;
  if (rhs.display_name < lhs.display_name)
    return false;
  return false;
}
template <typename StructPtrType>
ContentRatingPtr ContentRating::Clone() const {
  return New(
      mojo::Clone(agency),
      mojo::Clone(value)
  );
}

template <typename T, ContentRating::EnableIfSame<T>*>
bool ContentRating::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->agency, other_struct.agency))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, ContentRating::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.agency < rhs.agency)
    return true;
  if (rhs.agency < lhs.agency)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
AuthorPtr Author::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(url)
  );
}

template <typename T, Author::EnableIfSame<T>*>
bool Author::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  return true;
}

template <typename T, Author::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  return false;
}
template <typename StructPtrType>
IdentifierPtr Identifier::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(value)
  );
}

template <typename T, Identifier::EnableIfSame<T>*>
bool Identifier::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, Identifier::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
ActionPtr Action::Clone() const {
  return New(
      mojo::Clone(url),
      mojo::Clone(start_time)
  );
}

template <typename T, Action::EnableIfSame<T>*>
bool Action::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->start_time, other_struct.start_time))
    return false;
  return true;
}

template <typename T, Action::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.start_time < rhs.start_time)
    return true;
  if (rhs.start_time < lhs.start_time)
    return false;
  return false;
}
template <typename StructPtrType>
PlayNextCandidatePtr PlayNextCandidate::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(season_number),
      mojo::Clone(episode_number),
      mojo::Clone(action),
      mojo::Clone(duration),
      mojo::Clone(identifiers)
  );
}

template <typename T, PlayNextCandidate::EnableIfSame<T>*>
bool PlayNextCandidate::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->season_number, other_struct.season_number))
    return false;
  if (!mojo::Equals(this->episode_number, other_struct.episode_number))
    return false;
  if (!mojo::Equals(this->action, other_struct.action))
    return false;
  if (!mojo::Equals(this->duration, other_struct.duration))
    return false;
  if (!mojo::Equals(this->identifiers, other_struct.identifiers))
    return false;
  return true;
}

template <typename T, PlayNextCandidate::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.season_number < rhs.season_number)
    return true;
  if (rhs.season_number < lhs.season_number)
    return false;
  if (lhs.episode_number < rhs.episode_number)
    return true;
  if (rhs.episode_number < lhs.episode_number)
    return false;
  if (lhs.action < rhs.action)
    return true;
  if (rhs.action < lhs.action)
    return false;
  if (lhs.duration < rhs.duration)
    return true;
  if (rhs.duration < lhs.duration)
    return false;
  if (lhs.identifiers < rhs.identifiers)
    return true;
  if (rhs.identifiers < lhs.identifiers)
    return false;
  return false;
}
template <typename StructPtrType>
TVEpisodePtr TVEpisode::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(episode_number),
      mojo::Clone(season_number),
      mojo::Clone(identifiers)
  );
}

template <typename T, TVEpisode::EnableIfSame<T>*>
bool TVEpisode::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->episode_number, other_struct.episode_number))
    return false;
  if (!mojo::Equals(this->season_number, other_struct.season_number))
    return false;
  if (!mojo::Equals(this->identifiers, other_struct.identifiers))
    return false;
  return true;
}

template <typename T, TVEpisode::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.episode_number < rhs.episode_number)
    return true;
  if (rhs.episode_number < lhs.episode_number)
    return false;
  if (lhs.season_number < rhs.season_number)
    return true;
  if (rhs.season_number < lhs.season_number)
    return false;
  if (lhs.identifiers < rhs.identifiers)
    return true;
  if (rhs.identifiers < lhs.identifiers)
    return false;
  return false;
}
template <typename StructPtrType>
LiveDetailsPtr LiveDetails::Clone() const {
  return New(
      mojo::Clone(start_time),
      mojo::Clone(end_time)
  );
}

template <typename T, LiveDetails::EnableIfSame<T>*>
bool LiveDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->start_time, other_struct.start_time))
    return false;
  if (!mojo::Equals(this->end_time, other_struct.end_time))
    return false;
  return true;
}

template <typename T, LiveDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.start_time < rhs.start_time)
    return true;
  if (rhs.start_time < lhs.start_time)
    return false;
  if (lhs.end_time < rhs.end_time)
    return true;
  if (rhs.end_time < lhs.end_time)
    return false;
  return false;
}
template <typename StructPtrType>
MediaFeedItemPtr MediaFeedItem::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(name),
      mojo::Clone(author),
      mojo::Clone(date_published),
      mojo::Clone(is_family_friendly),
      mojo::Clone(action_status),
      mojo::Clone(action),
      mojo::Clone(interaction_counters),
      mojo::Clone(content_ratings),
      mojo::Clone(genre),
      mojo::Clone(duration),
      mojo::Clone(live),
      mojo::Clone(tv_episode),
      mojo::Clone(play_next_candidate),
      mojo::Clone(identifiers),
      mojo::Clone(shown_count),
      mojo::Clone(clicked),
      mojo::Clone(images),
      mojo::Clone(safe_search_result)
  );
}

template <typename T, MediaFeedItem::EnableIfSame<T>*>
bool MediaFeedItem::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->author, other_struct.author))
    return false;
  if (!mojo::Equals(this->date_published, other_struct.date_published))
    return false;
  if (!mojo::Equals(this->is_family_friendly, other_struct.is_family_friendly))
    return false;
  if (!mojo::Equals(this->action_status, other_struct.action_status))
    return false;
  if (!mojo::Equals(this->action, other_struct.action))
    return false;
  if (!mojo::Equals(this->interaction_counters, other_struct.interaction_counters))
    return false;
  if (!mojo::Equals(this->content_ratings, other_struct.content_ratings))
    return false;
  if (!mojo::Equals(this->genre, other_struct.genre))
    return false;
  if (!mojo::Equals(this->duration, other_struct.duration))
    return false;
  if (!mojo::Equals(this->live, other_struct.live))
    return false;
  if (!mojo::Equals(this->tv_episode, other_struct.tv_episode))
    return false;
  if (!mojo::Equals(this->play_next_candidate, other_struct.play_next_candidate))
    return false;
  if (!mojo::Equals(this->identifiers, other_struct.identifiers))
    return false;
  if (!mojo::Equals(this->shown_count, other_struct.shown_count))
    return false;
  if (!mojo::Equals(this->clicked, other_struct.clicked))
    return false;
  if (!mojo::Equals(this->images, other_struct.images))
    return false;
  if (!mojo::Equals(this->safe_search_result, other_struct.safe_search_result))
    return false;
  return true;
}

template <typename T, MediaFeedItem::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.author < rhs.author)
    return true;
  if (rhs.author < lhs.author)
    return false;
  if (lhs.date_published < rhs.date_published)
    return true;
  if (rhs.date_published < lhs.date_published)
    return false;
  if (lhs.is_family_friendly < rhs.is_family_friendly)
    return true;
  if (rhs.is_family_friendly < lhs.is_family_friendly)
    return false;
  if (lhs.action_status < rhs.action_status)
    return true;
  if (rhs.action_status < lhs.action_status)
    return false;
  if (lhs.action < rhs.action)
    return true;
  if (rhs.action < lhs.action)
    return false;
  if (lhs.interaction_counters < rhs.interaction_counters)
    return true;
  if (rhs.interaction_counters < lhs.interaction_counters)
    return false;
  if (lhs.content_ratings < rhs.content_ratings)
    return true;
  if (rhs.content_ratings < lhs.content_ratings)
    return false;
  if (lhs.genre < rhs.genre)
    return true;
  if (rhs.genre < lhs.genre)
    return false;
  if (lhs.duration < rhs.duration)
    return true;
  if (rhs.duration < lhs.duration)
    return false;
  if (lhs.live < rhs.live)
    return true;
  if (rhs.live < lhs.live)
    return false;
  if (lhs.tv_episode < rhs.tv_episode)
    return true;
  if (rhs.tv_episode < lhs.tv_episode)
    return false;
  if (lhs.play_next_candidate < rhs.play_next_candidate)
    return true;
  if (rhs.play_next_candidate < lhs.play_next_candidate)
    return false;
  if (lhs.identifiers < rhs.identifiers)
    return true;
  if (rhs.identifiers < lhs.identifiers)
    return false;
  if (lhs.shown_count < rhs.shown_count)
    return true;
  if (rhs.shown_count < lhs.shown_count)
    return false;
  if (lhs.clicked < rhs.clicked)
    return true;
  if (rhs.clicked < lhs.clicked)
    return false;
  if (lhs.images < rhs.images)
    return true;
  if (rhs.images < lhs.images)
    return false;
  if (lhs.safe_search_result < rhs.safe_search_result)
    return true;
  if (rhs.safe_search_result < lhs.safe_search_result)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace media_feeds

namespace mojo {


template <>
struct  StructTraits<::media_feeds::mojom::MediaFeed::DataView,
                                         ::media_feeds::mojom::MediaFeedPtr> {
  static bool IsNull(const ::media_feeds::mojom::MediaFeedPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::MediaFeedPtr* output) { output->reset(); }

  static decltype(::media_feeds::mojom::MediaFeed::id) id(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->id;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::url)& url(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->url;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::last_discovery_time)& last_discovery_time(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_discovery_time;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::last_fetch_time)& last_fetch_time(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_fetch_time;
  }

  static decltype(::media_feeds::mojom::MediaFeed::user_status) user_status(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->user_status;
  }

  static decltype(::media_feeds::mojom::MediaFeed::last_fetch_result) last_fetch_result(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_fetch_result;
  }

  static decltype(::media_feeds::mojom::MediaFeed::fetch_failed_count) fetch_failed_count(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->fetch_failed_count;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::cache_expiry_time)& cache_expiry_time(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->cache_expiry_time;
  }

  static decltype(::media_feeds::mojom::MediaFeed::last_fetch_item_count) last_fetch_item_count(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_fetch_item_count;
  }

  static decltype(::media_feeds::mojom::MediaFeed::last_fetch_play_next_count) last_fetch_play_next_count(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_fetch_play_next_count;
  }

  static decltype(::media_feeds::mojom::MediaFeed::last_fetch_content_types) last_fetch_content_types(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->last_fetch_content_types;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::logos)& logos(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->logos;
  }

  static const decltype(::media_feeds::mojom::MediaFeed::display_name)& display_name(
      const ::media_feeds::mojom::MediaFeedPtr& input) {
    return input->display_name;
  }

  static bool Read(::media_feeds::mojom::MediaFeed::DataView input, ::media_feeds::mojom::MediaFeedPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::ContentRating::DataView,
                                         ::media_feeds::mojom::ContentRatingPtr> {
  static bool IsNull(const ::media_feeds::mojom::ContentRatingPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::ContentRatingPtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::ContentRating::agency)& agency(
      const ::media_feeds::mojom::ContentRatingPtr& input) {
    return input->agency;
  }

  static const decltype(::media_feeds::mojom::ContentRating::value)& value(
      const ::media_feeds::mojom::ContentRatingPtr& input) {
    return input->value;
  }

  static bool Read(::media_feeds::mojom::ContentRating::DataView input, ::media_feeds::mojom::ContentRatingPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::Author::DataView,
                                         ::media_feeds::mojom::AuthorPtr> {
  static bool IsNull(const ::media_feeds::mojom::AuthorPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::AuthorPtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::Author::name)& name(
      const ::media_feeds::mojom::AuthorPtr& input) {
    return input->name;
  }

  static const decltype(::media_feeds::mojom::Author::url)& url(
      const ::media_feeds::mojom::AuthorPtr& input) {
    return input->url;
  }

  static bool Read(::media_feeds::mojom::Author::DataView input, ::media_feeds::mojom::AuthorPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::Identifier::DataView,
                                         ::media_feeds::mojom::IdentifierPtr> {
  static bool IsNull(const ::media_feeds::mojom::IdentifierPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::IdentifierPtr* output) { output->reset(); }

  static decltype(::media_feeds::mojom::Identifier::type) type(
      const ::media_feeds::mojom::IdentifierPtr& input) {
    return input->type;
  }

  static const decltype(::media_feeds::mojom::Identifier::value)& value(
      const ::media_feeds::mojom::IdentifierPtr& input) {
    return input->value;
  }

  static bool Read(::media_feeds::mojom::Identifier::DataView input, ::media_feeds::mojom::IdentifierPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::Action::DataView,
                                         ::media_feeds::mojom::ActionPtr> {
  static bool IsNull(const ::media_feeds::mojom::ActionPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::ActionPtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::Action::url)& url(
      const ::media_feeds::mojom::ActionPtr& input) {
    return input->url;
  }

  static const decltype(::media_feeds::mojom::Action::start_time)& start_time(
      const ::media_feeds::mojom::ActionPtr& input) {
    return input->start_time;
  }

  static bool Read(::media_feeds::mojom::Action::DataView input, ::media_feeds::mojom::ActionPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::PlayNextCandidate::DataView,
                                         ::media_feeds::mojom::PlayNextCandidatePtr> {
  static bool IsNull(const ::media_feeds::mojom::PlayNextCandidatePtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::PlayNextCandidatePtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::PlayNextCandidate::name)& name(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->name;
  }

  static decltype(::media_feeds::mojom::PlayNextCandidate::season_number) season_number(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->season_number;
  }

  static decltype(::media_feeds::mojom::PlayNextCandidate::episode_number) episode_number(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->episode_number;
  }

  static const decltype(::media_feeds::mojom::PlayNextCandidate::action)& action(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->action;
  }

  static const decltype(::media_feeds::mojom::PlayNextCandidate::duration)& duration(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->duration;
  }

  static const decltype(::media_feeds::mojom::PlayNextCandidate::identifiers)& identifiers(
      const ::media_feeds::mojom::PlayNextCandidatePtr& input) {
    return input->identifiers;
  }

  static bool Read(::media_feeds::mojom::PlayNextCandidate::DataView input, ::media_feeds::mojom::PlayNextCandidatePtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::TVEpisode::DataView,
                                         ::media_feeds::mojom::TVEpisodePtr> {
  static bool IsNull(const ::media_feeds::mojom::TVEpisodePtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::TVEpisodePtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::TVEpisode::name)& name(
      const ::media_feeds::mojom::TVEpisodePtr& input) {
    return input->name;
  }

  static decltype(::media_feeds::mojom::TVEpisode::episode_number) episode_number(
      const ::media_feeds::mojom::TVEpisodePtr& input) {
    return input->episode_number;
  }

  static decltype(::media_feeds::mojom::TVEpisode::season_number) season_number(
      const ::media_feeds::mojom::TVEpisodePtr& input) {
    return input->season_number;
  }

  static const decltype(::media_feeds::mojom::TVEpisode::identifiers)& identifiers(
      const ::media_feeds::mojom::TVEpisodePtr& input) {
    return input->identifiers;
  }

  static bool Read(::media_feeds::mojom::TVEpisode::DataView input, ::media_feeds::mojom::TVEpisodePtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::LiveDetails::DataView,
                                         ::media_feeds::mojom::LiveDetailsPtr> {
  static bool IsNull(const ::media_feeds::mojom::LiveDetailsPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::LiveDetailsPtr* output) { output->reset(); }

  static const decltype(::media_feeds::mojom::LiveDetails::start_time)& start_time(
      const ::media_feeds::mojom::LiveDetailsPtr& input) {
    return input->start_time;
  }

  static const decltype(::media_feeds::mojom::LiveDetails::end_time)& end_time(
      const ::media_feeds::mojom::LiveDetailsPtr& input) {
    return input->end_time;
  }

  static bool Read(::media_feeds::mojom::LiveDetails::DataView input, ::media_feeds::mojom::LiveDetailsPtr* output);
};


template <>
struct  StructTraits<::media_feeds::mojom::MediaFeedItem::DataView,
                                         ::media_feeds::mojom::MediaFeedItemPtr> {
  static bool IsNull(const ::media_feeds::mojom::MediaFeedItemPtr& input) { return !input; }
  static void SetToNull(::media_feeds::mojom::MediaFeedItemPtr* output) { output->reset(); }

  static decltype(::media_feeds::mojom::MediaFeedItem::type) type(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->type;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::name)& name(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->name;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::author)& author(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->author;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::date_published)& date_published(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->date_published;
  }

  static decltype(::media_feeds::mojom::MediaFeedItem::is_family_friendly) is_family_friendly(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->is_family_friendly;
  }

  static decltype(::media_feeds::mojom::MediaFeedItem::action_status) action_status(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->action_status;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::action)& action(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->action;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::interaction_counters)& interaction_counters(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->interaction_counters;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::content_ratings)& content_ratings(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->content_ratings;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::genre)& genre(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->genre;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::duration)& duration(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->duration;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::live)& live(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->live;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::tv_episode)& tv_episode(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->tv_episode;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::play_next_candidate)& play_next_candidate(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->play_next_candidate;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::identifiers)& identifiers(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->identifiers;
  }

  static decltype(::media_feeds::mojom::MediaFeedItem::shown_count) shown_count(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->shown_count;
  }

  static decltype(::media_feeds::mojom::MediaFeedItem::clicked) clicked(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->clicked;
  }

  static const decltype(::media_feeds::mojom::MediaFeedItem::images)& images(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->images;
  }

  static decltype(::media_feeds::mojom::MediaFeedItem::safe_search_result) safe_search_result(
      const ::media_feeds::mojom::MediaFeedItemPtr& input) {
    return input->safe_search_result;
  }

  static bool Read(::media_feeds::mojom::MediaFeedItem::DataView input, ::media_feeds::mojom::MediaFeedItemPtr* output);
};

}  // namespace mojo

#endif  // CHROME_BROWSER_MEDIA_FEEDS_MEDIA_FEEDS_STORE_MOJOM_H_