// chrome/browser/media/history/media_history_store.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/browser/media/history/media_history_store.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/media/history/media_history_store.mojom-params-data.h"
#include "chrome/browser/media/history/media_history_store.mojom-shared-message-ids.h"

#include "chrome/browser/media/history/media_history_store.mojom-import-headers.h"


#ifndef CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_JUMBO_H_
#define CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_JUMBO_H_
#include "services/media_session/public/cpp/media_session_mojom_traits.h"
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#endif
namespace media_history {
namespace mojom {
MediaHistoryStats::MediaHistoryStats()
    : table_row_counts() {}

MediaHistoryStats::MediaHistoryStats(
    const base::flat_map<std::string, int32_t>& table_row_counts_in)
    : table_row_counts(std::move(table_row_counts_in)) {}

MediaHistoryStats::~MediaHistoryStats() = default;

bool MediaHistoryStats::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MediaHistoryOriginRow::MediaHistoryOriginRow()
    : origin(),
      cached_audio_video_watchtime(),
      actual_audio_video_watchtime(),
      last_updated_time() {}

MediaHistoryOriginRow::MediaHistoryOriginRow(
    const ::url::Origin& origin_in,
    ::base::TimeDelta cached_audio_video_watchtime_in,
    ::base::TimeDelta actual_audio_video_watchtime_in,
    double last_updated_time_in)
    : origin(std::move(origin_in)),
      cached_audio_video_watchtime(std::move(cached_audio_video_watchtime_in)),
      actual_audio_video_watchtime(std::move(actual_audio_video_watchtime_in)),
      last_updated_time(std::move(last_updated_time_in)) {}

MediaHistoryOriginRow::~MediaHistoryOriginRow() = default;

bool MediaHistoryOriginRow::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MediaHistoryPlaybackRow::MediaHistoryPlaybackRow()
    : url(),
      has_audio(),
      has_video(),
      watchtime(),
      last_updated_time() {}

MediaHistoryPlaybackRow::MediaHistoryPlaybackRow(
    const ::GURL& url_in,
    bool has_audio_in,
    bool has_video_in,
    ::base::TimeDelta watchtime_in,
    double last_updated_time_in)
    : url(std::move(url_in)),
      has_audio(std::move(has_audio_in)),
      has_video(std::move(has_video_in)),
      watchtime(std::move(watchtime_in)),
      last_updated_time(std::move(last_updated_time_in)) {}

MediaHistoryPlaybackRow::~MediaHistoryPlaybackRow() = default;

bool MediaHistoryPlaybackRow::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MediaHistoryPlaybackSessionRow::MediaHistoryPlaybackSessionRow()
    : id(),
      url(),
      duration(),
      position(),
      metadata(),
      artwork(),
      last_updated_time() {}

MediaHistoryPlaybackSessionRow::MediaHistoryPlaybackSessionRow(
    int64_t id_in,
    const ::GURL& url_in,
    ::base::TimeDelta duration_in,
    ::base::TimeDelta position_in,
    const ::media_session::MediaMetadata& metadata_in,
    std::vector<::media_session::MediaImage> artwork_in,
    double last_updated_time_in)
    : id(std::move(id_in)),
      url(std::move(url_in)),
      duration(std::move(duration_in)),
      position(std::move(position_in)),
      metadata(std::move(metadata_in)),
      artwork(std::move(artwork_in)),
      last_updated_time(std::move(last_updated_time_in)) {}

MediaHistoryPlaybackSessionRow::~MediaHistoryPlaybackSessionRow() = default;

bool MediaHistoryPlaybackSessionRow::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char MediaHistoryStore::Name_[] = "media_history.mojom.MediaHistoryStore";

class MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback(
      MediaHistoryStore::GetMediaHistoryStatsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaHistoryStore::GetMediaHistoryStatsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback);
};

class MediaHistoryStore_GetMediaHistoryOriginRows_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaHistoryStore_GetMediaHistoryOriginRows_ForwardToCallback(
      MediaHistoryStore::GetMediaHistoryOriginRowsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaHistoryStore::GetMediaHistoryOriginRowsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryOriginRows_ForwardToCallback);
};

class MediaHistoryStore_GetMediaHistoryPlaybackRows_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaHistoryStore_GetMediaHistoryPlaybackRows_ForwardToCallback(
      MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryPlaybackRows_ForwardToCallback);
};

class MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ForwardToCallback(
      MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ForwardToCallback);
};

MediaHistoryStoreProxy::MediaHistoryStoreProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MediaHistoryStoreProxy::GetMediaHistoryStats(
    GetMediaHistoryStatsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryStats");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryStats_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryStats");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void MediaHistoryStoreProxy::GetMediaHistoryOriginRows(
    GetMediaHistoryOriginRowsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryOriginRows");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryOriginRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryOriginRows_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryOriginRows");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaHistoryStore_GetMediaHistoryOriginRows_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void MediaHistoryStoreProxy::GetMediaHistoryPlaybackRows(
    GetMediaHistoryPlaybackRowsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackRows");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryPlaybackRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryPlaybackRows");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaHistoryStore_GetMediaHistoryPlaybackRows_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void MediaHistoryStoreProxy::GetMediaHistoryPlaybackSessionRows(
    GetMediaHistoryPlaybackSessionRowsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackSessionRows");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryPlaybackSessionRows");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder {
 public:
  static MediaHistoryStore::GetMediaHistoryStatsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder> proxy(
        new MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaHistoryStore::GetMediaHistoryStatsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      MediaHistoryStatsPtr in_stats);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder);
};

bool MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryStatsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  MediaHistoryStatsPtr p_stats{};
  MediaHistoryStore_GetMediaHistoryStats_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadStats(&p_stats))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaHistoryStore::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_stats));
  return true;
}

void MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::Run(
    MediaHistoryStatsPtr in_stats) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryStats_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->stats)::BaseType::BufferWriter
      stats_writer;
  mojo::internal::Serialize<::media_history::mojom::MediaHistoryStatsDataView>(
      in_stats, buffer, &stats_writer, &serialization_context);
  params->stats.Set(
      stats_writer.is_null() ? nullptr : stats_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->stats.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null stats in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStatsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryStats");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder {
 public:
  static MediaHistoryStore::GetMediaHistoryOriginRowsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder> proxy(
        new MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaHistoryStore::GetMediaHistoryOriginRowsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<MediaHistoryOriginRowPtr> in_rows);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder);
};

bool MediaHistoryStore_GetMediaHistoryOriginRows_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryOriginRowsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaHistoryStore_GetMediaHistoryOriginRows_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaHistoryStore_GetMediaHistoryOriginRows_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<MediaHistoryOriginRowPtr> p_rows{};
  MediaHistoryStore_GetMediaHistoryOriginRows_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadRows(&p_rows))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaHistoryStore::Name_, 357885228, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_rows));
  return true;
}

void MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder::Run(
    std::vector<MediaHistoryOriginRowPtr> in_rows) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryOriginRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryOriginRows_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->rows)::BaseType::BufferWriter
      rows_writer;
  const mojo::internal::ContainerValidateParams rows_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::media_history::mojom::MediaHistoryOriginRowDataView>>(
      in_rows, buffer, &rows_writer, &rows_validate_params,
      &serialization_context);
  params->rows.Set(
      rows_writer.is_null() ? nullptr : rows_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->rows.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null rows in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryOriginRowsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryOriginRows");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder {
 public:
  static MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder> proxy(
        new MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<MediaHistoryPlaybackRowPtr> in_rows);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder);
};

bool MediaHistoryStore_GetMediaHistoryPlaybackRows_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<MediaHistoryPlaybackRowPtr> p_rows{};
  MediaHistoryStore_GetMediaHistoryPlaybackRows_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadRows(&p_rows))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaHistoryStore::Name_, 1381010240, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_rows));
  return true;
}

void MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder::Run(
    std::vector<MediaHistoryPlaybackRowPtr> in_rows) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryPlaybackRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->rows)::BaseType::BufferWriter
      rows_writer;
  const mojo::internal::ContainerValidateParams rows_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::media_history::mojom::MediaHistoryPlaybackRowDataView>>(
      in_rows, buffer, &rows_writer, &rows_validate_params,
      &serialization_context);
  params->rows.Set(
      rows_writer.is_null() ? nullptr : rows_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->rows.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null rows in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryPlaybackRows");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder {
 public:
  static MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder> proxy(
        new MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<MediaHistoryPlaybackSessionRowPtr> in_rows);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder);
};

bool MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<MediaHistoryPlaybackSessionRowPtr> p_rows{};
  MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadRows(&p_rows))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaHistoryStore::Name_, 1280567960, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_rows));
  return true;
}

void MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder::Run(
    std::vector<MediaHistoryPlaybackSessionRowPtr> in_rows) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->rows)::BaseType::BufferWriter
      rows_writer;
  const mojo::internal::ContainerValidateParams rows_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::media_history::mojom::MediaHistoryPlaybackSessionRowDataView>>(
      in_rows, buffer, &rows_writer, &rows_validate_params,
      &serialization_context);
  params->rows.Set(
      rows_writer.is_null() ? nullptr : rows_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->rows.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null rows in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryPlaybackSessionRows");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool MediaHistoryStoreStubDispatch::Accept(
    MediaHistoryStore* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kMediaHistoryStore_GetMediaHistoryStats_Name: {
      break;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryOriginRows_Name: {
      break;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryPlaybackRows_Name: {
      break;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Name: {
      break;
    }
  }
  return false;
}

// static
bool MediaHistoryStoreStubDispatch::AcceptWithResponder(
    MediaHistoryStore* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kMediaHistoryStore_GetMediaHistoryStats_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStats",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStats");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data* params =
          reinterpret_cast<
              internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      MediaHistoryStore_GetMediaHistoryStats_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaHistoryStore::Name_, 0, false);
        return false;
      }
      MediaHistoryStore::GetMediaHistoryStatsCallback callback =
          MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaHistoryStats(std::move(callback));
      return true;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryOriginRows_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryOriginRows",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryOriginRows");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaHistoryStore_GetMediaHistoryOriginRows_Params_Data* params =
          reinterpret_cast<
              internal::MediaHistoryStore_GetMediaHistoryOriginRows_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      MediaHistoryStore_GetMediaHistoryOriginRows_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaHistoryStore::Name_, 357885228, false);
        return false;
      }
      MediaHistoryStore::GetMediaHistoryOriginRowsCallback callback =
          MediaHistoryStore_GetMediaHistoryOriginRows_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaHistoryOriginRows(std::move(callback));
      return true;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryPlaybackRows_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackRows",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackRows");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_Params_Data* params =
          reinterpret_cast<
              internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      MediaHistoryStore_GetMediaHistoryPlaybackRows_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaHistoryStore::Name_, 1381010240, false);
        return false;
      }
      MediaHistoryStore::GetMediaHistoryPlaybackRowsCallback callback =
          MediaHistoryStore_GetMediaHistoryPlaybackRows_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaHistoryPlaybackRows(std::move(callback));
      return true;
    }
    case internal::kMediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackSessionRows",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryPlaybackSessionRows");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Params_Data* params =
          reinterpret_cast<
              internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaHistoryStore::Name_, 1280567960, false);
        return false;
      }
      MediaHistoryStore::GetMediaHistoryPlaybackSessionRowsCallback callback =
          MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaHistoryPlaybackSessionRows(std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kMediaHistoryStoreValidationInfo[] = {
    {internal::kMediaHistoryStore_GetMediaHistoryStats_Name,
     {&internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data::Validate,
      &internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data::Validate}},
    {internal::kMediaHistoryStore_GetMediaHistoryOriginRows_Name,
     {&internal::MediaHistoryStore_GetMediaHistoryOriginRows_Params_Data::Validate,
      &internal::MediaHistoryStore_GetMediaHistoryOriginRows_ResponseParams_Data::Validate}},
    {internal::kMediaHistoryStore_GetMediaHistoryPlaybackRows_Name,
     {&internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_Params_Data::Validate,
      &internal::MediaHistoryStore_GetMediaHistoryPlaybackRows_ResponseParams_Data::Validate}},
    {internal::kMediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Name,
     {&internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_Params_Data::Validate,
      &internal::MediaHistoryStore_GetMediaHistoryPlaybackSessionRows_ResponseParams_Data::Validate}},
};

bool MediaHistoryStoreRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::media_history::mojom::MediaHistoryStore::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kMediaHistoryStoreValidationInfo);
}

bool MediaHistoryStoreResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::media_history::mojom::MediaHistoryStore::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kMediaHistoryStoreValidationInfo);

}
}  // namespace mojom
}  // namespace media_history

namespace mojo {


// static
bool StructTraits<::media_history::mojom::MediaHistoryStats::DataView, ::media_history::mojom::MediaHistoryStatsPtr>::Read(
    ::media_history::mojom::MediaHistoryStats::DataView input,
    ::media_history::mojom::MediaHistoryStatsPtr* output) {
  bool success = true;
  ::media_history::mojom::MediaHistoryStatsPtr result(::media_history::mojom::MediaHistoryStats::New());
  
      if (success && !input.ReadTableRowCounts(&result->table_row_counts))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_history::mojom::MediaHistoryOriginRow::DataView, ::media_history::mojom::MediaHistoryOriginRowPtr>::Read(
    ::media_history::mojom::MediaHistoryOriginRow::DataView input,
    ::media_history::mojom::MediaHistoryOriginRowPtr* output) {
  bool success = true;
  ::media_history::mojom::MediaHistoryOriginRowPtr result(::media_history::mojom::MediaHistoryOriginRow::New());
  
      if (success && !input.ReadOrigin(&result->origin))
        success = false;
      if (success && !input.ReadCachedAudioVideoWatchtime(&result->cached_audio_video_watchtime))
        success = false;
      if (success && !input.ReadActualAudioVideoWatchtime(&result->actual_audio_video_watchtime))
        success = false;
      if (success)
        result->last_updated_time = input.last_updated_time();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_history::mojom::MediaHistoryPlaybackRow::DataView, ::media_history::mojom::MediaHistoryPlaybackRowPtr>::Read(
    ::media_history::mojom::MediaHistoryPlaybackRow::DataView input,
    ::media_history::mojom::MediaHistoryPlaybackRowPtr* output) {
  bool success = true;
  ::media_history::mojom::MediaHistoryPlaybackRowPtr result(::media_history::mojom::MediaHistoryPlaybackRow::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success)
        result->has_audio = input.has_audio();
      if (success)
        result->has_video = input.has_video();
      if (success && !input.ReadWatchtime(&result->watchtime))
        success = false;
      if (success)
        result->last_updated_time = input.last_updated_time();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_history::mojom::MediaHistoryPlaybackSessionRow::DataView, ::media_history::mojom::MediaHistoryPlaybackSessionRowPtr>::Read(
    ::media_history::mojom::MediaHistoryPlaybackSessionRow::DataView input,
    ::media_history::mojom::MediaHistoryPlaybackSessionRowPtr* output) {
  bool success = true;
  ::media_history::mojom::MediaHistoryPlaybackSessionRowPtr result(::media_history::mojom::MediaHistoryPlaybackSessionRow::New());
  
      if (success)
        result->id = input.id();
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadDuration(&result->duration))
        success = false;
      if (success && !input.ReadPosition(&result->position))
        success = false;
      if (success && !input.ReadMetadata(&result->metadata))
        success = false;
      if (success && !input.ReadArtwork(&result->artwork))
        success = false;
      if (success)
        result->last_updated_time = input.last_updated_time();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif