// chrome/browser/ui/webui/app_management/app_management.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/browser/ui/webui/app_management/app_management.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/ui/webui/app_management/app_management.mojom-params-data.h"
#include "chrome/browser/ui/webui/app_management/app_management.mojom-shared-message-ids.h"

#include "chrome/browser/ui/webui/app_management/app_management.mojom-import-headers.h"


#ifndef CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_JUMBO_H_
#endif
namespace app_management {
namespace mojom {
App::App()
    : id(),
      type(),
      title(),
      description(),
      is_pinned(),
      is_policy_pinned(),
      version(),
      size(),
      permissions(),
      install_source(),
      hide_more_settings(),
      hide_pin_to_shelf() {}

App::App(
    const std::string& id_in,
    ::apps::mojom::AppType type_in,
    const base::Optional<std::string>& title_in,
    const base::Optional<std::string>& description_in,
    ::apps::mojom::OptionalBool is_pinned_in,
    ::apps::mojom::OptionalBool is_policy_pinned_in,
    const base::Optional<std::string>& version_in,
    const base::Optional<std::string>& size_in,
    base::flat_map<uint32_t, ::apps::mojom::PermissionPtr> permissions_in,
    ::apps::mojom::InstallSource install_source_in,
    bool hide_more_settings_in,
    bool hide_pin_to_shelf_in)
    : id(std::move(id_in)),
      type(std::move(type_in)),
      title(std::move(title_in)),
      description(std::move(description_in)),
      is_pinned(std::move(is_pinned_in)),
      is_policy_pinned(std::move(is_policy_pinned_in)),
      version(std::move(version_in)),
      size(std::move(size_in)),
      permissions(std::move(permissions_in)),
      install_source(std::move(install_source_in)),
      hide_more_settings(std::move(hide_more_settings_in)),
      hide_pin_to_shelf(std::move(hide_pin_to_shelf_in)) {}

App::~App() = default;

bool App::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ExtensionAppPermissionMessage::ExtensionAppPermissionMessage()
    : message(),
      submessages() {}

ExtensionAppPermissionMessage::ExtensionAppPermissionMessage(
    const std::string& message_in,
    std::vector<std::string> submessages_in)
    : message(std::move(message_in)),
      submessages(std::move(submessages_in)) {}

ExtensionAppPermissionMessage::~ExtensionAppPermissionMessage() = default;

bool ExtensionAppPermissionMessage::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char PageHandlerFactory::Name_[] = "app_management.mojom.PageHandlerFactory";

PageHandlerFactoryProxy::PageHandlerFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageHandlerFactoryProxy::CreatePageHandler(
    mojo::PendingRemote<Page> in_page, mojo::PendingReceiver<PageHandler> in_handler) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandlerFactory::CreatePageHandler");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandlerFactory_CreatePageHandler_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandlerFactory_CreatePageHandler_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::app_management::mojom::PageInterfaceBase>>(
      in_page, &params->page, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->page),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid page in PageHandlerFactory.CreatePageHandler request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::app_management::mojom::PageHandlerInterfaceBase>>(
      in_handler, &params->handler, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->handler),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid handler in PageHandlerFactory.CreatePageHandler request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandlerFactory::Name_);
  message.set_method_name("CreatePageHandler");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PageHandlerFactoryStubDispatch::Accept(
    PageHandlerFactory* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPageHandlerFactory_CreatePageHandler_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandlerFactory::CreatePageHandler",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandlerFactory::CreatePageHandler");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandlerFactory_CreatePageHandler_Params_Data* params =
          reinterpret_cast<internal::PageHandlerFactory_CreatePageHandler_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingRemote<Page> p_page{};
      mojo::PendingReceiver<PageHandler> p_handler{};
      PageHandlerFactory_CreatePageHandler_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_page =
            input_data_view.TakePage<decltype(p_page)>();
      }
      if (success) {
        p_handler =
            input_data_view.TakeHandler<decltype(p_handler)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandlerFactory::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreatePageHandler(
std::move(p_page), 
std::move(p_handler));
      return true;
    }
  }
  return false;
}

// static
bool PageHandlerFactoryStubDispatch::AcceptWithResponder(
    PageHandlerFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPageHandlerFactory_CreatePageHandler_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageHandlerFactoryValidationInfo[] = {
    {internal::kPageHandlerFactory_CreatePageHandler_Name,
     {&internal::PageHandlerFactory_CreatePageHandler_Params_Data::Validate,
      nullptr /* no response */}},
};

bool PageHandlerFactoryRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::app_management::mojom::PageHandlerFactory::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageHandlerFactoryValidationInfo);
}

const char PageHandler::Name_[] = "app_management.mojom.PageHandler";

class PageHandler_GetApps_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_GetApps_ForwardToCallback(
      PageHandler::GetAppsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::GetAppsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetApps_ForwardToCallback);
};

class PageHandler_GetExtensionAppPermissionMessages_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_GetExtensionAppPermissionMessages_ForwardToCallback(
      PageHandler::GetExtensionAppPermissionMessagesCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::GetExtensionAppPermissionMessagesCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetExtensionAppPermissionMessages_ForwardToCallback);
};

PageHandlerProxy::PageHandlerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageHandlerProxy::GetApps(
    GetAppsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::GetApps");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetApps_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_GetApps_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetApps");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_GetApps_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PageHandlerProxy::GetExtensionAppPermissionMessages(
    const std::string& in_app_id, GetExtensionAppPermissionMessagesCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::GetExtensionAppPermissionMessages");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetExtensionAppPermissionMessages_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in PageHandler.GetExtensionAppPermissionMessages request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetExtensionAppPermissionMessages");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_GetExtensionAppPermissionMessages_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PageHandlerProxy::SetPinned(
    const std::string& in_app_id, ::apps::mojom::OptionalBool in_pinned) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::SetPinned");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_SetPinned_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_SetPinned_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in PageHandler.SetPinned request");
  mojo::internal::Serialize<::apps::mojom::OptionalBool>(
      in_pinned, &params->pinned);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("SetPinned");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageHandlerProxy::SetPermission(
    const std::string& in_app_id, ::apps::mojom::PermissionPtr in_permission) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::SetPermission");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_SetPermission_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_SetPermission_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in PageHandler.SetPermission request");
  typename decltype(params->permission)::BaseType::BufferWriter
      permission_writer;
  mojo::internal::Serialize<::apps::mojom::PermissionDataView>(
      in_permission, buffer, &permission_writer, &serialization_context);
  params->permission.Set(
      permission_writer.is_null() ? nullptr : permission_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->permission.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null permission in PageHandler.SetPermission request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("SetPermission");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageHandlerProxy::Uninstall(
    const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::Uninstall");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_Uninstall_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_Uninstall_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in PageHandler.Uninstall request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("Uninstall");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageHandlerProxy::OpenNativeSettings(
    const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::PageHandler::OpenNativeSettings");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_OpenNativeSettings_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_OpenNativeSettings_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in PageHandler.OpenNativeSettings request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("OpenNativeSettings");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class PageHandler_GetApps_ProxyToResponder {
 public:
  static PageHandler::GetAppsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<PageHandler_GetApps_ProxyToResponder> proxy(
        new PageHandler_GetApps_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&PageHandler_GetApps_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_GetApps_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PageHandler_GetApps_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::GetAppsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<AppPtr> in_apps);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetApps_ProxyToResponder);
};

bool PageHandler_GetApps_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "app_management::mojom::PageHandler::GetAppsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PageHandler_GetApps_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_GetApps_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<AppPtr> p_apps{};
  PageHandler_GetApps_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadApps(&p_apps))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_apps));
  return true;
}

void PageHandler_GetApps_ProxyToResponder::Run(
    std::vector<AppPtr> in_apps) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetApps_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_GetApps_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->apps)::BaseType::BufferWriter
      apps_writer;
  const mojo::internal::ContainerValidateParams apps_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::app_management::mojom::AppDataView>>(
      in_apps, buffer, &apps_writer, &apps_validate_params,
      &serialization_context);
  params->apps.Set(
      apps_writer.is_null() ? nullptr : apps_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->apps.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null apps in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)app_management::mojom::PageHandler::GetAppsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetApps");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder {
 public:
  static PageHandler::GetExtensionAppPermissionMessagesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder> proxy(
        new PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::GetExtensionAppPermissionMessagesCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<ExtensionAppPermissionMessagePtr> in_messages);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder);
};

bool PageHandler_GetExtensionAppPermissionMessages_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "app_management::mojom::PageHandler::GetExtensionAppPermissionMessagesCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  std::vector<ExtensionAppPermissionMessagePtr> p_messages{};
  PageHandler_GetExtensionAppPermissionMessages_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadMessages(&p_messages))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 1173928087, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_messages));
  return true;
}

void PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder::Run(
    std::vector<ExtensionAppPermissionMessagePtr> in_messages) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetExtensionAppPermissionMessages_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->messages)::BaseType::BufferWriter
      messages_writer;
  const mojo::internal::ContainerValidateParams messages_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::app_management::mojom::ExtensionAppPermissionMessageDataView>>(
      in_messages, buffer, &messages_writer, &messages_validate_params,
      &serialization_context);
  params->messages.Set(
      messages_writer.is_null() ? nullptr : messages_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->messages.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null messages in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)app_management::mojom::PageHandler::GetExtensionAppPermissionMessagesCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetExtensionAppPermissionMessages");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PageHandlerStubDispatch::Accept(
    PageHandler* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPageHandler_GetApps_Name: {
      break;
    }
    case internal::kPageHandler_GetExtensionAppPermissionMessages_Name: {
      break;
    }
    case internal::kPageHandler_SetPinned_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::SetPinned",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::SetPinned");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandler_SetPinned_Params_Data* params =
          reinterpret_cast<internal::PageHandler_SetPinned_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      ::apps::mojom::OptionalBool p_pinned{};
      PageHandler_SetPinned_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (success && !input_data_view.ReadPinned(&p_pinned))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 1493353712, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetPinned(
std::move(p_app_id), 
std::move(p_pinned));
      return true;
    }
    case internal::kPageHandler_SetPermission_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::SetPermission",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::SetPermission");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandler_SetPermission_Params_Data* params =
          reinterpret_cast<internal::PageHandler_SetPermission_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      ::apps::mojom::PermissionPtr p_permission{};
      PageHandler_SetPermission_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (success && !input_data_view.ReadPermission(&p_permission))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 850036206, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetPermission(
std::move(p_app_id), 
std::move(p_permission));
      return true;
    }
    case internal::kPageHandler_Uninstall_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::Uninstall",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::Uninstall");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandler_Uninstall_Params_Data* params =
          reinterpret_cast<internal::PageHandler_Uninstall_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      PageHandler_Uninstall_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 594379113, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Uninstall(
std::move(p_app_id));
      return true;
    }
    case internal::kPageHandler_OpenNativeSettings_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::OpenNativeSettings",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::OpenNativeSettings");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandler_OpenNativeSettings_Params_Data* params =
          reinterpret_cast<internal::PageHandler_OpenNativeSettings_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      PageHandler_OpenNativeSettings_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 1259494392, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OpenNativeSettings(
std::move(p_app_id));
      return true;
    }
  }
  return false;
}

// static
bool PageHandlerStubDispatch::AcceptWithResponder(
    PageHandler* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPageHandler_GetApps_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::GetApps",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::GetApps");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::PageHandler_GetApps_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_GetApps_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      PageHandler_GetApps_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 0, false);
        return false;
      }
      PageHandler::GetAppsCallback callback =
          PageHandler_GetApps_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetApps(std::move(callback));
      return true;
    }
    case internal::kPageHandler_GetExtensionAppPermissionMessages_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::PageHandler::GetExtensionAppPermissionMessages",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::PageHandler::GetExtensionAppPermissionMessages");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      PageHandler_GetExtensionAppPermissionMessages_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 1173928087, false);
        return false;
      }
      PageHandler::GetExtensionAppPermissionMessagesCallback callback =
          PageHandler_GetExtensionAppPermissionMessages_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetExtensionAppPermissionMessages(
std::move(p_app_id), std::move(callback));
      return true;
    }
    case internal::kPageHandler_SetPinned_Name: {
      break;
    }
    case internal::kPageHandler_SetPermission_Name: {
      break;
    }
    case internal::kPageHandler_Uninstall_Name: {
      break;
    }
    case internal::kPageHandler_OpenNativeSettings_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageHandlerValidationInfo[] = {
    {internal::kPageHandler_GetApps_Name,
     {&internal::PageHandler_GetApps_Params_Data::Validate,
      &internal::PageHandler_GetApps_ResponseParams_Data::Validate}},
    {internal::kPageHandler_GetExtensionAppPermissionMessages_Name,
     {&internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data::Validate,
      &internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data::Validate}},
    {internal::kPageHandler_SetPinned_Name,
     {&internal::PageHandler_SetPinned_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPageHandler_SetPermission_Name,
     {&internal::PageHandler_SetPermission_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPageHandler_Uninstall_Name,
     {&internal::PageHandler_Uninstall_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPageHandler_OpenNativeSettings_Name,
     {&internal::PageHandler_OpenNativeSettings_Params_Data::Validate,
      nullptr /* no response */}},
};

bool PageHandlerRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::app_management::mojom::PageHandler::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageHandlerValidationInfo);
}

bool PageHandlerResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::app_management::mojom::PageHandler::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kPageHandlerValidationInfo);

}
const char Page::Name_[] = "app_management.mojom.Page";

PageProxy::PageProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageProxy::OnAppAdded(
    AppPtr in_app) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::Page::OnAppAdded");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPage_OnAppAdded_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::Page_OnAppAdded_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app)::BaseType::BufferWriter
      app_writer;
  mojo::internal::Serialize<::app_management::mojom::AppDataView>(
      in_app, buffer, &app_writer, &serialization_context);
  params->app.Set(
      app_writer.is_null() ? nullptr : app_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app in Page.OnAppAdded request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Page::Name_);
  message.set_method_name("OnAppAdded");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageProxy::OnAppChanged(
    AppPtr in_update) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::Page::OnAppChanged");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPage_OnAppChanged_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::Page_OnAppChanged_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->update)::BaseType::BufferWriter
      update_writer;
  mojo::internal::Serialize<::app_management::mojom::AppDataView>(
      in_update, buffer, &update_writer, &serialization_context);
  params->update.Set(
      update_writer.is_null() ? nullptr : update_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->update.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null update in Page.OnAppChanged request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Page::Name_);
  message.set_method_name("OnAppChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageProxy::OnAppRemoved(
    const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::Page::OnAppRemoved");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPage_OnAppRemoved_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::Page_OnAppRemoved_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Page.OnAppRemoved request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Page::Name_);
  message.set_method_name("OnAppRemoved");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PageProxy::OnArcSupportChanged(
    bool in_supported) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "app_management::mojom::Page::OnArcSupportChanged");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPage_OnArcSupportChanged_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::app_management::mojom::internal::Page_OnArcSupportChanged_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->supported = in_supported;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Page::Name_);
  message.set_method_name("OnArcSupportChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PageStubDispatch::Accept(
    Page* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPage_OnAppAdded_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::Page::OnAppAdded",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::Page::OnAppAdded");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::Page_OnAppAdded_Params_Data* params =
          reinterpret_cast<internal::Page_OnAppAdded_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      AppPtr p_app{};
      Page_OnAppAdded_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadApp(&p_app))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Page::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnAppAdded(
std::move(p_app));
      return true;
    }
    case internal::kPage_OnAppChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::Page::OnAppChanged",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::Page::OnAppChanged");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::Page_OnAppChanged_Params_Data* params =
          reinterpret_cast<internal::Page_OnAppChanged_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      AppPtr p_update{};
      Page_OnAppChanged_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUpdate(&p_update))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Page::Name_, 1520892774, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnAppChanged(
std::move(p_update));
      return true;
    }
    case internal::kPage_OnAppRemoved_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::Page::OnAppRemoved",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::Page::OnAppRemoved");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::Page_OnAppRemoved_Params_Data* params =
          reinterpret_cast<internal::Page_OnAppRemoved_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      std::string p_app_id{};
      Page_OnAppRemoved_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Page::Name_, 741750258, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnAppRemoved(
std::move(p_app_id));
      return true;
    }
    case internal::kPage_OnArcSupportChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)app_management::mojom::Page::OnArcSupportChanged",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)app_management::mojom::Page::OnArcSupportChanged");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::Page_OnArcSupportChanged_Params_Data* params =
          reinterpret_cast<internal::Page_OnArcSupportChanged_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      bool p_supported{};
      Page_OnArcSupportChanged_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_supported = input_data_view.supported();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Page::Name_, 1272502201, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnArcSupportChanged(
std::move(p_supported));
      return true;
    }
  }
  return false;
}

// static
bool PageStubDispatch::AcceptWithResponder(
    Page* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPage_OnAppAdded_Name: {
      break;
    }
    case internal::kPage_OnAppChanged_Name: {
      break;
    }
    case internal::kPage_OnAppRemoved_Name: {
      break;
    }
    case internal::kPage_OnArcSupportChanged_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageValidationInfo[] = {
    {internal::kPage_OnAppAdded_Name,
     {&internal::Page_OnAppAdded_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPage_OnAppChanged_Name,
     {&internal::Page_OnAppChanged_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPage_OnAppRemoved_Name,
     {&internal::Page_OnAppRemoved_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kPage_OnArcSupportChanged_Name,
     {&internal::Page_OnArcSupportChanged_Params_Data::Validate,
      nullptr /* no response */}},
};

bool PageRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::app_management::mojom::Page::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageValidationInfo);
}

}  // namespace mojom
}  // namespace app_management

namespace mojo {


// static
bool StructTraits<::app_management::mojom::App::DataView, ::app_management::mojom::AppPtr>::Read(
    ::app_management::mojom::App::DataView input,
    ::app_management::mojom::AppPtr* output) {
  bool success = true;
  ::app_management::mojom::AppPtr result(::app_management::mojom::App::New());
  
      if (success && !input.ReadId(&result->id))
        success = false;
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success && !input.ReadTitle(&result->title))
        success = false;
      if (success && !input.ReadDescription(&result->description))
        success = false;
      if (success && !input.ReadIsPinned(&result->is_pinned))
        success = false;
      if (success && !input.ReadIsPolicyPinned(&result->is_policy_pinned))
        success = false;
      if (success && !input.ReadVersion(&result->version))
        success = false;
      if (success && !input.ReadSize(&result->size))
        success = false;
      if (success && !input.ReadPermissions(&result->permissions))
        success = false;
      if (success && !input.ReadInstallSource(&result->install_source))
        success = false;
      if (success)
        result->hide_more_settings = input.hide_more_settings();
      if (success)
        result->hide_pin_to_shelf = input.hide_pin_to_shelf();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::app_management::mojom::ExtensionAppPermissionMessage::DataView, ::app_management::mojom::ExtensionAppPermissionMessagePtr>::Read(
    ::app_management::mojom::ExtensionAppPermissionMessage::DataView input,
    ::app_management::mojom::ExtensionAppPermissionMessagePtr* output) {
  bool success = true;
  ::app_management::mojom::ExtensionAppPermissionMessagePtr result(::app_management::mojom::ExtensionAppPermissionMessage::New());
  
      if (success && !input.ReadMessage(&result->message))
        success = false;
      if (success && !input.ReadSubmessages(&result->submessages))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif