// chrome/browser/ui/webui/new_tab_page/new_tab_page.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_NEW_TAB_PAGE_NEW_TAB_PAGE_MOJOM_H_
#define CHROME_BROWSER_UI_WEBUI_NEW_TAB_PAGE_NEW_TAB_PAGE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/ui/webui/new_tab_page/new_tab_page.mojom-shared.h"
#include "chrome/browser/ui/webui/new_tab_page/new_tab_page.mojom-forward.h"
#include "skia/public/mojom/skcolor.mojom.h"
#include "url/mojom/url.mojom.h"
#include "mojo/public/mojom/base/text_direction.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace new_tab_page {
namespace mojom {

class PageHandlerFactoryProxy;

template <typename ImplRefTraits>
class PageHandlerFactoryStub;

class PageHandlerFactoryRequestValidator;


class  PageHandlerFactory
    : public PageHandlerFactoryInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PageHandlerFactoryInterfaceBase;
  using Proxy_ = PageHandlerFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = PageHandlerFactoryStub<ImplRefTraits>;

  using RequestValidator_ = PageHandlerFactoryRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreatePageHandlerMinVersion = 0,
  };
  virtual ~PageHandlerFactory() {}

  
  virtual void CreatePageHandler(mojo::PendingRemote<Page> page, mojo::PendingReceiver<PageHandler> handler) = 0;
};

class PageHandlerProxy;

template <typename ImplRefTraits>
class PageHandlerStub;

class PageHandlerRequestValidator;
class PageHandlerResponseValidator;


class  PageHandler
    : public PageHandlerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PageHandlerInterfaceBase;
  using Proxy_ = PageHandlerProxy;

  template <typename ImplRefTraits>
  using Stub_ = PageHandlerStub<ImplRefTraits>;

  using RequestValidator_ = PageHandlerRequestValidator;
  using ResponseValidator_ = PageHandlerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kAddMostVisitedTileMinVersion = 0,
    kDeleteMostVisitedTileMinVersion = 0,
    kReorderMostVisitedTileMinVersion = 0,
    kRestoreMostVisitedDefaultsMinVersion = 0,
    kSetMostVisitedSettingsMinVersion = 0,
    kUndoMostVisitedTileActionMinVersion = 0,
    kUpdateMostVisitedInfoMinVersion = 0,
    kUpdateMostVisitedTileMinVersion = 0,
    kGetChromeThemesMinVersion = 0,
    kApplyDefaultThemeMinVersion = 0,
    kApplyAutogeneratedThemeMinVersion = 0,
    kApplyChromeThemeMinVersion = 0,
    kConfirmThemeChangesMinVersion = 0,
    kRevertThemeChangesMinVersion = 0,
    kGetBackgroundCollectionsMinVersion = 0,
    kGetBackgroundImagesMinVersion = 0,
    kFocusOmniboxMinVersion = 0,
    kPasteIntoOmniboxMinVersion = 0,
    kGetDoodleMinVersion = 0,
  };
  virtual ~PageHandler() {}


  using AddMostVisitedTileCallback = base::OnceCallback<void(bool)>;
  
  virtual void AddMostVisitedTile(const ::GURL& url, const std::string& title, AddMostVisitedTileCallback callback) = 0;

  
  virtual void DeleteMostVisitedTile(const ::GURL& url) = 0;

  
  virtual void ReorderMostVisitedTile(const ::GURL& url, uint8_t new_pos) = 0;

  
  virtual void RestoreMostVisitedDefaults() = 0;

  
  virtual void SetMostVisitedSettings(bool customLinksEnabled, bool visible) = 0;

  
  virtual void UndoMostVisitedTileAction() = 0;

  
  virtual void UpdateMostVisitedInfo() = 0;


  using UpdateMostVisitedTileCallback = base::OnceCallback<void(bool)>;
  
  virtual void UpdateMostVisitedTile(const ::GURL& url, const ::GURL& new_url, const std::string& new_title, UpdateMostVisitedTileCallback callback) = 0;


  using GetChromeThemesCallback = base::OnceCallback<void(std::vector<ChromeThemePtr>)>;
  
  virtual void GetChromeThemes(GetChromeThemesCallback callback) = 0;

  
  virtual void ApplyDefaultTheme() = 0;

  
  virtual void ApplyAutogeneratedTheme(const ::SkColor& frame_color) = 0;

  
  virtual void ApplyChromeTheme(int32_t id) = 0;

  
  virtual void ConfirmThemeChanges() = 0;

  
  virtual void RevertThemeChanges() = 0;


  using GetBackgroundCollectionsCallback = base::OnceCallback<void(std::vector<BackgroundCollectionPtr>)>;
  
  virtual void GetBackgroundCollections(GetBackgroundCollectionsCallback callback) = 0;


  using GetBackgroundImagesCallback = base::OnceCallback<void(std::vector<BackgroundImagePtr>)>;
  
  virtual void GetBackgroundImages(const std::string& collection_id, GetBackgroundImagesCallback callback) = 0;

  
  virtual void FocusOmnibox() = 0;

  
  virtual void PasteIntoOmnibox(const std::string& text) = 0;


  using GetDoodleCallback = base::OnceCallback<void(DoodlePtr)>;
  
  virtual void GetDoodle(GetDoodleCallback callback) = 0;
};

class PageProxy;

template <typename ImplRefTraits>
class PageStub;

class PageRequestValidator;


class  Page
    : public PageInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PageInterfaceBase;
  using Proxy_ = PageProxy;

  template <typename ImplRefTraits>
  using Stub_ = PageStub<ImplRefTraits>;

  using RequestValidator_ = PageRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetMostVisitedInfoMinVersion = 0,
    kSetThemeMinVersion = 0,
    kSetFakeboxFocusedMinVersion = 0,
    kSetFakeboxVisibleMinVersion = 0,
  };
  virtual ~Page() {}

  
  virtual void SetMostVisitedInfo(MostVisitedInfoPtr info) = 0;

  
  virtual void SetTheme(ThemePtr theme) = 0;

  
  virtual void SetFakeboxFocused(bool focused) = 0;

  
  virtual void SetFakeboxVisible(bool visible) = 0;
};



class  PageHandlerFactoryProxy
    : public PageHandlerFactory {
 public:
  using InterfaceType = PageHandlerFactory;

  explicit PageHandlerFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreatePageHandler(mojo::PendingRemote<Page> page, mojo::PendingReceiver<PageHandler> handler) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  PageHandlerProxy
    : public PageHandler {
 public:
  using InterfaceType = PageHandler;

  explicit PageHandlerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddMostVisitedTile(const ::GURL& url, const std::string& title, AddMostVisitedTileCallback callback) final;
  
  void DeleteMostVisitedTile(const ::GURL& url) final;
  
  void ReorderMostVisitedTile(const ::GURL& url, uint8_t new_pos) final;
  
  void RestoreMostVisitedDefaults() final;
  
  void SetMostVisitedSettings(bool customLinksEnabled, bool visible) final;
  
  void UndoMostVisitedTileAction() final;
  
  void UpdateMostVisitedInfo() final;
  
  void UpdateMostVisitedTile(const ::GURL& url, const ::GURL& new_url, const std::string& new_title, UpdateMostVisitedTileCallback callback) final;
  
  void GetChromeThemes(GetChromeThemesCallback callback) final;
  
  void ApplyDefaultTheme() final;
  
  void ApplyAutogeneratedTheme(const ::SkColor& frame_color) final;
  
  void ApplyChromeTheme(int32_t id) final;
  
  void ConfirmThemeChanges() final;
  
  void RevertThemeChanges() final;
  
  void GetBackgroundCollections(GetBackgroundCollectionsCallback callback) final;
  
  void GetBackgroundImages(const std::string& collection_id, GetBackgroundImagesCallback callback) final;
  
  void FocusOmnibox() final;
  
  void PasteIntoOmnibox(const std::string& text) final;
  
  void GetDoodle(GetDoodleCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  PageProxy
    : public Page {
 public:
  using InterfaceType = Page;

  explicit PageProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetMostVisitedInfo(MostVisitedInfoPtr info) final;
  
  void SetTheme(ThemePtr theme) final;
  
  void SetFakeboxFocused(bool focused) final;
  
  void SetFakeboxVisible(bool visible) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  PageHandlerFactoryStubDispatch {
 public:
  static bool Accept(PageHandlerFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PageHandlerFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PageHandlerFactory>>
class PageHandlerFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PageHandlerFactoryStub() {}
  ~PageHandlerFactoryStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageHandlerFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageHandlerFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  PageHandlerStubDispatch {
 public:
  static bool Accept(PageHandler* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PageHandler* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PageHandler>>
class PageHandlerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PageHandlerStub() {}
  ~PageHandlerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageHandlerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageHandlerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  PageStubDispatch {
 public:
  static bool Accept(Page* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Page* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Page>>
class PageStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PageStub() {}
  ~PageStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PageStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  PageHandlerFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  PageHandlerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  PageRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  PageHandlerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};











class  ThirdPartyThemeInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ThirdPartyThemeInfo, T>::value>;
  using DataView = ThirdPartyThemeInfoDataView;
  using Data_ = internal::ThirdPartyThemeInfo_Data;

  template <typename... Args>
  static ThirdPartyThemeInfoPtr New(Args&&... args) {
    return ThirdPartyThemeInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ThirdPartyThemeInfoPtr From(const U& u) {
    return mojo::TypeConverter<ThirdPartyThemeInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ThirdPartyThemeInfo>::Convert(*this);
  }


  ThirdPartyThemeInfo();

  ThirdPartyThemeInfo(
      const std::string& id,
      const std::string& name);

  ~ThirdPartyThemeInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ThirdPartyThemeInfoPtr>
  ThirdPartyThemeInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ThirdPartyThemeInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ThirdPartyThemeInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ThirdPartyThemeInfo_UnserializedMessageContext<
            UserType, ThirdPartyThemeInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ThirdPartyThemeInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ThirdPartyThemeInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ThirdPartyThemeInfo_UnserializedMessageContext<
            UserType, ThirdPartyThemeInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ThirdPartyThemeInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string id;
  
  std::string name;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  ThemeInfo {
 public:
  using DataView = ThemeInfoDataView;
  using Data_ = internal::ThemeInfo_Data;
  using Tag = Data_::ThemeInfo_Tag;

  static ThemeInfoPtr New() {
    return ThemeInfoPtr(base::in_place);
  }
  // Construct an instance holding |chrome_theme_id|.
  static ThemeInfoPtr
  NewChromeThemeId(
      int32_t chrome_theme_id) {
    auto result = ThemeInfoPtr(base::in_place);
    result->set_chrome_theme_id(std::move(chrome_theme_id));
    return result;
  }
  // Construct an instance holding |autogenerated_theme_colors|.
  static ThemeInfoPtr
  NewAutogeneratedThemeColors(
      ThemeColorsPtr autogenerated_theme_colors) {
    auto result = ThemeInfoPtr(base::in_place);
    result->set_autogenerated_theme_colors(std::move(autogenerated_theme_colors));
    return result;
  }
  // Construct an instance holding |third_party_theme_info|.
  static ThemeInfoPtr
  NewThirdPartyThemeInfo(
      ThirdPartyThemeInfoPtr third_party_theme_info) {
    auto result = ThemeInfoPtr(base::in_place);
    result->set_third_party_theme_info(std::move(third_party_theme_info));
    return result;
  }

  template <typename U>
  static ThemeInfoPtr From(const U& u) {
    return mojo::TypeConverter<ThemeInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ThemeInfo>::Convert(*this);
  }

  ThemeInfo();
  ~ThemeInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = ThemeInfoPtr>
  ThemeInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ThemeInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_chrome_theme_id() const { return tag_ == Tag::CHROME_THEME_ID; }

  
  int32_t get_chrome_theme_id() const {
    DCHECK(tag_ == Tag::CHROME_THEME_ID);
    return data_.chrome_theme_id;
  }

  
  void set_chrome_theme_id(
      int32_t chrome_theme_id);
  
  bool is_autogenerated_theme_colors() const { return tag_ == Tag::AUTOGENERATED_THEME_COLORS; }

  
  ThemeColorsPtr& get_autogenerated_theme_colors() const {
    DCHECK(tag_ == Tag::AUTOGENERATED_THEME_COLORS);
    return *(data_.autogenerated_theme_colors);
  }

  
  void set_autogenerated_theme_colors(
      ThemeColorsPtr autogenerated_theme_colors);
  
  bool is_third_party_theme_info() const { return tag_ == Tag::THIRD_PARTY_THEME_INFO; }

  
  ThirdPartyThemeInfoPtr& get_third_party_theme_info() const {
    DCHECK(tag_ == Tag::THIRD_PARTY_THEME_INFO);
    return *(data_.third_party_theme_info);
  }

  
  void set_third_party_theme_info(
      ThirdPartyThemeInfoPtr third_party_theme_info);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ThemeInfo::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<ThemeInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    int32_t chrome_theme_id;
    ThemeColorsPtr* autogenerated_theme_colors;
    ThirdPartyThemeInfoPtr* third_party_theme_info;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  DoodleContent {
 public:
  using DataView = DoodleContentDataView;
  using Data_ = internal::DoodleContent_Data;
  using Tag = Data_::DoodleContent_Tag;

  static DoodleContentPtr New() {
    return DoodleContentPtr(base::in_place);
  }
  // Construct an instance holding |image|.
  static DoodleContentPtr
  NewImage(
      const std::string& image) {
    auto result = DoodleContentPtr(base::in_place);
    result->set_image(std::move(image));
    return result;
  }
  // Construct an instance holding |url|.
  static DoodleContentPtr
  NewUrl(
      const ::GURL& url) {
    auto result = DoodleContentPtr(base::in_place);
    result->set_url(std::move(url));
    return result;
  }

  template <typename U>
  static DoodleContentPtr From(const U& u) {
    return mojo::TypeConverter<DoodleContentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DoodleContent>::Convert(*this);
  }

  DoodleContent();
  ~DoodleContent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = DoodleContentPtr>
  DoodleContentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, DoodleContent>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_image() const { return tag_ == Tag::IMAGE; }

  
  std::string& get_image() const {
    DCHECK(tag_ == Tag::IMAGE);
    return *(data_.image);
  }

  
  void set_image(
      const std::string& image);
  
  bool is_url() const { return tag_ == Tag::URL; }

  
  ::GURL& get_url() const {
    DCHECK(tag_ == Tag::URL);
    return *(data_.url);
  }

  
  void set_url(
      const ::GURL& url);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DoodleContent::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<DoodleContent::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    std::string* image;
    ::GURL* url;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  MostVisitedTile {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MostVisitedTile, T>::value>;
  using DataView = MostVisitedTileDataView;
  using Data_ = internal::MostVisitedTile_Data;

  template <typename... Args>
  static MostVisitedTilePtr New(Args&&... args) {
    return MostVisitedTilePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MostVisitedTilePtr From(const U& u) {
    return mojo::TypeConverter<MostVisitedTilePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MostVisitedTile>::Convert(*this);
  }


  MostVisitedTile();

  MostVisitedTile(
      const std::string& title,
      ::base::i18n::TextDirection title_direction,
      const ::GURL& url);

  ~MostVisitedTile();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MostVisitedTilePtr>
  MostVisitedTilePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MostVisitedTile::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MostVisitedTile::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MostVisitedTile::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MostVisitedTile_UnserializedMessageContext<
            UserType, MostVisitedTile::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MostVisitedTile::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MostVisitedTile::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MostVisitedTile_UnserializedMessageContext<
            UserType, MostVisitedTile::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MostVisitedTile::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string title;
  
  ::base::i18n::TextDirection title_direction;
  
  ::GURL url;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MostVisitedTile::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MostVisitedTile::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MostVisitedTile::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MostVisitedTile::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  MostVisitedInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MostVisitedInfo, T>::value>;
  using DataView = MostVisitedInfoDataView;
  using Data_ = internal::MostVisitedInfo_Data;

  template <typename... Args>
  static MostVisitedInfoPtr New(Args&&... args) {
    return MostVisitedInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MostVisitedInfoPtr From(const U& u) {
    return mojo::TypeConverter<MostVisitedInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MostVisitedInfo>::Convert(*this);
  }


  MostVisitedInfo();

  MostVisitedInfo(
      bool custom_links_enabled,
      bool visible,
      std::vector<MostVisitedTilePtr> tiles);

  ~MostVisitedInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MostVisitedInfoPtr>
  MostVisitedInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MostVisitedInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MostVisitedInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MostVisitedInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MostVisitedInfo_UnserializedMessageContext<
            UserType, MostVisitedInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MostVisitedInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MostVisitedInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MostVisitedInfo_UnserializedMessageContext<
            UserType, MostVisitedInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MostVisitedInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool custom_links_enabled;
  
  bool visible;
  
  std::vector<MostVisitedTilePtr> tiles;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(MostVisitedInfo);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MostVisitedInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MostVisitedInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MostVisitedInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MostVisitedInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ThemeColors {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ThemeColors, T>::value>;
  using DataView = ThemeColorsDataView;
  using Data_ = internal::ThemeColors_Data;

  template <typename... Args>
  static ThemeColorsPtr New(Args&&... args) {
    return ThemeColorsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ThemeColorsPtr From(const U& u) {
    return mojo::TypeConverter<ThemeColorsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ThemeColors>::Convert(*this);
  }


  ThemeColors();

  ThemeColors(
      const ::SkColor& frame,
      const ::SkColor& active_tab);

  ~ThemeColors();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ThemeColorsPtr>
  ThemeColorsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ThemeColors::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ThemeColors::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ThemeColors::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ThemeColors_UnserializedMessageContext<
            UserType, ThemeColors::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ThemeColors::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ThemeColors::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ThemeColors_UnserializedMessageContext<
            UserType, ThemeColors::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ThemeColors::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::SkColor frame;
  
  ::SkColor active_tab;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ThemeColors::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ThemeColors::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ThemeColors::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ThemeColors::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  BackgroundCollection {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BackgroundCollection, T>::value>;
  using DataView = BackgroundCollectionDataView;
  using Data_ = internal::BackgroundCollection_Data;

  template <typename... Args>
  static BackgroundCollectionPtr New(Args&&... args) {
    return BackgroundCollectionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BackgroundCollectionPtr From(const U& u) {
    return mojo::TypeConverter<BackgroundCollectionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BackgroundCollection>::Convert(*this);
  }


  BackgroundCollection();

  BackgroundCollection(
      const std::string& id,
      const std::string& label,
      const ::GURL& preview_image_url);

  ~BackgroundCollection();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BackgroundCollectionPtr>
  BackgroundCollectionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BackgroundCollection::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BackgroundCollection::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BackgroundCollection::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BackgroundCollection_UnserializedMessageContext<
            UserType, BackgroundCollection::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BackgroundCollection::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BackgroundCollection::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BackgroundCollection_UnserializedMessageContext<
            UserType, BackgroundCollection::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BackgroundCollection::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string id;
  
  std::string label;
  
  ::GURL preview_image_url;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BackgroundCollection::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BackgroundCollection::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BackgroundCollection::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BackgroundCollection::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  BackgroundImage {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BackgroundImage, T>::value>;
  using DataView = BackgroundImageDataView;
  using Data_ = internal::BackgroundImage_Data;

  template <typename... Args>
  static BackgroundImagePtr New(Args&&... args) {
    return BackgroundImagePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BackgroundImagePtr From(const U& u) {
    return mojo::TypeConverter<BackgroundImagePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BackgroundImage>::Convert(*this);
  }


  BackgroundImage();

  BackgroundImage(
      const std::string& label,
      const ::GURL& preview_image_url);

  ~BackgroundImage();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BackgroundImagePtr>
  BackgroundImagePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BackgroundImage::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BackgroundImage::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BackgroundImage::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BackgroundImage_UnserializedMessageContext<
            UserType, BackgroundImage::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BackgroundImage::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BackgroundImage::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BackgroundImage_UnserializedMessageContext<
            UserType, BackgroundImage::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BackgroundImage::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string label;
  
  ::GURL preview_image_url;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BackgroundImage::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BackgroundImage::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BackgroundImage::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BackgroundImage::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ChromeTheme {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ChromeTheme, T>::value>;
  using DataView = ChromeThemeDataView;
  using Data_ = internal::ChromeTheme_Data;

  template <typename... Args>
  static ChromeThemePtr New(Args&&... args) {
    return ChromeThemePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ChromeThemePtr From(const U& u) {
    return mojo::TypeConverter<ChromeThemePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ChromeTheme>::Convert(*this);
  }


  ChromeTheme();

  ChromeTheme(
      int32_t id,
      const std::string& label,
      ThemeColorsPtr colors);

  ~ChromeTheme();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ChromeThemePtr>
  ChromeThemePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ChromeTheme::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ChromeTheme::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ChromeTheme::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ChromeTheme_UnserializedMessageContext<
            UserType, ChromeTheme::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ChromeTheme::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ChromeTheme::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ChromeTheme_UnserializedMessageContext<
            UserType, ChromeTheme::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ChromeTheme::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t id;
  
  std::string label;
  
  ThemeColorsPtr colors;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ChromeTheme);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ChromeTheme::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ChromeTheme::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ChromeTheme::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ChromeTheme::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Theme {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Theme, T>::value>;
  using DataView = ThemeDataView;
  using Data_ = internal::Theme_Data;

  template <typename... Args>
  static ThemePtr New(Args&&... args) {
    return ThemePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ThemePtr From(const U& u) {
    return mojo::TypeConverter<ThemePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Theme>::Convert(*this);
  }


  Theme();

  Theme(
      ThemeType type,
      const ::SkColor& background_color,
      const ::SkColor& shortcut_background_color,
      const ::SkColor& shortcut_text_color,
      bool is_dark,
      const base::Optional<::SkColor>& logo_color,
      const base::Optional<::GURL>& background_image_url,
      const base::Optional<std::string>& background_image_attribution_1,
      const base::Optional<std::string>& background_image_attribution_2,
      const base::Optional<::GURL>& background_image_attribution_url,
      ThemeInfoPtr info);

  ~Theme();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ThemePtr>
  ThemePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Theme::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Theme::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Theme::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Theme_UnserializedMessageContext<
            UserType, Theme::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Theme::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Theme::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Theme_UnserializedMessageContext<
            UserType, Theme::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Theme::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ThemeType type;
  
  ::SkColor background_color;
  
  ::SkColor shortcut_background_color;
  
  ::SkColor shortcut_text_color;
  
  bool is_dark;
  
  base::Optional<::SkColor> logo_color;
  
  base::Optional<::GURL> background_image_url;
  
  base::Optional<std::string> background_image_attribution_1;
  
  base::Optional<std::string> background_image_attribution_2;
  
  base::Optional<::GURL> background_image_attribution_url;
  
  ThemeInfoPtr info;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Theme);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Theme::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Theme::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Theme::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Theme::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Doodle {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Doodle, T>::value>;
  using DataView = DoodleDataView;
  using Data_ = internal::Doodle_Data;

  template <typename... Args>
  static DoodlePtr New(Args&&... args) {
    return DoodlePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DoodlePtr From(const U& u) {
    return mojo::TypeConverter<DoodlePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Doodle>::Convert(*this);
  }


  Doodle();

  explicit Doodle(
      DoodleContentPtr content);

  ~Doodle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DoodlePtr>
  DoodlePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Doodle::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Doodle::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Doodle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Doodle_UnserializedMessageContext<
            UserType, Doodle::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Doodle::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Doodle::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Doodle_UnserializedMessageContext<
            UserType, Doodle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Doodle::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  DoodleContentPtr content;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Doodle);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Doodle::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Doodle::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Doodle::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Doodle::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
ThemeInfoPtr ThemeInfo::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::CHROME_THEME_ID:
      rv->set_chrome_theme_id(mojo::Clone(data_.chrome_theme_id));
      break;
    case Tag::AUTOGENERATED_THEME_COLORS:
      rv->set_autogenerated_theme_colors(mojo::Clone(*data_.autogenerated_theme_colors));
      break;
    case Tag::THIRD_PARTY_THEME_INFO:
      rv->set_third_party_theme_info(mojo::Clone(*data_.third_party_theme_info));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ThemeInfo>::value>::type*>
bool ThemeInfo::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::CHROME_THEME_ID:
      return mojo::Equals(data_.chrome_theme_id, other.data_.chrome_theme_id);
    case Tag::AUTOGENERATED_THEME_COLORS:
      return mojo::Equals(*(data_.autogenerated_theme_colors), *(other.data_.autogenerated_theme_colors));
    case Tag::THIRD_PARTY_THEME_INFO:
      return mojo::Equals(*(data_.third_party_theme_info), *(other.data_.third_party_theme_info));
  }

  return false;
}
template <typename UnionPtrType>
DoodleContentPtr DoodleContent::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::IMAGE:
      rv->set_image(mojo::Clone(*data_.image));
      break;
    case Tag::URL:
      rv->set_url(mojo::Clone(*data_.url));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, DoodleContent>::value>::type*>
bool DoodleContent::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::IMAGE:
      return mojo::Equals(*(data_.image), *(other.data_.image));
    case Tag::URL:
      return mojo::Equals(*(data_.url), *(other.data_.url));
  }

  return false;
}
template <typename StructPtrType>
MostVisitedTilePtr MostVisitedTile::Clone() const {
  return New(
      mojo::Clone(title),
      mojo::Clone(title_direction),
      mojo::Clone(url)
  );
}

template <typename T, MostVisitedTile::EnableIfSame<T>*>
bool MostVisitedTile::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->title, other_struct.title))
    return false;
  if (!mojo::Equals(this->title_direction, other_struct.title_direction))
    return false;
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  return true;
}

template <typename T, MostVisitedTile::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.title < rhs.title)
    return true;
  if (rhs.title < lhs.title)
    return false;
  if (lhs.title_direction < rhs.title_direction)
    return true;
  if (rhs.title_direction < lhs.title_direction)
    return false;
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  return false;
}
template <typename StructPtrType>
MostVisitedInfoPtr MostVisitedInfo::Clone() const {
  return New(
      mojo::Clone(custom_links_enabled),
      mojo::Clone(visible),
      mojo::Clone(tiles)
  );
}

template <typename T, MostVisitedInfo::EnableIfSame<T>*>
bool MostVisitedInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->custom_links_enabled, other_struct.custom_links_enabled))
    return false;
  if (!mojo::Equals(this->visible, other_struct.visible))
    return false;
  if (!mojo::Equals(this->tiles, other_struct.tiles))
    return false;
  return true;
}

template <typename T, MostVisitedInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.custom_links_enabled < rhs.custom_links_enabled)
    return true;
  if (rhs.custom_links_enabled < lhs.custom_links_enabled)
    return false;
  if (lhs.visible < rhs.visible)
    return true;
  if (rhs.visible < lhs.visible)
    return false;
  if (lhs.tiles < rhs.tiles)
    return true;
  if (rhs.tiles < lhs.tiles)
    return false;
  return false;
}
template <typename StructPtrType>
ThemeColorsPtr ThemeColors::Clone() const {
  return New(
      mojo::Clone(frame),
      mojo::Clone(active_tab)
  );
}

template <typename T, ThemeColors::EnableIfSame<T>*>
bool ThemeColors::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->frame, other_struct.frame))
    return false;
  if (!mojo::Equals(this->active_tab, other_struct.active_tab))
    return false;
  return true;
}

template <typename T, ThemeColors::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.frame < rhs.frame)
    return true;
  if (rhs.frame < lhs.frame)
    return false;
  if (lhs.active_tab < rhs.active_tab)
    return true;
  if (rhs.active_tab < lhs.active_tab)
    return false;
  return false;
}
template <typename StructPtrType>
BackgroundCollectionPtr BackgroundCollection::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(label),
      mojo::Clone(preview_image_url)
  );
}

template <typename T, BackgroundCollection::EnableIfSame<T>*>
bool BackgroundCollection::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  if (!mojo::Equals(this->preview_image_url, other_struct.preview_image_url))
    return false;
  return true;
}

template <typename T, BackgroundCollection::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.label < rhs.label)
    return true;
  if (rhs.label < lhs.label)
    return false;
  if (lhs.preview_image_url < rhs.preview_image_url)
    return true;
  if (rhs.preview_image_url < lhs.preview_image_url)
    return false;
  return false;
}
template <typename StructPtrType>
BackgroundImagePtr BackgroundImage::Clone() const {
  return New(
      mojo::Clone(label),
      mojo::Clone(preview_image_url)
  );
}

template <typename T, BackgroundImage::EnableIfSame<T>*>
bool BackgroundImage::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  if (!mojo::Equals(this->preview_image_url, other_struct.preview_image_url))
    return false;
  return true;
}

template <typename T, BackgroundImage::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.label < rhs.label)
    return true;
  if (rhs.label < lhs.label)
    return false;
  if (lhs.preview_image_url < rhs.preview_image_url)
    return true;
  if (rhs.preview_image_url < lhs.preview_image_url)
    return false;
  return false;
}
template <typename StructPtrType>
ChromeThemePtr ChromeTheme::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(label),
      mojo::Clone(colors)
  );
}

template <typename T, ChromeTheme::EnableIfSame<T>*>
bool ChromeTheme::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  if (!mojo::Equals(this->colors, other_struct.colors))
    return false;
  return true;
}

template <typename T, ChromeTheme::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.label < rhs.label)
    return true;
  if (rhs.label < lhs.label)
    return false;
  if (lhs.colors < rhs.colors)
    return true;
  if (rhs.colors < lhs.colors)
    return false;
  return false;
}
template <typename StructPtrType>
ThirdPartyThemeInfoPtr ThirdPartyThemeInfo::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(name)
  );
}

template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>*>
bool ThirdPartyThemeInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  return true;
}

template <typename T, ThirdPartyThemeInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  return false;
}
template <typename StructPtrType>
ThemePtr Theme::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(background_color),
      mojo::Clone(shortcut_background_color),
      mojo::Clone(shortcut_text_color),
      mojo::Clone(is_dark),
      mojo::Clone(logo_color),
      mojo::Clone(background_image_url),
      mojo::Clone(background_image_attribution_1),
      mojo::Clone(background_image_attribution_2),
      mojo::Clone(background_image_attribution_url),
      mojo::Clone(info)
  );
}

template <typename T, Theme::EnableIfSame<T>*>
bool Theme::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->background_color, other_struct.background_color))
    return false;
  if (!mojo::Equals(this->shortcut_background_color, other_struct.shortcut_background_color))
    return false;
  if (!mojo::Equals(this->shortcut_text_color, other_struct.shortcut_text_color))
    return false;
  if (!mojo::Equals(this->is_dark, other_struct.is_dark))
    return false;
  if (!mojo::Equals(this->logo_color, other_struct.logo_color))
    return false;
  if (!mojo::Equals(this->background_image_url, other_struct.background_image_url))
    return false;
  if (!mojo::Equals(this->background_image_attribution_1, other_struct.background_image_attribution_1))
    return false;
  if (!mojo::Equals(this->background_image_attribution_2, other_struct.background_image_attribution_2))
    return false;
  if (!mojo::Equals(this->background_image_attribution_url, other_struct.background_image_attribution_url))
    return false;
  if (!mojo::Equals(this->info, other_struct.info))
    return false;
  return true;
}

template <typename T, Theme::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.background_color < rhs.background_color)
    return true;
  if (rhs.background_color < lhs.background_color)
    return false;
  if (lhs.shortcut_background_color < rhs.shortcut_background_color)
    return true;
  if (rhs.shortcut_background_color < lhs.shortcut_background_color)
    return false;
  if (lhs.shortcut_text_color < rhs.shortcut_text_color)
    return true;
  if (rhs.shortcut_text_color < lhs.shortcut_text_color)
    return false;
  if (lhs.is_dark < rhs.is_dark)
    return true;
  if (rhs.is_dark < lhs.is_dark)
    return false;
  if (lhs.logo_color < rhs.logo_color)
    return true;
  if (rhs.logo_color < lhs.logo_color)
    return false;
  if (lhs.background_image_url < rhs.background_image_url)
    return true;
  if (rhs.background_image_url < lhs.background_image_url)
    return false;
  if (lhs.background_image_attribution_1 < rhs.background_image_attribution_1)
    return true;
  if (rhs.background_image_attribution_1 < lhs.background_image_attribution_1)
    return false;
  if (lhs.background_image_attribution_2 < rhs.background_image_attribution_2)
    return true;
  if (rhs.background_image_attribution_2 < lhs.background_image_attribution_2)
    return false;
  if (lhs.background_image_attribution_url < rhs.background_image_attribution_url)
    return true;
  if (rhs.background_image_attribution_url < lhs.background_image_attribution_url)
    return false;
  if (lhs.info < rhs.info)
    return true;
  if (rhs.info < lhs.info)
    return false;
  return false;
}
template <typename StructPtrType>
DoodlePtr Doodle::Clone() const {
  return New(
      mojo::Clone(content)
  );
}

template <typename T, Doodle::EnableIfSame<T>*>
bool Doodle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->content, other_struct.content))
    return false;
  return true;
}

template <typename T, Doodle::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.content < rhs.content)
    return true;
  if (rhs.content < lhs.content)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace new_tab_page

namespace mojo {


template <>
struct  StructTraits<::new_tab_page::mojom::MostVisitedTile::DataView,
                                         ::new_tab_page::mojom::MostVisitedTilePtr> {
  static bool IsNull(const ::new_tab_page::mojom::MostVisitedTilePtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::MostVisitedTilePtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::MostVisitedTile::title)& title(
      const ::new_tab_page::mojom::MostVisitedTilePtr& input) {
    return input->title;
  }

  static decltype(::new_tab_page::mojom::MostVisitedTile::title_direction) title_direction(
      const ::new_tab_page::mojom::MostVisitedTilePtr& input) {
    return input->title_direction;
  }

  static const decltype(::new_tab_page::mojom::MostVisitedTile::url)& url(
      const ::new_tab_page::mojom::MostVisitedTilePtr& input) {
    return input->url;
  }

  static bool Read(::new_tab_page::mojom::MostVisitedTile::DataView input, ::new_tab_page::mojom::MostVisitedTilePtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::MostVisitedInfo::DataView,
                                         ::new_tab_page::mojom::MostVisitedInfoPtr> {
  static bool IsNull(const ::new_tab_page::mojom::MostVisitedInfoPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::MostVisitedInfoPtr* output) { output->reset(); }

  static decltype(::new_tab_page::mojom::MostVisitedInfo::custom_links_enabled) custom_links_enabled(
      const ::new_tab_page::mojom::MostVisitedInfoPtr& input) {
    return input->custom_links_enabled;
  }

  static decltype(::new_tab_page::mojom::MostVisitedInfo::visible) visible(
      const ::new_tab_page::mojom::MostVisitedInfoPtr& input) {
    return input->visible;
  }

  static const decltype(::new_tab_page::mojom::MostVisitedInfo::tiles)& tiles(
      const ::new_tab_page::mojom::MostVisitedInfoPtr& input) {
    return input->tiles;
  }

  static bool Read(::new_tab_page::mojom::MostVisitedInfo::DataView input, ::new_tab_page::mojom::MostVisitedInfoPtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::ThemeColors::DataView,
                                         ::new_tab_page::mojom::ThemeColorsPtr> {
  static bool IsNull(const ::new_tab_page::mojom::ThemeColorsPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::ThemeColorsPtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::ThemeColors::frame)& frame(
      const ::new_tab_page::mojom::ThemeColorsPtr& input) {
    return input->frame;
  }

  static const decltype(::new_tab_page::mojom::ThemeColors::active_tab)& active_tab(
      const ::new_tab_page::mojom::ThemeColorsPtr& input) {
    return input->active_tab;
  }

  static bool Read(::new_tab_page::mojom::ThemeColors::DataView input, ::new_tab_page::mojom::ThemeColorsPtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::BackgroundCollection::DataView,
                                         ::new_tab_page::mojom::BackgroundCollectionPtr> {
  static bool IsNull(const ::new_tab_page::mojom::BackgroundCollectionPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::BackgroundCollectionPtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::BackgroundCollection::id)& id(
      const ::new_tab_page::mojom::BackgroundCollectionPtr& input) {
    return input->id;
  }

  static const decltype(::new_tab_page::mojom::BackgroundCollection::label)& label(
      const ::new_tab_page::mojom::BackgroundCollectionPtr& input) {
    return input->label;
  }

  static const decltype(::new_tab_page::mojom::BackgroundCollection::preview_image_url)& preview_image_url(
      const ::new_tab_page::mojom::BackgroundCollectionPtr& input) {
    return input->preview_image_url;
  }

  static bool Read(::new_tab_page::mojom::BackgroundCollection::DataView input, ::new_tab_page::mojom::BackgroundCollectionPtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::BackgroundImage::DataView,
                                         ::new_tab_page::mojom::BackgroundImagePtr> {
  static bool IsNull(const ::new_tab_page::mojom::BackgroundImagePtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::BackgroundImagePtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::BackgroundImage::label)& label(
      const ::new_tab_page::mojom::BackgroundImagePtr& input) {
    return input->label;
  }

  static const decltype(::new_tab_page::mojom::BackgroundImage::preview_image_url)& preview_image_url(
      const ::new_tab_page::mojom::BackgroundImagePtr& input) {
    return input->preview_image_url;
  }

  static bool Read(::new_tab_page::mojom::BackgroundImage::DataView input, ::new_tab_page::mojom::BackgroundImagePtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::ChromeTheme::DataView,
                                         ::new_tab_page::mojom::ChromeThemePtr> {
  static bool IsNull(const ::new_tab_page::mojom::ChromeThemePtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::ChromeThemePtr* output) { output->reset(); }

  static decltype(::new_tab_page::mojom::ChromeTheme::id) id(
      const ::new_tab_page::mojom::ChromeThemePtr& input) {
    return input->id;
  }

  static const decltype(::new_tab_page::mojom::ChromeTheme::label)& label(
      const ::new_tab_page::mojom::ChromeThemePtr& input) {
    return input->label;
  }

  static const decltype(::new_tab_page::mojom::ChromeTheme::colors)& colors(
      const ::new_tab_page::mojom::ChromeThemePtr& input) {
    return input->colors;
  }

  static bool Read(::new_tab_page::mojom::ChromeTheme::DataView input, ::new_tab_page::mojom::ChromeThemePtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::ThirdPartyThemeInfo::DataView,
                                         ::new_tab_page::mojom::ThirdPartyThemeInfoPtr> {
  static bool IsNull(const ::new_tab_page::mojom::ThirdPartyThemeInfoPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::ThirdPartyThemeInfoPtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::ThirdPartyThemeInfo::id)& id(
      const ::new_tab_page::mojom::ThirdPartyThemeInfoPtr& input) {
    return input->id;
  }

  static const decltype(::new_tab_page::mojom::ThirdPartyThemeInfo::name)& name(
      const ::new_tab_page::mojom::ThirdPartyThemeInfoPtr& input) {
    return input->name;
  }

  static bool Read(::new_tab_page::mojom::ThirdPartyThemeInfo::DataView input, ::new_tab_page::mojom::ThirdPartyThemeInfoPtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::Theme::DataView,
                                         ::new_tab_page::mojom::ThemePtr> {
  static bool IsNull(const ::new_tab_page::mojom::ThemePtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::ThemePtr* output) { output->reset(); }

  static decltype(::new_tab_page::mojom::Theme::type) type(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->type;
  }

  static const decltype(::new_tab_page::mojom::Theme::background_color)& background_color(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->background_color;
  }

  static const decltype(::new_tab_page::mojom::Theme::shortcut_background_color)& shortcut_background_color(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->shortcut_background_color;
  }

  static const decltype(::new_tab_page::mojom::Theme::shortcut_text_color)& shortcut_text_color(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->shortcut_text_color;
  }

  static decltype(::new_tab_page::mojom::Theme::is_dark) is_dark(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->is_dark;
  }

  static const decltype(::new_tab_page::mojom::Theme::logo_color)& logo_color(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->logo_color;
  }

  static const decltype(::new_tab_page::mojom::Theme::background_image_url)& background_image_url(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->background_image_url;
  }

  static const decltype(::new_tab_page::mojom::Theme::background_image_attribution_1)& background_image_attribution_1(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->background_image_attribution_1;
  }

  static const decltype(::new_tab_page::mojom::Theme::background_image_attribution_2)& background_image_attribution_2(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->background_image_attribution_2;
  }

  static const decltype(::new_tab_page::mojom::Theme::background_image_attribution_url)& background_image_attribution_url(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->background_image_attribution_url;
  }

  static const decltype(::new_tab_page::mojom::Theme::info)& info(
      const ::new_tab_page::mojom::ThemePtr& input) {
    return input->info;
  }

  static bool Read(::new_tab_page::mojom::Theme::DataView input, ::new_tab_page::mojom::ThemePtr* output);
};


template <>
struct  StructTraits<::new_tab_page::mojom::Doodle::DataView,
                                         ::new_tab_page::mojom::DoodlePtr> {
  static bool IsNull(const ::new_tab_page::mojom::DoodlePtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::DoodlePtr* output) { output->reset(); }

  static const decltype(::new_tab_page::mojom::Doodle::content)& content(
      const ::new_tab_page::mojom::DoodlePtr& input) {
    return input->content;
  }

  static bool Read(::new_tab_page::mojom::Doodle::DataView input, ::new_tab_page::mojom::DoodlePtr* output);
};


template <>
struct  UnionTraits<::new_tab_page::mojom::ThemeInfo::DataView,
                                        ::new_tab_page::mojom::ThemeInfoPtr> {
  static bool IsNull(const ::new_tab_page::mojom::ThemeInfoPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::ThemeInfoPtr* output) { output->reset(); }

  static ::new_tab_page::mojom::ThemeInfo::Tag GetTag(const ::new_tab_page::mojom::ThemeInfoPtr& input) {
    return input->which();
  }

  static  int32_t chrome_theme_id(const ::new_tab_page::mojom::ThemeInfoPtr& input) {
    return input->get_chrome_theme_id();
  }

  static const ::new_tab_page::mojom::ThemeColorsPtr& autogenerated_theme_colors(const ::new_tab_page::mojom::ThemeInfoPtr& input) {
    return input->get_autogenerated_theme_colors();
  }

  static const ::new_tab_page::mojom::ThirdPartyThemeInfoPtr& third_party_theme_info(const ::new_tab_page::mojom::ThemeInfoPtr& input) {
    return input->get_third_party_theme_info();
  }

  static bool Read(::new_tab_page::mojom::ThemeInfo::DataView input, ::new_tab_page::mojom::ThemeInfoPtr* output);
};


template <>
struct  UnionTraits<::new_tab_page::mojom::DoodleContent::DataView,
                                        ::new_tab_page::mojom::DoodleContentPtr> {
  static bool IsNull(const ::new_tab_page::mojom::DoodleContentPtr& input) { return !input; }
  static void SetToNull(::new_tab_page::mojom::DoodleContentPtr* output) { output->reset(); }

  static ::new_tab_page::mojom::DoodleContent::Tag GetTag(const ::new_tab_page::mojom::DoodleContentPtr& input) {
    return input->which();
  }

  static const std::string& image(const ::new_tab_page::mojom::DoodleContentPtr& input) {
    return input->get_image();
  }

  static const ::GURL& url(const ::new_tab_page::mojom::DoodleContentPtr& input) {
    return input->get_url();
  }

  static bool Read(::new_tab_page::mojom::DoodleContent::DataView input, ::new_tab_page::mojom::DoodleContentPtr* output);
};

}  // namespace mojo

#endif  // CHROME_BROWSER_UI_WEBUI_NEW_TAB_PAGE_NEW_TAB_PAGE_MOJOM_H_