// chrome/common/content_settings_agent.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CONTENT_SETTINGS_AGENT_MOJOM_H_
#define CHROME_COMMON_CONTENT_SETTINGS_AGENT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/content_settings_agent.mojom-shared.h"
#include "chrome/common/content_settings_agent.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace chrome {
namespace mojom {

class ContentSettingsAgentProxy;

template <typename ImplRefTraits>
class ContentSettingsAgentStub;

class ContentSettingsAgentRequestValidator;


class  ContentSettingsAgent
    : public ContentSettingsAgentInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = ContentSettingsAgentInterfaceBase;
  using Proxy_ = ContentSettingsAgentProxy;

  template <typename ImplRefTraits>
  using Stub_ = ContentSettingsAgentStub<ImplRefTraits>;

  using RequestValidator_ = ContentSettingsAgentRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetAllowRunningInsecureContentMinVersion = 0,
    kSetAsInterstitialMinVersion = 0,
    kSetDisabledMixedContentUpgradesMinVersion = 0,
  };
  virtual ~ContentSettingsAgent() {}

  
  virtual void SetAllowRunningInsecureContent() = 0;

  
  virtual void SetAsInterstitial() = 0;

  
  virtual void SetDisabledMixedContentUpgrades() = 0;
};



class  ContentSettingsAgentProxy
    : public ContentSettingsAgent {
 public:
  using InterfaceType = ContentSettingsAgent;

  explicit ContentSettingsAgentProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetAllowRunningInsecureContent() final;
  
  void SetAsInterstitial() final;
  
  void SetDisabledMixedContentUpgrades() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ContentSettingsAgentStubDispatch {
 public:
  static bool Accept(ContentSettingsAgent* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ContentSettingsAgent* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ContentSettingsAgent>>
class ContentSettingsAgentStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ContentSettingsAgentStub() {}
  ~ContentSettingsAgentStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSettingsAgentStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSettingsAgentStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ContentSettingsAgentRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#endif  // CHROME_COMMON_CONTENT_SETTINGS_AGENT_MOJOM_H_