// chrome/common/network_diagnostics.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/common/network_diagnostics.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/common/network_diagnostics.mojom-params-data.h"
#include "chrome/common/network_diagnostics.mojom-shared-message-ids.h"

#include "chrome/common/network_diagnostics.mojom-import-headers.h"


#ifndef CHROME_COMMON_NETWORK_DIAGNOSTICS_MOJOM_JUMBO_H_
#define CHROME_COMMON_NETWORK_DIAGNOSTICS_MOJOM_JUMBO_H_
#endif
namespace chrome {
namespace mojom {
const char NetworkDiagnostics::Name_[] = "chrome.mojom.NetworkDiagnostics";

NetworkDiagnosticsProxy::NetworkDiagnosticsProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void NetworkDiagnosticsProxy::RunNetworkDiagnostics(
    const ::GURL& in_failed_url) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "chrome::mojom::NetworkDiagnostics::RunNetworkDiagnostics");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kNetworkDiagnostics_RunNetworkDiagnostics_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::NetworkDiagnostics_RunNetworkDiagnostics_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->failed_url)::BaseType::BufferWriter
      failed_url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_failed_url, buffer, &failed_url_writer, &serialization_context);
  params->failed_url.Set(
      failed_url_writer.is_null() ? nullptr : failed_url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->failed_url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null failed_url in NetworkDiagnostics.RunNetworkDiagnostics request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NetworkDiagnostics::Name_);
  message.set_method_name("RunNetworkDiagnostics");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool NetworkDiagnosticsStubDispatch::Accept(
    NetworkDiagnostics* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kNetworkDiagnostics_RunNetworkDiagnostics_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)chrome::mojom::NetworkDiagnostics::RunNetworkDiagnostics",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)chrome::mojom::NetworkDiagnostics::RunNetworkDiagnostics");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::NetworkDiagnostics_RunNetworkDiagnostics_Params_Data* params =
          reinterpret_cast<internal::NetworkDiagnostics_RunNetworkDiagnostics_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_failed_url{};
      NetworkDiagnostics_RunNetworkDiagnostics_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadFailedUrl(&p_failed_url))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            NetworkDiagnostics::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->RunNetworkDiagnostics(
std::move(p_failed_url));
      return true;
    }
  }
  return false;
}

// static
bool NetworkDiagnosticsStubDispatch::AcceptWithResponder(
    NetworkDiagnostics* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kNetworkDiagnostics_RunNetworkDiagnostics_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kNetworkDiagnosticsValidationInfo[] = {
    {internal::kNetworkDiagnostics_RunNetworkDiagnostics_Name,
     {&internal::NetworkDiagnostics_RunNetworkDiagnostics_Params_Data::Validate,
      nullptr /* no response */}},
};

bool NetworkDiagnosticsRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::chrome::mojom::NetworkDiagnostics::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kNetworkDiagnosticsValidationInfo);
}

const char NetworkDiagnosticsClient::Name_[] = "chrome.mojom.NetworkDiagnosticsClient";

NetworkDiagnosticsClientProxy::NetworkDiagnosticsClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void NetworkDiagnosticsClientProxy::SetCanShowNetworkDiagnosticsDialog(
    bool in_can_show) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "chrome::mojom::NetworkDiagnosticsClient::SetCanShowNetworkDiagnosticsDialog");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kNetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::NetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->can_show = in_can_show;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NetworkDiagnosticsClient::Name_);
  message.set_method_name("SetCanShowNetworkDiagnosticsDialog");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void NetworkDiagnosticsClientProxy::DNSProbeStatus(
    int32_t in_status) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "chrome::mojom::NetworkDiagnosticsClient::DNSProbeStatus");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kNetworkDiagnosticsClient_DNSProbeStatus_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::NetworkDiagnosticsClient_DNSProbeStatus_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->status = in_status;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NetworkDiagnosticsClient::Name_);
  message.set_method_name("DNSProbeStatus");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool NetworkDiagnosticsClientStubDispatch::Accept(
    NetworkDiagnosticsClient* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kNetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)chrome::mojom::NetworkDiagnosticsClient::SetCanShowNetworkDiagnosticsDialog",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)chrome::mojom::NetworkDiagnosticsClient::SetCanShowNetworkDiagnosticsDialog");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::NetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Params_Data* params =
          reinterpret_cast<internal::NetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      bool p_can_show{};
      NetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_can_show = input_data_view.can_show();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            NetworkDiagnosticsClient::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetCanShowNetworkDiagnosticsDialog(
std::move(p_can_show));
      return true;
    }
    case internal::kNetworkDiagnosticsClient_DNSProbeStatus_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)chrome::mojom::NetworkDiagnosticsClient::DNSProbeStatus",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)chrome::mojom::NetworkDiagnosticsClient::DNSProbeStatus");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::NetworkDiagnosticsClient_DNSProbeStatus_Params_Data* params =
          reinterpret_cast<internal::NetworkDiagnosticsClient_DNSProbeStatus_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      int32_t p_status{};
      NetworkDiagnosticsClient_DNSProbeStatus_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_status = input_data_view.status();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            NetworkDiagnosticsClient::Name_, 1297192775, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DNSProbeStatus(
std::move(p_status));
      return true;
    }
  }
  return false;
}

// static
bool NetworkDiagnosticsClientStubDispatch::AcceptWithResponder(
    NetworkDiagnosticsClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kNetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Name: {
      break;
    }
    case internal::kNetworkDiagnosticsClient_DNSProbeStatus_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kNetworkDiagnosticsClientValidationInfo[] = {
    {internal::kNetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Name,
     {&internal::NetworkDiagnosticsClient_SetCanShowNetworkDiagnosticsDialog_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kNetworkDiagnosticsClient_DNSProbeStatus_Name,
     {&internal::NetworkDiagnosticsClient_DNSProbeStatus_Params_Data::Validate,
      nullptr /* no response */}},
};

bool NetworkDiagnosticsClientRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::chrome::mojom::NetworkDiagnosticsClient::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kNetworkDiagnosticsClientValidationInfo);
}

}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif