// chrome/common/search.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_SEARCH_MOJOM_H_
#define CHROME_COMMON_SEARCH_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/search.mojom-shared.h"
#include "chrome/common/search.mojom-forward.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "chrome/common/search/instant_types.h"
#include "chrome/common/search/ntp_logging_events.h"
#include "components/ntp_tiles/ntp_tile_impression.h"
#include "components/omnibox/common/omnibox_focus_state.h"




namespace chrome {
namespace mojom {

class EmbeddedSearchConnectorProxy;

template <typename ImplRefTraits>
class EmbeddedSearchConnectorStub;

class EmbeddedSearchConnectorRequestValidator;


class  EmbeddedSearchConnector
    : public EmbeddedSearchConnectorInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = EmbeddedSearchConnectorInterfaceBase;
  using Proxy_ = EmbeddedSearchConnectorProxy;

  template <typename ImplRefTraits>
  using Stub_ = EmbeddedSearchConnectorStub<ImplRefTraits>;

  using RequestValidator_ = EmbeddedSearchConnectorRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kConnectMinVersion = 0,
  };
  virtual ~EmbeddedSearchConnector() {}

  
  virtual void Connect(mojo::PendingAssociatedReceiver<EmbeddedSearch> embedded_search, mojo::PendingAssociatedRemote<EmbeddedSearchClient> client) = 0;
};

class EmbeddedSearchProxy;

template <typename ImplRefTraits>
class EmbeddedSearchStub;

class EmbeddedSearchRequestValidator;
class EmbeddedSearchResponseValidator;


class  EmbeddedSearch
    : public EmbeddedSearchInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = EmbeddedSearchInterfaceBase;
  using Proxy_ = EmbeddedSearchProxy;

  template <typename ImplRefTraits>
  using Stub_ = EmbeddedSearchStub<ImplRefTraits>;

  using RequestValidator_ = EmbeddedSearchRequestValidator;
  using ResponseValidator_ = EmbeddedSearchResponseValidator;
  enum MethodMinVersions : uint32_t {
    kFocusOmniboxMinVersion = 0,
    kDeleteMostVisitedItemMinVersion = 0,
    kUndoAllMostVisitedDeletionsMinVersion = 0,
    kUndoMostVisitedDeletionMinVersion = 0,
    kAddCustomLinkMinVersion = 0,
    kUpdateCustomLinkMinVersion = 0,
    kReorderCustomLinkMinVersion = 0,
    kDeleteCustomLinkMinVersion = 0,
    kUndoCustomLinkActionMinVersion = 0,
    kResetCustomLinksMinVersion = 0,
    kToggleMostVisitedOrCustomLinksMinVersion = 0,
    kToggleShortcutsVisibilityMinVersion = 0,
    kLogEventMinVersion = 0,
    kLogSuggestionEventWithValueMinVersion = 0,
    kLogMostVisitedImpressionMinVersion = 0,
    kLogMostVisitedNavigationMinVersion = 0,
    kPasteAndOpenDropdownMinVersion = 0,
    kSetCustomBackgroundInfoMinVersion = 0,
    kSelectLocalBackgroundImageMinVersion = 0,
    kBlocklistSearchSuggestionMinVersion = 0,
    kBlocklistSearchSuggestionWithHashMinVersion = 0,
    kSearchSuggestionSelectedMinVersion = 0,
    kOptOutOfSearchSuggestionsMinVersion = 0,
    kApplyDefaultThemeMinVersion = 0,
    kApplyAutogeneratedThemeMinVersion = 0,
    kRevertThemeChangesMinVersion = 0,
    kConfirmThemeChangesMinVersion = 0,
    kQueryAutocompleteMinVersion = 0,
    kDeleteAutocompleteMatchMinVersion = 0,
    kStopAutocompleteMinVersion = 0,
    kLogCharTypedToRepaintLatencyMinVersion = 0,
    kBlocklistPromoMinVersion = 0,
    kOpenExtensionsPageMinVersion = 0,
    kOpenAutocompleteMatchMinVersion = 0,
  };
  virtual ~EmbeddedSearch() {}

  
  virtual void FocusOmnibox(int32_t page_seq_no, bool focus) = 0;

  
  virtual void DeleteMostVisitedItem(int32_t page_seq_no, const ::GURL& url) = 0;

  
  virtual void UndoAllMostVisitedDeletions(int32_t page_seq_no) = 0;

  
  virtual void UndoMostVisitedDeletion(int32_t page_seq_no, const ::GURL& url) = 0;


  using AddCustomLinkCallback = base::OnceCallback<void(bool)>;
  
  virtual void AddCustomLink(int32_t page_seq_no, const ::GURL& url, const std::string& title, AddCustomLinkCallback callback) = 0;


  using UpdateCustomLinkCallback = base::OnceCallback<void(bool)>;
  
  virtual void UpdateCustomLink(int32_t page_seq_no, const ::GURL& url, const ::GURL& new_url, const std::string& new_title, UpdateCustomLinkCallback callback) = 0;

  
  virtual void ReorderCustomLink(int32_t page_seq_no, const ::GURL& url, int32_t new_pos) = 0;


  using DeleteCustomLinkCallback = base::OnceCallback<void(bool)>;
  
  virtual void DeleteCustomLink(int32_t page_seq_no, const ::GURL& url, DeleteCustomLinkCallback callback) = 0;

  
  virtual void UndoCustomLinkAction(int32_t page_seq_no) = 0;

  
  virtual void ResetCustomLinks(int32_t page_seq_no) = 0;

  
  virtual void ToggleMostVisitedOrCustomLinks(int32_t page_seq_no) = 0;

  
  virtual void ToggleShortcutsVisibility(int32_t page_seq_no, bool do_notify) = 0;

  
  virtual void LogEvent(int32_t page_seq_no, ::NTPLoggingEventType event, ::base::TimeDelta time) = 0;

  
  virtual void LogSuggestionEventWithValue(int32_t page_seq_no, ::NTPSuggestionsLoggingEventType event, int32_t data, ::base::TimeDelta time) = 0;

  
  virtual void LogMostVisitedImpression(int32_t page_seq_no, const ::ntp_tiles::NTPTileImpression& impression) = 0;

  
  virtual void LogMostVisitedNavigation(int32_t page_seq_no, const ::ntp_tiles::NTPTileImpression& impression) = 0;

  
  virtual void PasteAndOpenDropdown(int32_t page_seq_no, const ::base::string16& text_to_be_pasted) = 0;

  
  virtual void SetCustomBackgroundInfo(const ::GURL& background_url, const std::string& attribution_line_1, const std::string& attribution_line_2, const ::GURL& action_url, const std::string& collection_id) = 0;

  
  virtual void SelectLocalBackgroundImage() = 0;

  
  virtual void BlocklistSearchSuggestion(int32_t task_version, int64_t task_id) = 0;

  
  virtual void BlocklistSearchSuggestionWithHash(int32_t task_version, int64_t task_id, const std::vector<uint8_t>& hash) = 0;

  
  virtual void SearchSuggestionSelected(int32_t task_version, int64_t task_id, const std::vector<uint8_t>& hash) = 0;

  
  virtual void OptOutOfSearchSuggestions() = 0;

  
  virtual void ApplyDefaultTheme() = 0;

  
  virtual void ApplyAutogeneratedTheme(uint32_t color) = 0;

  
  virtual void RevertThemeChanges() = 0;

  
  virtual void ConfirmThemeChanges() = 0;

  
  virtual void QueryAutocomplete(const ::base::string16& input, bool prevent_inline_autocomplete) = 0;

  
  virtual void DeleteAutocompleteMatch(uint8_t line) = 0;

  
  virtual void StopAutocomplete(bool clear_result) = 0;

  
  virtual void LogCharTypedToRepaintLatency(uint32_t latency_ms) = 0;

  
  virtual void BlocklistPromo(const std::string& promo_id) = 0;

  
  virtual void OpenExtensionsPage(double button, bool alt_key, bool ctrl_key, bool meta_key, bool shift_key) = 0;

  
  virtual void OpenAutocompleteMatch(uint8_t line, const ::GURL& url, bool are_matches_showing, double time_elapsed_since_last_focus, double button, bool alt_key, bool ctrl_key, bool meta_key, bool shift_key) = 0;
};

class EmbeddedSearchClientProxy;

template <typename ImplRefTraits>
class EmbeddedSearchClientStub;

class EmbeddedSearchClientRequestValidator;


class  EmbeddedSearchClient
    : public EmbeddedSearchClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = EmbeddedSearchClientInterfaceBase;
  using Proxy_ = EmbeddedSearchClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = EmbeddedSearchClientStub<ImplRefTraits>;

  using RequestValidator_ = EmbeddedSearchClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAutocompleteResultChangedMinVersion = 0,
    kAutocompleteMatchImageAvailableMinVersion = 0,
    kSetPageSequenceNumberMinVersion = 0,
    kFocusChangedMinVersion = 0,
    kMostVisitedInfoChangedMinVersion = 0,
    kSetInputInProgressMinVersion = 0,
    kThemeChangedMinVersion = 0,
    kLocalBackgroundSelectedMinVersion = 0,
  };
  virtual ~EmbeddedSearchClient() {}

  
  virtual void AutocompleteResultChanged(AutocompleteResultPtr result) = 0;

  
  virtual void AutocompleteMatchImageAvailable(uint32_t match_index, const std::string& url, const std::string& data_url) = 0;

  
  virtual void SetPageSequenceNumber(int32_t page_seq_no) = 0;

  
  virtual void FocusChanged(::OmniboxFocusState new_focus_state, ::OmniboxFocusChangeReason reason) = 0;

  
  virtual void MostVisitedInfoChanged(const ::InstantMostVisitedInfo& most_visited_info) = 0;

  
  virtual void SetInputInProgress(bool input_in_progress) = 0;

  
  virtual void ThemeChanged(const ::NtpTheme& theme) = 0;

  
  virtual void LocalBackgroundSelected() = 0;
};

class SearchBouncerProxy;

template <typename ImplRefTraits>
class SearchBouncerStub;

class SearchBouncerRequestValidator;


class  SearchBouncer
    : public SearchBouncerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SearchBouncerInterfaceBase;
  using Proxy_ = SearchBouncerProxy;

  template <typename ImplRefTraits>
  using Stub_ = SearchBouncerStub<ImplRefTraits>;

  using RequestValidator_ = SearchBouncerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetNewTabPageURLMinVersion = 0,
  };
  virtual ~SearchBouncer() {}

  
  virtual void SetNewTabPageURL(const ::GURL& new_tab_page_url) = 0;
};



class  EmbeddedSearchConnectorProxy
    : public EmbeddedSearchConnector {
 public:
  using InterfaceType = EmbeddedSearchConnector;

  explicit EmbeddedSearchConnectorProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Connect(mojo::PendingAssociatedReceiver<EmbeddedSearch> embedded_search, mojo::PendingAssociatedRemote<EmbeddedSearchClient> client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  EmbeddedSearchProxy
    : public EmbeddedSearch {
 public:
  using InterfaceType = EmbeddedSearch;

  explicit EmbeddedSearchProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void FocusOmnibox(int32_t page_seq_no, bool focus) final;
  
  void DeleteMostVisitedItem(int32_t page_seq_no, const ::GURL& url) final;
  
  void UndoAllMostVisitedDeletions(int32_t page_seq_no) final;
  
  void UndoMostVisitedDeletion(int32_t page_seq_no, const ::GURL& url) final;
  
  void AddCustomLink(int32_t page_seq_no, const ::GURL& url, const std::string& title, AddCustomLinkCallback callback) final;
  
  void UpdateCustomLink(int32_t page_seq_no, const ::GURL& url, const ::GURL& new_url, const std::string& new_title, UpdateCustomLinkCallback callback) final;
  
  void ReorderCustomLink(int32_t page_seq_no, const ::GURL& url, int32_t new_pos) final;
  
  void DeleteCustomLink(int32_t page_seq_no, const ::GURL& url, DeleteCustomLinkCallback callback) final;
  
  void UndoCustomLinkAction(int32_t page_seq_no) final;
  
  void ResetCustomLinks(int32_t page_seq_no) final;
  
  void ToggleMostVisitedOrCustomLinks(int32_t page_seq_no) final;
  
  void ToggleShortcutsVisibility(int32_t page_seq_no, bool do_notify) final;
  
  void LogEvent(int32_t page_seq_no, ::NTPLoggingEventType event, ::base::TimeDelta time) final;
  
  void LogSuggestionEventWithValue(int32_t page_seq_no, ::NTPSuggestionsLoggingEventType event, int32_t data, ::base::TimeDelta time) final;
  
  void LogMostVisitedImpression(int32_t page_seq_no, const ::ntp_tiles::NTPTileImpression& impression) final;
  
  void LogMostVisitedNavigation(int32_t page_seq_no, const ::ntp_tiles::NTPTileImpression& impression) final;
  
  void PasteAndOpenDropdown(int32_t page_seq_no, const ::base::string16& text_to_be_pasted) final;
  
  void SetCustomBackgroundInfo(const ::GURL& background_url, const std::string& attribution_line_1, const std::string& attribution_line_2, const ::GURL& action_url, const std::string& collection_id) final;
  
  void SelectLocalBackgroundImage() final;
  
  void BlocklistSearchSuggestion(int32_t task_version, int64_t task_id) final;
  
  void BlocklistSearchSuggestionWithHash(int32_t task_version, int64_t task_id, const std::vector<uint8_t>& hash) final;
  
  void SearchSuggestionSelected(int32_t task_version, int64_t task_id, const std::vector<uint8_t>& hash) final;
  
  void OptOutOfSearchSuggestions() final;
  
  void ApplyDefaultTheme() final;
  
  void ApplyAutogeneratedTheme(uint32_t color) final;
  
  void RevertThemeChanges() final;
  
  void ConfirmThemeChanges() final;
  
  void QueryAutocomplete(const ::base::string16& input, bool prevent_inline_autocomplete) final;
  
  void DeleteAutocompleteMatch(uint8_t line) final;
  
  void StopAutocomplete(bool clear_result) final;
  
  void LogCharTypedToRepaintLatency(uint32_t latency_ms) final;
  
  void BlocklistPromo(const std::string& promo_id) final;
  
  void OpenExtensionsPage(double button, bool alt_key, bool ctrl_key, bool meta_key, bool shift_key) final;
  
  void OpenAutocompleteMatch(uint8_t line, const ::GURL& url, bool are_matches_showing, double time_elapsed_since_last_focus, double button, bool alt_key, bool ctrl_key, bool meta_key, bool shift_key) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  EmbeddedSearchClientProxy
    : public EmbeddedSearchClient {
 public:
  using InterfaceType = EmbeddedSearchClient;

  explicit EmbeddedSearchClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AutocompleteResultChanged(AutocompleteResultPtr result) final;
  
  void AutocompleteMatchImageAvailable(uint32_t match_index, const std::string& url, const std::string& data_url) final;
  
  void SetPageSequenceNumber(int32_t page_seq_no) final;
  
  void FocusChanged(::OmniboxFocusState new_focus_state, ::OmniboxFocusChangeReason reason) final;
  
  void MostVisitedInfoChanged(const ::InstantMostVisitedInfo& most_visited_info) final;
  
  void SetInputInProgress(bool input_in_progress) final;
  
  void ThemeChanged(const ::NtpTheme& theme) final;
  
  void LocalBackgroundSelected() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SearchBouncerProxy
    : public SearchBouncer {
 public:
  using InterfaceType = SearchBouncer;

  explicit SearchBouncerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetNewTabPageURL(const ::GURL& new_tab_page_url) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  EmbeddedSearchConnectorStubDispatch {
 public:
  static bool Accept(EmbeddedSearchConnector* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      EmbeddedSearchConnector* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<EmbeddedSearchConnector>>
class EmbeddedSearchConnectorStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  EmbeddedSearchConnectorStub() {}
  ~EmbeddedSearchConnectorStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchConnectorStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchConnectorStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  EmbeddedSearchStubDispatch {
 public:
  static bool Accept(EmbeddedSearch* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      EmbeddedSearch* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<EmbeddedSearch>>
class EmbeddedSearchStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  EmbeddedSearchStub() {}
  ~EmbeddedSearchStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  EmbeddedSearchClientStubDispatch {
 public:
  static bool Accept(EmbeddedSearchClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      EmbeddedSearchClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<EmbeddedSearchClient>>
class EmbeddedSearchClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  EmbeddedSearchClientStub() {}
  ~EmbeddedSearchClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EmbeddedSearchClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SearchBouncerStubDispatch {
 public:
  static bool Accept(SearchBouncer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SearchBouncer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SearchBouncer>>
class SearchBouncerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SearchBouncerStub() {}
  ~SearchBouncerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SearchBouncerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SearchBouncerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  EmbeddedSearchConnectorRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  EmbeddedSearchRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  EmbeddedSearchClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SearchBouncerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  EmbeddedSearchResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class  ACMatchClassification {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ACMatchClassification, T>::value>;
  using DataView = ACMatchClassificationDataView;
  using Data_ = internal::ACMatchClassification_Data;

  template <typename... Args>
  static ACMatchClassificationPtr New(Args&&... args) {
    return ACMatchClassificationPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ACMatchClassificationPtr From(const U& u) {
    return mojo::TypeConverter<ACMatchClassificationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ACMatchClassification>::Convert(*this);
  }


  ACMatchClassification();

  ACMatchClassification(
      uint32_t offset,
      int32_t style);

  ~ACMatchClassification();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ACMatchClassificationPtr>
  ACMatchClassificationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ACMatchClassification::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ACMatchClassification::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ACMatchClassification::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ACMatchClassification_UnserializedMessageContext<
            UserType, ACMatchClassification::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ACMatchClassification::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ACMatchClassification::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ACMatchClassification_UnserializedMessageContext<
            UserType, ACMatchClassification::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ACMatchClassification::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint32_t offset;
  
  int32_t style;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ACMatchClassification::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ACMatchClassification::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ACMatchClassification::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ACMatchClassification::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}














class  AutocompleteMatch {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AutocompleteMatch, T>::value>;
  using DataView = AutocompleteMatchDataView;
  using Data_ = internal::AutocompleteMatch_Data;

  template <typename... Args>
  static AutocompleteMatchPtr New(Args&&... args) {
    return AutocompleteMatchPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AutocompleteMatchPtr From(const U& u) {
    return mojo::TypeConverter<AutocompleteMatchPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AutocompleteMatch>::Convert(*this);
  }


  AutocompleteMatch();

  AutocompleteMatch(
      bool allowed_to_be_default_match,
      const ::base::string16& contents,
      std::vector<ACMatchClassificationPtr> contents_class,
      const ::base::string16& description,
      std::vector<ACMatchClassificationPtr> description_class,
      const std::string& destination_url,
      const ::base::string16& inline_autocompletion,
      const ::base::string16& fill_into_edit,
      const std::string& icon_url,
      const std::string& image_dominant_color,
      const std::string& image_url,
      bool is_search_type,
      const std::string& type,
      bool swap_contents_and_description,
      bool supports_deletion);

  ~AutocompleteMatch();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AutocompleteMatchPtr>
  AutocompleteMatchPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AutocompleteMatch::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AutocompleteMatch::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AutocompleteMatch::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AutocompleteMatch_UnserializedMessageContext<
            UserType, AutocompleteMatch::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AutocompleteMatch::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AutocompleteMatch::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AutocompleteMatch_UnserializedMessageContext<
            UserType, AutocompleteMatch::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AutocompleteMatch::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool allowed_to_be_default_match;
  
  ::base::string16 contents;
  
  std::vector<ACMatchClassificationPtr> contents_class;
  
  ::base::string16 description;
  
  std::vector<ACMatchClassificationPtr> description_class;
  
  std::string destination_url;
  
  ::base::string16 inline_autocompletion;
  
  ::base::string16 fill_into_edit;
  
  std::string icon_url;
  
  std::string image_dominant_color;
  
  std::string image_url;
  
  bool is_search_type;
  
  std::string type;
  
  bool swap_contents_and_description;
  
  bool supports_deletion;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(AutocompleteMatch);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AutocompleteMatch::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AutocompleteMatch::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AutocompleteMatch::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AutocompleteMatch::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AutocompleteResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AutocompleteResult, T>::value>;
  using DataView = AutocompleteResultDataView;
  using Data_ = internal::AutocompleteResult_Data;

  template <typename... Args>
  static AutocompleteResultPtr New(Args&&... args) {
    return AutocompleteResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AutocompleteResultPtr From(const U& u) {
    return mojo::TypeConverter<AutocompleteResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AutocompleteResult>::Convert(*this);
  }


  AutocompleteResult();

  AutocompleteResult(
      const ::base::string16& input,
      std::vector<AutocompleteMatchPtr> matches);

  ~AutocompleteResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AutocompleteResultPtr>
  AutocompleteResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AutocompleteResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AutocompleteResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AutocompleteResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AutocompleteResult_UnserializedMessageContext<
            UserType, AutocompleteResult::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AutocompleteResult::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AutocompleteResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AutocompleteResult_UnserializedMessageContext<
            UserType, AutocompleteResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AutocompleteResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::base::string16 input;
  
  std::vector<AutocompleteMatchPtr> matches;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(AutocompleteResult);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AutocompleteResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AutocompleteResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AutocompleteResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AutocompleteResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
ACMatchClassificationPtr ACMatchClassification::Clone() const {
  return New(
      mojo::Clone(offset),
      mojo::Clone(style)
  );
}

template <typename T, ACMatchClassification::EnableIfSame<T>*>
bool ACMatchClassification::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->offset, other_struct.offset))
    return false;
  if (!mojo::Equals(this->style, other_struct.style))
    return false;
  return true;
}

template <typename T, ACMatchClassification::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.offset < rhs.offset)
    return true;
  if (rhs.offset < lhs.offset)
    return false;
  if (lhs.style < rhs.style)
    return true;
  if (rhs.style < lhs.style)
    return false;
  return false;
}
template <typename StructPtrType>
AutocompleteMatchPtr AutocompleteMatch::Clone() const {
  return New(
      mojo::Clone(allowed_to_be_default_match),
      mojo::Clone(contents),
      mojo::Clone(contents_class),
      mojo::Clone(description),
      mojo::Clone(description_class),
      mojo::Clone(destination_url),
      mojo::Clone(inline_autocompletion),
      mojo::Clone(fill_into_edit),
      mojo::Clone(icon_url),
      mojo::Clone(image_dominant_color),
      mojo::Clone(image_url),
      mojo::Clone(is_search_type),
      mojo::Clone(type),
      mojo::Clone(swap_contents_and_description),
      mojo::Clone(supports_deletion)
  );
}

template <typename T, AutocompleteMatch::EnableIfSame<T>*>
bool AutocompleteMatch::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->allowed_to_be_default_match, other_struct.allowed_to_be_default_match))
    return false;
  if (!mojo::Equals(this->contents, other_struct.contents))
    return false;
  if (!mojo::Equals(this->contents_class, other_struct.contents_class))
    return false;
  if (!mojo::Equals(this->description, other_struct.description))
    return false;
  if (!mojo::Equals(this->description_class, other_struct.description_class))
    return false;
  if (!mojo::Equals(this->destination_url, other_struct.destination_url))
    return false;
  if (!mojo::Equals(this->inline_autocompletion, other_struct.inline_autocompletion))
    return false;
  if (!mojo::Equals(this->fill_into_edit, other_struct.fill_into_edit))
    return false;
  if (!mojo::Equals(this->icon_url, other_struct.icon_url))
    return false;
  if (!mojo::Equals(this->image_dominant_color, other_struct.image_dominant_color))
    return false;
  if (!mojo::Equals(this->image_url, other_struct.image_url))
    return false;
  if (!mojo::Equals(this->is_search_type, other_struct.is_search_type))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->swap_contents_and_description, other_struct.swap_contents_and_description))
    return false;
  if (!mojo::Equals(this->supports_deletion, other_struct.supports_deletion))
    return false;
  return true;
}

template <typename T, AutocompleteMatch::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.allowed_to_be_default_match < rhs.allowed_to_be_default_match)
    return true;
  if (rhs.allowed_to_be_default_match < lhs.allowed_to_be_default_match)
    return false;
  if (lhs.contents < rhs.contents)
    return true;
  if (rhs.contents < lhs.contents)
    return false;
  if (lhs.contents_class < rhs.contents_class)
    return true;
  if (rhs.contents_class < lhs.contents_class)
    return false;
  if (lhs.description < rhs.description)
    return true;
  if (rhs.description < lhs.description)
    return false;
  if (lhs.description_class < rhs.description_class)
    return true;
  if (rhs.description_class < lhs.description_class)
    return false;
  if (lhs.destination_url < rhs.destination_url)
    return true;
  if (rhs.destination_url < lhs.destination_url)
    return false;
  if (lhs.inline_autocompletion < rhs.inline_autocompletion)
    return true;
  if (rhs.inline_autocompletion < lhs.inline_autocompletion)
    return false;
  if (lhs.fill_into_edit < rhs.fill_into_edit)
    return true;
  if (rhs.fill_into_edit < lhs.fill_into_edit)
    return false;
  if (lhs.icon_url < rhs.icon_url)
    return true;
  if (rhs.icon_url < lhs.icon_url)
    return false;
  if (lhs.image_dominant_color < rhs.image_dominant_color)
    return true;
  if (rhs.image_dominant_color < lhs.image_dominant_color)
    return false;
  if (lhs.image_url < rhs.image_url)
    return true;
  if (rhs.image_url < lhs.image_url)
    return false;
  if (lhs.is_search_type < rhs.is_search_type)
    return true;
  if (rhs.is_search_type < lhs.is_search_type)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.swap_contents_and_description < rhs.swap_contents_and_description)
    return true;
  if (rhs.swap_contents_and_description < lhs.swap_contents_and_description)
    return false;
  if (lhs.supports_deletion < rhs.supports_deletion)
    return true;
  if (rhs.supports_deletion < lhs.supports_deletion)
    return false;
  return false;
}
template <typename StructPtrType>
AutocompleteResultPtr AutocompleteResult::Clone() const {
  return New(
      mojo::Clone(input),
      mojo::Clone(matches)
  );
}

template <typename T, AutocompleteResult::EnableIfSame<T>*>
bool AutocompleteResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input, other_struct.input))
    return false;
  if (!mojo::Equals(this->matches, other_struct.matches))
    return false;
  return true;
}

template <typename T, AutocompleteResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input < rhs.input)
    return true;
  if (rhs.input < lhs.input)
    return false;
  if (lhs.matches < rhs.matches)
    return true;
  if (rhs.matches < lhs.matches)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace chrome

namespace mojo {


template <>
struct  StructTraits<::chrome::mojom::ACMatchClassification::DataView,
                                         ::chrome::mojom::ACMatchClassificationPtr> {
  static bool IsNull(const ::chrome::mojom::ACMatchClassificationPtr& input) { return !input; }
  static void SetToNull(::chrome::mojom::ACMatchClassificationPtr* output) { output->reset(); }

  static decltype(::chrome::mojom::ACMatchClassification::offset) offset(
      const ::chrome::mojom::ACMatchClassificationPtr& input) {
    return input->offset;
  }

  static decltype(::chrome::mojom::ACMatchClassification::style) style(
      const ::chrome::mojom::ACMatchClassificationPtr& input) {
    return input->style;
  }

  static bool Read(::chrome::mojom::ACMatchClassification::DataView input, ::chrome::mojom::ACMatchClassificationPtr* output);
};


template <>
struct  StructTraits<::chrome::mojom::AutocompleteMatch::DataView,
                                         ::chrome::mojom::AutocompleteMatchPtr> {
  static bool IsNull(const ::chrome::mojom::AutocompleteMatchPtr& input) { return !input; }
  static void SetToNull(::chrome::mojom::AutocompleteMatchPtr* output) { output->reset(); }

  static decltype(::chrome::mojom::AutocompleteMatch::allowed_to_be_default_match) allowed_to_be_default_match(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->allowed_to_be_default_match;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::contents)& contents(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->contents;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::contents_class)& contents_class(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->contents_class;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::description)& description(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->description;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::description_class)& description_class(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->description_class;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::destination_url)& destination_url(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->destination_url;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::inline_autocompletion)& inline_autocompletion(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->inline_autocompletion;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::fill_into_edit)& fill_into_edit(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->fill_into_edit;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::icon_url)& icon_url(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->icon_url;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::image_dominant_color)& image_dominant_color(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->image_dominant_color;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::image_url)& image_url(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->image_url;
  }

  static decltype(::chrome::mojom::AutocompleteMatch::is_search_type) is_search_type(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->is_search_type;
  }

  static const decltype(::chrome::mojom::AutocompleteMatch::type)& type(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->type;
  }

  static decltype(::chrome::mojom::AutocompleteMatch::swap_contents_and_description) swap_contents_and_description(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->swap_contents_and_description;
  }

  static decltype(::chrome::mojom::AutocompleteMatch::supports_deletion) supports_deletion(
      const ::chrome::mojom::AutocompleteMatchPtr& input) {
    return input->supports_deletion;
  }

  static bool Read(::chrome::mojom::AutocompleteMatch::DataView input, ::chrome::mojom::AutocompleteMatchPtr* output);
};


template <>
struct  StructTraits<::chrome::mojom::AutocompleteResult::DataView,
                                         ::chrome::mojom::AutocompleteResultPtr> {
  static bool IsNull(const ::chrome::mojom::AutocompleteResultPtr& input) { return !input; }
  static void SetToNull(::chrome::mojom::AutocompleteResultPtr* output) { output->reset(); }

  static const decltype(::chrome::mojom::AutocompleteResult::input)& input(
      const ::chrome::mojom::AutocompleteResultPtr& input) {
    return input->input;
  }

  static const decltype(::chrome::mojom::AutocompleteResult::matches)& matches(
      const ::chrome::mojom::AutocompleteResultPtr& input) {
    return input->matches;
  }

  static bool Read(::chrome::mojom::AutocompleteResult::DataView input, ::chrome::mojom::AutocompleteResultPtr* output);
};

}  // namespace mojo

#endif  // CHROME_COMMON_SEARCH_MOJOM_H_