// chrome/common/sync_encryption_keys_extension.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/common/sync_encryption_keys_extension.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/common/sync_encryption_keys_extension.mojom-params-data.h"
#include "chrome/common/sync_encryption_keys_extension.mojom-shared-message-ids.h"

#include "chrome/common/sync_encryption_keys_extension.mojom-import-headers.h"


#ifndef CHROME_COMMON_SYNC_ENCRYPTION_KEYS_EXTENSION_MOJOM_JUMBO_H_
#define CHROME_COMMON_SYNC_ENCRYPTION_KEYS_EXTENSION_MOJOM_JUMBO_H_
#endif
namespace chrome {
namespace mojom {
const char SyncEncryptionKeysExtension::Name_[] = "chrome.mojom.SyncEncryptionKeysExtension";

class SyncEncryptionKeysExtension_SetEncryptionKeys_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  SyncEncryptionKeysExtension_SetEncryptionKeys_ForwardToCallback(
      SyncEncryptionKeysExtension::SetEncryptionKeysCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  SyncEncryptionKeysExtension::SetEncryptionKeysCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(SyncEncryptionKeysExtension_SetEncryptionKeys_ForwardToCallback);
};

SyncEncryptionKeysExtensionProxy::SyncEncryptionKeysExtensionProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SyncEncryptionKeysExtensionProxy::SetEncryptionKeys(
    const std::string& in_gaia_id, const std::vector<std::vector<uint8_t>>& in_encryption_keys, int32_t in_last_key_version, SetEncryptionKeysCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "chrome::mojom::SyncEncryptionKeysExtension::SetEncryptionKeys");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSyncEncryptionKeysExtension_SetEncryptionKeys_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::SyncEncryptionKeysExtension_SetEncryptionKeys_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->gaia_id)::BaseType::BufferWriter
      gaia_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_gaia_id, buffer, &gaia_id_writer, &serialization_context);
  params->gaia_id.Set(
      gaia_id_writer.is_null() ? nullptr : gaia_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->gaia_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null gaia_id in SyncEncryptionKeysExtension.SetEncryptionKeys request");
  typename decltype(params->encryption_keys)::BaseType::BufferWriter
      encryption_keys_writer;
  const mojo::internal::ContainerValidateParams encryption_keys_validate_params(
      0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
  mojo::internal::Serialize<mojo::ArrayDataView<mojo::ArrayDataView<uint8_t>>>(
      in_encryption_keys, buffer, &encryption_keys_writer, &encryption_keys_validate_params,
      &serialization_context);
  params->encryption_keys.Set(
      encryption_keys_writer.is_null() ? nullptr : encryption_keys_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->encryption_keys.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null encryption_keys in SyncEncryptionKeysExtension.SetEncryptionKeys request");
  params->last_key_version = in_last_key_version;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SyncEncryptionKeysExtension::Name_);
  message.set_method_name("SetEncryptionKeys");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new SyncEncryptionKeysExtension_SetEncryptionKeys_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder {
 public:
  static SyncEncryptionKeysExtension::SetEncryptionKeysCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder> proxy(
        new SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "SyncEncryptionKeysExtension::SetEncryptionKeysCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder);
};

bool SyncEncryptionKeysExtension_SetEncryptionKeys_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "chrome::mojom::SyncEncryptionKeysExtension::SetEncryptionKeysCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::SyncEncryptionKeysExtension_SetEncryptionKeys_ResponseParams_Data* params =
      reinterpret_cast<
          internal::SyncEncryptionKeysExtension_SetEncryptionKeys_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  SyncEncryptionKeysExtension_SetEncryptionKeys_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        SyncEncryptionKeysExtension::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSyncEncryptionKeysExtension_SetEncryptionKeys_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::SyncEncryptionKeysExtension_SetEncryptionKeys_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)chrome::mojom::SyncEncryptionKeysExtension::SetEncryptionKeysCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SyncEncryptionKeysExtension::Name_);
  message.set_method_name("SetEncryptionKeys");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool SyncEncryptionKeysExtensionStubDispatch::Accept(
    SyncEncryptionKeysExtension* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kSyncEncryptionKeysExtension_SetEncryptionKeys_Name: {
      break;
    }
  }
  return false;
}

// static
bool SyncEncryptionKeysExtensionStubDispatch::AcceptWithResponder(
    SyncEncryptionKeysExtension* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kSyncEncryptionKeysExtension_SetEncryptionKeys_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)chrome::mojom::SyncEncryptionKeysExtension::SetEncryptionKeys",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)chrome::mojom::SyncEncryptionKeysExtension::SetEncryptionKeys");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::SyncEncryptionKeysExtension_SetEncryptionKeys_Params_Data* params =
          reinterpret_cast<
              internal::SyncEncryptionKeysExtension_SetEncryptionKeys_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      std::string p_gaia_id{};
      std::vector<std::vector<uint8_t>> p_encryption_keys{};
      int32_t p_last_key_version{};
      SyncEncryptionKeysExtension_SetEncryptionKeys_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadGaiaId(&p_gaia_id))
        success = false;
      if (success && !input_data_view.ReadEncryptionKeys(&p_encryption_keys))
        success = false;
      if (success)
        p_last_key_version = input_data_view.last_key_version();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SyncEncryptionKeysExtension::Name_, 0, false);
        return false;
      }
      SyncEncryptionKeysExtension::SetEncryptionKeysCallback callback =
          SyncEncryptionKeysExtension_SetEncryptionKeys_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetEncryptionKeys(
std::move(p_gaia_id), 
std::move(p_encryption_keys), 
std::move(p_last_key_version), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kSyncEncryptionKeysExtensionValidationInfo[] = {
    {internal::kSyncEncryptionKeysExtension_SetEncryptionKeys_Name,
     {&internal::SyncEncryptionKeysExtension_SetEncryptionKeys_Params_Data::Validate,
      &internal::SyncEncryptionKeysExtension_SetEncryptionKeys_ResponseParams_Data::Validate}},
};

bool SyncEncryptionKeysExtensionRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::chrome::mojom::SyncEncryptionKeysExtension::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kSyncEncryptionKeysExtensionValidationInfo);
}

bool SyncEncryptionKeysExtensionResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::chrome::mojom::SyncEncryptionKeysExtension::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kSyncEncryptionKeysExtensionValidationInfo);

}
}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif