// chrome/services/app_service/public/mojom/app_service.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_TEST_UTILS_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_TEST_UTILS_H_

#include "chrome/services/app_service/public/mojom/app_service.mojom.h"


namespace apps {
namespace mojom {


class  AppServiceInterceptorForTesting : public AppService {
  virtual AppService* GetForwardingInterface() = 0;
  void RegisterPublisher(mojo::PendingRemote<Publisher> publisher, ::apps::mojom::AppType app_type) override;
  void RegisterSubscriber(mojo::PendingRemote<Subscriber> subscriber, ConnectOptionsPtr opts) override;
  void LoadIcon(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, LoadIconCallback callback) override;
  void Launch(::apps::mojom::AppType app_type, const std::string& app_id, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, int64_t display_id) override;
  void LaunchAppWithFiles(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::LaunchContainer container, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, ::apps::mojom::FilePathsPtr file_paths) override;
  void LaunchAppWithIntent(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IntentPtr intent, ::apps::mojom::LaunchSource launch_source, int64_t display_id) override;
  void SetPermission(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::PermissionPtr permission) override;
  void Uninstall(::apps::mojom::AppType app_type, const std::string& app_id, bool clear_site_data, bool report_abuse) override;
  void PauseApp(::apps::mojom::AppType app_type, const std::string& app_id) override;
  void UnpauseApps(::apps::mojom::AppType app_type, const std::string& app_id) override;
  void GetMenuModel(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::MenuType menu_type, int64_t display_id, GetMenuModelCallback callback) override;
  void OpenNativeSettings(::apps::mojom::AppType app_type, const std::string& app_id) override;
  void AddPreferredApp(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IntentFilterPtr intent_filter, ::apps::mojom::IntentPtr intent, bool from_publisher) override;
  void RemovePreferredApp(::apps::mojom::AppType app_type, const std::string& app_id) override;
  void RemovePreferredAppForFilter(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IntentFilterPtr intent_filter) override;
};
class  AppServiceAsyncWaiter {
 public:
  explicit AppServiceAsyncWaiter(AppService* proxy);
  ~AppServiceAsyncWaiter();
  void LoadIcon(
      ::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, ::apps::mojom::IconValuePtr* out_icon_value);
  void GetMenuModel(
      ::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::MenuType menu_type, int64_t display_id, ::apps::mojom::MenuItemsPtr* out_menu_items);

 private:
  AppService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AppServiceAsyncWaiter);
};


class  PublisherInterceptorForTesting : public Publisher {
  virtual Publisher* GetForwardingInterface() = 0;
  void Connect(mojo::PendingRemote<Subscriber> subscriber, ConnectOptionsPtr opts) override;
  void LoadIcon(const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, LoadIconCallback callback) override;
  void Launch(const std::string& app_id, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, int64_t display_id) override;
  void LaunchAppWithFiles(const std::string& app_id, ::apps::mojom::LaunchContainer container, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, ::apps::mojom::FilePathsPtr file_paths) override;
  void LaunchAppWithIntent(const std::string& app_id, ::apps::mojom::IntentPtr intent, ::apps::mojom::LaunchSource launch_source, int64_t display_id) override;
  void SetPermission(const std::string& app_id, ::apps::mojom::PermissionPtr permission) override;
  void Uninstall(const std::string& app_id, bool clear_site_data, bool report_abuse) override;
  void PauseApp(const std::string& app_id) override;
  void UnpauseApps(const std::string& app_id) override;
  void GetMenuModel(const std::string& app_id, ::apps::mojom::MenuType menu_type, int64_t display_id, GetMenuModelCallback callback) override;
  void OpenNativeSettings(const std::string& app_id) override;
  void OnPreferredAppSet(const std::string& app_id, ::apps::mojom::IntentFilterPtr intent_filter, ::apps::mojom::IntentPtr intent, ::apps::mojom::ReplacedAppPreferencesPtr replaced_app_preferences) override;
};
class  PublisherAsyncWaiter {
 public:
  explicit PublisherAsyncWaiter(Publisher* proxy);
  ~PublisherAsyncWaiter();
  void LoadIcon(
      const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, ::apps::mojom::IconValuePtr* out_icon_value);
  void GetMenuModel(
      const std::string& app_id, ::apps::mojom::MenuType menu_type, int64_t display_id, ::apps::mojom::MenuItemsPtr* out_menu_items);

 private:
  Publisher* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PublisherAsyncWaiter);
};


class  SubscriberInterceptorForTesting : public Subscriber {
  virtual Subscriber* GetForwardingInterface() = 0;
  void OnApps(std::vector<::apps::mojom::AppPtr> deltas) override;
  void Clone(mojo::PendingReceiver<Subscriber> receiver) override;
  void OnPreferredAppSet(const std::string& app_id, ::apps::mojom::IntentFilterPtr intent_filter) override;
  void OnPreferredAppRemoved(const std::string& app_id, ::apps::mojom::IntentFilterPtr intent_filter) override;
  void InitializePreferredApps(std::vector<::apps::mojom::PreferredAppPtr> preferred_apps) override;
};
class  SubscriberAsyncWaiter {
 public:
  explicit SubscriberAsyncWaiter(Subscriber* proxy);
  ~SubscriberAsyncWaiter();

 private:
  Subscriber* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(SubscriberAsyncWaiter);
};




}  // namespace mojom
}  // namespace apps

#endif  // CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_TEST_UTILS_H_