// chrome/services/app_service/public/mojom/types.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/services/app_service/public/mojom/types.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/app_service/public/mojom/types.mojom-params-data.h"
#include "chrome/services/app_service/public/mojom/types.mojom-shared-message-ids.h"

#include "chrome/services/app_service/public/mojom/types.mojom-import-headers.h"


#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_JUMBO_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_JUMBO_H_
#include "skia/public/mojom/bitmap_skbitmap_mojom_traits.h"
#include "skia/public/mojom/image_info_mojom_traits.h"
#include "ui/gfx/image/mojom/image_skia_mojom_traits.h"
#endif
namespace apps {
namespace mojom {
constexpr uint64_t IconKey::kDoesNotChangeOverTime;
constexpr int32_t IconKey::kInvalidResourceId;
App::App()
    : app_type(),
      app_id(),
      readiness(),
      name(),
      short_name(),
      publisher_id(),
      description(),
      version(),
      additional_search_terms(),
      icon_key(),
      last_launch_time(),
      install_time(),
      permissions(),
      install_source(),
      is_platform_app(),
      recommendable(),
      searchable(),
      show_in_launcher(),
      show_in_search(),
      show_in_management(),
      paused(),
      intent_filters() {}

App::App(
    AppType app_type_in,
    const std::string& app_id_in,
    Readiness readiness_in,
    const base::Optional<std::string>& name_in,
    const base::Optional<std::string>& short_name_in,
    const base::Optional<std::string>& publisher_id_in,
    const base::Optional<std::string>& description_in,
    const base::Optional<std::string>& version_in,
    std::vector<std::string> additional_search_terms_in,
    IconKeyPtr icon_key_in,
    base::Optional<::base::Time> last_launch_time_in,
    base::Optional<::base::Time> install_time_in,
    std::vector<PermissionPtr> permissions_in,
    InstallSource install_source_in,
    OptionalBool is_platform_app_in,
    OptionalBool recommendable_in,
    OptionalBool searchable_in,
    OptionalBool show_in_launcher_in,
    OptionalBool show_in_search_in,
    OptionalBool show_in_management_in,
    OptionalBool paused_in,
    std::vector<IntentFilterPtr> intent_filters_in)
    : app_type(std::move(app_type_in)),
      app_id(std::move(app_id_in)),
      readiness(std::move(readiness_in)),
      name(std::move(name_in)),
      short_name(std::move(short_name_in)),
      publisher_id(std::move(publisher_id_in)),
      description(std::move(description_in)),
      version(std::move(version_in)),
      additional_search_terms(std::move(additional_search_terms_in)),
      icon_key(std::move(icon_key_in)),
      last_launch_time(std::move(last_launch_time_in)),
      install_time(std::move(install_time_in)),
      permissions(std::move(permissions_in)),
      install_source(std::move(install_source_in)),
      is_platform_app(std::move(is_platform_app_in)),
      recommendable(std::move(recommendable_in)),
      searchable(std::move(searchable_in)),
      show_in_launcher(std::move(show_in_launcher_in)),
      show_in_search(std::move(show_in_search_in)),
      show_in_management(std::move(show_in_management_in)),
      paused(std::move(paused_in)),
      intent_filters(std::move(intent_filters_in)) {}

App::~App() = default;

bool App::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Permission::Permission()
    : permission_id(),
      value_type(),
      value(),
      is_managed() {}

Permission::Permission(
    uint32_t permission_id_in,
    PermissionValueType value_type_in,
    uint32_t value_in,
    bool is_managed_in)
    : permission_id(std::move(permission_id_in)),
      value_type(std::move(value_type_in)),
      value(std::move(value_in)),
      is_managed(std::move(is_managed_in)) {}

Permission::~Permission() = default;
size_t Permission::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->permission_id);
  seed = mojo::internal::Hash(seed, this->value_type);
  seed = mojo::internal::Hash(seed, this->value);
  seed = mojo::internal::Hash(seed, this->is_managed);
  return seed;
}

bool Permission::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
IconKey::IconKey()
    : timeline(),
      resource_id(),
      icon_effects() {}

IconKey::IconKey(
    uint64_t timeline_in,
    int32_t resource_id_in,
    uint32_t icon_effects_in)
    : timeline(std::move(timeline_in)),
      resource_id(std::move(resource_id_in)),
      icon_effects(std::move(icon_effects_in)) {}

IconKey::~IconKey() = default;
size_t IconKey::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->timeline);
  seed = mojo::internal::Hash(seed, this->resource_id);
  seed = mojo::internal::Hash(seed, this->icon_effects);
  return seed;
}

bool IconKey::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
IconValue::IconValue()
    : icon_compression(),
      uncompressed(),
      compressed(),
      is_placeholder_icon() {}

IconValue::IconValue(
    IconCompression icon_compression_in,
    const ::gfx::ImageSkia& uncompressed_in,
    base::Optional<std::vector<uint8_t>> compressed_in,
    bool is_placeholder_icon_in)
    : icon_compression(std::move(icon_compression_in)),
      uncompressed(std::move(uncompressed_in)),
      compressed(std::move(compressed_in)),
      is_placeholder_icon(std::move(is_placeholder_icon_in)) {}

IconValue::~IconValue() = default;

bool IconValue::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MenuItems::MenuItems()
    : items() {}

MenuItems::MenuItems(
    std::vector<MenuItemPtr> items_in)
    : items(std::move(items_in)) {}

MenuItems::~MenuItems() = default;

bool MenuItems::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MenuItem::MenuItem()
    : type(),
      command_id(),
      string_id(),
      submenu(),
      radio_group_id(),
      shortcut_id(),
      label(),
      image() {}

MenuItem::MenuItem(
    MenuItemType type_in,
    int32_t command_id_in,
    int32_t string_id_in,
    std::vector<MenuItemPtr> submenu_in,
    int32_t radio_group_id_in,
    const std::string& shortcut_id_in,
    const std::string& label_in,
    const ::gfx::ImageSkia& image_in)
    : type(std::move(type_in)),
      command_id(std::move(command_id_in)),
      string_id(std::move(string_id_in)),
      submenu(std::move(submenu_in)),
      radio_group_id(std::move(radio_group_id_in)),
      shortcut_id(std::move(shortcut_id_in)),
      label(std::move(label_in)),
      image(std::move(image_in)) {}

MenuItem::~MenuItem() = default;

bool MenuItem::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ConditionValue::ConditionValue()
    : value(),
      match_type() {}

ConditionValue::ConditionValue(
    const std::string& value_in,
    PatternMatchType match_type_in)
    : value(std::move(value_in)),
      match_type(std::move(match_type_in)) {}

ConditionValue::~ConditionValue() = default;
size_t ConditionValue::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->value);
  seed = mojo::internal::Hash(seed, this->match_type);
  return seed;
}

bool ConditionValue::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Condition::Condition()
    : condition_type(),
      condition_values() {}

Condition::Condition(
    ConditionType condition_type_in,
    std::vector<ConditionValuePtr> condition_values_in)
    : condition_type(std::move(condition_type_in)),
      condition_values(std::move(condition_values_in)) {}

Condition::~Condition() = default;

bool Condition::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
IntentFilter::IntentFilter()
    : conditions() {}

IntentFilter::IntentFilter(
    std::vector<ConditionPtr> conditions_in)
    : conditions(std::move(conditions_in)) {}

IntentFilter::~IntentFilter() = default;

bool IntentFilter::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Intent::Intent()
    : scheme(),
      host(),
      path() {}

Intent::Intent(
    const base::Optional<std::string>& scheme_in,
    const base::Optional<std::string>& host_in,
    const base::Optional<std::string>& path_in)
    : scheme(std::move(scheme_in)),
      host(std::move(host_in)),
      path(std::move(path_in)) {}

Intent::~Intent() = default;

bool Intent::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ReplacedAppPreferences::ReplacedAppPreferences()
    : replaced_preference() {}

ReplacedAppPreferences::ReplacedAppPreferences(
    base::flat_map<std::string, std::vector<IntentFilterPtr>> replaced_preference_in)
    : replaced_preference(std::move(replaced_preference_in)) {}

ReplacedAppPreferences::~ReplacedAppPreferences() = default;

bool ReplacedAppPreferences::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PreferredApp::PreferredApp()
    : intent_filter(),
      app_id() {}

PreferredApp::PreferredApp(
    IntentFilterPtr intent_filter_in,
    const std::string& app_id_in)
    : intent_filter(std::move(intent_filter_in)),
      app_id(std::move(app_id_in)) {}

PreferredApp::~PreferredApp() = default;

bool PreferredApp::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
FilePaths::FilePaths()
    : file_paths() {}

FilePaths::FilePaths(
    std::vector<::base::FilePath> file_paths_in)
    : file_paths(std::move(file_paths_in)) {}

FilePaths::~FilePaths() = default;

bool FilePaths::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace apps

namespace mojo {


// static
bool StructTraits<::apps::mojom::App::DataView, ::apps::mojom::AppPtr>::Read(
    ::apps::mojom::App::DataView input,
    ::apps::mojom::AppPtr* output) {
  bool success = true;
  ::apps::mojom::AppPtr result(::apps::mojom::App::New());
  
      if (success && !input.ReadAppType(&result->app_type))
        success = false;
      if (success && !input.ReadAppId(&result->app_id))
        success = false;
      if (success && !input.ReadReadiness(&result->readiness))
        success = false;
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadShortName(&result->short_name))
        success = false;
      if (success && !input.ReadPublisherId(&result->publisher_id))
        success = false;
      if (success && !input.ReadDescription(&result->description))
        success = false;
      if (success && !input.ReadVersion(&result->version))
        success = false;
      if (success && !input.ReadAdditionalSearchTerms(&result->additional_search_terms))
        success = false;
      if (success && !input.ReadIconKey(&result->icon_key))
        success = false;
      if (success && !input.ReadLastLaunchTime(&result->last_launch_time))
        success = false;
      if (success && !input.ReadInstallTime(&result->install_time))
        success = false;
      if (success && !input.ReadPermissions(&result->permissions))
        success = false;
      if (success && !input.ReadInstallSource(&result->install_source))
        success = false;
      if (success && !input.ReadIsPlatformApp(&result->is_platform_app))
        success = false;
      if (success && !input.ReadRecommendable(&result->recommendable))
        success = false;
      if (success && !input.ReadSearchable(&result->searchable))
        success = false;
      if (success && !input.ReadShowInLauncher(&result->show_in_launcher))
        success = false;
      if (success && !input.ReadShowInSearch(&result->show_in_search))
        success = false;
      if (success && !input.ReadShowInManagement(&result->show_in_management))
        success = false;
      if (success && !input.ReadPaused(&result->paused))
        success = false;
      if (success && !input.ReadIntentFilters(&result->intent_filters))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::Permission::DataView, ::apps::mojom::PermissionPtr>::Read(
    ::apps::mojom::Permission::DataView input,
    ::apps::mojom::PermissionPtr* output) {
  bool success = true;
  ::apps::mojom::PermissionPtr result(::apps::mojom::Permission::New());
  
      if (success)
        result->permission_id = input.permission_id();
      if (success && !input.ReadValueType(&result->value_type))
        success = false;
      if (success)
        result->value = input.value();
      if (success)
        result->is_managed = input.is_managed();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::IconKey::DataView, ::apps::mojom::IconKeyPtr>::Read(
    ::apps::mojom::IconKey::DataView input,
    ::apps::mojom::IconKeyPtr* output) {
  bool success = true;
  ::apps::mojom::IconKeyPtr result(::apps::mojom::IconKey::New());
  
      if (success)
        result->timeline = input.timeline();
      if (success)
        result->resource_id = input.resource_id();
      if (success)
        result->icon_effects = input.icon_effects();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::IconValue::DataView, ::apps::mojom::IconValuePtr>::Read(
    ::apps::mojom::IconValue::DataView input,
    ::apps::mojom::IconValuePtr* output) {
  bool success = true;
  ::apps::mojom::IconValuePtr result(::apps::mojom::IconValue::New());
  
      if (success && !input.ReadIconCompression(&result->icon_compression))
        success = false;
      if (success && !input.ReadUncompressed(&result->uncompressed))
        success = false;
      if (success && !input.ReadCompressed(&result->compressed))
        success = false;
      if (success)
        result->is_placeholder_icon = input.is_placeholder_icon();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::MenuItems::DataView, ::apps::mojom::MenuItemsPtr>::Read(
    ::apps::mojom::MenuItems::DataView input,
    ::apps::mojom::MenuItemsPtr* output) {
  bool success = true;
  ::apps::mojom::MenuItemsPtr result(::apps::mojom::MenuItems::New());
  
      if (success && !input.ReadItems(&result->items))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::MenuItem::DataView, ::apps::mojom::MenuItemPtr>::Read(
    ::apps::mojom::MenuItem::DataView input,
    ::apps::mojom::MenuItemPtr* output) {
  bool success = true;
  ::apps::mojom::MenuItemPtr result(::apps::mojom::MenuItem::New());
  
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success)
        result->command_id = input.command_id();
      if (success)
        result->string_id = input.string_id();
      if (success && !input.ReadSubmenu(&result->submenu))
        success = false;
      if (success)
        result->radio_group_id = input.radio_group_id();
      if (success && !input.ReadShortcutId(&result->shortcut_id))
        success = false;
      if (success && !input.ReadLabel(&result->label))
        success = false;
      if (success && !input.ReadImage(&result->image))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::ConditionValue::DataView, ::apps::mojom::ConditionValuePtr>::Read(
    ::apps::mojom::ConditionValue::DataView input,
    ::apps::mojom::ConditionValuePtr* output) {
  bool success = true;
  ::apps::mojom::ConditionValuePtr result(::apps::mojom::ConditionValue::New());
  
      if (success && !input.ReadValue(&result->value))
        success = false;
      if (success && !input.ReadMatchType(&result->match_type))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::Condition::DataView, ::apps::mojom::ConditionPtr>::Read(
    ::apps::mojom::Condition::DataView input,
    ::apps::mojom::ConditionPtr* output) {
  bool success = true;
  ::apps::mojom::ConditionPtr result(::apps::mojom::Condition::New());
  
      if (success && !input.ReadConditionType(&result->condition_type))
        success = false;
      if (success && !input.ReadConditionValues(&result->condition_values))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::IntentFilter::DataView, ::apps::mojom::IntentFilterPtr>::Read(
    ::apps::mojom::IntentFilter::DataView input,
    ::apps::mojom::IntentFilterPtr* output) {
  bool success = true;
  ::apps::mojom::IntentFilterPtr result(::apps::mojom::IntentFilter::New());
  
      if (success && !input.ReadConditions(&result->conditions))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::Intent::DataView, ::apps::mojom::IntentPtr>::Read(
    ::apps::mojom::Intent::DataView input,
    ::apps::mojom::IntentPtr* output) {
  bool success = true;
  ::apps::mojom::IntentPtr result(::apps::mojom::Intent::New());
  
      if (success && !input.ReadScheme(&result->scheme))
        success = false;
      if (success && !input.ReadHost(&result->host))
        success = false;
      if (success && !input.ReadPath(&result->path))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::ReplacedAppPreferences::DataView, ::apps::mojom::ReplacedAppPreferencesPtr>::Read(
    ::apps::mojom::ReplacedAppPreferences::DataView input,
    ::apps::mojom::ReplacedAppPreferencesPtr* output) {
  bool success = true;
  ::apps::mojom::ReplacedAppPreferencesPtr result(::apps::mojom::ReplacedAppPreferences::New());
  
      if (success && !input.ReadReplacedPreference(&result->replaced_preference))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::PreferredApp::DataView, ::apps::mojom::PreferredAppPtr>::Read(
    ::apps::mojom::PreferredApp::DataView input,
    ::apps::mojom::PreferredAppPtr* output) {
  bool success = true;
  ::apps::mojom::PreferredAppPtr result(::apps::mojom::PreferredApp::New());
  
      if (success && !input.ReadIntentFilter(&result->intent_filter))
        success = false;
      if (success && !input.ReadAppId(&result->app_id))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::apps::mojom::FilePaths::DataView, ::apps::mojom::FilePathsPtr>::Read(
    ::apps::mojom::FilePaths::DataView input,
    ::apps::mojom::FilePathsPtr* output) {
  bool success = true;
  ::apps::mojom::FilePathsPtr result(::apps::mojom::FilePaths::New());
  
      if (success && !input.ReadFilePaths(&result->file_paths))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif