// chrome/services/app_service/public/mojom/types.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/app_service/public/mojom/types.mojom-shared.h"
#include "chrome/services/app_service/public/mojom/types.mojom-forward.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "ui/gfx/image/mojom/image.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace apps {
namespace mojom {






class  Permission {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Permission, T>::value>;
  using DataView = PermissionDataView;
  using Data_ = internal::Permission_Data;

  template <typename... Args>
  static PermissionPtr New(Args&&... args) {
    return PermissionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PermissionPtr From(const U& u) {
    return mojo::TypeConverter<PermissionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Permission>::Convert(*this);
  }


  Permission();

  Permission(
      uint32_t permission_id,
      PermissionValueType value_type,
      uint32_t value,
      bool is_managed);

  ~Permission();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PermissionPtr>
  PermissionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Permission::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Permission::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Permission::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Permission_UnserializedMessageContext<
            UserType, Permission::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Permission::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Permission::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Permission_UnserializedMessageContext<
            UserType, Permission::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Permission::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint32_t permission_id;
  
  PermissionValueType value_type;
  
  uint32_t value;
  
  bool is_managed;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Permission::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Permission::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Permission::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Permission::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  IconKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IconKey, T>::value>;
  using DataView = IconKeyDataView;
  using Data_ = internal::IconKey_Data;
  
  static constexpr uint64_t kDoesNotChangeOverTime = 0ULL;
  
  static constexpr int32_t kInvalidResourceId = 0;

  template <typename... Args>
  static IconKeyPtr New(Args&&... args) {
    return IconKeyPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IconKeyPtr From(const U& u) {
    return mojo::TypeConverter<IconKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IconKey>::Convert(*this);
  }


  IconKey();

  IconKey(
      uint64_t timeline,
      int32_t resource_id,
      uint32_t icon_effects);

  ~IconKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IconKeyPtr>
  IconKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IconKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IconKey::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IconKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IconKey_UnserializedMessageContext<
            UserType, IconKey::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IconKey::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IconKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IconKey_UnserializedMessageContext<
            UserType, IconKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IconKey::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint64_t timeline;
  
  int32_t resource_id;
  
  uint32_t icon_effects;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IconKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IconKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IconKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IconKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class  ConditionValue {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConditionValue, T>::value>;
  using DataView = ConditionValueDataView;
  using Data_ = internal::ConditionValue_Data;

  template <typename... Args>
  static ConditionValuePtr New(Args&&... args) {
    return ConditionValuePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConditionValuePtr From(const U& u) {
    return mojo::TypeConverter<ConditionValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConditionValue>::Convert(*this);
  }


  ConditionValue();

  ConditionValue(
      const std::string& value,
      PatternMatchType match_type);

  ~ConditionValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConditionValuePtr>
  ConditionValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConditionValue::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConditionValue::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConditionValue::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConditionValue_UnserializedMessageContext<
            UserType, ConditionValue::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ConditionValue::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ConditionValue::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConditionValue_UnserializedMessageContext<
            UserType, ConditionValue::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConditionValue::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string value;
  
  PatternMatchType match_type;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConditionValue::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConditionValue::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConditionValue::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConditionValue::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  Intent {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Intent, T>::value>;
  using DataView = IntentDataView;
  using Data_ = internal::Intent_Data;

  template <typename... Args>
  static IntentPtr New(Args&&... args) {
    return IntentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IntentPtr From(const U& u) {
    return mojo::TypeConverter<IntentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Intent>::Convert(*this);
  }


  Intent();

  Intent(
      const base::Optional<std::string>& scheme,
      const base::Optional<std::string>& host,
      const base::Optional<std::string>& path);

  ~Intent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IntentPtr>
  IntentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Intent::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Intent::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Intent::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Intent_UnserializedMessageContext<
            UserType, Intent::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Intent::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Intent::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Intent_UnserializedMessageContext<
            UserType, Intent::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Intent::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  base::Optional<std::string> scheme;
  
  base::Optional<std::string> host;
  
  base::Optional<std::string> path;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Intent::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Intent::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Intent::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Intent::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}










class  App {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<App, T>::value>;
  using DataView = AppDataView;
  using Data_ = internal::App_Data;

  template <typename... Args>
  static AppPtr New(Args&&... args) {
    return AppPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AppPtr From(const U& u) {
    return mojo::TypeConverter<AppPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, App>::Convert(*this);
  }


  App();

  App(
      AppType app_type,
      const std::string& app_id,
      Readiness readiness,
      const base::Optional<std::string>& name,
      const base::Optional<std::string>& short_name,
      const base::Optional<std::string>& publisher_id,
      const base::Optional<std::string>& description,
      const base::Optional<std::string>& version,
      std::vector<std::string> additional_search_terms,
      IconKeyPtr icon_key,
      base::Optional<::base::Time> last_launch_time,
      base::Optional<::base::Time> install_time,
      std::vector<PermissionPtr> permissions,
      InstallSource install_source,
      OptionalBool is_platform_app,
      OptionalBool recommendable,
      OptionalBool searchable,
      OptionalBool show_in_launcher,
      OptionalBool show_in_search,
      OptionalBool show_in_management,
      OptionalBool paused,
      std::vector<IntentFilterPtr> intent_filters);

  ~App();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AppPtr>
  AppPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, App::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        App::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        App::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::App_UnserializedMessageContext<
            UserType, App::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<App::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return App::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::App_UnserializedMessageContext<
            UserType, App::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<App::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  AppType app_type;
  
  std::string app_id;
  
  Readiness readiness;
  
  base::Optional<std::string> name;
  
  base::Optional<std::string> short_name;
  
  base::Optional<std::string> publisher_id;
  
  base::Optional<std::string> description;
  
  base::Optional<std::string> version;
  
  std::vector<std::string> additional_search_terms;
  
  IconKeyPtr icon_key;
  
  base::Optional<::base::Time> last_launch_time;
  
  base::Optional<::base::Time> install_time;
  
  std::vector<PermissionPtr> permissions;
  
  InstallSource install_source;
  
  OptionalBool is_platform_app;
  
  OptionalBool recommendable;
  
  OptionalBool searchable;
  
  OptionalBool show_in_launcher;
  
  OptionalBool show_in_search;
  
  OptionalBool show_in_management;
  
  OptionalBool paused;
  
  std::vector<IntentFilterPtr> intent_filters;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(App);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, App::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, App::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, App::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, App::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  IconValue {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IconValue, T>::value>;
  using DataView = IconValueDataView;
  using Data_ = internal::IconValue_Data;

  template <typename... Args>
  static IconValuePtr New(Args&&... args) {
    return IconValuePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IconValuePtr From(const U& u) {
    return mojo::TypeConverter<IconValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IconValue>::Convert(*this);
  }


  IconValue();

  IconValue(
      IconCompression icon_compression,
      const ::gfx::ImageSkia& uncompressed,
      base::Optional<std::vector<uint8_t>> compressed,
      bool is_placeholder_icon);

  ~IconValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IconValuePtr>
  IconValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IconValue::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IconValue::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IconValue::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IconValue_UnserializedMessageContext<
            UserType, IconValue::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IconValue::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IconValue::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IconValue_UnserializedMessageContext<
            UserType, IconValue::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IconValue::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  IconCompression icon_compression;
  
  ::gfx::ImageSkia uncompressed;
  
  base::Optional<std::vector<uint8_t>> compressed;
  
  bool is_placeholder_icon;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IconValue::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IconValue::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IconValue::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IconValue::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  MenuItems {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MenuItems, T>::value>;
  using DataView = MenuItemsDataView;
  using Data_ = internal::MenuItems_Data;

  template <typename... Args>
  static MenuItemsPtr New(Args&&... args) {
    return MenuItemsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MenuItemsPtr From(const U& u) {
    return mojo::TypeConverter<MenuItemsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MenuItems>::Convert(*this);
  }


  MenuItems();

  explicit MenuItems(
      std::vector<MenuItemPtr> items);

  ~MenuItems();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MenuItemsPtr>
  MenuItemsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MenuItems::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MenuItems::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MenuItems::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MenuItems_UnserializedMessageContext<
            UserType, MenuItems::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MenuItems::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MenuItems::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MenuItems_UnserializedMessageContext<
            UserType, MenuItems::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MenuItems::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<MenuItemPtr> items;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(MenuItems);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MenuItems::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MenuItems::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MenuItems::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MenuItems::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  MenuItem {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MenuItem, T>::value>;
  using DataView = MenuItemDataView;
  using Data_ = internal::MenuItem_Data;

  template <typename... Args>
  static MenuItemPtr New(Args&&... args) {
    return MenuItemPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MenuItemPtr From(const U& u) {
    return mojo::TypeConverter<MenuItemPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MenuItem>::Convert(*this);
  }


  MenuItem();

  MenuItem(
      MenuItemType type,
      int32_t command_id,
      int32_t string_id,
      std::vector<MenuItemPtr> submenu,
      int32_t radio_group_id,
      const std::string& shortcut_id,
      const std::string& label,
      const ::gfx::ImageSkia& image);

  ~MenuItem();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MenuItemPtr>
  MenuItemPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MenuItem::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MenuItem::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MenuItem::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MenuItem_UnserializedMessageContext<
            UserType, MenuItem::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MenuItem::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MenuItem::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MenuItem_UnserializedMessageContext<
            UserType, MenuItem::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MenuItem::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  MenuItemType type;
  
  int32_t command_id;
  
  int32_t string_id;
  
  std::vector<MenuItemPtr> submenu;
  
  int32_t radio_group_id;
  
  std::string shortcut_id;
  
  std::string label;
  
  ::gfx::ImageSkia image;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(MenuItem);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MenuItem::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MenuItem::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MenuItem::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MenuItem::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Condition {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Condition, T>::value>;
  using DataView = ConditionDataView;
  using Data_ = internal::Condition_Data;

  template <typename... Args>
  static ConditionPtr New(Args&&... args) {
    return ConditionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConditionPtr From(const U& u) {
    return mojo::TypeConverter<ConditionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Condition>::Convert(*this);
  }


  Condition();

  Condition(
      ConditionType condition_type,
      std::vector<ConditionValuePtr> condition_values);

  ~Condition();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConditionPtr>
  ConditionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Condition::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Condition::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Condition::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Condition_UnserializedMessageContext<
            UserType, Condition::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Condition::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Condition::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Condition_UnserializedMessageContext<
            UserType, Condition::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Condition::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ConditionType condition_type;
  
  std::vector<ConditionValuePtr> condition_values;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Condition);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Condition::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Condition::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Condition::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Condition::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  IntentFilter {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IntentFilter, T>::value>;
  using DataView = IntentFilterDataView;
  using Data_ = internal::IntentFilter_Data;

  template <typename... Args>
  static IntentFilterPtr New(Args&&... args) {
    return IntentFilterPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IntentFilterPtr From(const U& u) {
    return mojo::TypeConverter<IntentFilterPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IntentFilter>::Convert(*this);
  }


  IntentFilter();

  explicit IntentFilter(
      std::vector<ConditionPtr> conditions);

  ~IntentFilter();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IntentFilterPtr>
  IntentFilterPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IntentFilter::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IntentFilter::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IntentFilter::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IntentFilter_UnserializedMessageContext<
            UserType, IntentFilter::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IntentFilter::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IntentFilter::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IntentFilter_UnserializedMessageContext<
            UserType, IntentFilter::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IntentFilter::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<ConditionPtr> conditions;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(IntentFilter);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IntentFilter::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IntentFilter::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IntentFilter::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IntentFilter::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  ReplacedAppPreferences {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ReplacedAppPreferences, T>::value>;
  using DataView = ReplacedAppPreferencesDataView;
  using Data_ = internal::ReplacedAppPreferences_Data;

  template <typename... Args>
  static ReplacedAppPreferencesPtr New(Args&&... args) {
    return ReplacedAppPreferencesPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReplacedAppPreferencesPtr From(const U& u) {
    return mojo::TypeConverter<ReplacedAppPreferencesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ReplacedAppPreferences>::Convert(*this);
  }


  ReplacedAppPreferences();

  explicit ReplacedAppPreferences(
      base::flat_map<std::string, std::vector<IntentFilterPtr>> replaced_preference);

  ~ReplacedAppPreferences();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReplacedAppPreferencesPtr>
  ReplacedAppPreferencesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ReplacedAppPreferences::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ReplacedAppPreferences::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ReplacedAppPreferences::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ReplacedAppPreferences_UnserializedMessageContext<
            UserType, ReplacedAppPreferences::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ReplacedAppPreferences::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ReplacedAppPreferences::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ReplacedAppPreferences_UnserializedMessageContext<
            UserType, ReplacedAppPreferences::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ReplacedAppPreferences::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  base::flat_map<std::string, std::vector<IntentFilterPtr>> replaced_preference;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ReplacedAppPreferences);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ReplacedAppPreferences::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ReplacedAppPreferences::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ReplacedAppPreferences::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ReplacedAppPreferences::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  PreferredApp {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PreferredApp, T>::value>;
  using DataView = PreferredAppDataView;
  using Data_ = internal::PreferredApp_Data;

  template <typename... Args>
  static PreferredAppPtr New(Args&&... args) {
    return PreferredAppPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PreferredAppPtr From(const U& u) {
    return mojo::TypeConverter<PreferredAppPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PreferredApp>::Convert(*this);
  }


  PreferredApp();

  PreferredApp(
      IntentFilterPtr intent_filter,
      const std::string& app_id);

  ~PreferredApp();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PreferredAppPtr>
  PreferredAppPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PreferredApp::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PreferredApp::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PreferredApp::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PreferredApp_UnserializedMessageContext<
            UserType, PreferredApp::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PreferredApp::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PreferredApp::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PreferredApp_UnserializedMessageContext<
            UserType, PreferredApp::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PreferredApp::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  IntentFilterPtr intent_filter;
  
  std::string app_id;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PreferredApp);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PreferredApp::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PreferredApp::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PreferredApp::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PreferredApp::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FilePaths {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilePaths, T>::value>;
  using DataView = FilePathsDataView;
  using Data_ = internal::FilePaths_Data;

  template <typename... Args>
  static FilePathsPtr New(Args&&... args) {
    return FilePathsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilePathsPtr From(const U& u) {
    return mojo::TypeConverter<FilePathsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilePaths>::Convert(*this);
  }


  FilePaths();

  explicit FilePaths(
      std::vector<::base::FilePath> file_paths);

  ~FilePaths();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilePathsPtr>
  FilePathsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilePaths::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilePaths::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilePaths::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilePaths_UnserializedMessageContext<
            UserType, FilePaths::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FilePaths::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FilePaths::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilePaths_UnserializedMessageContext<
            UserType, FilePaths::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilePaths::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<::base::FilePath> file_paths;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilePaths::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilePaths::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilePaths::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilePaths::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AppPtr App::Clone() const {
  return New(
      mojo::Clone(app_type),
      mojo::Clone(app_id),
      mojo::Clone(readiness),
      mojo::Clone(name),
      mojo::Clone(short_name),
      mojo::Clone(publisher_id),
      mojo::Clone(description),
      mojo::Clone(version),
      mojo::Clone(additional_search_terms),
      mojo::Clone(icon_key),
      mojo::Clone(last_launch_time),
      mojo::Clone(install_time),
      mojo::Clone(permissions),
      mojo::Clone(install_source),
      mojo::Clone(is_platform_app),
      mojo::Clone(recommendable),
      mojo::Clone(searchable),
      mojo::Clone(show_in_launcher),
      mojo::Clone(show_in_search),
      mojo::Clone(show_in_management),
      mojo::Clone(paused),
      mojo::Clone(intent_filters)
  );
}

template <typename T, App::EnableIfSame<T>*>
bool App::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->app_type, other_struct.app_type))
    return false;
  if (!mojo::Equals(this->app_id, other_struct.app_id))
    return false;
  if (!mojo::Equals(this->readiness, other_struct.readiness))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->short_name, other_struct.short_name))
    return false;
  if (!mojo::Equals(this->publisher_id, other_struct.publisher_id))
    return false;
  if (!mojo::Equals(this->description, other_struct.description))
    return false;
  if (!mojo::Equals(this->version, other_struct.version))
    return false;
  if (!mojo::Equals(this->additional_search_terms, other_struct.additional_search_terms))
    return false;
  if (!mojo::Equals(this->icon_key, other_struct.icon_key))
    return false;
  if (!mojo::Equals(this->last_launch_time, other_struct.last_launch_time))
    return false;
  if (!mojo::Equals(this->install_time, other_struct.install_time))
    return false;
  if (!mojo::Equals(this->permissions, other_struct.permissions))
    return false;
  if (!mojo::Equals(this->install_source, other_struct.install_source))
    return false;
  if (!mojo::Equals(this->is_platform_app, other_struct.is_platform_app))
    return false;
  if (!mojo::Equals(this->recommendable, other_struct.recommendable))
    return false;
  if (!mojo::Equals(this->searchable, other_struct.searchable))
    return false;
  if (!mojo::Equals(this->show_in_launcher, other_struct.show_in_launcher))
    return false;
  if (!mojo::Equals(this->show_in_search, other_struct.show_in_search))
    return false;
  if (!mojo::Equals(this->show_in_management, other_struct.show_in_management))
    return false;
  if (!mojo::Equals(this->paused, other_struct.paused))
    return false;
  if (!mojo::Equals(this->intent_filters, other_struct.intent_filters))
    return false;
  return true;
}

template <typename T, App::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.app_type < rhs.app_type)
    return true;
  if (rhs.app_type < lhs.app_type)
    return false;
  if (lhs.app_id < rhs.app_id)
    return true;
  if (rhs.app_id < lhs.app_id)
    return false;
  if (lhs.readiness < rhs.readiness)
    return true;
  if (rhs.readiness < lhs.readiness)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.short_name < rhs.short_name)
    return true;
  if (rhs.short_name < lhs.short_name)
    return false;
  if (lhs.publisher_id < rhs.publisher_id)
    return true;
  if (rhs.publisher_id < lhs.publisher_id)
    return false;
  if (lhs.description < rhs.description)
    return true;
  if (rhs.description < lhs.description)
    return false;
  if (lhs.version < rhs.version)
    return true;
  if (rhs.version < lhs.version)
    return false;
  if (lhs.additional_search_terms < rhs.additional_search_terms)
    return true;
  if (rhs.additional_search_terms < lhs.additional_search_terms)
    return false;
  if (lhs.icon_key < rhs.icon_key)
    return true;
  if (rhs.icon_key < lhs.icon_key)
    return false;
  if (lhs.last_launch_time < rhs.last_launch_time)
    return true;
  if (rhs.last_launch_time < lhs.last_launch_time)
    return false;
  if (lhs.install_time < rhs.install_time)
    return true;
  if (rhs.install_time < lhs.install_time)
    return false;
  if (lhs.permissions < rhs.permissions)
    return true;
  if (rhs.permissions < lhs.permissions)
    return false;
  if (lhs.install_source < rhs.install_source)
    return true;
  if (rhs.install_source < lhs.install_source)
    return false;
  if (lhs.is_platform_app < rhs.is_platform_app)
    return true;
  if (rhs.is_platform_app < lhs.is_platform_app)
    return false;
  if (lhs.recommendable < rhs.recommendable)
    return true;
  if (rhs.recommendable < lhs.recommendable)
    return false;
  if (lhs.searchable < rhs.searchable)
    return true;
  if (rhs.searchable < lhs.searchable)
    return false;
  if (lhs.show_in_launcher < rhs.show_in_launcher)
    return true;
  if (rhs.show_in_launcher < lhs.show_in_launcher)
    return false;
  if (lhs.show_in_search < rhs.show_in_search)
    return true;
  if (rhs.show_in_search < lhs.show_in_search)
    return false;
  if (lhs.show_in_management < rhs.show_in_management)
    return true;
  if (rhs.show_in_management < lhs.show_in_management)
    return false;
  if (lhs.paused < rhs.paused)
    return true;
  if (rhs.paused < lhs.paused)
    return false;
  if (lhs.intent_filters < rhs.intent_filters)
    return true;
  if (rhs.intent_filters < lhs.intent_filters)
    return false;
  return false;
}
template <typename StructPtrType>
PermissionPtr Permission::Clone() const {
  return New(
      mojo::Clone(permission_id),
      mojo::Clone(value_type),
      mojo::Clone(value),
      mojo::Clone(is_managed)
  );
}

template <typename T, Permission::EnableIfSame<T>*>
bool Permission::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->permission_id, other_struct.permission_id))
    return false;
  if (!mojo::Equals(this->value_type, other_struct.value_type))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  if (!mojo::Equals(this->is_managed, other_struct.is_managed))
    return false;
  return true;
}

template <typename T, Permission::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.permission_id < rhs.permission_id)
    return true;
  if (rhs.permission_id < lhs.permission_id)
    return false;
  if (lhs.value_type < rhs.value_type)
    return true;
  if (rhs.value_type < lhs.value_type)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  if (lhs.is_managed < rhs.is_managed)
    return true;
  if (rhs.is_managed < lhs.is_managed)
    return false;
  return false;
}
template <typename StructPtrType>
IconKeyPtr IconKey::Clone() const {
  return New(
      mojo::Clone(timeline),
      mojo::Clone(resource_id),
      mojo::Clone(icon_effects)
  );
}

template <typename T, IconKey::EnableIfSame<T>*>
bool IconKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->timeline, other_struct.timeline))
    return false;
  if (!mojo::Equals(this->resource_id, other_struct.resource_id))
    return false;
  if (!mojo::Equals(this->icon_effects, other_struct.icon_effects))
    return false;
  return true;
}

template <typename T, IconKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.timeline < rhs.timeline)
    return true;
  if (rhs.timeline < lhs.timeline)
    return false;
  if (lhs.resource_id < rhs.resource_id)
    return true;
  if (rhs.resource_id < lhs.resource_id)
    return false;
  if (lhs.icon_effects < rhs.icon_effects)
    return true;
  if (rhs.icon_effects < lhs.icon_effects)
    return false;
  return false;
}
template <typename StructPtrType>
IconValuePtr IconValue::Clone() const {
  return New(
      mojo::Clone(icon_compression),
      mojo::Clone(uncompressed),
      mojo::Clone(compressed),
      mojo::Clone(is_placeholder_icon)
  );
}

template <typename T, IconValue::EnableIfSame<T>*>
bool IconValue::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->icon_compression, other_struct.icon_compression))
    return false;
  if (!mojo::Equals(this->uncompressed, other_struct.uncompressed))
    return false;
  if (!mojo::Equals(this->compressed, other_struct.compressed))
    return false;
  if (!mojo::Equals(this->is_placeholder_icon, other_struct.is_placeholder_icon))
    return false;
  return true;
}

template <typename T, IconValue::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.icon_compression < rhs.icon_compression)
    return true;
  if (rhs.icon_compression < lhs.icon_compression)
    return false;
  if (lhs.uncompressed < rhs.uncompressed)
    return true;
  if (rhs.uncompressed < lhs.uncompressed)
    return false;
  if (lhs.compressed < rhs.compressed)
    return true;
  if (rhs.compressed < lhs.compressed)
    return false;
  if (lhs.is_placeholder_icon < rhs.is_placeholder_icon)
    return true;
  if (rhs.is_placeholder_icon < lhs.is_placeholder_icon)
    return false;
  return false;
}
template <typename StructPtrType>
MenuItemsPtr MenuItems::Clone() const {
  return New(
      mojo::Clone(items)
  );
}

template <typename T, MenuItems::EnableIfSame<T>*>
bool MenuItems::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->items, other_struct.items))
    return false;
  return true;
}

template <typename T, MenuItems::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.items < rhs.items)
    return true;
  if (rhs.items < lhs.items)
    return false;
  return false;
}
template <typename StructPtrType>
MenuItemPtr MenuItem::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(command_id),
      mojo::Clone(string_id),
      mojo::Clone(submenu),
      mojo::Clone(radio_group_id),
      mojo::Clone(shortcut_id),
      mojo::Clone(label),
      mojo::Clone(image)
  );
}

template <typename T, MenuItem::EnableIfSame<T>*>
bool MenuItem::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->command_id, other_struct.command_id))
    return false;
  if (!mojo::Equals(this->string_id, other_struct.string_id))
    return false;
  if (!mojo::Equals(this->submenu, other_struct.submenu))
    return false;
  if (!mojo::Equals(this->radio_group_id, other_struct.radio_group_id))
    return false;
  if (!mojo::Equals(this->shortcut_id, other_struct.shortcut_id))
    return false;
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  if (!mojo::Equals(this->image, other_struct.image))
    return false;
  return true;
}

template <typename T, MenuItem::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.command_id < rhs.command_id)
    return true;
  if (rhs.command_id < lhs.command_id)
    return false;
  if (lhs.string_id < rhs.string_id)
    return true;
  if (rhs.string_id < lhs.string_id)
    return false;
  if (lhs.submenu < rhs.submenu)
    return true;
  if (rhs.submenu < lhs.submenu)
    return false;
  if (lhs.radio_group_id < rhs.radio_group_id)
    return true;
  if (rhs.radio_group_id < lhs.radio_group_id)
    return false;
  if (lhs.shortcut_id < rhs.shortcut_id)
    return true;
  if (rhs.shortcut_id < lhs.shortcut_id)
    return false;
  if (lhs.label < rhs.label)
    return true;
  if (rhs.label < lhs.label)
    return false;
  if (lhs.image < rhs.image)
    return true;
  if (rhs.image < lhs.image)
    return false;
  return false;
}
template <typename StructPtrType>
ConditionValuePtr ConditionValue::Clone() const {
  return New(
      mojo::Clone(value),
      mojo::Clone(match_type)
  );
}

template <typename T, ConditionValue::EnableIfSame<T>*>
bool ConditionValue::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  if (!mojo::Equals(this->match_type, other_struct.match_type))
    return false;
  return true;
}

template <typename T, ConditionValue::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  if (lhs.match_type < rhs.match_type)
    return true;
  if (rhs.match_type < lhs.match_type)
    return false;
  return false;
}
template <typename StructPtrType>
ConditionPtr Condition::Clone() const {
  return New(
      mojo::Clone(condition_type),
      mojo::Clone(condition_values)
  );
}

template <typename T, Condition::EnableIfSame<T>*>
bool Condition::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->condition_type, other_struct.condition_type))
    return false;
  if (!mojo::Equals(this->condition_values, other_struct.condition_values))
    return false;
  return true;
}

template <typename T, Condition::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.condition_type < rhs.condition_type)
    return true;
  if (rhs.condition_type < lhs.condition_type)
    return false;
  if (lhs.condition_values < rhs.condition_values)
    return true;
  if (rhs.condition_values < lhs.condition_values)
    return false;
  return false;
}
template <typename StructPtrType>
IntentFilterPtr IntentFilter::Clone() const {
  return New(
      mojo::Clone(conditions)
  );
}

template <typename T, IntentFilter::EnableIfSame<T>*>
bool IntentFilter::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->conditions, other_struct.conditions))
    return false;
  return true;
}

template <typename T, IntentFilter::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.conditions < rhs.conditions)
    return true;
  if (rhs.conditions < lhs.conditions)
    return false;
  return false;
}
template <typename StructPtrType>
IntentPtr Intent::Clone() const {
  return New(
      mojo::Clone(scheme),
      mojo::Clone(host),
      mojo::Clone(path)
  );
}

template <typename T, Intent::EnableIfSame<T>*>
bool Intent::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->scheme, other_struct.scheme))
    return false;
  if (!mojo::Equals(this->host, other_struct.host))
    return false;
  if (!mojo::Equals(this->path, other_struct.path))
    return false;
  return true;
}

template <typename T, Intent::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.scheme < rhs.scheme)
    return true;
  if (rhs.scheme < lhs.scheme)
    return false;
  if (lhs.host < rhs.host)
    return true;
  if (rhs.host < lhs.host)
    return false;
  if (lhs.path < rhs.path)
    return true;
  if (rhs.path < lhs.path)
    return false;
  return false;
}
template <typename StructPtrType>
ReplacedAppPreferencesPtr ReplacedAppPreferences::Clone() const {
  return New(
      mojo::Clone(replaced_preference)
  );
}

template <typename T, ReplacedAppPreferences::EnableIfSame<T>*>
bool ReplacedAppPreferences::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->replaced_preference, other_struct.replaced_preference))
    return false;
  return true;
}

template <typename T, ReplacedAppPreferences::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.replaced_preference < rhs.replaced_preference)
    return true;
  if (rhs.replaced_preference < lhs.replaced_preference)
    return false;
  return false;
}
template <typename StructPtrType>
PreferredAppPtr PreferredApp::Clone() const {
  return New(
      mojo::Clone(intent_filter),
      mojo::Clone(app_id)
  );
}

template <typename T, PreferredApp::EnableIfSame<T>*>
bool PreferredApp::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->intent_filter, other_struct.intent_filter))
    return false;
  if (!mojo::Equals(this->app_id, other_struct.app_id))
    return false;
  return true;
}

template <typename T, PreferredApp::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.intent_filter < rhs.intent_filter)
    return true;
  if (rhs.intent_filter < lhs.intent_filter)
    return false;
  if (lhs.app_id < rhs.app_id)
    return true;
  if (rhs.app_id < lhs.app_id)
    return false;
  return false;
}
template <typename StructPtrType>
FilePathsPtr FilePaths::Clone() const {
  return New(
      mojo::Clone(file_paths)
  );
}

template <typename T, FilePaths::EnableIfSame<T>*>
bool FilePaths::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->file_paths, other_struct.file_paths))
    return false;
  return true;
}

template <typename T, FilePaths::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.file_paths < rhs.file_paths)
    return true;
  if (rhs.file_paths < lhs.file_paths)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace apps

namespace mojo {


template <>
struct  StructTraits<::apps::mojom::App::DataView,
                                         ::apps::mojom::AppPtr> {
  static bool IsNull(const ::apps::mojom::AppPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::AppPtr* output) { output->reset(); }

  static decltype(::apps::mojom::App::app_type) app_type(
      const ::apps::mojom::AppPtr& input) {
    return input->app_type;
  }

  static const decltype(::apps::mojom::App::app_id)& app_id(
      const ::apps::mojom::AppPtr& input) {
    return input->app_id;
  }

  static decltype(::apps::mojom::App::readiness) readiness(
      const ::apps::mojom::AppPtr& input) {
    return input->readiness;
  }

  static const decltype(::apps::mojom::App::name)& name(
      const ::apps::mojom::AppPtr& input) {
    return input->name;
  }

  static const decltype(::apps::mojom::App::short_name)& short_name(
      const ::apps::mojom::AppPtr& input) {
    return input->short_name;
  }

  static const decltype(::apps::mojom::App::publisher_id)& publisher_id(
      const ::apps::mojom::AppPtr& input) {
    return input->publisher_id;
  }

  static const decltype(::apps::mojom::App::description)& description(
      const ::apps::mojom::AppPtr& input) {
    return input->description;
  }

  static const decltype(::apps::mojom::App::version)& version(
      const ::apps::mojom::AppPtr& input) {
    return input->version;
  }

  static const decltype(::apps::mojom::App::additional_search_terms)& additional_search_terms(
      const ::apps::mojom::AppPtr& input) {
    return input->additional_search_terms;
  }

  static const decltype(::apps::mojom::App::icon_key)& icon_key(
      const ::apps::mojom::AppPtr& input) {
    return input->icon_key;
  }

  static const decltype(::apps::mojom::App::last_launch_time)& last_launch_time(
      const ::apps::mojom::AppPtr& input) {
    return input->last_launch_time;
  }

  static const decltype(::apps::mojom::App::install_time)& install_time(
      const ::apps::mojom::AppPtr& input) {
    return input->install_time;
  }

  static const decltype(::apps::mojom::App::permissions)& permissions(
      const ::apps::mojom::AppPtr& input) {
    return input->permissions;
  }

  static decltype(::apps::mojom::App::install_source) install_source(
      const ::apps::mojom::AppPtr& input) {
    return input->install_source;
  }

  static decltype(::apps::mojom::App::is_platform_app) is_platform_app(
      const ::apps::mojom::AppPtr& input) {
    return input->is_platform_app;
  }

  static decltype(::apps::mojom::App::recommendable) recommendable(
      const ::apps::mojom::AppPtr& input) {
    return input->recommendable;
  }

  static decltype(::apps::mojom::App::searchable) searchable(
      const ::apps::mojom::AppPtr& input) {
    return input->searchable;
  }

  static decltype(::apps::mojom::App::show_in_launcher) show_in_launcher(
      const ::apps::mojom::AppPtr& input) {
    return input->show_in_launcher;
  }

  static decltype(::apps::mojom::App::show_in_search) show_in_search(
      const ::apps::mojom::AppPtr& input) {
    return input->show_in_search;
  }

  static decltype(::apps::mojom::App::show_in_management) show_in_management(
      const ::apps::mojom::AppPtr& input) {
    return input->show_in_management;
  }

  static decltype(::apps::mojom::App::paused) paused(
      const ::apps::mojom::AppPtr& input) {
    return input->paused;
  }

  static const decltype(::apps::mojom::App::intent_filters)& intent_filters(
      const ::apps::mojom::AppPtr& input) {
    return input->intent_filters;
  }

  static bool Read(::apps::mojom::App::DataView input, ::apps::mojom::AppPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::Permission::DataView,
                                         ::apps::mojom::PermissionPtr> {
  static bool IsNull(const ::apps::mojom::PermissionPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::PermissionPtr* output) { output->reset(); }

  static decltype(::apps::mojom::Permission::permission_id) permission_id(
      const ::apps::mojom::PermissionPtr& input) {
    return input->permission_id;
  }

  static decltype(::apps::mojom::Permission::value_type) value_type(
      const ::apps::mojom::PermissionPtr& input) {
    return input->value_type;
  }

  static decltype(::apps::mojom::Permission::value) value(
      const ::apps::mojom::PermissionPtr& input) {
    return input->value;
  }

  static decltype(::apps::mojom::Permission::is_managed) is_managed(
      const ::apps::mojom::PermissionPtr& input) {
    return input->is_managed;
  }

  static bool Read(::apps::mojom::Permission::DataView input, ::apps::mojom::PermissionPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::IconKey::DataView,
                                         ::apps::mojom::IconKeyPtr> {
  static bool IsNull(const ::apps::mojom::IconKeyPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::IconKeyPtr* output) { output->reset(); }

  static decltype(::apps::mojom::IconKey::timeline) timeline(
      const ::apps::mojom::IconKeyPtr& input) {
    return input->timeline;
  }

  static decltype(::apps::mojom::IconKey::resource_id) resource_id(
      const ::apps::mojom::IconKeyPtr& input) {
    return input->resource_id;
  }

  static decltype(::apps::mojom::IconKey::icon_effects) icon_effects(
      const ::apps::mojom::IconKeyPtr& input) {
    return input->icon_effects;
  }

  static bool Read(::apps::mojom::IconKey::DataView input, ::apps::mojom::IconKeyPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::IconValue::DataView,
                                         ::apps::mojom::IconValuePtr> {
  static bool IsNull(const ::apps::mojom::IconValuePtr& input) { return !input; }
  static void SetToNull(::apps::mojom::IconValuePtr* output) { output->reset(); }

  static decltype(::apps::mojom::IconValue::icon_compression) icon_compression(
      const ::apps::mojom::IconValuePtr& input) {
    return input->icon_compression;
  }

  static  decltype(::apps::mojom::IconValue::uncompressed)& uncompressed(
       ::apps::mojom::IconValuePtr& input) {
    return input->uncompressed;
  }

  static const decltype(::apps::mojom::IconValue::compressed)& compressed(
      const ::apps::mojom::IconValuePtr& input) {
    return input->compressed;
  }

  static decltype(::apps::mojom::IconValue::is_placeholder_icon) is_placeholder_icon(
      const ::apps::mojom::IconValuePtr& input) {
    return input->is_placeholder_icon;
  }

  static bool Read(::apps::mojom::IconValue::DataView input, ::apps::mojom::IconValuePtr* output);
};


template <>
struct  StructTraits<::apps::mojom::MenuItems::DataView,
                                         ::apps::mojom::MenuItemsPtr> {
  static bool IsNull(const ::apps::mojom::MenuItemsPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::MenuItemsPtr* output) { output->reset(); }

  static  decltype(::apps::mojom::MenuItems::items)& items(
       ::apps::mojom::MenuItemsPtr& input) {
    return input->items;
  }

  static bool Read(::apps::mojom::MenuItems::DataView input, ::apps::mojom::MenuItemsPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::MenuItem::DataView,
                                         ::apps::mojom::MenuItemPtr> {
  static bool IsNull(const ::apps::mojom::MenuItemPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::MenuItemPtr* output) { output->reset(); }

  static decltype(::apps::mojom::MenuItem::type) type(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->type;
  }

  static decltype(::apps::mojom::MenuItem::command_id) command_id(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->command_id;
  }

  static decltype(::apps::mojom::MenuItem::string_id) string_id(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->string_id;
  }

  static  decltype(::apps::mojom::MenuItem::submenu)& submenu(
       ::apps::mojom::MenuItemPtr& input) {
    return input->submenu;
  }

  static decltype(::apps::mojom::MenuItem::radio_group_id) radio_group_id(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->radio_group_id;
  }

  static const decltype(::apps::mojom::MenuItem::shortcut_id)& shortcut_id(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->shortcut_id;
  }

  static const decltype(::apps::mojom::MenuItem::label)& label(
      const ::apps::mojom::MenuItemPtr& input) {
    return input->label;
  }

  static  decltype(::apps::mojom::MenuItem::image)& image(
       ::apps::mojom::MenuItemPtr& input) {
    return input->image;
  }

  static bool Read(::apps::mojom::MenuItem::DataView input, ::apps::mojom::MenuItemPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::ConditionValue::DataView,
                                         ::apps::mojom::ConditionValuePtr> {
  static bool IsNull(const ::apps::mojom::ConditionValuePtr& input) { return !input; }
  static void SetToNull(::apps::mojom::ConditionValuePtr* output) { output->reset(); }

  static const decltype(::apps::mojom::ConditionValue::value)& value(
      const ::apps::mojom::ConditionValuePtr& input) {
    return input->value;
  }

  static decltype(::apps::mojom::ConditionValue::match_type) match_type(
      const ::apps::mojom::ConditionValuePtr& input) {
    return input->match_type;
  }

  static bool Read(::apps::mojom::ConditionValue::DataView input, ::apps::mojom::ConditionValuePtr* output);
};


template <>
struct  StructTraits<::apps::mojom::Condition::DataView,
                                         ::apps::mojom::ConditionPtr> {
  static bool IsNull(const ::apps::mojom::ConditionPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::ConditionPtr* output) { output->reset(); }

  static decltype(::apps::mojom::Condition::condition_type) condition_type(
      const ::apps::mojom::ConditionPtr& input) {
    return input->condition_type;
  }

  static const decltype(::apps::mojom::Condition::condition_values)& condition_values(
      const ::apps::mojom::ConditionPtr& input) {
    return input->condition_values;
  }

  static bool Read(::apps::mojom::Condition::DataView input, ::apps::mojom::ConditionPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::IntentFilter::DataView,
                                         ::apps::mojom::IntentFilterPtr> {
  static bool IsNull(const ::apps::mojom::IntentFilterPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::IntentFilterPtr* output) { output->reset(); }

  static const decltype(::apps::mojom::IntentFilter::conditions)& conditions(
      const ::apps::mojom::IntentFilterPtr& input) {
    return input->conditions;
  }

  static bool Read(::apps::mojom::IntentFilter::DataView input, ::apps::mojom::IntentFilterPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::Intent::DataView,
                                         ::apps::mojom::IntentPtr> {
  static bool IsNull(const ::apps::mojom::IntentPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::IntentPtr* output) { output->reset(); }

  static const decltype(::apps::mojom::Intent::scheme)& scheme(
      const ::apps::mojom::IntentPtr& input) {
    return input->scheme;
  }

  static const decltype(::apps::mojom::Intent::host)& host(
      const ::apps::mojom::IntentPtr& input) {
    return input->host;
  }

  static const decltype(::apps::mojom::Intent::path)& path(
      const ::apps::mojom::IntentPtr& input) {
    return input->path;
  }

  static bool Read(::apps::mojom::Intent::DataView input, ::apps::mojom::IntentPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::ReplacedAppPreferences::DataView,
                                         ::apps::mojom::ReplacedAppPreferencesPtr> {
  static bool IsNull(const ::apps::mojom::ReplacedAppPreferencesPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::ReplacedAppPreferencesPtr* output) { output->reset(); }

  static const decltype(::apps::mojom::ReplacedAppPreferences::replaced_preference)& replaced_preference(
      const ::apps::mojom::ReplacedAppPreferencesPtr& input) {
    return input->replaced_preference;
  }

  static bool Read(::apps::mojom::ReplacedAppPreferences::DataView input, ::apps::mojom::ReplacedAppPreferencesPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::PreferredApp::DataView,
                                         ::apps::mojom::PreferredAppPtr> {
  static bool IsNull(const ::apps::mojom::PreferredAppPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::PreferredAppPtr* output) { output->reset(); }

  static const decltype(::apps::mojom::PreferredApp::intent_filter)& intent_filter(
      const ::apps::mojom::PreferredAppPtr& input) {
    return input->intent_filter;
  }

  static const decltype(::apps::mojom::PreferredApp::app_id)& app_id(
      const ::apps::mojom::PreferredAppPtr& input) {
    return input->app_id;
  }

  static bool Read(::apps::mojom::PreferredApp::DataView input, ::apps::mojom::PreferredAppPtr* output);
};


template <>
struct  StructTraits<::apps::mojom::FilePaths::DataView,
                                         ::apps::mojom::FilePathsPtr> {
  static bool IsNull(const ::apps::mojom::FilePathsPtr& input) { return !input; }
  static void SetToNull(::apps::mojom::FilePathsPtr* output) { output->reset(); }

  static const decltype(::apps::mojom::FilePaths::file_paths)& file_paths(
      const ::apps::mojom::FilePathsPtr& input) {
    return input->file_paths;
  }

  static bool Read(::apps::mojom::FilePaths::DataView input, ::apps::mojom::FilePathsPtr* output);
};

}  // namespace mojo

#endif  // CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_