// chrome/services/local_search_service/public/mojom/local_search_service.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom-params-data.h"
#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom-shared-message-ids.h"

#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom-import-headers.h"


#ifndef CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_LOCAL_SEARCH_SERVICE_MOJOM_JUMBO_H_
#define CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_LOCAL_SEARCH_SERVICE_MOJOM_JUMBO_H_
#endif
namespace local_search_service {
namespace mojom {
const char LocalSearchService::Name_[] = "local_search_service.mojom.LocalSearchService";

LocalSearchServiceProxy::LocalSearchServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void LocalSearchServiceProxy::GetIndex(
    LocalSearchService::IndexId in_index_id, mojo::PendingReceiver<Index> in_index) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::LocalSearchService::GetIndex");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kLocalSearchService_GetIndex_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::LocalSearchService_GetIndex_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::local_search_service::mojom::LocalSearchService_IndexId>(
      in_index_id, &params->index_id);
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::local_search_service::mojom::IndexInterfaceBase>>(
      in_index, &params->index, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->index),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid index in LocalSearchService.GetIndex request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(LocalSearchService::Name_);
  message.set_method_name("GetIndex");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool LocalSearchServiceStubDispatch::Accept(
    LocalSearchService* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kLocalSearchService_GetIndex_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::LocalSearchService::GetIndex",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::LocalSearchService::GetIndex");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::LocalSearchService_GetIndex_Params_Data* params =
          reinterpret_cast<internal::LocalSearchService_GetIndex_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      LocalSearchService::IndexId p_index_id{};
      mojo::PendingReceiver<Index> p_index{};
      LocalSearchService_GetIndex_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadIndexId(&p_index_id))
        success = false;
      if (success) {
        p_index =
            input_data_view.TakeIndex<decltype(p_index)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            LocalSearchService::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetIndex(
std::move(p_index_id), 
std::move(p_index));
      return true;
    }
  }
  return false;
}

// static
bool LocalSearchServiceStubDispatch::AcceptWithResponder(
    LocalSearchService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kLocalSearchService_GetIndex_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kLocalSearchServiceValidationInfo[] = {
    {internal::kLocalSearchService_GetIndex_Name,
     {&internal::LocalSearchService_GetIndex_Params_Data::Validate,
      nullptr /* no response */}},
};

bool LocalSearchServiceRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::local_search_service::mojom::LocalSearchService::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kLocalSearchServiceValidationInfo);
}

const char Index::Name_[] = "local_search_service.mojom.Index";

class Index_GetSize_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Index_GetSize_ForwardToCallback(
      Index::GetSizeCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Index::GetSizeCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Index_GetSize_ForwardToCallback);
};

class Index_AddOrUpdate_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Index_AddOrUpdate_ForwardToCallback(
      Index::AddOrUpdateCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Index::AddOrUpdateCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Index_AddOrUpdate_ForwardToCallback);
};

class Index_Delete_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Index_Delete_ForwardToCallback(
      Index::DeleteCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Index::DeleteCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Index_Delete_ForwardToCallback);
};

class Index_Find_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Index_Find_ForwardToCallback(
      Index::FindCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Index::FindCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Index_Find_ForwardToCallback);
};

class Index_SetSearchParams_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Index_SetSearchParams_ForwardToCallback(
      Index::SetSearchParamsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Index::SetSearchParamsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Index_SetSearchParams_ForwardToCallback);
};

IndexProxy::IndexProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void IndexProxy::GetSize(
    GetSizeCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::Index::GetSize");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_GetSize_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_GetSize_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("GetSize");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Index_GetSize_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IndexProxy::AddOrUpdate(
    std::vector<::local_search_service::mojom::DataPtr> in_data, AddOrUpdateCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::Index::AddOrUpdate");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_AddOrUpdate_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_AddOrUpdate_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::local_search_service::mojom::DataDataView>>(
      in_data, buffer, &data_writer, &data_validate_params,
      &serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in Index.AddOrUpdate request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("AddOrUpdate");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Index_AddOrUpdate_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IndexProxy::Delete(
    const std::vector<std::string>& in_ids, DeleteCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::Index::Delete");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_Delete_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_Delete_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->ids)::BaseType::BufferWriter
      ids_writer;
  const mojo::internal::ContainerValidateParams ids_validate_params(
      0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
  mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
      in_ids, buffer, &ids_writer, &ids_validate_params,
      &serialization_context);
  params->ids.Set(
      ids_writer.is_null() ? nullptr : ids_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->ids.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null ids in Index.Delete request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("Delete");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Index_Delete_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IndexProxy::Find(
    const ::base::string16& in_query, int32_t in_max_latency_in_ms, int32_t in_max_results, FindCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::Index::Find");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_Find_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_Find_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->query)::BaseType::BufferWriter
      query_writer;
  mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
      in_query, buffer, &query_writer, &serialization_context);
  params->query.Set(
      query_writer.is_null() ? nullptr : query_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->query.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null query in Index.Find request");
  params->max_latency_in_ms = in_max_latency_in_ms;
  params->max_results = in_max_results;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("Find");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Index_Find_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IndexProxy::SetSearchParams(
    ::local_search_service::mojom::SearchParamsPtr in_search_params, SetSearchParamsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "local_search_service::mojom::Index::SetSearchParams");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_SetSearchParams_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_SetSearchParams_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->search_params)::BaseType::BufferWriter
      search_params_writer;
  mojo::internal::Serialize<::local_search_service::mojom::SearchParamsDataView>(
      in_search_params, buffer, &search_params_writer, &serialization_context);
  params->search_params.Set(
      search_params_writer.is_null() ? nullptr : search_params_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->search_params.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null search_params in Index.SetSearchParams request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("SetSearchParams");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Index_SetSearchParams_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class Index_GetSize_ProxyToResponder {
 public:
  static Index::GetSizeCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<Index_GetSize_ProxyToResponder> proxy(
        new Index_GetSize_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&Index_GetSize_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Index_GetSize_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Index_GetSize_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Index::GetSizeCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      uint64_t in_num_items);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Index_GetSize_ProxyToResponder);
};

bool Index_GetSize_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "local_search_service::mojom::Index::GetSizeCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Index_GetSize_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Index_GetSize_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  uint64_t p_num_items{};
  Index_GetSize_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success)
    p_num_items = input_data_view.num_items();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Index::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_num_items));
  return true;
}

void Index_GetSize_ProxyToResponder::Run(
    uint64_t in_num_items) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_GetSize_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_GetSize_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->num_items = in_num_items;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)local_search_service::mojom::Index::GetSizeCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("GetSize");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Index_AddOrUpdate_ProxyToResponder {
 public:
  static Index::AddOrUpdateCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<Index_AddOrUpdate_ProxyToResponder> proxy(
        new Index_AddOrUpdate_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&Index_AddOrUpdate_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Index_AddOrUpdate_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Index_AddOrUpdate_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Index::AddOrUpdateCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Index_AddOrUpdate_ProxyToResponder);
};

bool Index_AddOrUpdate_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "local_search_service::mojom::Index::AddOrUpdateCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Index_AddOrUpdate_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Index_AddOrUpdate_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  Index_AddOrUpdate_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Index::Name_, 1761437805, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void Index_AddOrUpdate_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_AddOrUpdate_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_AddOrUpdate_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)local_search_service::mojom::Index::AddOrUpdateCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("AddOrUpdate");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Index_Delete_ProxyToResponder {
 public:
  static Index::DeleteCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<Index_Delete_ProxyToResponder> proxy(
        new Index_Delete_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&Index_Delete_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Index_Delete_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Index_Delete_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Index::DeleteCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      uint32_t in_num_deleted);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Index_Delete_ProxyToResponder);
};

bool Index_Delete_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "local_search_service::mojom::Index::DeleteCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Index_Delete_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Index_Delete_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  uint32_t p_num_deleted{};
  Index_Delete_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success)
    p_num_deleted = input_data_view.num_deleted();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Index::Name_, 236326112, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_num_deleted));
  return true;
}

void Index_Delete_ProxyToResponder::Run(
    uint32_t in_num_deleted) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_Delete_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_Delete_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->num_deleted = in_num_deleted;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)local_search_service::mojom::Index::DeleteCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("Delete");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Index_Find_ProxyToResponder {
 public:
  static Index::FindCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<Index_Find_ProxyToResponder> proxy(
        new Index_Find_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&Index_Find_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Index_Find_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Index_Find_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Index::FindCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::local_search_service::mojom::ResponseStatus in_status, base::Optional<std::vector<::local_search_service::mojom::ResultPtr>> in_results);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Index_Find_ProxyToResponder);
};

bool Index_Find_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "local_search_service::mojom::Index::FindCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Index_Find_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Index_Find_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  ::local_search_service::mojom::ResponseStatus p_status{};
  base::Optional<std::vector<::local_search_service::mojom::ResultPtr>> p_results{};
  Index_Find_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadStatus(&p_status))
    success = false;
  if (success && !input_data_view.ReadResults(&p_results))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Index::Name_, 647343929, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_results));
  return true;
}

void Index_Find_ProxyToResponder::Run(
    ::local_search_service::mojom::ResponseStatus in_status, base::Optional<std::vector<::local_search_service::mojom::ResultPtr>> in_results) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_Find_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_Find_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::local_search_service::mojom::ResponseStatus>(
      in_status, &params->status);
  typename decltype(params->results)::BaseType::BufferWriter
      results_writer;
  const mojo::internal::ContainerValidateParams results_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::local_search_service::mojom::ResultDataView>>(
      in_results, buffer, &results_writer, &results_validate_params,
      &serialization_context);
  params->results.Set(
      results_writer.is_null() ? nullptr : results_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)local_search_service::mojom::Index::FindCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("Find");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Index_SetSearchParams_ProxyToResponder {
 public:
  static Index::SetSearchParamsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<Index_SetSearchParams_ProxyToResponder> proxy(
        new Index_SetSearchParams_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&Index_SetSearchParams_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Index_SetSearchParams_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Index_SetSearchParams_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Index::SetSearchParamsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Index_SetSearchParams_ProxyToResponder);
};

bool Index_SetSearchParams_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "local_search_service::mojom::Index::SetSearchParamsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Index_SetSearchParams_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Index_SetSearchParams_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  Index_SetSearchParams_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Index::Name_, 1497216075, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void Index_SetSearchParams_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIndex_SetSearchParams_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::local_search_service::mojom::internal::Index_SetSearchParams_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)local_search_service::mojom::Index::SetSearchParamsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Index::Name_);
  message.set_method_name("SetSearchParams");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool IndexStubDispatch::Accept(
    Index* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kIndex_GetSize_Name: {
      break;
    }
    case internal::kIndex_AddOrUpdate_Name: {
      break;
    }
    case internal::kIndex_Delete_Name: {
      break;
    }
    case internal::kIndex_Find_Name: {
      break;
    }
    case internal::kIndex_SetSearchParams_Name: {
      break;
    }
  }
  return false;
}

// static
bool IndexStubDispatch::AcceptWithResponder(
    Index* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kIndex_GetSize_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::Index::GetSize",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::Index::GetSize");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::Index_GetSize_Params_Data* params =
          reinterpret_cast<
              internal::Index_GetSize_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      Index_GetSize_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Index::Name_, 0, false);
        return false;
      }
      Index::GetSizeCallback callback =
          Index_GetSize_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetSize(std::move(callback));
      return true;
    }
    case internal::kIndex_AddOrUpdate_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::Index::AddOrUpdate",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::Index::AddOrUpdate");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::Index_AddOrUpdate_Params_Data* params =
          reinterpret_cast<
              internal::Index_AddOrUpdate_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      std::vector<::local_search_service::mojom::DataPtr> p_data{};
      Index_AddOrUpdate_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadData(&p_data))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Index::Name_, 1761437805, false);
        return false;
      }
      Index::AddOrUpdateCallback callback =
          Index_AddOrUpdate_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->AddOrUpdate(
std::move(p_data), std::move(callback));
      return true;
    }
    case internal::kIndex_Delete_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::Index::Delete",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::Index::Delete");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::Index_Delete_Params_Data* params =
          reinterpret_cast<
              internal::Index_Delete_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      std::vector<std::string> p_ids{};
      Index_Delete_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadIds(&p_ids))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Index::Name_, 236326112, false);
        return false;
      }
      Index::DeleteCallback callback =
          Index_Delete_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Delete(
std::move(p_ids), std::move(callback));
      return true;
    }
    case internal::kIndex_Find_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::Index::Find",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::Index::Find");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::Index_Find_Params_Data* params =
          reinterpret_cast<
              internal::Index_Find_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      ::base::string16 p_query{};
      int32_t p_max_latency_in_ms{};
      int32_t p_max_results{};
      Index_Find_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadQuery(&p_query))
        success = false;
      if (success)
        p_max_latency_in_ms = input_data_view.max_latency_in_ms();
      if (success)
        p_max_results = input_data_view.max_results();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Index::Name_, 647343929, false);
        return false;
      }
      Index::FindCallback callback =
          Index_Find_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Find(
std::move(p_query), 
std::move(p_max_latency_in_ms), 
std::move(p_max_results), std::move(callback));
      return true;
    }
    case internal::kIndex_SetSearchParams_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)local_search_service::mojom::Index::SetSearchParams",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)local_search_service::mojom::Index::SetSearchParams");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::Index_SetSearchParams_Params_Data* params =
          reinterpret_cast<
              internal::Index_SetSearchParams_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      ::local_search_service::mojom::SearchParamsPtr p_search_params{};
      Index_SetSearchParams_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadSearchParams(&p_search_params))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Index::Name_, 1497216075, false);
        return false;
      }
      Index::SetSearchParamsCallback callback =
          Index_SetSearchParams_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetSearchParams(
std::move(p_search_params), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kIndexValidationInfo[] = {
    {internal::kIndex_GetSize_Name,
     {&internal::Index_GetSize_Params_Data::Validate,
      &internal::Index_GetSize_ResponseParams_Data::Validate}},
    {internal::kIndex_AddOrUpdate_Name,
     {&internal::Index_AddOrUpdate_Params_Data::Validate,
      &internal::Index_AddOrUpdate_ResponseParams_Data::Validate}},
    {internal::kIndex_Delete_Name,
     {&internal::Index_Delete_Params_Data::Validate,
      &internal::Index_Delete_ResponseParams_Data::Validate}},
    {internal::kIndex_Find_Name,
     {&internal::Index_Find_Params_Data::Validate,
      &internal::Index_Find_ResponseParams_Data::Validate}},
    {internal::kIndex_SetSearchParams_Name,
     {&internal::Index_SetSearchParams_Params_Data::Validate,
      &internal::Index_SetSearchParams_ResponseParams_Data::Validate}},
};

bool IndexRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::local_search_service::mojom::Index::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kIndexValidationInfo);
}

bool IndexResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::local_search_service::mojom::Index::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kIndexValidationInfo);

}
}  // namespace mojom
}  // namespace local_search_service

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif