// chrome/services/local_search_service/public/mojom/types.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_SHARED_H_
#define CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/services/local_search_service/public/mojom/types.mojom-shared-internal.h"
#include "mojo/public/mojom/base/values.mojom-shared.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"







namespace local_search_service {
namespace mojom {
class RangeDataView;

class DataDataView;

class ResultDataView;

class SearchParamsDataView;



}  // namespace mojom
}  // namespace local_search_service

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::local_search_service::mojom::RangeDataView> {
  using Data = ::local_search_service::mojom::internal::Range_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::local_search_service::mojom::DataDataView> {
  using Data = ::local_search_service::mojom::internal::Data_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::local_search_service::mojom::ResultDataView> {
  using Data = ::local_search_service::mojom::internal::Result_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::local_search_service::mojom::SearchParamsDataView> {
  using Data = ::local_search_service::mojom::internal::SearchParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace local_search_service {
namespace mojom {


enum class ResponseStatus : int32_t {
  
  UNKNOWN_ERROR,
  
  EMPTY_QUERY,
  
  EMPTY_INDEX,
  
  SUCCESS,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, ResponseStatus value);
inline bool IsKnownEnumValue(ResponseStatus value) {
  return internal::ResponseStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
class RangeDataView {
 public:
  RangeDataView() {}

  RangeDataView(
      internal::Range_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t start() const {
    return data_->start;
  }
  uint32_t end() const {
    return data_->end;
  }
 private:
  internal::Range_Data* data_ = nullptr;
};

class DataDataView {
 public:
  DataDataView() {}

  DataDataView(
      internal::Data_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetSearchTagsDataView(
      mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSearchTags(UserType* output) {
    auto* pointer = data_->search_tags.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojo_base::mojom::String16DataView>>(
        pointer, output, context_);
  }
 private:
  internal::Data_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ResultDataView {
 public:
  ResultDataView() {}

  ResultDataView(
      internal::Result_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  double score() const {
    return data_->score;
  }
  inline void GetHitsDataView(
      mojo::ArrayDataView<RangeDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHits(UserType* output) {
    auto* pointer = data_->hits.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::local_search_service::mojom::RangeDataView>>(
        pointer, output, context_);
  }
 private:
  internal::Result_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SearchParamsDataView {
 public:
  SearchParamsDataView() {}

  SearchParamsDataView(
      internal::SearchParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  double relevance_threshold() const {
    return data_->relevance_threshold;
  }
  double partial_match_penalty_rate() const {
    return data_->partial_match_penalty_rate;
  }
  bool use_prefix_only() const {
    return data_->use_prefix_only;
  }
  bool use_weighted_ratio() const {
    return data_->use_weighted_ratio;
  }
  bool use_edit_distance() const {
    return data_->use_edit_distance;
  }
 private:
  internal::SearchParams_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace local_search_service

namespace std {

template <>
struct hash<::local_search_service::mojom::ResponseStatus>
    : public mojo::internal::EnumHashImpl<::local_search_service::mojom::ResponseStatus> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::local_search_service::mojom::ResponseStatus, ::local_search_service::mojom::ResponseStatus> {
  static ::local_search_service::mojom::ResponseStatus ToMojom(::local_search_service::mojom::ResponseStatus input) { return input; }
  static bool FromMojom(::local_search_service::mojom::ResponseStatus input, ::local_search_service::mojom::ResponseStatus* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::local_search_service::mojom::ResponseStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::local_search_service::mojom::ResponseStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::local_search_service::mojom::ResponseStatus>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::local_search_service::mojom::RangeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::local_search_service::mojom::RangeDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::local_search_service::mojom::internal::Range_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->start = Traits::start(input);
    (*output)->end = Traits::end(input);
  }

  static bool Deserialize(::local_search_service::mojom::internal::Range_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::local_search_service::mojom::RangeDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::local_search_service::mojom::DataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::local_search_service::mojom::DataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::local_search_service::mojom::internal::Data_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::id(input)) in_id = Traits::id(input);
    typename decltype((*output)->id)::BaseType::BufferWriter
        id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, buffer, &id_writer, context);
    (*output)->id.Set(
        id_writer.is_null() ? nullptr : id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in Data struct");
    decltype(Traits::search_tags(input)) in_search_tags = Traits::search_tags(input);
    typename decltype((*output)->search_tags)::BaseType::BufferWriter
        search_tags_writer;
    const mojo::internal::ContainerValidateParams search_tags_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::mojo_base::mojom::String16DataView>>(
        in_search_tags, buffer, &search_tags_writer, &search_tags_validate_params,
        context);
    (*output)->search_tags.Set(
        search_tags_writer.is_null() ? nullptr : search_tags_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->search_tags.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null search_tags in Data struct");
  }

  static bool Deserialize(::local_search_service::mojom::internal::Data_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::local_search_service::mojom::DataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::local_search_service::mojom::ResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::local_search_service::mojom::ResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::local_search_service::mojom::internal::Result_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::id(input)) in_id = Traits::id(input);
    typename decltype((*output)->id)::BaseType::BufferWriter
        id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, buffer, &id_writer, context);
    (*output)->id.Set(
        id_writer.is_null() ? nullptr : id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in Result struct");
    (*output)->score = Traits::score(input);
    decltype(Traits::hits(input)) in_hits = Traits::hits(input);
    typename decltype((*output)->hits)::BaseType::BufferWriter
        hits_writer;
    const mojo::internal::ContainerValidateParams hits_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::local_search_service::mojom::RangeDataView>>(
        in_hits, buffer, &hits_writer, &hits_validate_params,
        context);
    (*output)->hits.Set(
        hits_writer.is_null() ? nullptr : hits_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->hits.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null hits in Result struct");
  }

  static bool Deserialize(::local_search_service::mojom::internal::Result_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::local_search_service::mojom::ResultDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::local_search_service::mojom::SearchParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::local_search_service::mojom::SearchParamsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::local_search_service::mojom::internal::SearchParams_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->relevance_threshold = Traits::relevance_threshold(input);
    (*output)->partial_match_penalty_rate = Traits::partial_match_penalty_rate(input);
    (*output)->use_prefix_only = Traits::use_prefix_only(input);
    (*output)->use_weighted_ratio = Traits::use_weighted_ratio(input);
    (*output)->use_edit_distance = Traits::use_edit_distance(input);
  }

  static bool Deserialize(::local_search_service::mojom::internal::SearchParams_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::local_search_service::mojom::SearchParamsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace local_search_service {
namespace mojom {



inline void DataDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void DataDataView::GetSearchTagsDataView(
    mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output) {
  auto pointer = data_->search_tags.Get();
  *output = mojo::ArrayDataView<::mojo_base::mojom::String16DataView>(pointer, context_);
}


inline void ResultDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ResultDataView::GetHitsDataView(
    mojo::ArrayDataView<RangeDataView>* output) {
  auto pointer = data_->hits.Get();
  *output = mojo::ArrayDataView<RangeDataView>(pointer, context_);
}





}  // namespace mojom
}  // namespace local_search_service

#endif  // CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_SHARED_H_