// chrome/services/qrcode_generator/public/mojom/qrcode_generator.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/services/qrcode_generator/public/mojom/qrcode_generator.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/qrcode_generator/public/mojom/qrcode_generator.mojom-params-data.h"
#include "chrome/services/qrcode_generator/public/mojom/qrcode_generator.mojom-shared-message-ids.h"

#include "chrome/services/qrcode_generator/public/mojom/qrcode_generator.mojom-import-headers.h"


#ifndef CHROME_SERVICES_QRCODE_GENERATOR_PUBLIC_MOJOM_QRCODE_GENERATOR_MOJOM_JUMBO_H_
#define CHROME_SERVICES_QRCODE_GENERATOR_PUBLIC_MOJOM_QRCODE_GENERATOR_MOJOM_JUMBO_H_
#include "skia/public/mojom/bitmap_skbitmap_mojom_traits.h"
#include "skia/public/mojom/image_info_mojom_traits.h"
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#endif
namespace qrcode_generator {
namespace mojom {
GenerateQRCodeRequest::GenerateQRCodeRequest()
    : data(),
      should_render(),
      render_dino(),
      render_module_style(),
      render_locator_style() {}

GenerateQRCodeRequest::GenerateQRCodeRequest(
    const std::string& data_in,
    bool should_render_in,
    bool render_dino_in,
    ModuleStyle render_module_style_in,
    LocatorStyle render_locator_style_in)
    : data(std::move(data_in)),
      should_render(std::move(should_render_in)),
      render_dino(std::move(render_dino_in)),
      render_module_style(std::move(render_module_style_in)),
      render_locator_style(std::move(render_locator_style_in)) {}

GenerateQRCodeRequest::~GenerateQRCodeRequest() = default;
size_t GenerateQRCodeRequest::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->data);
  seed = mojo::internal::Hash(seed, this->should_render);
  seed = mojo::internal::Hash(seed, this->render_dino);
  seed = mojo::internal::Hash(seed, this->render_module_style);
  seed = mojo::internal::Hash(seed, this->render_locator_style);
  return seed;
}

bool GenerateQRCodeRequest::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GenerateQRCodeResponse::GenerateQRCodeResponse()
    : error_code(),
      bitmap(),
      data(),
      data_size() {}

GenerateQRCodeResponse::GenerateQRCodeResponse(
    QRCodeGeneratorError error_code_in,
    const ::SkBitmap& bitmap_in,
    std::vector<uint8_t> data_in,
    const ::gfx::Size& data_size_in)
    : error_code(std::move(error_code_in)),
      bitmap(std::move(bitmap_in)),
      data(std::move(data_in)),
      data_size(std::move(data_size_in)) {}

GenerateQRCodeResponse::~GenerateQRCodeResponse() = default;

bool GenerateQRCodeResponse::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char QRCodeGeneratorService::Name_[] = "qrcode_generator.mojom.QRCodeGeneratorService";

class QRCodeGeneratorService_GenerateQRCode_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  QRCodeGeneratorService_GenerateQRCode_ForwardToCallback(
      QRCodeGeneratorService::GenerateQRCodeCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  QRCodeGeneratorService::GenerateQRCodeCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(QRCodeGeneratorService_GenerateQRCode_ForwardToCallback);
};

QRCodeGeneratorServiceProxy::QRCodeGeneratorServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void QRCodeGeneratorServiceProxy::GenerateQRCode(
    GenerateQRCodeRequestPtr in_request, GenerateQRCodeCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "qrcode_generator::mojom::QRCodeGeneratorService::GenerateQRCode");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kQRCodeGeneratorService_GenerateQRCode_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::qrcode_generator::mojom::internal::QRCodeGeneratorService_GenerateQRCode_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->request)::BaseType::BufferWriter
      request_writer;
  mojo::internal::Serialize<::qrcode_generator::mojom::GenerateQRCodeRequestDataView>(
      in_request, buffer, &request_writer, &serialization_context);
  params->request.Set(
      request_writer.is_null() ? nullptr : request_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in QRCodeGeneratorService.GenerateQRCode request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(QRCodeGeneratorService::Name_);
  message.set_method_name("GenerateQRCode");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new QRCodeGeneratorService_GenerateQRCode_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class QRCodeGeneratorService_GenerateQRCode_ProxyToResponder {
 public:
  static QRCodeGeneratorService::GenerateQRCodeCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<QRCodeGeneratorService_GenerateQRCode_ProxyToResponder> proxy(
        new QRCodeGeneratorService_GenerateQRCode_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&QRCodeGeneratorService_GenerateQRCode_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~QRCodeGeneratorService_GenerateQRCode_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  QRCodeGeneratorService_GenerateQRCode_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "QRCodeGeneratorService::GenerateQRCodeCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      GenerateQRCodeResponsePtr in_response);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(QRCodeGeneratorService_GenerateQRCode_ProxyToResponder);
};

bool QRCodeGeneratorService_GenerateQRCode_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "qrcode_generator::mojom::QRCodeGeneratorService::GenerateQRCodeCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::QRCodeGeneratorService_GenerateQRCode_ResponseParams_Data* params =
      reinterpret_cast<
          internal::QRCodeGeneratorService_GenerateQRCode_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  GenerateQRCodeResponsePtr p_response{};
  QRCodeGeneratorService_GenerateQRCode_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadResponse(&p_response))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        QRCodeGeneratorService::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_response));
  return true;
}

void QRCodeGeneratorService_GenerateQRCode_ProxyToResponder::Run(
    GenerateQRCodeResponsePtr in_response) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kQRCodeGeneratorService_GenerateQRCode_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::qrcode_generator::mojom::internal::QRCodeGeneratorService_GenerateQRCode_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->response)::BaseType::BufferWriter
      response_writer;
  mojo::internal::Serialize<::qrcode_generator::mojom::GenerateQRCodeResponseDataView>(
      in_response, buffer, &response_writer, &serialization_context);
  params->response.Set(
      response_writer.is_null() ? nullptr : response_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->response.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null response in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)qrcode_generator::mojom::QRCodeGeneratorService::GenerateQRCodeCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(QRCodeGeneratorService::Name_);
  message.set_method_name("GenerateQRCode");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool QRCodeGeneratorServiceStubDispatch::Accept(
    QRCodeGeneratorService* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kQRCodeGeneratorService_GenerateQRCode_Name: {
      break;
    }
  }
  return false;
}

// static
bool QRCodeGeneratorServiceStubDispatch::AcceptWithResponder(
    QRCodeGeneratorService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kQRCodeGeneratorService_GenerateQRCode_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)qrcode_generator::mojom::QRCodeGeneratorService::GenerateQRCode",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)qrcode_generator::mojom::QRCodeGeneratorService::GenerateQRCode");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::QRCodeGeneratorService_GenerateQRCode_Params_Data* params =
          reinterpret_cast<
              internal::QRCodeGeneratorService_GenerateQRCode_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      GenerateQRCodeRequestPtr p_request{};
      QRCodeGeneratorService_GenerateQRCode_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadRequest(&p_request))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            QRCodeGeneratorService::Name_, 0, false);
        return false;
      }
      QRCodeGeneratorService::GenerateQRCodeCallback callback =
          QRCodeGeneratorService_GenerateQRCode_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GenerateQRCode(
std::move(p_request), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kQRCodeGeneratorServiceValidationInfo[] = {
    {internal::kQRCodeGeneratorService_GenerateQRCode_Name,
     {&internal::QRCodeGeneratorService_GenerateQRCode_Params_Data::Validate,
      &internal::QRCodeGeneratorService_GenerateQRCode_ResponseParams_Data::Validate}},
};

bool QRCodeGeneratorServiceRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::qrcode_generator::mojom::QRCodeGeneratorService::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kQRCodeGeneratorServiceValidationInfo);
}

bool QRCodeGeneratorServiceResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::qrcode_generator::mojom::QRCodeGeneratorService::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kQRCodeGeneratorServiceValidationInfo);

}
}  // namespace mojom
}  // namespace qrcode_generator

namespace mojo {


// static
bool StructTraits<::qrcode_generator::mojom::GenerateQRCodeRequest::DataView, ::qrcode_generator::mojom::GenerateQRCodeRequestPtr>::Read(
    ::qrcode_generator::mojom::GenerateQRCodeRequest::DataView input,
    ::qrcode_generator::mojom::GenerateQRCodeRequestPtr* output) {
  bool success = true;
  ::qrcode_generator::mojom::GenerateQRCodeRequestPtr result(::qrcode_generator::mojom::GenerateQRCodeRequest::New());
  
      if (success && !input.ReadData(&result->data))
        success = false;
      if (success)
        result->should_render = input.should_render();
      if (success)
        result->render_dino = input.render_dino();
      if (success && !input.ReadRenderModuleStyle(&result->render_module_style))
        success = false;
      if (success && !input.ReadRenderLocatorStyle(&result->render_locator_style))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::qrcode_generator::mojom::GenerateQRCodeResponse::DataView, ::qrcode_generator::mojom::GenerateQRCodeResponsePtr>::Read(
    ::qrcode_generator::mojom::GenerateQRCodeResponse::DataView input,
    ::qrcode_generator::mojom::GenerateQRCodeResponsePtr* output) {
  bool success = true;
  ::qrcode_generator::mojom::GenerateQRCodeResponsePtr result(::qrcode_generator::mojom::GenerateQRCodeResponse::New());
  
      if (success && !input.ReadErrorCode(&result->error_code))
        success = false;
      if (success && !input.ReadBitmap(&result->bitmap))
        success = false;
      if (success && !input.ReadData(&result->data))
        success = false;
      if (success && !input.ReadDataSize(&result->data_size))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif