// chrome/services/sharing/public/mojom/webrtc.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_WEBRTC_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_WEBRTC_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/webrtc.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/webrtc.mojom-forward.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace sharing {
namespace mojom {

class SignallingSenderProxy;

template <typename ImplRefTraits>
class SignallingSenderStub;

class SignallingSenderRequestValidator;
class SignallingSenderResponseValidator;


class  SignallingSender
    : public SignallingSenderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SignallingSenderInterfaceBase;
  using Proxy_ = SignallingSenderProxy;

  template <typename ImplRefTraits>
  using Stub_ = SignallingSenderStub<ImplRefTraits>;

  using RequestValidator_ = SignallingSenderRequestValidator;
  using ResponseValidator_ = SignallingSenderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSendOfferMinVersion = 0,
    kSendIceCandidatesMinVersion = 0,
  };
  virtual ~SignallingSender() {}


  using SendOfferCallback = base::OnceCallback<void(const std::string&)>;
  
  virtual void SendOffer(const std::string& offer, SendOfferCallback callback) = 0;

  
  virtual void SendIceCandidates(std::vector<IceCandidatePtr> ice_candidates) = 0;
};

class SignallingReceiverProxy;

template <typename ImplRefTraits>
class SignallingReceiverStub;

class SignallingReceiverRequestValidator;
class SignallingReceiverResponseValidator;


class  SignallingReceiver
    : public SignallingReceiverInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SignallingReceiverInterfaceBase;
  using Proxy_ = SignallingReceiverProxy;

  template <typename ImplRefTraits>
  using Stub_ = SignallingReceiverStub<ImplRefTraits>;

  using RequestValidator_ = SignallingReceiverRequestValidator;
  using ResponseValidator_ = SignallingReceiverResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnOfferReceivedMinVersion = 0,
    kOnIceCandidatesReceivedMinVersion = 0,
  };
  virtual ~SignallingReceiver() {}


  using OnOfferReceivedCallback = base::OnceCallback<void(const std::string&)>;
  
  virtual void OnOfferReceived(const std::string& offer, OnOfferReceivedCallback callback) = 0;

  
  virtual void OnIceCandidatesReceived(std::vector<IceCandidatePtr> ice_candidates) = 0;
};

class SharingWebRtcConnectionDelegateProxy;

template <typename ImplRefTraits>
class SharingWebRtcConnectionDelegateStub;

class SharingWebRtcConnectionDelegateRequestValidator;


class  SharingWebRtcConnectionDelegate
    : public SharingWebRtcConnectionDelegateInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SharingWebRtcConnectionDelegateInterfaceBase;
  using Proxy_ = SharingWebRtcConnectionDelegateProxy;

  template <typename ImplRefTraits>
  using Stub_ = SharingWebRtcConnectionDelegateStub<ImplRefTraits>;

  using RequestValidator_ = SharingWebRtcConnectionDelegateRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnMessageReceivedMinVersion = 0,
  };
  virtual ~SharingWebRtcConnectionDelegate() {}

  
  virtual void OnMessageReceived(const std::vector<uint8_t>& message) = 0;
};

class SharingWebRtcConnectionProxy;

template <typename ImplRefTraits>
class SharingWebRtcConnectionStub;

class SharingWebRtcConnectionRequestValidator;
class SharingWebRtcConnectionResponseValidator;


class  SharingWebRtcConnection
    : public SharingWebRtcConnectionInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SharingWebRtcConnectionInterfaceBase;
  using Proxy_ = SharingWebRtcConnectionProxy;

  template <typename ImplRefTraits>
  using Stub_ = SharingWebRtcConnectionStub<ImplRefTraits>;

  using RequestValidator_ = SharingWebRtcConnectionRequestValidator;
  using ResponseValidator_ = SharingWebRtcConnectionResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSendMessageMinVersion = 0,
  };
  virtual ~SharingWebRtcConnection() {}


  using SendMessageCallback = base::OnceCallback<void(SendMessageResult)>;
  
  virtual void SendMessage(const std::vector<uint8_t>& message, SendMessageCallback callback) = 0;
};



class  SignallingSenderProxy
    : public SignallingSender {
 public:
  using InterfaceType = SignallingSender;

  explicit SignallingSenderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SendOffer(const std::string& offer, SendOfferCallback callback) final;
  
  void SendIceCandidates(std::vector<IceCandidatePtr> ice_candidates) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SignallingReceiverProxy
    : public SignallingReceiver {
 public:
  using InterfaceType = SignallingReceiver;

  explicit SignallingReceiverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnOfferReceived(const std::string& offer, OnOfferReceivedCallback callback) final;
  
  void OnIceCandidatesReceived(std::vector<IceCandidatePtr> ice_candidates) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SharingWebRtcConnectionDelegateProxy
    : public SharingWebRtcConnectionDelegate {
 public:
  using InterfaceType = SharingWebRtcConnectionDelegate;

  explicit SharingWebRtcConnectionDelegateProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnMessageReceived(const std::vector<uint8_t>& message) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SharingWebRtcConnectionProxy
    : public SharingWebRtcConnection {
 public:
  using InterfaceType = SharingWebRtcConnection;

  explicit SharingWebRtcConnectionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SendMessage(const std::vector<uint8_t>& message, SendMessageCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  SignallingSenderStubDispatch {
 public:
  static bool Accept(SignallingSender* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SignallingSender* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SignallingSender>>
class SignallingSenderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SignallingSenderStub() {}
  ~SignallingSenderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SignallingSenderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SignallingSenderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SignallingReceiverStubDispatch {
 public:
  static bool Accept(SignallingReceiver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SignallingReceiver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SignallingReceiver>>
class SignallingReceiverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SignallingReceiverStub() {}
  ~SignallingReceiverStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SignallingReceiverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SignallingReceiverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SharingWebRtcConnectionDelegateStubDispatch {
 public:
  static bool Accept(SharingWebRtcConnectionDelegate* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SharingWebRtcConnectionDelegate* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SharingWebRtcConnectionDelegate>>
class SharingWebRtcConnectionDelegateStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SharingWebRtcConnectionDelegateStub() {}
  ~SharingWebRtcConnectionDelegateStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingWebRtcConnectionDelegateStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingWebRtcConnectionDelegateStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SharingWebRtcConnectionStubDispatch {
 public:
  static bool Accept(SharingWebRtcConnection* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SharingWebRtcConnection* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SharingWebRtcConnection>>
class SharingWebRtcConnectionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SharingWebRtcConnectionStub() {}
  ~SharingWebRtcConnectionStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingWebRtcConnectionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingWebRtcConnectionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SignallingSenderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SignallingReceiverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SharingWebRtcConnectionDelegateRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SharingWebRtcConnectionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SignallingSenderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SignallingReceiverResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SharingWebRtcConnectionResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  IceCandidate {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IceCandidate, T>::value>;
  using DataView = IceCandidateDataView;
  using Data_ = internal::IceCandidate_Data;

  template <typename... Args>
  static IceCandidatePtr New(Args&&... args) {
    return IceCandidatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IceCandidatePtr From(const U& u) {
    return mojo::TypeConverter<IceCandidatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IceCandidate>::Convert(*this);
  }


  IceCandidate();

  IceCandidate(
      const std::string& candidate,
      const std::string& sdp_mid,
      int32_t sdp_mline_index);

  ~IceCandidate();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IceCandidatePtr>
  IceCandidatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IceCandidate::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IceCandidate::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IceCandidate::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IceCandidate_UnserializedMessageContext<
            UserType, IceCandidate::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IceCandidate::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IceCandidate::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IceCandidate_UnserializedMessageContext<
            UserType, IceCandidate::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IceCandidate::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string candidate;
  
  std::string sdp_mid;
  
  int32_t sdp_mline_index;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IceCandidate::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IceCandidate::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IceCandidate::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IceCandidate::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}









class  IceServer {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IceServer, T>::value>;
  using DataView = IceServerDataView;
  using Data_ = internal::IceServer_Data;

  template <typename... Args>
  static IceServerPtr New(Args&&... args) {
    return IceServerPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IceServerPtr From(const U& u) {
    return mojo::TypeConverter<IceServerPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IceServer>::Convert(*this);
  }


  IceServer();

  IceServer(
      std::vector<::GURL> urls,
      const base::Optional<std::string>& username,
      const base::Optional<std::string>& credential);

  ~IceServer();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IceServerPtr>
  IceServerPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IceServer::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IceServer::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IceServer::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IceServer_UnserializedMessageContext<
            UserType, IceServer::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IceServer::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IceServer::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IceServer_UnserializedMessageContext<
            UserType, IceServer::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IceServer::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<::GURL> urls;
  
  base::Optional<std::string> username;
  
  base::Optional<std::string> credential;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IceServer::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IceServer::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IceServer::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IceServer::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
IceCandidatePtr IceCandidate::Clone() const {
  return New(
      mojo::Clone(candidate),
      mojo::Clone(sdp_mid),
      mojo::Clone(sdp_mline_index)
  );
}

template <typename T, IceCandidate::EnableIfSame<T>*>
bool IceCandidate::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->candidate, other_struct.candidate))
    return false;
  if (!mojo::Equals(this->sdp_mid, other_struct.sdp_mid))
    return false;
  if (!mojo::Equals(this->sdp_mline_index, other_struct.sdp_mline_index))
    return false;
  return true;
}

template <typename T, IceCandidate::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.candidate < rhs.candidate)
    return true;
  if (rhs.candidate < lhs.candidate)
    return false;
  if (lhs.sdp_mid < rhs.sdp_mid)
    return true;
  if (rhs.sdp_mid < lhs.sdp_mid)
    return false;
  if (lhs.sdp_mline_index < rhs.sdp_mline_index)
    return true;
  if (rhs.sdp_mline_index < lhs.sdp_mline_index)
    return false;
  return false;
}
template <typename StructPtrType>
IceServerPtr IceServer::Clone() const {
  return New(
      mojo::Clone(urls),
      mojo::Clone(username),
      mojo::Clone(credential)
  );
}

template <typename T, IceServer::EnableIfSame<T>*>
bool IceServer::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->urls, other_struct.urls))
    return false;
  if (!mojo::Equals(this->username, other_struct.username))
    return false;
  if (!mojo::Equals(this->credential, other_struct.credential))
    return false;
  return true;
}

template <typename T, IceServer::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.urls < rhs.urls)
    return true;
  if (rhs.urls < lhs.urls)
    return false;
  if (lhs.username < rhs.username)
    return true;
  if (rhs.username < lhs.username)
    return false;
  if (lhs.credential < rhs.credential)
    return true;
  if (rhs.credential < lhs.credential)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace sharing

namespace mojo {


template <>
struct  StructTraits<::sharing::mojom::IceCandidate::DataView,
                                         ::sharing::mojom::IceCandidatePtr> {
  static bool IsNull(const ::sharing::mojom::IceCandidatePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::IceCandidatePtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::IceCandidate::candidate)& candidate(
      const ::sharing::mojom::IceCandidatePtr& input) {
    return input->candidate;
  }

  static const decltype(::sharing::mojom::IceCandidate::sdp_mid)& sdp_mid(
      const ::sharing::mojom::IceCandidatePtr& input) {
    return input->sdp_mid;
  }

  static decltype(::sharing::mojom::IceCandidate::sdp_mline_index) sdp_mline_index(
      const ::sharing::mojom::IceCandidatePtr& input) {
    return input->sdp_mline_index;
  }

  static bool Read(::sharing::mojom::IceCandidate::DataView input, ::sharing::mojom::IceCandidatePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::IceServer::DataView,
                                         ::sharing::mojom::IceServerPtr> {
  static bool IsNull(const ::sharing::mojom::IceServerPtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::IceServerPtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::IceServer::urls)& urls(
      const ::sharing::mojom::IceServerPtr& input) {
    return input->urls;
  }

  static const decltype(::sharing::mojom::IceServer::username)& username(
      const ::sharing::mojom::IceServerPtr& input) {
    return input->username;
  }

  static const decltype(::sharing::mojom::IceServer::credential)& credential(
      const ::sharing::mojom::IceServerPtr& input) {
    return input->credential;
  }

  static bool Read(::sharing::mojom::IceServer::DataView input, ::sharing::mojom::IceServerPtr* output);
};

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_WEBRTC_MOJOM_H_