// components/mirroring/mojom/resource_provider.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "components/mirroring/mojom/resource_provider.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "components/mirroring/mojom/resource_provider.mojom-params-data.h"
#include "components/mirroring/mojom/resource_provider.mojom-shared-message-ids.h"

#include "components/mirroring/mojom/resource_provider.mojom-import-headers.h"


#ifndef COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_JUMBO_H_
#define COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_JUMBO_H_
#include "media/base/ipc/media_param_traits.h"
#endif
namespace mirroring {
namespace mojom {
const char AudioStreamCreatorClient::Name_[] = "mirroring.mojom.AudioStreamCreatorClient";

AudioStreamCreatorClientProxy::AudioStreamCreatorClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AudioStreamCreatorClientProxy::StreamCreated(
    mojo::PendingRemote<::media::mojom::AudioInputStream> in_stream, mojo::PendingReceiver<::media::mojom::AudioInputStreamClient> in_client_receiver, ::media::mojom::ReadOnlyAudioDataPipePtr in_data_pipe, bool in_initially_muted) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::AudioStreamCreatorClient::StreamCreated");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAudioStreamCreatorClient_StreamCreated_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::AudioStreamCreatorClient_StreamCreated_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::media::mojom::AudioInputStreamInterfaceBase>>(
      in_stream, &params->stream, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->stream),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid stream in AudioStreamCreatorClient.StreamCreated request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::media::mojom::AudioInputStreamClientInterfaceBase>>(
      in_client_receiver, &params->client_receiver, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client_receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client_receiver in AudioStreamCreatorClient.StreamCreated request");
  typename decltype(params->data_pipe)::BaseType::BufferWriter
      data_pipe_writer;
  mojo::internal::Serialize<::media::mojom::ReadOnlyAudioDataPipeDataView>(
      in_data_pipe, buffer, &data_pipe_writer, &serialization_context);
  params->data_pipe.Set(
      data_pipe_writer.is_null() ? nullptr : data_pipe_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data_pipe.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data_pipe in AudioStreamCreatorClient.StreamCreated request");
  params->initially_muted = in_initially_muted;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AudioStreamCreatorClient::Name_);
  message.set_method_name("StreamCreated");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool AudioStreamCreatorClientStubDispatch::Accept(
    AudioStreamCreatorClient* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kAudioStreamCreatorClient_StreamCreated_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::AudioStreamCreatorClient::StreamCreated",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::AudioStreamCreatorClient::StreamCreated");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::AudioStreamCreatorClient_StreamCreated_Params_Data* params =
          reinterpret_cast<internal::AudioStreamCreatorClient_StreamCreated_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingRemote<::media::mojom::AudioInputStream> p_stream{};
      mojo::PendingReceiver<::media::mojom::AudioInputStreamClient> p_client_receiver{};
      ::media::mojom::ReadOnlyAudioDataPipePtr p_data_pipe{};
      bool p_initially_muted{};
      AudioStreamCreatorClient_StreamCreated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_stream =
            input_data_view.TakeStream<decltype(p_stream)>();
      }
      if (success) {
        p_client_receiver =
            input_data_view.TakeClientReceiver<decltype(p_client_receiver)>();
      }
      if (success && !input_data_view.ReadDataPipe(&p_data_pipe))
        success = false;
      if (success)
        p_initially_muted = input_data_view.initially_muted();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AudioStreamCreatorClient::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->StreamCreated(
std::move(p_stream), 
std::move(p_client_receiver), 
std::move(p_data_pipe), 
std::move(p_initially_muted));
      return true;
    }
  }
  return false;
}

// static
bool AudioStreamCreatorClientStubDispatch::AcceptWithResponder(
    AudioStreamCreatorClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kAudioStreamCreatorClient_StreamCreated_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kAudioStreamCreatorClientValidationInfo[] = {
    {internal::kAudioStreamCreatorClient_StreamCreated_Name,
     {&internal::AudioStreamCreatorClient_StreamCreated_Params_Data::Validate,
      nullptr /* no response */}},
};

bool AudioStreamCreatorClientRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::mirroring::mojom::AudioStreamCreatorClient::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kAudioStreamCreatorClientValidationInfo);
}

const char ResourceProvider::Name_[] = "mirroring.mojom.ResourceProvider";

ResourceProviderProxy::ResourceProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ResourceProviderProxy::BindGpu(
    mojo::PendingReceiver<::viz::mojom::Gpu> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::ResourceProvider::BindGpu");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kResourceProvider_BindGpu_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::ResourceProvider_BindGpu_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::viz::mojom::GpuInterfaceBase>>(
      in_receiver, &params->receiver, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid receiver in ResourceProvider.BindGpu request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ResourceProvider::Name_);
  message.set_method_name("BindGpu");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ResourceProviderProxy::GetVideoCaptureHost(
    mojo::PendingReceiver<::media::mojom::VideoCaptureHost> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::ResourceProvider::GetVideoCaptureHost");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kResourceProvider_GetVideoCaptureHost_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::ResourceProvider_GetVideoCaptureHost_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::media::mojom::VideoCaptureHostInterfaceBase>>(
      in_receiver, &params->receiver, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid receiver in ResourceProvider.GetVideoCaptureHost request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ResourceProvider::Name_);
  message.set_method_name("GetVideoCaptureHost");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ResourceProviderProxy::GetNetworkContext(
    mojo::PendingReceiver<::network::mojom::NetworkContext> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::ResourceProvider::GetNetworkContext");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kResourceProvider_GetNetworkContext_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::ResourceProvider_GetNetworkContext_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::network::mojom::NetworkContextInterfaceBase>>(
      in_receiver, &params->receiver, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid receiver in ResourceProvider.GetNetworkContext request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ResourceProvider::Name_);
  message.set_method_name("GetNetworkContext");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ResourceProviderProxy::CreateAudioStream(
    mojo::PendingRemote<AudioStreamCreatorClient> in_client, const ::media::AudioParameters& in_param, uint32_t in_shared_memory_count) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::ResourceProvider::CreateAudioStream");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kResourceProvider_CreateAudioStream_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::ResourceProvider_CreateAudioStream_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::mirroring::mojom::AudioStreamCreatorClientInterfaceBase>>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in ResourceProvider.CreateAudioStream request");
  typename decltype(params->param)::BaseType::BufferWriter
      param_writer;
  mojo::internal::Serialize<::media::mojom::AudioParametersDataView>(
      in_param, buffer, &param_writer, &serialization_context);
  params->param.Set(
      param_writer.is_null() ? nullptr : param_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->param.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null param in ResourceProvider.CreateAudioStream request");
  params->shared_memory_count = in_shared_memory_count;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ResourceProvider::Name_);
  message.set_method_name("CreateAudioStream");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ResourceProviderProxy::ConnectToRemotingSource(
    mojo::PendingRemote<::media::mojom::Remoter> in_remoter, mojo::PendingReceiver<::media::mojom::RemotingSource> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "mirroring::mojom::ResourceProvider::ConnectToRemotingSource");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kResourceProvider_ConnectToRemotingSource_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mirroring::mojom::internal::ResourceProvider_ConnectToRemotingSource_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::media::mojom::RemoterInterfaceBase>>(
      in_remoter, &params->remoter, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->remoter),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid remoter in ResourceProvider.ConnectToRemotingSource request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::media::mojom::RemotingSourceInterfaceBase>>(
      in_receiver, &params->receiver, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid receiver in ResourceProvider.ConnectToRemotingSource request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ResourceProvider::Name_);
  message.set_method_name("ConnectToRemotingSource");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ResourceProviderStubDispatch::Accept(
    ResourceProvider* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kResourceProvider_BindGpu_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::ResourceProvider::BindGpu",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::ResourceProvider::BindGpu");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ResourceProvider_BindGpu_Params_Data* params =
          reinterpret_cast<internal::ResourceProvider_BindGpu_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingReceiver<::viz::mojom::Gpu> p_receiver{};
      ResourceProvider_BindGpu_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ResourceProvider::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->BindGpu(
std::move(p_receiver));
      return true;
    }
    case internal::kResourceProvider_GetVideoCaptureHost_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::ResourceProvider::GetVideoCaptureHost",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::ResourceProvider::GetVideoCaptureHost");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ResourceProvider_GetVideoCaptureHost_Params_Data* params =
          reinterpret_cast<internal::ResourceProvider_GetVideoCaptureHost_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingReceiver<::media::mojom::VideoCaptureHost> p_receiver{};
      ResourceProvider_GetVideoCaptureHost_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ResourceProvider::Name_, 443823799, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetVideoCaptureHost(
std::move(p_receiver));
      return true;
    }
    case internal::kResourceProvider_GetNetworkContext_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::ResourceProvider::GetNetworkContext",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::ResourceProvider::GetNetworkContext");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ResourceProvider_GetNetworkContext_Params_Data* params =
          reinterpret_cast<internal::ResourceProvider_GetNetworkContext_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingReceiver<::network::mojom::NetworkContext> p_receiver{};
      ResourceProvider_GetNetworkContext_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ResourceProvider::Name_, 876059116, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetNetworkContext(
std::move(p_receiver));
      return true;
    }
    case internal::kResourceProvider_CreateAudioStream_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::ResourceProvider::CreateAudioStream",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::ResourceProvider::CreateAudioStream");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ResourceProvider_CreateAudioStream_Params_Data* params =
          reinterpret_cast<internal::ResourceProvider_CreateAudioStream_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingRemote<AudioStreamCreatorClient> p_client{};
      ::media::AudioParameters p_param{};
      uint32_t p_shared_memory_count{};
      ResourceProvider_CreateAudioStream_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_client =
            input_data_view.TakeClient<decltype(p_client)>();
      }
      if (success && !input_data_view.ReadParam(&p_param))
        success = false;
      if (success)
        p_shared_memory_count = input_data_view.shared_memory_count();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ResourceProvider::Name_, 1124617171, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateAudioStream(
std::move(p_client), 
std::move(p_param), 
std::move(p_shared_memory_count));
      return true;
    }
    case internal::kResourceProvider_ConnectToRemotingSource_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)mirroring::mojom::ResourceProvider::ConnectToRemotingSource",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)mirroring::mojom::ResourceProvider::ConnectToRemotingSource");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ResourceProvider_ConnectToRemotingSource_Params_Data* params =
          reinterpret_cast<internal::ResourceProvider_ConnectToRemotingSource_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingRemote<::media::mojom::Remoter> p_remoter{};
      mojo::PendingReceiver<::media::mojom::RemotingSource> p_receiver{};
      ResourceProvider_ConnectToRemotingSource_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_remoter =
            input_data_view.TakeRemoter<decltype(p_remoter)>();
      }
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ResourceProvider::Name_, 826047959, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->ConnectToRemotingSource(
std::move(p_remoter), 
std::move(p_receiver));
      return true;
    }
  }
  return false;
}

// static
bool ResourceProviderStubDispatch::AcceptWithResponder(
    ResourceProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kResourceProvider_BindGpu_Name: {
      break;
    }
    case internal::kResourceProvider_GetVideoCaptureHost_Name: {
      break;
    }
    case internal::kResourceProvider_GetNetworkContext_Name: {
      break;
    }
    case internal::kResourceProvider_CreateAudioStream_Name: {
      break;
    }
    case internal::kResourceProvider_ConnectToRemotingSource_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kResourceProviderValidationInfo[] = {
    {internal::kResourceProvider_BindGpu_Name,
     {&internal::ResourceProvider_BindGpu_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kResourceProvider_GetVideoCaptureHost_Name,
     {&internal::ResourceProvider_GetVideoCaptureHost_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kResourceProvider_GetNetworkContext_Name,
     {&internal::ResourceProvider_GetNetworkContext_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kResourceProvider_CreateAudioStream_Name,
     {&internal::ResourceProvider_CreateAudioStream_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kResourceProvider_ConnectToRemotingSource_Name,
     {&internal::ResourceProvider_ConnectToRemotingSource_Params_Data::Validate,
      nullptr /* no response */}},
};

bool ResourceProviderRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::mirroring::mojom::ResourceProvider::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kResourceProviderValidationInfo);
}

}  // namespace mojom
}  // namespace mirroring

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif