// components/services/storage/public/mojom/service_worker_storage_control.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/storage/public/mojom/service_worker_storage_control.mojom-shared.h"
#include "components/services/storage/public/mojom/service_worker_storage_control.mojom-forward.h"
#include "components/services/storage/public/mojom/service_worker_database.mojom.h"
#include "mojo/public/mojom/base/big_buffer.mojom.h"
#include "services/network/public/mojom/url_response_head.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace storage {
namespace mojom {

class ServiceWorkerResourceWriterProxy;

template <typename ImplRefTraits>
class ServiceWorkerResourceWriterStub;

class ServiceWorkerResourceWriterRequestValidator;
class ServiceWorkerResourceWriterResponseValidator;


class  ServiceWorkerResourceWriter
    : public ServiceWorkerResourceWriterInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = ServiceWorkerResourceWriterInterfaceBase;
  using Proxy_ = ServiceWorkerResourceWriterProxy;

  template <typename ImplRefTraits>
  using Stub_ = ServiceWorkerResourceWriterStub<ImplRefTraits>;

  using RequestValidator_ = ServiceWorkerResourceWriterRequestValidator;
  using ResponseValidator_ = ServiceWorkerResourceWriterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kWriteResponseHeadMinVersion = 0,
    kWriteDataMinVersion = 0,
  };
  virtual ~ServiceWorkerResourceWriter() {}


  using WriteResponseHeadCallback = base::OnceCallback<void(int32_t)>;
  
  virtual void WriteResponseHead(::network::mojom::URLResponseHeadPtr response_head, WriteResponseHeadCallback callback) = 0;


  using WriteDataCallback = base::OnceCallback<void(int32_t)>;
  
  virtual void WriteData(::mojo_base::BigBuffer data, WriteDataCallback callback) = 0;
};

class ServiceWorkerStorageControlProxy;

template <typename ImplRefTraits>
class ServiceWorkerStorageControlStub;

class ServiceWorkerStorageControlRequestValidator;
class ServiceWorkerStorageControlResponseValidator;


class  ServiceWorkerStorageControl
    : public ServiceWorkerStorageControlInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = ServiceWorkerStorageControlInterfaceBase;
  using Proxy_ = ServiceWorkerStorageControlProxy;

  template <typename ImplRefTraits>
  using Stub_ = ServiceWorkerStorageControlStub<ImplRefTraits>;

  using RequestValidator_ = ServiceWorkerStorageControlRequestValidator;
  using ResponseValidator_ = ServiceWorkerStorageControlResponseValidator;
  enum MethodMinVersions : uint32_t {
    kFindRegistrationForClientUrlMinVersion = 0,
    kFindRegistrationForScopeMinVersion = 0,
    kFindRegistrationForIdMinVersion = 0,
    kStoreRegistrationMinVersion = 0,
    kDeleteRegistrationMinVersion = 0,
    kGetNewResourceIdMinVersion = 0,
    kCreateResourceWriterMinVersion = 0,
  };
  virtual ~ServiceWorkerStorageControl() {}


  using FindRegistrationForClientUrlCallback = base::OnceCallback<void(ServiceWorkerFindRegistrationResultPtr)>;
  
  virtual void FindRegistrationForClientUrl(const ::GURL& client_url, FindRegistrationForClientUrlCallback callback) = 0;


  using FindRegistrationForScopeCallback = base::OnceCallback<void(ServiceWorkerFindRegistrationResultPtr)>;
  
  virtual void FindRegistrationForScope(const ::GURL& scope, FindRegistrationForScopeCallback callback) = 0;


  using FindRegistrationForIdCallback = base::OnceCallback<void(ServiceWorkerFindRegistrationResultPtr)>;
  
  virtual void FindRegistrationForId(int64_t registration_id, const ::GURL& origin, FindRegistrationForIdCallback callback) = 0;


  using StoreRegistrationCallback = base::OnceCallback<void(::storage::mojom::ServiceWorkerDatabaseStatus)>;
  
  virtual void StoreRegistration(::storage::mojom::ServiceWorkerRegistrationDataPtr registration, std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources, StoreRegistrationCallback callback) = 0;


  using DeleteRegistrationCallback = base::OnceCallback<void(::storage::mojom::ServiceWorkerDatabaseStatus, ServiceWorkerStorageOriginState)>;
  
  virtual void DeleteRegistration(int64_t registration_id, const ::GURL& origin, DeleteRegistrationCallback callback) = 0;


  using GetNewResourceIdCallback = base::OnceCallback<void(int64_t)>;
  
  virtual void GetNewResourceId(GetNewResourceIdCallback callback) = 0;

  
  virtual void CreateResourceWriter(int64_t resource_id, mojo::PendingReceiver<ServiceWorkerResourceWriter> writer) = 0;
};



class  ServiceWorkerResourceWriterProxy
    : public ServiceWorkerResourceWriter {
 public:
  using InterfaceType = ServiceWorkerResourceWriter;

  explicit ServiceWorkerResourceWriterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void WriteResponseHead(::network::mojom::URLResponseHeadPtr response_head, WriteResponseHeadCallback callback) final;
  
  void WriteData(::mojo_base::BigBuffer data, WriteDataCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  ServiceWorkerStorageControlProxy
    : public ServiceWorkerStorageControl {
 public:
  using InterfaceType = ServiceWorkerStorageControl;

  explicit ServiceWorkerStorageControlProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void FindRegistrationForClientUrl(const ::GURL& client_url, FindRegistrationForClientUrlCallback callback) final;
  
  void FindRegistrationForScope(const ::GURL& scope, FindRegistrationForScopeCallback callback) final;
  
  void FindRegistrationForId(int64_t registration_id, const ::GURL& origin, FindRegistrationForIdCallback callback) final;
  
  void StoreRegistration(::storage::mojom::ServiceWorkerRegistrationDataPtr registration, std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources, StoreRegistrationCallback callback) final;
  
  void DeleteRegistration(int64_t registration_id, const ::GURL& origin, DeleteRegistrationCallback callback) final;
  
  void GetNewResourceId(GetNewResourceIdCallback callback) final;
  
  void CreateResourceWriter(int64_t resource_id, mojo::PendingReceiver<ServiceWorkerResourceWriter> writer) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ServiceWorkerResourceWriterStubDispatch {
 public:
  static bool Accept(ServiceWorkerResourceWriter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ServiceWorkerResourceWriter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ServiceWorkerResourceWriter>>
class ServiceWorkerResourceWriterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ServiceWorkerResourceWriterStub() {}
  ~ServiceWorkerResourceWriterStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerResourceWriterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerResourceWriterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ServiceWorkerStorageControlStubDispatch {
 public:
  static bool Accept(ServiceWorkerStorageControl* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ServiceWorkerStorageControl* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ServiceWorkerStorageControl>>
class ServiceWorkerStorageControlStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ServiceWorkerStorageControlStub() {}
  ~ServiceWorkerStorageControlStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerStorageControlStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerStorageControlStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ServiceWorkerResourceWriterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ServiceWorkerStorageControlRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ServiceWorkerResourceWriterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ServiceWorkerStorageControlResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  ServiceWorkerFindRegistrationResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ServiceWorkerFindRegistrationResult, T>::value>;
  using DataView = ServiceWorkerFindRegistrationResultDataView;
  using Data_ = internal::ServiceWorkerFindRegistrationResult_Data;

  template <typename... Args>
  static ServiceWorkerFindRegistrationResultPtr New(Args&&... args) {
    return ServiceWorkerFindRegistrationResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ServiceWorkerFindRegistrationResultPtr From(const U& u) {
    return mojo::TypeConverter<ServiceWorkerFindRegistrationResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ServiceWorkerFindRegistrationResult>::Convert(*this);
  }


  ServiceWorkerFindRegistrationResult();

  ServiceWorkerFindRegistrationResult(
      ::storage::mojom::ServiceWorkerDatabaseStatus status,
      ::storage::mojom::ServiceWorkerRegistrationDataPtr registration,
      std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources);

  ~ServiceWorkerFindRegistrationResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ServiceWorkerFindRegistrationResultPtr>
  ServiceWorkerFindRegistrationResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ServiceWorkerFindRegistrationResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ServiceWorkerFindRegistrationResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ServiceWorkerFindRegistrationResult_UnserializedMessageContext<
            UserType, ServiceWorkerFindRegistrationResult::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ServiceWorkerFindRegistrationResult::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ServiceWorkerFindRegistrationResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ServiceWorkerFindRegistrationResult_UnserializedMessageContext<
            UserType, ServiceWorkerFindRegistrationResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ServiceWorkerFindRegistrationResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::storage::mojom::ServiceWorkerDatabaseStatus status;
  
  ::storage::mojom::ServiceWorkerRegistrationDataPtr registration;
  
  std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerFindRegistrationResult);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ServiceWorkerFindRegistrationResultPtr ServiceWorkerFindRegistrationResult::Clone() const {
  return New(
      mojo::Clone(status),
      mojo::Clone(registration),
      mojo::Clone(resources)
  );
}

template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>*>
bool ServiceWorkerFindRegistrationResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  if (!mojo::Equals(this->registration, other_struct.registration))
    return false;
  if (!mojo::Equals(this->resources, other_struct.resources))
    return false;
  return true;
}

template <typename T, ServiceWorkerFindRegistrationResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.status < rhs.status)
    return true;
  if (rhs.status < lhs.status)
    return false;
  if (lhs.registration < rhs.registration)
    return true;
  if (rhs.registration < lhs.registration)
    return false;
  if (lhs.resources < rhs.resources)
    return true;
  if (rhs.resources < lhs.resources)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace storage

namespace mojo {


template <>
struct  StructTraits<::storage::mojom::ServiceWorkerFindRegistrationResult::DataView,
                                         ::storage::mojom::ServiceWorkerFindRegistrationResultPtr> {
  static bool IsNull(const ::storage::mojom::ServiceWorkerFindRegistrationResultPtr& input) { return !input; }
  static void SetToNull(::storage::mojom::ServiceWorkerFindRegistrationResultPtr* output) { output->reset(); }

  static decltype(::storage::mojom::ServiceWorkerFindRegistrationResult::status) status(
      const ::storage::mojom::ServiceWorkerFindRegistrationResultPtr& input) {
    return input->status;
  }

  static const decltype(::storage::mojom::ServiceWorkerFindRegistrationResult::registration)& registration(
      const ::storage::mojom::ServiceWorkerFindRegistrationResultPtr& input) {
    return input->registration;
  }

  static const decltype(::storage::mojom::ServiceWorkerFindRegistrationResult::resources)& resources(
      const ::storage::mojom::ServiceWorkerFindRegistrationResultPtr& input) {
    return input->resources;
  }

  static bool Read(::storage::mojom::ServiceWorkerFindRegistrationResult::DataView input, ::storage::mojom::ServiceWorkerFindRegistrationResultPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_H_