// This file is generated by TypeBuilder_cpp.template.

// Copyright (c) 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "content/browser/devtools/protocol/security.h"

#include "content/browser/devtools/protocol/protocol.h"

#include "third_party/inspector_protocol/crdtp/cbor.h"
#include "third_party/inspector_protocol/crdtp/find_by_first.h"
#include "third_party/inspector_protocol/crdtp/serializer_traits.h"
#include "third_party/inspector_protocol/crdtp/span.h"

namespace content {
namespace protocol {
namespace Security {

// ------------- Enum values from types.

const char Metainfo::domainName[] = "Security";
const char Metainfo::commandPrefix[] = "Security.";
const char Metainfo::version[] = "1.3";

namespace MixedContentTypeEnum {
const char Blockable[] = "blockable";
const char OptionallyBlockable[] = "optionally-blockable";
const char None[] = "none";
} // namespace MixedContentTypeEnum

namespace SecurityStateEnum {
const char Unknown[] = "unknown";
const char Neutral[] = "neutral";
const char Insecure[] = "insecure";
const char Secure[] = "secure";
const char Info[] = "info";
const char InsecureBroken[] = "insecure-broken";
} // namespace SecurityStateEnum

std::unique_ptr<CertificateSecurityState> CertificateSecurityState::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<CertificateSecurityState> result(new CertificateSecurityState());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* protocolValue = object->get("protocol");
    errors->SetName("protocol");
    result->m_protocol = ValueConversions<String>::fromValue(protocolValue, errors);
    protocol::Value* keyExchangeValue = object->get("keyExchange");
    errors->SetName("keyExchange");
    result->m_keyExchange = ValueConversions<String>::fromValue(keyExchangeValue, errors);
    protocol::Value* keyExchangeGroupValue = object->get("keyExchangeGroup");
    if (keyExchangeGroupValue) {
        errors->SetName("keyExchangeGroup");
        result->m_keyExchangeGroup = ValueConversions<String>::fromValue(keyExchangeGroupValue, errors);
    }
    protocol::Value* cipherValue = object->get("cipher");
    errors->SetName("cipher");
    result->m_cipher = ValueConversions<String>::fromValue(cipherValue, errors);
    protocol::Value* macValue = object->get("mac");
    if (macValue) {
        errors->SetName("mac");
        result->m_mac = ValueConversions<String>::fromValue(macValue, errors);
    }
    protocol::Value* certificateValue = object->get("certificate");
    errors->SetName("certificate");
    result->m_certificate = ValueConversions<protocol::Array<String>>::fromValue(certificateValue, errors);
    protocol::Value* subjectNameValue = object->get("subjectName");
    errors->SetName("subjectName");
    result->m_subjectName = ValueConversions<String>::fromValue(subjectNameValue, errors);
    protocol::Value* issuerValue = object->get("issuer");
    errors->SetName("issuer");
    result->m_issuer = ValueConversions<String>::fromValue(issuerValue, errors);
    protocol::Value* validFromValue = object->get("validFrom");
    errors->SetName("validFrom");
    result->m_validFrom = ValueConversions<double>::fromValue(validFromValue, errors);
    protocol::Value* validToValue = object->get("validTo");
    errors->SetName("validTo");
    result->m_validTo = ValueConversions<double>::fromValue(validToValue, errors);
    protocol::Value* certificateNetworkErrorValue = object->get("certificateNetworkError");
    if (certificateNetworkErrorValue) {
        errors->SetName("certificateNetworkError");
        result->m_certificateNetworkError = ValueConversions<String>::fromValue(certificateNetworkErrorValue, errors);
    }
    protocol::Value* certificateHasWeakSignatureValue = object->get("certificateHasWeakSignature");
    errors->SetName("certificateHasWeakSignature");
    result->m_certificateHasWeakSignature = ValueConversions<bool>::fromValue(certificateHasWeakSignatureValue, errors);
    protocol::Value* certificateHasSha1SignatureValue = object->get("certificateHasSha1Signature");
    errors->SetName("certificateHasSha1Signature");
    result->m_certificateHasSha1Signature = ValueConversions<bool>::fromValue(certificateHasSha1SignatureValue, errors);
    protocol::Value* modernSSLValue = object->get("modernSSL");
    errors->SetName("modernSSL");
    result->m_modernSSL = ValueConversions<bool>::fromValue(modernSSLValue, errors);
    protocol::Value* obsoleteSslProtocolValue = object->get("obsoleteSslProtocol");
    errors->SetName("obsoleteSslProtocol");
    result->m_obsoleteSslProtocol = ValueConversions<bool>::fromValue(obsoleteSslProtocolValue, errors);
    protocol::Value* obsoleteSslKeyExchangeValue = object->get("obsoleteSslKeyExchange");
    errors->SetName("obsoleteSslKeyExchange");
    result->m_obsoleteSslKeyExchange = ValueConversions<bool>::fromValue(obsoleteSslKeyExchangeValue, errors);
    protocol::Value* obsoleteSslCipherValue = object->get("obsoleteSslCipher");
    errors->SetName("obsoleteSslCipher");
    result->m_obsoleteSslCipher = ValueConversions<bool>::fromValue(obsoleteSslCipherValue, errors);
    protocol::Value* obsoleteSslSignatureValue = object->get("obsoleteSslSignature");
    errors->SetName("obsoleteSslSignature");
    result->m_obsoleteSslSignature = ValueConversions<bool>::fromValue(obsoleteSslSignatureValue, errors);
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> CertificateSecurityState::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("protocol", ValueConversions<String>::toValue(m_protocol));
    result->setValue("keyExchange", ValueConversions<String>::toValue(m_keyExchange));
    if (m_keyExchangeGroup.isJust())
        result->setValue("keyExchangeGroup", ValueConversions<String>::toValue(m_keyExchangeGroup.fromJust()));
    result->setValue("cipher", ValueConversions<String>::toValue(m_cipher));
    if (m_mac.isJust())
        result->setValue("mac", ValueConversions<String>::toValue(m_mac.fromJust()));
    result->setValue("certificate", ValueConversions<protocol::Array<String>>::toValue(m_certificate.get()));
    result->setValue("subjectName", ValueConversions<String>::toValue(m_subjectName));
    result->setValue("issuer", ValueConversions<String>::toValue(m_issuer));
    result->setValue("validFrom", ValueConversions<double>::toValue(m_validFrom));
    result->setValue("validTo", ValueConversions<double>::toValue(m_validTo));
    if (m_certificateNetworkError.isJust())
        result->setValue("certificateNetworkError", ValueConversions<String>::toValue(m_certificateNetworkError.fromJust()));
    result->setValue("certificateHasWeakSignature", ValueConversions<bool>::toValue(m_certificateHasWeakSignature));
    result->setValue("certificateHasSha1Signature", ValueConversions<bool>::toValue(m_certificateHasSha1Signature));
    result->setValue("modernSSL", ValueConversions<bool>::toValue(m_modernSSL));
    result->setValue("obsoleteSslProtocol", ValueConversions<bool>::toValue(m_obsoleteSslProtocol));
    result->setValue("obsoleteSslKeyExchange", ValueConversions<bool>::toValue(m_obsoleteSslKeyExchange));
    result->setValue("obsoleteSslCipher", ValueConversions<bool>::toValue(m_obsoleteSslCipher));
    result->setValue("obsoleteSslSignature", ValueConversions<bool>::toValue(m_obsoleteSslSignature));
    return result;
}

void CertificateSecurityState::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("protocol"), m_protocol, out);
      crdtp::SerializeField(crdtp::SpanFrom("keyExchange"), m_keyExchange, out);
      crdtp::SerializeField(crdtp::SpanFrom("keyExchangeGroup"), m_keyExchangeGroup, out);
      crdtp::SerializeField(crdtp::SpanFrom("cipher"), m_cipher, out);
      crdtp::SerializeField(crdtp::SpanFrom("mac"), m_mac, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificate"), m_certificate, out);
      crdtp::SerializeField(crdtp::SpanFrom("subjectName"), m_subjectName, out);
      crdtp::SerializeField(crdtp::SpanFrom("issuer"), m_issuer, out);
      crdtp::SerializeField(crdtp::SpanFrom("validFrom"), m_validFrom, out);
      crdtp::SerializeField(crdtp::SpanFrom("validTo"), m_validTo, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificateNetworkError"), m_certificateNetworkError, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificateHasWeakSignature"), m_certificateHasWeakSignature, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificateHasSha1Signature"), m_certificateHasSha1Signature, out);
      crdtp::SerializeField(crdtp::SpanFrom("modernSSL"), m_modernSSL, out);
      crdtp::SerializeField(crdtp::SpanFrom("obsoleteSslProtocol"), m_obsoleteSslProtocol, out);
      crdtp::SerializeField(crdtp::SpanFrom("obsoleteSslKeyExchange"), m_obsoleteSslKeyExchange, out);
      crdtp::SerializeField(crdtp::SpanFrom("obsoleteSslCipher"), m_obsoleteSslCipher, out);
      crdtp::SerializeField(crdtp::SpanFrom("obsoleteSslSignature"), m_obsoleteSslSignature, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<CertificateSecurityState> CertificateSecurityState::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

namespace SafetyTipStatusEnum {
const char BadReputation[] = "badReputation";
const char Lookalike[] = "lookalike";
} // namespace SafetyTipStatusEnum

std::unique_ptr<SafetyTipInfo> SafetyTipInfo::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<SafetyTipInfo> result(new SafetyTipInfo());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* safetyTipStatusValue = object->get("safetyTipStatus");
    errors->SetName("safetyTipStatus");
    result->m_safetyTipStatus = ValueConversions<String>::fromValue(safetyTipStatusValue, errors);
    protocol::Value* safeUrlValue = object->get("safeUrl");
    if (safeUrlValue) {
        errors->SetName("safeUrl");
        result->m_safeUrl = ValueConversions<String>::fromValue(safeUrlValue, errors);
    }
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> SafetyTipInfo::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("safetyTipStatus", ValueConversions<String>::toValue(m_safetyTipStatus));
    if (m_safeUrl.isJust())
        result->setValue("safeUrl", ValueConversions<String>::toValue(m_safeUrl.fromJust()));
    return result;
}

void SafetyTipInfo::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("safetyTipStatus"), m_safetyTipStatus, out);
      crdtp::SerializeField(crdtp::SpanFrom("safeUrl"), m_safeUrl, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<SafetyTipInfo> SafetyTipInfo::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

std::unique_ptr<VisibleSecurityState> VisibleSecurityState::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<VisibleSecurityState> result(new VisibleSecurityState());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* securityStateValue = object->get("securityState");
    errors->SetName("securityState");
    result->m_securityState = ValueConversions<String>::fromValue(securityStateValue, errors);
    protocol::Value* certificateSecurityStateValue = object->get("certificateSecurityState");
    if (certificateSecurityStateValue) {
        errors->SetName("certificateSecurityState");
        result->m_certificateSecurityState = ValueConversions<protocol::Security::CertificateSecurityState>::fromValue(certificateSecurityStateValue, errors);
    }
    protocol::Value* safetyTipInfoValue = object->get("safetyTipInfo");
    if (safetyTipInfoValue) {
        errors->SetName("safetyTipInfo");
        result->m_safetyTipInfo = ValueConversions<protocol::Security::SafetyTipInfo>::fromValue(safetyTipInfoValue, errors);
    }
    protocol::Value* securityStateIssueIdsValue = object->get("securityStateIssueIds");
    errors->SetName("securityStateIssueIds");
    result->m_securityStateIssueIds = ValueConversions<protocol::Array<String>>::fromValue(securityStateIssueIdsValue, errors);
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> VisibleSecurityState::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("securityState", ValueConversions<String>::toValue(m_securityState));
    if (m_certificateSecurityState.isJust())
        result->setValue("certificateSecurityState", ValueConversions<protocol::Security::CertificateSecurityState>::toValue(m_certificateSecurityState.fromJust()));
    if (m_safetyTipInfo.isJust())
        result->setValue("safetyTipInfo", ValueConversions<protocol::Security::SafetyTipInfo>::toValue(m_safetyTipInfo.fromJust()));
    result->setValue("securityStateIssueIds", ValueConversions<protocol::Array<String>>::toValue(m_securityStateIssueIds.get()));
    return result;
}

void VisibleSecurityState::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("securityState"), m_securityState, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificateSecurityState"), m_certificateSecurityState, out);
      crdtp::SerializeField(crdtp::SpanFrom("safetyTipInfo"), m_safetyTipInfo, out);
      crdtp::SerializeField(crdtp::SpanFrom("securityStateIssueIds"), m_securityStateIssueIds, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<VisibleSecurityState> VisibleSecurityState::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

std::unique_ptr<SecurityStateExplanation> SecurityStateExplanation::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<SecurityStateExplanation> result(new SecurityStateExplanation());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* securityStateValue = object->get("securityState");
    errors->SetName("securityState");
    result->m_securityState = ValueConversions<String>::fromValue(securityStateValue, errors);
    protocol::Value* titleValue = object->get("title");
    errors->SetName("title");
    result->m_title = ValueConversions<String>::fromValue(titleValue, errors);
    protocol::Value* summaryValue = object->get("summary");
    errors->SetName("summary");
    result->m_summary = ValueConversions<String>::fromValue(summaryValue, errors);
    protocol::Value* descriptionValue = object->get("description");
    errors->SetName("description");
    result->m_description = ValueConversions<String>::fromValue(descriptionValue, errors);
    protocol::Value* mixedContentTypeValue = object->get("mixedContentType");
    errors->SetName("mixedContentType");
    result->m_mixedContentType = ValueConversions<String>::fromValue(mixedContentTypeValue, errors);
    protocol::Value* certificateValue = object->get("certificate");
    errors->SetName("certificate");
    result->m_certificate = ValueConversions<protocol::Array<String>>::fromValue(certificateValue, errors);
    protocol::Value* recommendationsValue = object->get("recommendations");
    if (recommendationsValue) {
        errors->SetName("recommendations");
        result->m_recommendations = ValueConversions<protocol::Array<String>>::fromValue(recommendationsValue, errors);
    }
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> SecurityStateExplanation::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("securityState", ValueConversions<String>::toValue(m_securityState));
    result->setValue("title", ValueConversions<String>::toValue(m_title));
    result->setValue("summary", ValueConversions<String>::toValue(m_summary));
    result->setValue("description", ValueConversions<String>::toValue(m_description));
    result->setValue("mixedContentType", ValueConversions<String>::toValue(m_mixedContentType));
    result->setValue("certificate", ValueConversions<protocol::Array<String>>::toValue(m_certificate.get()));
    if (m_recommendations.isJust())
        result->setValue("recommendations", ValueConversions<protocol::Array<String>>::toValue(m_recommendations.fromJust()));
    return result;
}

void SecurityStateExplanation::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("securityState"), m_securityState, out);
      crdtp::SerializeField(crdtp::SpanFrom("title"), m_title, out);
      crdtp::SerializeField(crdtp::SpanFrom("summary"), m_summary, out);
      crdtp::SerializeField(crdtp::SpanFrom("description"), m_description, out);
      crdtp::SerializeField(crdtp::SpanFrom("mixedContentType"), m_mixedContentType, out);
      crdtp::SerializeField(crdtp::SpanFrom("certificate"), m_certificate, out);
      crdtp::SerializeField(crdtp::SpanFrom("recommendations"), m_recommendations, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<SecurityStateExplanation> SecurityStateExplanation::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

std::unique_ptr<InsecureContentStatus> InsecureContentStatus::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<InsecureContentStatus> result(new InsecureContentStatus());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* ranMixedContentValue = object->get("ranMixedContent");
    errors->SetName("ranMixedContent");
    result->m_ranMixedContent = ValueConversions<bool>::fromValue(ranMixedContentValue, errors);
    protocol::Value* displayedMixedContentValue = object->get("displayedMixedContent");
    errors->SetName("displayedMixedContent");
    result->m_displayedMixedContent = ValueConversions<bool>::fromValue(displayedMixedContentValue, errors);
    protocol::Value* containedMixedFormValue = object->get("containedMixedForm");
    errors->SetName("containedMixedForm");
    result->m_containedMixedForm = ValueConversions<bool>::fromValue(containedMixedFormValue, errors);
    protocol::Value* ranContentWithCertErrorsValue = object->get("ranContentWithCertErrors");
    errors->SetName("ranContentWithCertErrors");
    result->m_ranContentWithCertErrors = ValueConversions<bool>::fromValue(ranContentWithCertErrorsValue, errors);
    protocol::Value* displayedContentWithCertErrorsValue = object->get("displayedContentWithCertErrors");
    errors->SetName("displayedContentWithCertErrors");
    result->m_displayedContentWithCertErrors = ValueConversions<bool>::fromValue(displayedContentWithCertErrorsValue, errors);
    protocol::Value* ranInsecureContentStyleValue = object->get("ranInsecureContentStyle");
    errors->SetName("ranInsecureContentStyle");
    result->m_ranInsecureContentStyle = ValueConversions<String>::fromValue(ranInsecureContentStyleValue, errors);
    protocol::Value* displayedInsecureContentStyleValue = object->get("displayedInsecureContentStyle");
    errors->SetName("displayedInsecureContentStyle");
    result->m_displayedInsecureContentStyle = ValueConversions<String>::fromValue(displayedInsecureContentStyleValue, errors);
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> InsecureContentStatus::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("ranMixedContent", ValueConversions<bool>::toValue(m_ranMixedContent));
    result->setValue("displayedMixedContent", ValueConversions<bool>::toValue(m_displayedMixedContent));
    result->setValue("containedMixedForm", ValueConversions<bool>::toValue(m_containedMixedForm));
    result->setValue("ranContentWithCertErrors", ValueConversions<bool>::toValue(m_ranContentWithCertErrors));
    result->setValue("displayedContentWithCertErrors", ValueConversions<bool>::toValue(m_displayedContentWithCertErrors));
    result->setValue("ranInsecureContentStyle", ValueConversions<String>::toValue(m_ranInsecureContentStyle));
    result->setValue("displayedInsecureContentStyle", ValueConversions<String>::toValue(m_displayedInsecureContentStyle));
    return result;
}

void InsecureContentStatus::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("ranMixedContent"), m_ranMixedContent, out);
      crdtp::SerializeField(crdtp::SpanFrom("displayedMixedContent"), m_displayedMixedContent, out);
      crdtp::SerializeField(crdtp::SpanFrom("containedMixedForm"), m_containedMixedForm, out);
      crdtp::SerializeField(crdtp::SpanFrom("ranContentWithCertErrors"), m_ranContentWithCertErrors, out);
      crdtp::SerializeField(crdtp::SpanFrom("displayedContentWithCertErrors"), m_displayedContentWithCertErrors, out);
      crdtp::SerializeField(crdtp::SpanFrom("ranInsecureContentStyle"), m_ranInsecureContentStyle, out);
      crdtp::SerializeField(crdtp::SpanFrom("displayedInsecureContentStyle"), m_displayedInsecureContentStyle, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<InsecureContentStatus> InsecureContentStatus::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

namespace CertificateErrorActionEnum {
const char Continue[] = "continue";
const char Cancel[] = "cancel";
} // namespace CertificateErrorActionEnum

std::unique_ptr<CertificateErrorNotification> CertificateErrorNotification::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<CertificateErrorNotification> result(new CertificateErrorNotification());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* eventIdValue = object->get("eventId");
    errors->SetName("eventId");
    result->m_eventId = ValueConversions<int>::fromValue(eventIdValue, errors);
    protocol::Value* errorTypeValue = object->get("errorType");
    errors->SetName("errorType");
    result->m_errorType = ValueConversions<String>::fromValue(errorTypeValue, errors);
    protocol::Value* requestURLValue = object->get("requestURL");
    errors->SetName("requestURL");
    result->m_requestURL = ValueConversions<String>::fromValue(requestURLValue, errors);
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> CertificateErrorNotification::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("eventId", ValueConversions<int>::toValue(m_eventId));
    result->setValue("errorType", ValueConversions<String>::toValue(m_errorType));
    result->setValue("requestURL", ValueConversions<String>::toValue(m_requestURL));
    return result;
}

void CertificateErrorNotification::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("eventId"), m_eventId, out);
      crdtp::SerializeField(crdtp::SpanFrom("errorType"), m_errorType, out);
      crdtp::SerializeField(crdtp::SpanFrom("requestURL"), m_requestURL, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<CertificateErrorNotification> CertificateErrorNotification::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

std::unique_ptr<VisibleSecurityStateChangedNotification> VisibleSecurityStateChangedNotification::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<VisibleSecurityStateChangedNotification> result(new VisibleSecurityStateChangedNotification());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* visibleSecurityStateValue = object->get("visibleSecurityState");
    errors->SetName("visibleSecurityState");
    result->m_visibleSecurityState = ValueConversions<protocol::Security::VisibleSecurityState>::fromValue(visibleSecurityStateValue, errors);
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> VisibleSecurityStateChangedNotification::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("visibleSecurityState", ValueConversions<protocol::Security::VisibleSecurityState>::toValue(m_visibleSecurityState.get()));
    return result;
}

void VisibleSecurityStateChangedNotification::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("visibleSecurityState"), m_visibleSecurityState, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<VisibleSecurityStateChangedNotification> VisibleSecurityStateChangedNotification::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

std::unique_ptr<SecurityStateChangedNotification> SecurityStateChangedNotification::fromValue(protocol::Value* value, ErrorSupport* errors)
{
    if (!value || value->type() != protocol::Value::TypeObject) {
        errors->AddError("object expected");
        return nullptr;
    }

    std::unique_ptr<SecurityStateChangedNotification> result(new SecurityStateChangedNotification());
    protocol::DictionaryValue* object = DictionaryValue::cast(value);
    errors->Push();
    protocol::Value* securityStateValue = object->get("securityState");
    errors->SetName("securityState");
    result->m_securityState = ValueConversions<String>::fromValue(securityStateValue, errors);
    protocol::Value* schemeIsCryptographicValue = object->get("schemeIsCryptographic");
    errors->SetName("schemeIsCryptographic");
    result->m_schemeIsCryptographic = ValueConversions<bool>::fromValue(schemeIsCryptographicValue, errors);
    protocol::Value* explanationsValue = object->get("explanations");
    errors->SetName("explanations");
    result->m_explanations = ValueConversions<protocol::Array<protocol::Security::SecurityStateExplanation>>::fromValue(explanationsValue, errors);
    protocol::Value* insecureContentStatusValue = object->get("insecureContentStatus");
    errors->SetName("insecureContentStatus");
    result->m_insecureContentStatus = ValueConversions<protocol::Security::InsecureContentStatus>::fromValue(insecureContentStatusValue, errors);
    protocol::Value* summaryValue = object->get("summary");
    if (summaryValue) {
        errors->SetName("summary");
        result->m_summary = ValueConversions<String>::fromValue(summaryValue, errors);
    }
    errors->Pop();
    if (!errors->Errors().empty())
        return nullptr;
    return result;
}

std::unique_ptr<protocol::DictionaryValue> SecurityStateChangedNotification::toValue() const
{
    std::unique_ptr<protocol::DictionaryValue> result = DictionaryValue::create();
    result->setValue("securityState", ValueConversions<String>::toValue(m_securityState));
    result->setValue("schemeIsCryptographic", ValueConversions<bool>::toValue(m_schemeIsCryptographic));
    result->setValue("explanations", ValueConversions<protocol::Array<protocol::Security::SecurityStateExplanation>>::toValue(m_explanations.get()));
    result->setValue("insecureContentStatus", ValueConversions<protocol::Security::InsecureContentStatus>::toValue(m_insecureContentStatus.get()));
    if (m_summary.isJust())
        result->setValue("summary", ValueConversions<String>::toValue(m_summary.fromJust()));
    return result;
}

void SecurityStateChangedNotification::AppendSerialized(std::vector<uint8_t>* out) const {
    crdtp::cbor::EnvelopeEncoder envelope_encoder;
    envelope_encoder.EncodeStart(out);
    out->push_back(crdtp::cbor::EncodeIndefiniteLengthMapStart());
      crdtp::SerializeField(crdtp::SpanFrom("securityState"), m_securityState, out);
      crdtp::SerializeField(crdtp::SpanFrom("schemeIsCryptographic"), m_schemeIsCryptographic, out);
      crdtp::SerializeField(crdtp::SpanFrom("explanations"), m_explanations, out);
      crdtp::SerializeField(crdtp::SpanFrom("insecureContentStatus"), m_insecureContentStatus, out);
      crdtp::SerializeField(crdtp::SpanFrom("summary"), m_summary, out);
    out->push_back(crdtp::cbor::EncodeStop());
    envelope_encoder.EncodeStop(out);
}

std::unique_ptr<SecurityStateChangedNotification> SecurityStateChangedNotification::clone() const
{
    ErrorSupport errors;
    return fromValue(toValue().get(), &errors);
}

// ------------- Enum values from params.


// ------------- Frontend notifications.

void Frontend::CertificateError(int eventId, const String& errorType, const String& requestURL)
{
    if (!frontend_channel_)
        return;
    std::unique_ptr<CertificateErrorNotification> messageData = CertificateErrorNotification::Create()
        .SetEventId(eventId)
        .SetErrorType(errorType)
        .SetRequestURL(requestURL)
        .Build();
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Security.certificateError", std::move(messageData)));
}

void Frontend::VisibleSecurityStateChanged(std::unique_ptr<protocol::Security::VisibleSecurityState> visibleSecurityState)
{
    if (!frontend_channel_)
        return;
    std::unique_ptr<VisibleSecurityStateChangedNotification> messageData = VisibleSecurityStateChangedNotification::Create()
        .SetVisibleSecurityState(std::move(visibleSecurityState))
        .Build();
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Security.visibleSecurityStateChanged", std::move(messageData)));
}

void Frontend::SecurityStateChanged(const String& securityState, bool schemeIsCryptographic, std::unique_ptr<protocol::Array<protocol::Security::SecurityStateExplanation>> explanations, std::unique_ptr<protocol::Security::InsecureContentStatus> insecureContentStatus, Maybe<String> summary)
{
    if (!frontend_channel_)
        return;
    std::unique_ptr<SecurityStateChangedNotification> messageData = SecurityStateChangedNotification::Create()
        .SetSecurityState(securityState)
        .SetSchemeIsCryptographic(schemeIsCryptographic)
        .SetExplanations(std::move(explanations))
        .SetInsecureContentStatus(std::move(insecureContentStatus))
        .Build();
    if (summary.isJust())
        messageData->SetSummary(std::move(summary).takeJust());
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Security.securityStateChanged", std::move(messageData)));
}

void Frontend::flush()
{
    frontend_channel_->FlushProtocolNotifications();
}

void Frontend::sendRawNotification(std::unique_ptr<Serializable> notification)
{
    frontend_channel_->SendProtocolNotification(std::move(notification));
}

// --------------------- Dispatcher.

class DomainDispatcherImpl : public protocol::DomainDispatcher {
public:
    DomainDispatcherImpl(FrontendChannel* frontendChannel, Backend* backend)
        : DomainDispatcher(frontendChannel)
        , m_backend(backend) {}
    ~DomainDispatcherImpl() override { }

    using CallHandler = void (DomainDispatcherImpl::*)(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);

    std::function<void(const crdtp::Dispatchable&)> Dispatch(crdtp::span<uint8_t> command_name) override;

    void disable(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);
    void enable(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);
    void setIgnoreCertificateErrors(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);
    void handleCertificateError(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);
    void setOverrideCertificateErrors(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors);
 protected:
    Backend* m_backend;
};

namespace {
// This helper method with a static map of command methods (instance methods
// of DomainDispatcherImpl declared just above) by their name is used immediately below,
// in the DomainDispatcherImpl::Dispatch method.
DomainDispatcherImpl::CallHandler CommandByName(crdtp::span<uint8_t> command_name) {
  static auto* commands = [](){
    auto* commands = new std::vector<std::pair<crdtp::span<uint8_t>,
                              DomainDispatcherImpl::CallHandler>>{
    {
          crdtp::SpanFrom("disable"),
          &DomainDispatcherImpl::disable
    },
    {
          crdtp::SpanFrom("enable"),
          &DomainDispatcherImpl::enable
    },
    {
          crdtp::SpanFrom("handleCertificateError"),
          &DomainDispatcherImpl::handleCertificateError
    },
    {
          crdtp::SpanFrom("setIgnoreCertificateErrors"),
          &DomainDispatcherImpl::setIgnoreCertificateErrors
    },
    {
          crdtp::SpanFrom("setOverrideCertificateErrors"),
          &DomainDispatcherImpl::setOverrideCertificateErrors
    },
    };
    return commands;
  }();
  return crdtp::FindByFirst<DomainDispatcherImpl::CallHandler>(*commands, command_name, nullptr);
}
}  // namespace

std::function<void(const crdtp::Dispatchable&)> DomainDispatcherImpl::Dispatch(crdtp::span<uint8_t> command_name) {
  CallHandler handler = CommandByName(command_name);
  if (!handler) return nullptr;
  return [this, handler](const crdtp::Dispatchable& dispatchable){
    std::unique_ptr<DictionaryValue> params =
        DictionaryValue::cast(protocol::Value::parseBinary(dispatchable.Params().data(),
        dispatchable.Params().size()));
    ErrorSupport errors;
    errors.Push();
    (this->*handler)(dispatchable, params.get(), &errors);
  };
}


void DomainDispatcherImpl::disable(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors)
{

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->Disable();
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Security.disable"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

void DomainDispatcherImpl::enable(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors)
{

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->Enable();
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Security.enable"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

void DomainDispatcherImpl::setIgnoreCertificateErrors(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors)
{
    // Prepare input parameters.
    protocol::Value* ignoreValue = params ? params->get("ignore") : nullptr;
    errors->SetName("ignore");
    bool in_ignore = ValueConversions<bool>::fromValue(ignoreValue, errors);
    if (MaybeReportInvalidParams(dispatchable, *errors)) return;

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->SetIgnoreCertificateErrors(in_ignore);
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Security.setIgnoreCertificateErrors"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

void DomainDispatcherImpl::handleCertificateError(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors)
{
    // Prepare input parameters.
    protocol::Value* eventIdValue = params ? params->get("eventId") : nullptr;
    errors->SetName("eventId");
    int in_eventId = ValueConversions<int>::fromValue(eventIdValue, errors);
    protocol::Value* actionValue = params ? params->get("action") : nullptr;
    errors->SetName("action");
    String in_action = ValueConversions<String>::fromValue(actionValue, errors);
    if (MaybeReportInvalidParams(dispatchable, *errors)) return;

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->HandleCertificateError(in_eventId, in_action);
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Security.handleCertificateError"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

void DomainDispatcherImpl::setOverrideCertificateErrors(const crdtp::Dispatchable& dispatchable, DictionaryValue* params, ErrorSupport* errors)
{
    // Prepare input parameters.
    protocol::Value* overrideValue = params ? params->get("override") : nullptr;
    errors->SetName("override");
    bool in_override = ValueConversions<bool>::fromValue(overrideValue, errors);
    if (MaybeReportInvalidParams(dispatchable, *errors)) return;

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->SetOverrideCertificateErrors(in_override);
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Security.setOverrideCertificateErrors"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

namespace {
// This helper method (with a static map of redirects) is used from Dispatcher::wire
// immediately below.
const std::vector<std::pair<crdtp::span<uint8_t>, crdtp::span<uint8_t>>>& SortedRedirects() {
  static auto* redirects = [](){
    auto* redirects = new std::vector<std::pair<crdtp::span<uint8_t>, crdtp::span<uint8_t>>>{
    };
    return redirects;
  }();
  return *redirects;
}
}  // namespace

// static
void Dispatcher::wire(UberDispatcher* uber, Backend* backend)
{
    auto dispatcher = std::make_unique<DomainDispatcherImpl>(uber->channel(), backend);
    uber->WireBackend(crdtp::SpanFrom("Security"), SortedRedirects(), std::move(dispatcher));
}

} // Security
} // namespace content
} // namespace protocol
