// content/common/ax_content_node_data.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_AX_CONTENT_NODE_DATA_MOJOM_H_
#define CONTENT_COMMON_AX_CONTENT_NODE_DATA_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/ax_content_node_data.mojom-shared.h"
#include "content/common/ax_content_node_data.mojom-forward.h"
#include "ui/accessibility/mojom/ax_node_data.mojom.h"
#include <string>
#include <vector>




#include "content/common/ax_content_node_data_mojom_traits.h"
#include "content/common/content_export.h"




namespace ax {
namespace mojom {








class CONTENT_EXPORT AXContentNodeData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AXContentNodeData, T>::value>;
  using DataView = AXContentNodeDataDataView;
  using Data_ = internal::AXContentNodeData_Data;

  template <typename... Args>
  static AXContentNodeDataPtr New(Args&&... args) {
    return AXContentNodeDataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AXContentNodeDataPtr From(const U& u) {
    return mojo::TypeConverter<AXContentNodeDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AXContentNodeData>::Convert(*this);
  }


  AXContentNodeData();

  AXContentNodeData(
      const ::ui::AXNodeData& node_data,
      int32_t child_routing_id);

  ~AXContentNodeData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AXContentNodeDataPtr>
  AXContentNodeDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AXContentNodeData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AXContentNodeData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AXContentNodeData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AXContentNodeData_UnserializedMessageContext<
            UserType, AXContentNodeData::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AXContentNodeData::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AXContentNodeData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AXContentNodeData_UnserializedMessageContext<
            UserType, AXContentNodeData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AXContentNodeData::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::ui::AXNodeData node_data;
  
  int32_t child_routing_id;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AXContentNodeData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AXContentNodeData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AXContentNodeData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AXContentNodeData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AXContentNodeDataPtr AXContentNodeData::Clone() const {
  return New(
      mojo::Clone(node_data),
      mojo::Clone(child_routing_id)
  );
}

template <typename T, AXContentNodeData::EnableIfSame<T>*>
bool AXContentNodeData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->node_data, other_struct.node_data))
    return false;
  if (!mojo::Equals(this->child_routing_id, other_struct.child_routing_id))
    return false;
  return true;
}

template <typename T, AXContentNodeData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.node_data < rhs.node_data)
    return true;
  if (rhs.node_data < lhs.node_data)
    return false;
  if (lhs.child_routing_id < rhs.child_routing_id)
    return true;
  if (rhs.child_routing_id < lhs.child_routing_id)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace ax

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::ax::mojom::AXContentNodeData::DataView,
                                         ::ax::mojom::AXContentNodeDataPtr> {
  static bool IsNull(const ::ax::mojom::AXContentNodeDataPtr& input) { return !input; }
  static void SetToNull(::ax::mojom::AXContentNodeDataPtr* output) { output->reset(); }

  static const decltype(::ax::mojom::AXContentNodeData::node_data)& node_data(
      const ::ax::mojom::AXContentNodeDataPtr& input) {
    return input->node_data;
  }

  static decltype(::ax::mojom::AXContentNodeData::child_routing_id) child_routing_id(
      const ::ax::mojom::AXContentNodeDataPtr& input) {
    return input->child_routing_id;
  }

  static bool Read(::ax::mojom::AXContentNodeData::DataView input, ::ax::mojom::AXContentNodeDataPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_AX_CONTENT_NODE_DATA_MOJOM_H_