// content/common/ax_content_tree_data.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_SHARED_H_
#define CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/common/ax_content_tree_data.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_data.mojom-shared.h"



#include "base/component_export.h"




namespace ax {
namespace mojom {
class AXContentTreeDataDataView;



}  // namespace mojom
}  // namespace ax

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::ax::mojom::AXContentTreeDataDataView> {
  using Data = ::ax::mojom::internal::AXContentTreeData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace ax {
namespace mojom {
class AXContentTreeDataDataView {
 public:
  AXContentTreeDataDataView() {}

  AXContentTreeDataDataView(
      internal::AXContentTreeData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTreeDataDataView(
      ::ax::mojom::AXTreeDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTreeData(UserType* output) {
    auto* pointer = data_->tree_data.Get();
    return mojo::internal::Deserialize<::ax::mojom::AXTreeDataDataView>(
        pointer, output, context_);
  }
  int32_t routing_id() const {
    return data_->routing_id;
  }
  int32_t parent_routing_id() const {
    return data_->parent_routing_id;
  }
 private:
  internal::AXContentTreeData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ax

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ax::mojom::AXContentTreeDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ax::mojom::AXContentTreeDataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::ax::mojom::internal::AXContentTreeData_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::tree_data(input)) in_tree_data = Traits::tree_data(input);
    typename decltype((*output)->tree_data)::BaseType::BufferWriter
        tree_data_writer;
    mojo::internal::Serialize<::ax::mojom::AXTreeDataDataView>(
        in_tree_data, buffer, &tree_data_writer, context);
    (*output)->tree_data.Set(
        tree_data_writer.is_null() ? nullptr : tree_data_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->tree_data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tree_data in AXContentTreeData struct");
    (*output)->routing_id = Traits::routing_id(input);
    (*output)->parent_routing_id = Traits::parent_routing_id(input);
  }

  static bool Deserialize(::ax::mojom::internal::AXContentTreeData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ax::mojom::AXContentTreeDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace ax {
namespace mojom {

inline void AXContentTreeDataDataView::GetTreeDataDataView(
    ::ax::mojom::AXTreeDataDataView* output) {
  auto pointer = data_->tree_data.Get();
  *output = ::ax::mojom::AXTreeDataDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace ax

#endif  // CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_SHARED_H_