// content/common/ax_content_tree_data.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_H_
#define CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/ax_content_tree_data.mojom-shared.h"
#include "content/common/ax_content_tree_data.mojom-forward.h"
#include "ui/accessibility/mojom/ax_tree_data.mojom.h"
#include <string>
#include <vector>




#include "content/common/ax_content_tree_data_mojom_traits.h"
#include "content/common/content_export.h"




namespace ax {
namespace mojom {








class CONTENT_EXPORT AXContentTreeData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AXContentTreeData, T>::value>;
  using DataView = AXContentTreeDataDataView;
  using Data_ = internal::AXContentTreeData_Data;

  template <typename... Args>
  static AXContentTreeDataPtr New(Args&&... args) {
    return AXContentTreeDataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AXContentTreeDataPtr From(const U& u) {
    return mojo::TypeConverter<AXContentTreeDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AXContentTreeData>::Convert(*this);
  }


  AXContentTreeData();

  AXContentTreeData(
      const ::ui::AXTreeData& tree_data,
      int32_t routing_id,
      int32_t parent_routing_id);

  ~AXContentTreeData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AXContentTreeDataPtr>
  AXContentTreeDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AXContentTreeData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AXContentTreeData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AXContentTreeData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AXContentTreeData_UnserializedMessageContext<
            UserType, AXContentTreeData::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AXContentTreeData::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AXContentTreeData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AXContentTreeData_UnserializedMessageContext<
            UserType, AXContentTreeData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AXContentTreeData::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::ui::AXTreeData tree_data;
  
  int32_t routing_id;
  
  int32_t parent_routing_id;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AXContentTreeData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AXContentTreeData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AXContentTreeData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AXContentTreeData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AXContentTreeDataPtr AXContentTreeData::Clone() const {
  return New(
      mojo::Clone(tree_data),
      mojo::Clone(routing_id),
      mojo::Clone(parent_routing_id)
  );
}

template <typename T, AXContentTreeData::EnableIfSame<T>*>
bool AXContentTreeData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->tree_data, other_struct.tree_data))
    return false;
  if (!mojo::Equals(this->routing_id, other_struct.routing_id))
    return false;
  if (!mojo::Equals(this->parent_routing_id, other_struct.parent_routing_id))
    return false;
  return true;
}

template <typename T, AXContentTreeData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.tree_data < rhs.tree_data)
    return true;
  if (rhs.tree_data < lhs.tree_data)
    return false;
  if (lhs.routing_id < rhs.routing_id)
    return true;
  if (rhs.routing_id < lhs.routing_id)
    return false;
  if (lhs.parent_routing_id < rhs.parent_routing_id)
    return true;
  if (rhs.parent_routing_id < lhs.parent_routing_id)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace ax

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::ax::mojom::AXContentTreeData::DataView,
                                         ::ax::mojom::AXContentTreeDataPtr> {
  static bool IsNull(const ::ax::mojom::AXContentTreeDataPtr& input) { return !input; }
  static void SetToNull(::ax::mojom::AXContentTreeDataPtr* output) { output->reset(); }

  static const decltype(::ax::mojom::AXContentTreeData::tree_data)& tree_data(
      const ::ax::mojom::AXContentTreeDataPtr& input) {
    return input->tree_data;
  }

  static decltype(::ax::mojom::AXContentTreeData::routing_id) routing_id(
      const ::ax::mojom::AXContentTreeDataPtr& input) {
    return input->routing_id;
  }

  static decltype(::ax::mojom::AXContentTreeData::parent_routing_id) parent_routing_id(
      const ::ax::mojom::AXContentTreeDataPtr& input) {
    return input->parent_routing_id;
  }

  static bool Read(::ax::mojom::AXContentTreeData::DataView input, ::ax::mojom::AXContentTreeDataPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_AX_CONTENT_TREE_DATA_MOJOM_H_