// content/common/render_accessibility.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_ACCESSIBILITY_MOJOM_H_
#define CONTENT_COMMON_RENDER_ACCESSIBILITY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/render_accessibility.mojom-shared.h"
#include "content/common/render_accessibility.mojom-forward.h"
#include "content/common/ax_content_tree_update.mojom.h"
#include "ui/accessibility/ax_enums.mojom.h"
#include "ui/accessibility/mojom/ax_action_data.mojom.h"
#include "ui/accessibility/mojom/ax_event.mojom.h"
#include "ui/accessibility/mojom/ax_relative_bounds.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "content/common/content_export.h"




namespace content {
namespace mojom {

class RenderAccessibilityHostProxy;

template <typename ImplRefTraits>
class RenderAccessibilityHostStub;

class RenderAccessibilityHostRequestValidator;
class RenderAccessibilityHostResponseValidator;


class CONTENT_EXPORT RenderAccessibilityHost
    : public RenderAccessibilityHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = RenderAccessibilityHostInterfaceBase;
  using Proxy_ = RenderAccessibilityHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = RenderAccessibilityHostStub<ImplRefTraits>;

  using RequestValidator_ = RenderAccessibilityHostRequestValidator;
  using ResponseValidator_ = RenderAccessibilityHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kHandleAXEventsMinVersion = 0,
    kHandleAXLocationChangesMinVersion = 0,
  };
  virtual ~RenderAccessibilityHost() {}


  using HandleAXEventsCallback = base::OnceCallback<void()>;
  
  virtual void HandleAXEvents(const std::vector<::content::AXContentTreeUpdate>& updates, const std::vector<::ui::AXEvent>& events, int32_t reset_token, HandleAXEventsCallback callback) = 0;

  
  virtual void HandleAXLocationChanges(std::vector<LocationChangesPtr> changes) = 0;
};

class RenderAccessibilityProxy;

template <typename ImplRefTraits>
class RenderAccessibilityStub;

class RenderAccessibilityRequestValidator;
class RenderAccessibilityResponseValidator;


class CONTENT_EXPORT RenderAccessibility
    : public RenderAccessibilityInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = RenderAccessibilityInterfaceBase;
  using Proxy_ = RenderAccessibilityProxy;

  template <typename ImplRefTraits>
  using Stub_ = RenderAccessibilityStub<ImplRefTraits>;

  using RequestValidator_ = RenderAccessibilityRequestValidator;
  using ResponseValidator_ = RenderAccessibilityResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetModeMinVersion = 0,
    kFatalErrorMinVersion = 0,
    kHitTestMinVersion = 0,
    kPerformActionMinVersion = 0,
    kResetMinVersion = 0,
  };
  virtual ~RenderAccessibility() {}

  
  virtual void SetMode(uint32_t ax_mode) = 0;

  
  virtual void FatalError() = 0;


  using HitTestCallback = base::OnceCallback<void(ChildFrameHitTestInfoPtr)>;
  
  virtual void HitTest(const ::ui::AXActionData& action_data, HitTestCallback callback) = 0;

  
  virtual void PerformAction(const ::ui::AXActionData& action_data) = 0;

  
  virtual void Reset(int32_t reset_token) = 0;
};



class CONTENT_EXPORT RenderAccessibilityHostProxy
    : public RenderAccessibilityHost {
 public:
  using InterfaceType = RenderAccessibilityHost;

  explicit RenderAccessibilityHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void HandleAXEvents(const std::vector<::content::AXContentTreeUpdate>& updates, const std::vector<::ui::AXEvent>& events, int32_t reset_token, HandleAXEventsCallback callback) final;
  
  void HandleAXLocationChanges(std::vector<LocationChangesPtr> changes) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class CONTENT_EXPORT RenderAccessibilityProxy
    : public RenderAccessibility {
 public:
  using InterfaceType = RenderAccessibility;

  explicit RenderAccessibilityProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetMode(uint32_t ax_mode) final;
  
  void FatalError() final;
  
  void HitTest(const ::ui::AXActionData& action_data, HitTestCallback callback) final;
  
  void PerformAction(const ::ui::AXActionData& action_data) final;
  
  void Reset(int32_t reset_token) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT RenderAccessibilityHostStubDispatch {
 public:
  static bool Accept(RenderAccessibilityHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      RenderAccessibilityHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RenderAccessibilityHost>>
class RenderAccessibilityHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RenderAccessibilityHostStub() {}
  ~RenderAccessibilityHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderAccessibilityHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderAccessibilityHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT RenderAccessibilityStubDispatch {
 public:
  static bool Accept(RenderAccessibility* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      RenderAccessibility* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RenderAccessibility>>
class RenderAccessibilityStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RenderAccessibilityStub() {}
  ~RenderAccessibilityStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderAccessibilityStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RenderAccessibilityStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT RenderAccessibilityHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT RenderAccessibilityRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT RenderAccessibilityHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT RenderAccessibilityResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};









class CONTENT_EXPORT LocationChanges {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LocationChanges, T>::value>;
  using DataView = LocationChangesDataView;
  using Data_ = internal::LocationChanges_Data;

  template <typename... Args>
  static LocationChangesPtr New(Args&&... args) {
    return LocationChangesPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LocationChangesPtr From(const U& u) {
    return mojo::TypeConverter<LocationChangesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LocationChanges>::Convert(*this);
  }


  LocationChanges();

  LocationChanges(
      int32_t id,
      const ::ui::AXRelativeBounds& new_location);

  ~LocationChanges();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LocationChangesPtr>
  LocationChangesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LocationChanges::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LocationChanges::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LocationChanges::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LocationChanges_UnserializedMessageContext<
            UserType, LocationChanges::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<LocationChanges::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return LocationChanges::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LocationChanges_UnserializedMessageContext<
            UserType, LocationChanges::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LocationChanges::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t id;
  
  ::ui::AXRelativeBounds new_location;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LocationChanges::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LocationChanges::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LocationChanges::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LocationChanges::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT ChildFrameHitTestInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ChildFrameHitTestInfo, T>::value>;
  using DataView = ChildFrameHitTestInfoDataView;
  using Data_ = internal::ChildFrameHitTestInfo_Data;

  template <typename... Args>
  static ChildFrameHitTestInfoPtr New(Args&&... args) {
    return ChildFrameHitTestInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ChildFrameHitTestInfoPtr From(const U& u) {
    return mojo::TypeConverter<ChildFrameHitTestInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ChildFrameHitTestInfo>::Convert(*this);
  }


  ChildFrameHitTestInfo();

  ChildFrameHitTestInfo(
      int32_t child_frame_routing_id,
      const ::gfx::Point& transformed_point,
      ::ax::mojom::Event event_to_fire);

  ~ChildFrameHitTestInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ChildFrameHitTestInfoPtr>
  ChildFrameHitTestInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ChildFrameHitTestInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ChildFrameHitTestInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ChildFrameHitTestInfo_UnserializedMessageContext<
            UserType, ChildFrameHitTestInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ChildFrameHitTestInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ChildFrameHitTestInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ChildFrameHitTestInfo_UnserializedMessageContext<
            UserType, ChildFrameHitTestInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ChildFrameHitTestInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t child_frame_routing_id;
  
  ::gfx::Point transformed_point;
  
  ::ax::mojom::Event event_to_fire;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
LocationChangesPtr LocationChanges::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(new_location)
  );
}

template <typename T, LocationChanges::EnableIfSame<T>*>
bool LocationChanges::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->new_location, other_struct.new_location))
    return false;
  return true;
}

template <typename T, LocationChanges::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.new_location < rhs.new_location)
    return true;
  if (rhs.new_location < lhs.new_location)
    return false;
  return false;
}
template <typename StructPtrType>
ChildFrameHitTestInfoPtr ChildFrameHitTestInfo::Clone() const {
  return New(
      mojo::Clone(child_frame_routing_id),
      mojo::Clone(transformed_point),
      mojo::Clone(event_to_fire)
  );
}

template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>*>
bool ChildFrameHitTestInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->child_frame_routing_id, other_struct.child_frame_routing_id))
    return false;
  if (!mojo::Equals(this->transformed_point, other_struct.transformed_point))
    return false;
  if (!mojo::Equals(this->event_to_fire, other_struct.event_to_fire))
    return false;
  return true;
}

template <typename T, ChildFrameHitTestInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.child_frame_routing_id < rhs.child_frame_routing_id)
    return true;
  if (rhs.child_frame_routing_id < lhs.child_frame_routing_id)
    return false;
  if (lhs.transformed_point < rhs.transformed_point)
    return true;
  if (rhs.transformed_point < lhs.transformed_point)
    return false;
  if (lhs.event_to_fire < rhs.event_to_fire)
    return true;
  if (rhs.event_to_fire < lhs.event_to_fire)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace content

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::LocationChanges::DataView,
                                         ::content::mojom::LocationChangesPtr> {
  static bool IsNull(const ::content::mojom::LocationChangesPtr& input) { return !input; }
  static void SetToNull(::content::mojom::LocationChangesPtr* output) { output->reset(); }

  static decltype(::content::mojom::LocationChanges::id) id(
      const ::content::mojom::LocationChangesPtr& input) {
    return input->id;
  }

  static const decltype(::content::mojom::LocationChanges::new_location)& new_location(
      const ::content::mojom::LocationChangesPtr& input) {
    return input->new_location;
  }

  static bool Read(::content::mojom::LocationChanges::DataView input, ::content::mojom::LocationChangesPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::ChildFrameHitTestInfo::DataView,
                                         ::content::mojom::ChildFrameHitTestInfoPtr> {
  static bool IsNull(const ::content::mojom::ChildFrameHitTestInfoPtr& input) { return !input; }
  static void SetToNull(::content::mojom::ChildFrameHitTestInfoPtr* output) { output->reset(); }

  static decltype(::content::mojom::ChildFrameHitTestInfo::child_frame_routing_id) child_frame_routing_id(
      const ::content::mojom::ChildFrameHitTestInfoPtr& input) {
    return input->child_frame_routing_id;
  }

  static const decltype(::content::mojom::ChildFrameHitTestInfo::transformed_point)& transformed_point(
      const ::content::mojom::ChildFrameHitTestInfoPtr& input) {
    return input->transformed_point;
  }

  static decltype(::content::mojom::ChildFrameHitTestInfo::event_to_fire) event_to_fire(
      const ::content::mojom::ChildFrameHitTestInfoPtr& input) {
    return input->event_to_fire;
  }

  static bool Read(::content::mojom::ChildFrameHitTestInfo::DataView input, ::content::mojom::ChildFrameHitTestInfoPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_RENDER_ACCESSIBILITY_MOJOM_H_