// content/common/renderer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDERER_MOJOM_H_
#define CONTENT_COMMON_RENDERER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/renderer.mojom-shared.h"
#include "content/common/renderer.mojom-forward.h"
#include "content/common/document_scoped_interface_bundle.mojom.h"
#include "content/common/native_types.mojom.h"
#include "content/public/common/web_preferences.mojom.h"
#include "ipc/constants.mojom.h"
#include "mojo/public/mojom/base/generic_pending_receiver.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include "services/network/public/mojom/network_types.mojom.h"
#include "third_party/blink/public/mojom/frame/frame_owner_properties.mojom.h"
#include "third_party/blink/public/mojom/manifest/manifest.mojom.h"
#include "third_party/blink/public/mojom/page/page.mojom.h"
#include "third_party/blink/public/mojom/page/widget.mojom.h"
#include "third_party/blink/public/mojom/renderer_preferences.mojom.h"
#include "third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "content/common/content_export.h"




namespace content {
namespace mojom {

class RendererProxy;

template <typename ImplRefTraits>
class RendererStub;

class RendererRequestValidator;


class CONTENT_EXPORT Renderer
    : public RendererInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = RendererInterfaceBase;
  using Proxy_ = RendererProxy;

  template <typename ImplRefTraits>
  using Stub_ = RendererStub<ImplRefTraits>;

  using RequestValidator_ = RendererRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateViewMinVersion = 0,
    kDestroyViewMinVersion = 0,
    kCreateFrameMinVersion = 0,
    kCreateFrameProxyMinVersion = 0,
    kOnNetworkConnectionChangedMinVersion = 0,
    kOnNetworkQualityChangedMinVersion = 0,
    kSetWebKitSharedTimersSuspendedMinVersion = 0,
    kSetUserAgentMinVersion = 0,
    kSetUserAgentMetadataMinVersion = 0,
    kUpdateScrollbarThemeMinVersion = 0,
    kOnSystemColorsChangedMinVersion = 0,
    kUpdateSystemColorInfoMinVersion = 0,
    kPurgePluginListCacheMinVersion = 0,
    kSetProcessStateMinVersion = 0,
    kSetSchedulerKeepActiveMinVersion = 0,
    kSetIsLockedToSiteMinVersion = 0,
    kEnableV8LowMemoryModeMinVersion = 0,
  };
  virtual ~Renderer() {}

  
  virtual void CreateView(CreateViewParamsPtr params) = 0;

  
  virtual void DestroyView(int32_t view_id) = 0;

  
  virtual void CreateFrame(CreateFrameParamsPtr params) = 0;

  
  virtual void CreateFrameProxy(int32_t routing_id, int32_t render_view_routing_id, int32_t opener_routing_id, int32_t parent_routing_id, const ::content::FrameReplicationState& replication_state, const ::base::UnguessableToken& devtools_frame_token) = 0;

  
  virtual void OnNetworkConnectionChanged(::net::NetworkChangeNotifier::ConnectionType connection_type, double max_bandwidth_mbps) = 0;

  
  virtual void OnNetworkQualityChanged(::net::EffectiveConnectionType effective_connection_type, ::base::TimeDelta http_rtt, ::base::TimeDelta transport_rtt, double bandwidth_kbps) = 0;

  
  virtual void SetWebKitSharedTimersSuspended(bool suspend) = 0;

  
  virtual void SetUserAgent(const std::string& user_agent) = 0;

  
  virtual void SetUserAgentMetadata(const ::blink::UserAgentMetadata& metadata) = 0;

  
  virtual void UpdateScrollbarTheme(UpdateScrollbarThemeParamsPtr params) = 0;

  
  virtual void OnSystemColorsChanged(int32_t aqua_color_variant, const std::string& highlight_text_color, const std::string& highlight_color) = 0;

  
  virtual void UpdateSystemColorInfo(UpdateSystemColorInfoParamsPtr params) = 0;

  
  virtual void PurgePluginListCache(bool reload_pages) = 0;

  
  virtual void SetProcessState(RenderProcessBackgroundState background_state, RenderProcessVisibleState visible_state) = 0;

  
  virtual void SetSchedulerKeepActive(bool keep_active) = 0;

  
  virtual void SetIsLockedToSite() = 0;

  
  virtual void EnableV8LowMemoryMode() = 0;
};



class CONTENT_EXPORT RendererProxy
    : public Renderer {
 public:
  using InterfaceType = Renderer;

  explicit RendererProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateView(CreateViewParamsPtr params) final;
  
  void DestroyView(int32_t view_id) final;
  
  void CreateFrame(CreateFrameParamsPtr params) final;
  
  void CreateFrameProxy(int32_t routing_id, int32_t render_view_routing_id, int32_t opener_routing_id, int32_t parent_routing_id, const ::content::FrameReplicationState& replication_state, const ::base::UnguessableToken& devtools_frame_token) final;
  
  void OnNetworkConnectionChanged(::net::NetworkChangeNotifier::ConnectionType connection_type, double max_bandwidth_mbps) final;
  
  void OnNetworkQualityChanged(::net::EffectiveConnectionType effective_connection_type, ::base::TimeDelta http_rtt, ::base::TimeDelta transport_rtt, double bandwidth_kbps) final;
  
  void SetWebKitSharedTimersSuspended(bool suspend) final;
  
  void SetUserAgent(const std::string& user_agent) final;
  
  void SetUserAgentMetadata(const ::blink::UserAgentMetadata& metadata) final;
  
  void UpdateScrollbarTheme(UpdateScrollbarThemeParamsPtr params) final;
  
  void OnSystemColorsChanged(int32_t aqua_color_variant, const std::string& highlight_text_color, const std::string& highlight_color) final;
  
  void UpdateSystemColorInfo(UpdateSystemColorInfoParamsPtr params) final;
  
  void PurgePluginListCache(bool reload_pages) final;
  
  void SetProcessState(RenderProcessBackgroundState background_state, RenderProcessVisibleState visible_state) final;
  
  void SetSchedulerKeepActive(bool keep_active) final;
  
  void SetIsLockedToSite() final;
  
  void EnableV8LowMemoryMode() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT RendererStubDispatch {
 public:
  static bool Accept(Renderer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Renderer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Renderer>>
class RendererStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RendererStub() {}
  ~RendererStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT RendererRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};












class CONTENT_EXPORT CreateViewParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CreateViewParams, T>::value>;
  using DataView = CreateViewParamsDataView;
  using Data_ = internal::CreateViewParams_Data;

  template <typename... Args>
  static CreateViewParamsPtr New(Args&&... args) {
    return CreateViewParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CreateViewParamsPtr From(const U& u) {
    return mojo::TypeConverter<CreateViewParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateViewParams>::Convert(*this);
  }


  CreateViewParams();

  CreateViewParams(
      ::blink::mojom::RendererPreferencesPtr renderer_preferences,
      const ::content::WebPreferences& web_preferences,
      int32_t view_id,
      int32_t main_frame_routing_id,
      int32_t main_frame_widget_routing_id,
      ::content::mojom::DocumentScopedInterfaceBundlePtr main_frame_interface_bundle,
      mojo::PendingAssociatedRemote<::blink::mojom::FrameWidgetHost> frame_widget_host,
      mojo::PendingAssociatedReceiver<::blink::mojom::FrameWidget> frame_widget,
      mojo::PendingAssociatedRemote<::blink::mojom::WidgetHost> widget_host,
      mojo::PendingAssociatedReceiver<::blink::mojom::Widget> widget,
      const std::string& session_storage_namespace_id,
      int32_t opener_frame_route_id,
      const ::content::FrameReplicationState& replicated_frame_state,
      const ::base::UnguessableToken& devtools_main_frame_token,
      int32_t proxy_routing_id,
      bool hidden,
      bool never_composited,
      bool window_was_created_with_opener,
      bool has_committed_real_load,
      const ::content::VisualProperties& visual_properties,
      bool renderer_wide_named_frame_lookup,
      bool inside_portal,
      mojo::PendingAssociatedReceiver<::blink::mojom::PageBroadcast> blink_page_broadcast);

  ~CreateViewParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CreateViewParamsPtr>
  CreateViewParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CreateViewParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CreateViewParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateViewParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CreateViewParams_UnserializedMessageContext<
            UserType, CreateViewParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CreateViewParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CreateViewParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CreateViewParams_UnserializedMessageContext<
            UserType, CreateViewParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CreateViewParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::blink::mojom::RendererPreferencesPtr renderer_preferences;
  
  ::content::WebPreferences web_preferences;
  
  int32_t view_id;
  
  int32_t main_frame_routing_id;
  
  int32_t main_frame_widget_routing_id;
  
  ::content::mojom::DocumentScopedInterfaceBundlePtr main_frame_interface_bundle;
  
  mojo::PendingAssociatedRemote<::blink::mojom::FrameWidgetHost> frame_widget_host;
  
  mojo::PendingAssociatedReceiver<::blink::mojom::FrameWidget> frame_widget;
  
  mojo::PendingAssociatedRemote<::blink::mojom::WidgetHost> widget_host;
  
  mojo::PendingAssociatedReceiver<::blink::mojom::Widget> widget;
  
  std::string session_storage_namespace_id;
  
  int32_t opener_frame_route_id;
  
  ::content::FrameReplicationState replicated_frame_state;
  
  ::base::UnguessableToken devtools_main_frame_token;
  
  int32_t proxy_routing_id;
  
  bool hidden;
  
  bool never_composited;
  
  bool window_was_created_with_opener;
  
  bool has_committed_real_load;
  
  ::content::VisualProperties visual_properties;
  
  bool renderer_wide_named_frame_lookup;
  
  bool inside_portal;
  
  mojo::PendingAssociatedReceiver<::blink::mojom::PageBroadcast> blink_page_broadcast;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(CreateViewParams);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CreateViewParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CreateViewParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CreateViewParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CreateViewParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT CreateFrameWidgetParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CreateFrameWidgetParams, T>::value>;
  using DataView = CreateFrameWidgetParamsDataView;
  using Data_ = internal::CreateFrameWidgetParams_Data;

  template <typename... Args>
  static CreateFrameWidgetParamsPtr New(Args&&... args) {
    return CreateFrameWidgetParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CreateFrameWidgetParamsPtr From(const U& u) {
    return mojo::TypeConverter<CreateFrameWidgetParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateFrameWidgetParams>::Convert(*this);
  }


  CreateFrameWidgetParams();

  CreateFrameWidgetParams(
      int32_t routing_id,
      mojo::PendingAssociatedRemote<::blink::mojom::FrameWidgetHost> frame_widget_host,
      mojo::PendingAssociatedReceiver<::blink::mojom::FrameWidget> frame_widget,
      mojo::PendingAssociatedRemote<::blink::mojom::WidgetHost> widget_host,
      mojo::PendingAssociatedReceiver<::blink::mojom::Widget> widget,
      const ::content::VisualProperties& visual_properties);

  ~CreateFrameWidgetParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CreateFrameWidgetParamsPtr>
  CreateFrameWidgetParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CreateFrameWidgetParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CreateFrameWidgetParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateFrameWidgetParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CreateFrameWidgetParams_UnserializedMessageContext<
            UserType, CreateFrameWidgetParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CreateFrameWidgetParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CreateFrameWidgetParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CreateFrameWidgetParams_UnserializedMessageContext<
            UserType, CreateFrameWidgetParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CreateFrameWidgetParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t routing_id;
  
  mojo::PendingAssociatedRemote<::blink::mojom::FrameWidgetHost> frame_widget_host;
  
  mojo::PendingAssociatedReceiver<::blink::mojom::FrameWidget> frame_widget;
  
  mojo::PendingAssociatedRemote<::blink::mojom::WidgetHost> widget_host;
  
  mojo::PendingAssociatedReceiver<::blink::mojom::Widget> widget;
  
  ::content::VisualProperties visual_properties;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(CreateFrameWidgetParams);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CreateFrameWidgetParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CreateFrameWidgetParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CreateFrameWidgetParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CreateFrameWidgetParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT CreateFrameParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CreateFrameParams, T>::value>;
  using DataView = CreateFrameParamsDataView;
  using Data_ = internal::CreateFrameParams_Data;

  template <typename... Args>
  static CreateFrameParamsPtr New(Args&&... args) {
    return CreateFrameParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CreateFrameParamsPtr From(const U& u) {
    return mojo::TypeConverter<CreateFrameParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateFrameParams>::Convert(*this);
  }


  CreateFrameParams();

  CreateFrameParams(
      int32_t routing_id,
      int32_t previous_routing_id,
      int32_t opener_routing_id,
      int32_t parent_routing_id,
      int32_t previous_sibling_routing_id,
      ::content::mojom::DocumentScopedInterfaceBundlePtr interface_bundle,
      const ::content::FrameReplicationState& replication_state,
      const ::base::UnguessableToken& devtools_frame_token,
      ::blink::mojom::FrameOwnerPropertiesPtr frame_owner_properties,
      CreateFrameWidgetParamsPtr widget_params,
      bool has_committed_real_load);

  ~CreateFrameParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CreateFrameParamsPtr>
  CreateFrameParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CreateFrameParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CreateFrameParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateFrameParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CreateFrameParams_UnserializedMessageContext<
            UserType, CreateFrameParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CreateFrameParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CreateFrameParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CreateFrameParams_UnserializedMessageContext<
            UserType, CreateFrameParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CreateFrameParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t routing_id;
  
  int32_t previous_routing_id;
  
  int32_t opener_routing_id;
  
  int32_t parent_routing_id;
  
  int32_t previous_sibling_routing_id;
  
  ::content::mojom::DocumentScopedInterfaceBundlePtr interface_bundle;
  
  ::content::FrameReplicationState replication_state;
  
  ::base::UnguessableToken devtools_frame_token;
  
  ::blink::mojom::FrameOwnerPropertiesPtr frame_owner_properties;
  
  CreateFrameWidgetParamsPtr widget_params;
  
  bool has_committed_real_load;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(CreateFrameParams);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CreateFrameParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CreateFrameParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CreateFrameParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CreateFrameParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT UpdateScrollbarThemeParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<UpdateScrollbarThemeParams, T>::value>;
  using DataView = UpdateScrollbarThemeParamsDataView;
  using Data_ = internal::UpdateScrollbarThemeParams_Data;

  template <typename... Args>
  static UpdateScrollbarThemeParamsPtr New(Args&&... args) {
    return UpdateScrollbarThemeParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static UpdateScrollbarThemeParamsPtr From(const U& u) {
    return mojo::TypeConverter<UpdateScrollbarThemeParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, UpdateScrollbarThemeParams>::Convert(*this);
  }


  UpdateScrollbarThemeParams();

  UpdateScrollbarThemeParams(
      bool has_initial_button_delay,
      float initial_button_delay,
      bool has_autoscroll_button_delay,
      float autoscroll_button_delay,
      bool jump_on_track_click,
      ::content::mojom::ScrollerStyle preferred_scroller_style,
      bool redraw,
      bool scroll_view_rubber_banding);

  ~UpdateScrollbarThemeParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = UpdateScrollbarThemeParamsPtr>
  UpdateScrollbarThemeParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        UpdateScrollbarThemeParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        UpdateScrollbarThemeParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::UpdateScrollbarThemeParams_UnserializedMessageContext<
            UserType, UpdateScrollbarThemeParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<UpdateScrollbarThemeParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return UpdateScrollbarThemeParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::UpdateScrollbarThemeParams_UnserializedMessageContext<
            UserType, UpdateScrollbarThemeParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<UpdateScrollbarThemeParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool has_initial_button_delay;
  
  float initial_button_delay;
  
  bool has_autoscroll_button_delay;
  
  float autoscroll_button_delay;
  
  bool jump_on_track_click;
  
  ::content::mojom::ScrollerStyle preferred_scroller_style;
  
  bool redraw;
  
  bool scroll_view_rubber_banding;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT UpdateSystemColorInfoParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<UpdateSystemColorInfoParams, T>::value>;
  using DataView = UpdateSystemColorInfoParamsDataView;
  using Data_ = internal::UpdateSystemColorInfoParams_Data;

  template <typename... Args>
  static UpdateSystemColorInfoParamsPtr New(Args&&... args) {
    return UpdateSystemColorInfoParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static UpdateSystemColorInfoParamsPtr From(const U& u) {
    return mojo::TypeConverter<UpdateSystemColorInfoParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, UpdateSystemColorInfoParams>::Convert(*this);
  }


  UpdateSystemColorInfoParams();

  UpdateSystemColorInfoParams(
      bool is_dark_mode,
      bool is_high_contrast,
      const base::flat_map<::ui::NativeTheme::SystemThemeColor, uint32_t>& colors);

  ~UpdateSystemColorInfoParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = UpdateSystemColorInfoParamsPtr>
  UpdateSystemColorInfoParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        UpdateSystemColorInfoParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        UpdateSystemColorInfoParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::UpdateSystemColorInfoParams_UnserializedMessageContext<
            UserType, UpdateSystemColorInfoParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<UpdateSystemColorInfoParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return UpdateSystemColorInfoParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::UpdateSystemColorInfoParams_UnserializedMessageContext<
            UserType, UpdateSystemColorInfoParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<UpdateSystemColorInfoParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool is_dark_mode;
  
  bool is_high_contrast;
  
  base::flat_map<::ui::NativeTheme::SystemThemeColor, uint32_t> colors;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
CreateViewParamsPtr CreateViewParams::Clone() const {
  return New(
      mojo::Clone(renderer_preferences),
      mojo::Clone(web_preferences),
      mojo::Clone(view_id),
      mojo::Clone(main_frame_routing_id),
      mojo::Clone(main_frame_widget_routing_id),
      mojo::Clone(main_frame_interface_bundle),
      mojo::Clone(frame_widget_host),
      mojo::Clone(frame_widget),
      mojo::Clone(widget_host),
      mojo::Clone(widget),
      mojo::Clone(session_storage_namespace_id),
      mojo::Clone(opener_frame_route_id),
      mojo::Clone(replicated_frame_state),
      mojo::Clone(devtools_main_frame_token),
      mojo::Clone(proxy_routing_id),
      mojo::Clone(hidden),
      mojo::Clone(never_composited),
      mojo::Clone(window_was_created_with_opener),
      mojo::Clone(has_committed_real_load),
      mojo::Clone(visual_properties),
      mojo::Clone(renderer_wide_named_frame_lookup),
      mojo::Clone(inside_portal),
      mojo::Clone(blink_page_broadcast)
  );
}

template <typename T, CreateViewParams::EnableIfSame<T>*>
bool CreateViewParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->renderer_preferences, other_struct.renderer_preferences))
    return false;
  if (!mojo::Equals(this->web_preferences, other_struct.web_preferences))
    return false;
  if (!mojo::Equals(this->view_id, other_struct.view_id))
    return false;
  if (!mojo::Equals(this->main_frame_routing_id, other_struct.main_frame_routing_id))
    return false;
  if (!mojo::Equals(this->main_frame_widget_routing_id, other_struct.main_frame_widget_routing_id))
    return false;
  if (!mojo::Equals(this->main_frame_interface_bundle, other_struct.main_frame_interface_bundle))
    return false;
  if (!mojo::Equals(this->frame_widget_host, other_struct.frame_widget_host))
    return false;
  if (!mojo::Equals(this->frame_widget, other_struct.frame_widget))
    return false;
  if (!mojo::Equals(this->widget_host, other_struct.widget_host))
    return false;
  if (!mojo::Equals(this->widget, other_struct.widget))
    return false;
  if (!mojo::Equals(this->session_storage_namespace_id, other_struct.session_storage_namespace_id))
    return false;
  if (!mojo::Equals(this->opener_frame_route_id, other_struct.opener_frame_route_id))
    return false;
  if (!mojo::Equals(this->replicated_frame_state, other_struct.replicated_frame_state))
    return false;
  if (!mojo::Equals(this->devtools_main_frame_token, other_struct.devtools_main_frame_token))
    return false;
  if (!mojo::Equals(this->proxy_routing_id, other_struct.proxy_routing_id))
    return false;
  if (!mojo::Equals(this->hidden, other_struct.hidden))
    return false;
  if (!mojo::Equals(this->never_composited, other_struct.never_composited))
    return false;
  if (!mojo::Equals(this->window_was_created_with_opener, other_struct.window_was_created_with_opener))
    return false;
  if (!mojo::Equals(this->has_committed_real_load, other_struct.has_committed_real_load))
    return false;
  if (!mojo::Equals(this->visual_properties, other_struct.visual_properties))
    return false;
  if (!mojo::Equals(this->renderer_wide_named_frame_lookup, other_struct.renderer_wide_named_frame_lookup))
    return false;
  if (!mojo::Equals(this->inside_portal, other_struct.inside_portal))
    return false;
  if (!mojo::Equals(this->blink_page_broadcast, other_struct.blink_page_broadcast))
    return false;
  return true;
}

template <typename T, CreateViewParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.renderer_preferences < rhs.renderer_preferences)
    return true;
  if (rhs.renderer_preferences < lhs.renderer_preferences)
    return false;
  if (lhs.web_preferences < rhs.web_preferences)
    return true;
  if (rhs.web_preferences < lhs.web_preferences)
    return false;
  if (lhs.view_id < rhs.view_id)
    return true;
  if (rhs.view_id < lhs.view_id)
    return false;
  if (lhs.main_frame_routing_id < rhs.main_frame_routing_id)
    return true;
  if (rhs.main_frame_routing_id < lhs.main_frame_routing_id)
    return false;
  if (lhs.main_frame_widget_routing_id < rhs.main_frame_widget_routing_id)
    return true;
  if (rhs.main_frame_widget_routing_id < lhs.main_frame_widget_routing_id)
    return false;
  if (lhs.main_frame_interface_bundle < rhs.main_frame_interface_bundle)
    return true;
  if (rhs.main_frame_interface_bundle < lhs.main_frame_interface_bundle)
    return false;
  if (lhs.frame_widget_host < rhs.frame_widget_host)
    return true;
  if (rhs.frame_widget_host < lhs.frame_widget_host)
    return false;
  if (lhs.frame_widget < rhs.frame_widget)
    return true;
  if (rhs.frame_widget < lhs.frame_widget)
    return false;
  if (lhs.widget_host < rhs.widget_host)
    return true;
  if (rhs.widget_host < lhs.widget_host)
    return false;
  if (lhs.widget < rhs.widget)
    return true;
  if (rhs.widget < lhs.widget)
    return false;
  if (lhs.session_storage_namespace_id < rhs.session_storage_namespace_id)
    return true;
  if (rhs.session_storage_namespace_id < lhs.session_storage_namespace_id)
    return false;
  if (lhs.opener_frame_route_id < rhs.opener_frame_route_id)
    return true;
  if (rhs.opener_frame_route_id < lhs.opener_frame_route_id)
    return false;
  if (lhs.replicated_frame_state < rhs.replicated_frame_state)
    return true;
  if (rhs.replicated_frame_state < lhs.replicated_frame_state)
    return false;
  if (lhs.devtools_main_frame_token < rhs.devtools_main_frame_token)
    return true;
  if (rhs.devtools_main_frame_token < lhs.devtools_main_frame_token)
    return false;
  if (lhs.proxy_routing_id < rhs.proxy_routing_id)
    return true;
  if (rhs.proxy_routing_id < lhs.proxy_routing_id)
    return false;
  if (lhs.hidden < rhs.hidden)
    return true;
  if (rhs.hidden < lhs.hidden)
    return false;
  if (lhs.never_composited < rhs.never_composited)
    return true;
  if (rhs.never_composited < lhs.never_composited)
    return false;
  if (lhs.window_was_created_with_opener < rhs.window_was_created_with_opener)
    return true;
  if (rhs.window_was_created_with_opener < lhs.window_was_created_with_opener)
    return false;
  if (lhs.has_committed_real_load < rhs.has_committed_real_load)
    return true;
  if (rhs.has_committed_real_load < lhs.has_committed_real_load)
    return false;
  if (lhs.visual_properties < rhs.visual_properties)
    return true;
  if (rhs.visual_properties < lhs.visual_properties)
    return false;
  if (lhs.renderer_wide_named_frame_lookup < rhs.renderer_wide_named_frame_lookup)
    return true;
  if (rhs.renderer_wide_named_frame_lookup < lhs.renderer_wide_named_frame_lookup)
    return false;
  if (lhs.inside_portal < rhs.inside_portal)
    return true;
  if (rhs.inside_portal < lhs.inside_portal)
    return false;
  if (lhs.blink_page_broadcast < rhs.blink_page_broadcast)
    return true;
  if (rhs.blink_page_broadcast < lhs.blink_page_broadcast)
    return false;
  return false;
}
template <typename StructPtrType>
CreateFrameWidgetParamsPtr CreateFrameWidgetParams::Clone() const {
  return New(
      mojo::Clone(routing_id),
      mojo::Clone(frame_widget_host),
      mojo::Clone(frame_widget),
      mojo::Clone(widget_host),
      mojo::Clone(widget),
      mojo::Clone(visual_properties)
  );
}

template <typename T, CreateFrameWidgetParams::EnableIfSame<T>*>
bool CreateFrameWidgetParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->routing_id, other_struct.routing_id))
    return false;
  if (!mojo::Equals(this->frame_widget_host, other_struct.frame_widget_host))
    return false;
  if (!mojo::Equals(this->frame_widget, other_struct.frame_widget))
    return false;
  if (!mojo::Equals(this->widget_host, other_struct.widget_host))
    return false;
  if (!mojo::Equals(this->widget, other_struct.widget))
    return false;
  if (!mojo::Equals(this->visual_properties, other_struct.visual_properties))
    return false;
  return true;
}

template <typename T, CreateFrameWidgetParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.routing_id < rhs.routing_id)
    return true;
  if (rhs.routing_id < lhs.routing_id)
    return false;
  if (lhs.frame_widget_host < rhs.frame_widget_host)
    return true;
  if (rhs.frame_widget_host < lhs.frame_widget_host)
    return false;
  if (lhs.frame_widget < rhs.frame_widget)
    return true;
  if (rhs.frame_widget < lhs.frame_widget)
    return false;
  if (lhs.widget_host < rhs.widget_host)
    return true;
  if (rhs.widget_host < lhs.widget_host)
    return false;
  if (lhs.widget < rhs.widget)
    return true;
  if (rhs.widget < lhs.widget)
    return false;
  if (lhs.visual_properties < rhs.visual_properties)
    return true;
  if (rhs.visual_properties < lhs.visual_properties)
    return false;
  return false;
}
template <typename StructPtrType>
CreateFrameParamsPtr CreateFrameParams::Clone() const {
  return New(
      mojo::Clone(routing_id),
      mojo::Clone(previous_routing_id),
      mojo::Clone(opener_routing_id),
      mojo::Clone(parent_routing_id),
      mojo::Clone(previous_sibling_routing_id),
      mojo::Clone(interface_bundle),
      mojo::Clone(replication_state),
      mojo::Clone(devtools_frame_token),
      mojo::Clone(frame_owner_properties),
      mojo::Clone(widget_params),
      mojo::Clone(has_committed_real_load)
  );
}

template <typename T, CreateFrameParams::EnableIfSame<T>*>
bool CreateFrameParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->routing_id, other_struct.routing_id))
    return false;
  if (!mojo::Equals(this->previous_routing_id, other_struct.previous_routing_id))
    return false;
  if (!mojo::Equals(this->opener_routing_id, other_struct.opener_routing_id))
    return false;
  if (!mojo::Equals(this->parent_routing_id, other_struct.parent_routing_id))
    return false;
  if (!mojo::Equals(this->previous_sibling_routing_id, other_struct.previous_sibling_routing_id))
    return false;
  if (!mojo::Equals(this->interface_bundle, other_struct.interface_bundle))
    return false;
  if (!mojo::Equals(this->replication_state, other_struct.replication_state))
    return false;
  if (!mojo::Equals(this->devtools_frame_token, other_struct.devtools_frame_token))
    return false;
  if (!mojo::Equals(this->frame_owner_properties, other_struct.frame_owner_properties))
    return false;
  if (!mojo::Equals(this->widget_params, other_struct.widget_params))
    return false;
  if (!mojo::Equals(this->has_committed_real_load, other_struct.has_committed_real_load))
    return false;
  return true;
}

template <typename T, CreateFrameParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.routing_id < rhs.routing_id)
    return true;
  if (rhs.routing_id < lhs.routing_id)
    return false;
  if (lhs.previous_routing_id < rhs.previous_routing_id)
    return true;
  if (rhs.previous_routing_id < lhs.previous_routing_id)
    return false;
  if (lhs.opener_routing_id < rhs.opener_routing_id)
    return true;
  if (rhs.opener_routing_id < lhs.opener_routing_id)
    return false;
  if (lhs.parent_routing_id < rhs.parent_routing_id)
    return true;
  if (rhs.parent_routing_id < lhs.parent_routing_id)
    return false;
  if (lhs.previous_sibling_routing_id < rhs.previous_sibling_routing_id)
    return true;
  if (rhs.previous_sibling_routing_id < lhs.previous_sibling_routing_id)
    return false;
  if (lhs.interface_bundle < rhs.interface_bundle)
    return true;
  if (rhs.interface_bundle < lhs.interface_bundle)
    return false;
  if (lhs.replication_state < rhs.replication_state)
    return true;
  if (rhs.replication_state < lhs.replication_state)
    return false;
  if (lhs.devtools_frame_token < rhs.devtools_frame_token)
    return true;
  if (rhs.devtools_frame_token < lhs.devtools_frame_token)
    return false;
  if (lhs.frame_owner_properties < rhs.frame_owner_properties)
    return true;
  if (rhs.frame_owner_properties < lhs.frame_owner_properties)
    return false;
  if (lhs.widget_params < rhs.widget_params)
    return true;
  if (rhs.widget_params < lhs.widget_params)
    return false;
  if (lhs.has_committed_real_load < rhs.has_committed_real_load)
    return true;
  if (rhs.has_committed_real_load < lhs.has_committed_real_load)
    return false;
  return false;
}
template <typename StructPtrType>
UpdateScrollbarThemeParamsPtr UpdateScrollbarThemeParams::Clone() const {
  return New(
      mojo::Clone(has_initial_button_delay),
      mojo::Clone(initial_button_delay),
      mojo::Clone(has_autoscroll_button_delay),
      mojo::Clone(autoscroll_button_delay),
      mojo::Clone(jump_on_track_click),
      mojo::Clone(preferred_scroller_style),
      mojo::Clone(redraw),
      mojo::Clone(scroll_view_rubber_banding)
  );
}

template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>*>
bool UpdateScrollbarThemeParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->has_initial_button_delay, other_struct.has_initial_button_delay))
    return false;
  if (!mojo::Equals(this->initial_button_delay, other_struct.initial_button_delay))
    return false;
  if (!mojo::Equals(this->has_autoscroll_button_delay, other_struct.has_autoscroll_button_delay))
    return false;
  if (!mojo::Equals(this->autoscroll_button_delay, other_struct.autoscroll_button_delay))
    return false;
  if (!mojo::Equals(this->jump_on_track_click, other_struct.jump_on_track_click))
    return false;
  if (!mojo::Equals(this->preferred_scroller_style, other_struct.preferred_scroller_style))
    return false;
  if (!mojo::Equals(this->redraw, other_struct.redraw))
    return false;
  if (!mojo::Equals(this->scroll_view_rubber_banding, other_struct.scroll_view_rubber_banding))
    return false;
  return true;
}

template <typename T, UpdateScrollbarThemeParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.has_initial_button_delay < rhs.has_initial_button_delay)
    return true;
  if (rhs.has_initial_button_delay < lhs.has_initial_button_delay)
    return false;
  if (lhs.initial_button_delay < rhs.initial_button_delay)
    return true;
  if (rhs.initial_button_delay < lhs.initial_button_delay)
    return false;
  if (lhs.has_autoscroll_button_delay < rhs.has_autoscroll_button_delay)
    return true;
  if (rhs.has_autoscroll_button_delay < lhs.has_autoscroll_button_delay)
    return false;
  if (lhs.autoscroll_button_delay < rhs.autoscroll_button_delay)
    return true;
  if (rhs.autoscroll_button_delay < lhs.autoscroll_button_delay)
    return false;
  if (lhs.jump_on_track_click < rhs.jump_on_track_click)
    return true;
  if (rhs.jump_on_track_click < lhs.jump_on_track_click)
    return false;
  if (lhs.preferred_scroller_style < rhs.preferred_scroller_style)
    return true;
  if (rhs.preferred_scroller_style < lhs.preferred_scroller_style)
    return false;
  if (lhs.redraw < rhs.redraw)
    return true;
  if (rhs.redraw < lhs.redraw)
    return false;
  if (lhs.scroll_view_rubber_banding < rhs.scroll_view_rubber_banding)
    return true;
  if (rhs.scroll_view_rubber_banding < lhs.scroll_view_rubber_banding)
    return false;
  return false;
}
template <typename StructPtrType>
UpdateSystemColorInfoParamsPtr UpdateSystemColorInfoParams::Clone() const {
  return New(
      mojo::Clone(is_dark_mode),
      mojo::Clone(is_high_contrast),
      mojo::Clone(colors)
  );
}

template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>*>
bool UpdateSystemColorInfoParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->is_dark_mode, other_struct.is_dark_mode))
    return false;
  if (!mojo::Equals(this->is_high_contrast, other_struct.is_high_contrast))
    return false;
  if (!mojo::Equals(this->colors, other_struct.colors))
    return false;
  return true;
}

template <typename T, UpdateSystemColorInfoParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.is_dark_mode < rhs.is_dark_mode)
    return true;
  if (rhs.is_dark_mode < lhs.is_dark_mode)
    return false;
  if (lhs.is_high_contrast < rhs.is_high_contrast)
    return true;
  if (rhs.is_high_contrast < lhs.is_high_contrast)
    return false;
  if (lhs.colors < rhs.colors)
    return true;
  if (rhs.colors < lhs.colors)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace content

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::CreateViewParams::DataView,
                                         ::content::mojom::CreateViewParamsPtr> {
  static bool IsNull(const ::content::mojom::CreateViewParamsPtr& input) { return !input; }
  static void SetToNull(::content::mojom::CreateViewParamsPtr* output) { output->reset(); }

  static const decltype(::content::mojom::CreateViewParams::renderer_preferences)& renderer_preferences(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->renderer_preferences;
  }

  static const decltype(::content::mojom::CreateViewParams::web_preferences)& web_preferences(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->web_preferences;
  }

  static decltype(::content::mojom::CreateViewParams::view_id) view_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->view_id;
  }

  static decltype(::content::mojom::CreateViewParams::main_frame_routing_id) main_frame_routing_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->main_frame_routing_id;
  }

  static decltype(::content::mojom::CreateViewParams::main_frame_widget_routing_id) main_frame_widget_routing_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->main_frame_widget_routing_id;
  }

  static  decltype(::content::mojom::CreateViewParams::main_frame_interface_bundle)& main_frame_interface_bundle(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->main_frame_interface_bundle;
  }

  static  decltype(::content::mojom::CreateViewParams::frame_widget_host)& frame_widget_host(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->frame_widget_host;
  }

  static  decltype(::content::mojom::CreateViewParams::frame_widget)& frame_widget(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->frame_widget;
  }

  static  decltype(::content::mojom::CreateViewParams::widget_host)& widget_host(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->widget_host;
  }

  static  decltype(::content::mojom::CreateViewParams::widget)& widget(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->widget;
  }

  static const decltype(::content::mojom::CreateViewParams::session_storage_namespace_id)& session_storage_namespace_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->session_storage_namespace_id;
  }

  static decltype(::content::mojom::CreateViewParams::opener_frame_route_id) opener_frame_route_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->opener_frame_route_id;
  }

  static const decltype(::content::mojom::CreateViewParams::replicated_frame_state)& replicated_frame_state(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->replicated_frame_state;
  }

  static const decltype(::content::mojom::CreateViewParams::devtools_main_frame_token)& devtools_main_frame_token(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->devtools_main_frame_token;
  }

  static decltype(::content::mojom::CreateViewParams::proxy_routing_id) proxy_routing_id(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->proxy_routing_id;
  }

  static decltype(::content::mojom::CreateViewParams::hidden) hidden(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->hidden;
  }

  static decltype(::content::mojom::CreateViewParams::never_composited) never_composited(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->never_composited;
  }

  static decltype(::content::mojom::CreateViewParams::window_was_created_with_opener) window_was_created_with_opener(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->window_was_created_with_opener;
  }

  static decltype(::content::mojom::CreateViewParams::has_committed_real_load) has_committed_real_load(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->has_committed_real_load;
  }

  static const decltype(::content::mojom::CreateViewParams::visual_properties)& visual_properties(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->visual_properties;
  }

  static decltype(::content::mojom::CreateViewParams::renderer_wide_named_frame_lookup) renderer_wide_named_frame_lookup(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->renderer_wide_named_frame_lookup;
  }

  static decltype(::content::mojom::CreateViewParams::inside_portal) inside_portal(
      const ::content::mojom::CreateViewParamsPtr& input) {
    return input->inside_portal;
  }

  static  decltype(::content::mojom::CreateViewParams::blink_page_broadcast)& blink_page_broadcast(
       ::content::mojom::CreateViewParamsPtr& input) {
    return input->blink_page_broadcast;
  }

  static bool Read(::content::mojom::CreateViewParams::DataView input, ::content::mojom::CreateViewParamsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::CreateFrameWidgetParams::DataView,
                                         ::content::mojom::CreateFrameWidgetParamsPtr> {
  static bool IsNull(const ::content::mojom::CreateFrameWidgetParamsPtr& input) { return !input; }
  static void SetToNull(::content::mojom::CreateFrameWidgetParamsPtr* output) { output->reset(); }

  static decltype(::content::mojom::CreateFrameWidgetParams::routing_id) routing_id(
      const ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->routing_id;
  }

  static  decltype(::content::mojom::CreateFrameWidgetParams::frame_widget_host)& frame_widget_host(
       ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->frame_widget_host;
  }

  static  decltype(::content::mojom::CreateFrameWidgetParams::frame_widget)& frame_widget(
       ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->frame_widget;
  }

  static  decltype(::content::mojom::CreateFrameWidgetParams::widget_host)& widget_host(
       ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->widget_host;
  }

  static  decltype(::content::mojom::CreateFrameWidgetParams::widget)& widget(
       ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->widget;
  }

  static const decltype(::content::mojom::CreateFrameWidgetParams::visual_properties)& visual_properties(
      const ::content::mojom::CreateFrameWidgetParamsPtr& input) {
    return input->visual_properties;
  }

  static bool Read(::content::mojom::CreateFrameWidgetParams::DataView input, ::content::mojom::CreateFrameWidgetParamsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::CreateFrameParams::DataView,
                                         ::content::mojom::CreateFrameParamsPtr> {
  static bool IsNull(const ::content::mojom::CreateFrameParamsPtr& input) { return !input; }
  static void SetToNull(::content::mojom::CreateFrameParamsPtr* output) { output->reset(); }

  static decltype(::content::mojom::CreateFrameParams::routing_id) routing_id(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->routing_id;
  }

  static decltype(::content::mojom::CreateFrameParams::previous_routing_id) previous_routing_id(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->previous_routing_id;
  }

  static decltype(::content::mojom::CreateFrameParams::opener_routing_id) opener_routing_id(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->opener_routing_id;
  }

  static decltype(::content::mojom::CreateFrameParams::parent_routing_id) parent_routing_id(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->parent_routing_id;
  }

  static decltype(::content::mojom::CreateFrameParams::previous_sibling_routing_id) previous_sibling_routing_id(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->previous_sibling_routing_id;
  }

  static  decltype(::content::mojom::CreateFrameParams::interface_bundle)& interface_bundle(
       ::content::mojom::CreateFrameParamsPtr& input) {
    return input->interface_bundle;
  }

  static const decltype(::content::mojom::CreateFrameParams::replication_state)& replication_state(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->replication_state;
  }

  static const decltype(::content::mojom::CreateFrameParams::devtools_frame_token)& devtools_frame_token(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->devtools_frame_token;
  }

  static const decltype(::content::mojom::CreateFrameParams::frame_owner_properties)& frame_owner_properties(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->frame_owner_properties;
  }

  static  decltype(::content::mojom::CreateFrameParams::widget_params)& widget_params(
       ::content::mojom::CreateFrameParamsPtr& input) {
    return input->widget_params;
  }

  static decltype(::content::mojom::CreateFrameParams::has_committed_real_load) has_committed_real_load(
      const ::content::mojom::CreateFrameParamsPtr& input) {
    return input->has_committed_real_load;
  }

  static bool Read(::content::mojom::CreateFrameParams::DataView input, ::content::mojom::CreateFrameParamsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::UpdateScrollbarThemeParams::DataView,
                                         ::content::mojom::UpdateScrollbarThemeParamsPtr> {
  static bool IsNull(const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) { return !input; }
  static void SetToNull(::content::mojom::UpdateScrollbarThemeParamsPtr* output) { output->reset(); }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::has_initial_button_delay) has_initial_button_delay(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->has_initial_button_delay;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::initial_button_delay) initial_button_delay(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->initial_button_delay;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::has_autoscroll_button_delay) has_autoscroll_button_delay(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->has_autoscroll_button_delay;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::autoscroll_button_delay) autoscroll_button_delay(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->autoscroll_button_delay;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::jump_on_track_click) jump_on_track_click(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->jump_on_track_click;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::preferred_scroller_style) preferred_scroller_style(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->preferred_scroller_style;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::redraw) redraw(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->redraw;
  }

  static decltype(::content::mojom::UpdateScrollbarThemeParams::scroll_view_rubber_banding) scroll_view_rubber_banding(
      const ::content::mojom::UpdateScrollbarThemeParamsPtr& input) {
    return input->scroll_view_rubber_banding;
  }

  static bool Read(::content::mojom::UpdateScrollbarThemeParams::DataView input, ::content::mojom::UpdateScrollbarThemeParamsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::UpdateSystemColorInfoParams::DataView,
                                         ::content::mojom::UpdateSystemColorInfoParamsPtr> {
  static bool IsNull(const ::content::mojom::UpdateSystemColorInfoParamsPtr& input) { return !input; }
  static void SetToNull(::content::mojom::UpdateSystemColorInfoParamsPtr* output) { output->reset(); }

  static decltype(::content::mojom::UpdateSystemColorInfoParams::is_dark_mode) is_dark_mode(
      const ::content::mojom::UpdateSystemColorInfoParamsPtr& input) {
    return input->is_dark_mode;
  }

  static decltype(::content::mojom::UpdateSystemColorInfoParams::is_high_contrast) is_high_contrast(
      const ::content::mojom::UpdateSystemColorInfoParamsPtr& input) {
    return input->is_high_contrast;
  }

  static const decltype(::content::mojom::UpdateSystemColorInfoParams::colors)& colors(
      const ::content::mojom::UpdateSystemColorInfoParamsPtr& input) {
    return input->colors;
  }

  static bool Read(::content::mojom::UpdateSystemColorInfoParams::DataView input, ::content::mojom::UpdateSystemColorInfoParamsPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_RENDERER_MOJOM_H_