// media/mojo/mojom/soda_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_SODA_SERVICE_MOJOM_H_
#define MEDIA_MOJO_MOJOM_SODA_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "media/mojo/mojom/soda_service.mojom-shared.h"
#include "media/mojo/mojom/soda_service.mojom-forward.h"
#include "media/mojo/mojom/media_types.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace media {
namespace mojom {

class SodaContextProxy;

template <typename ImplRefTraits>
class SodaContextStub;

class SodaContextRequestValidator;


class  SodaContext
    : public SodaContextInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SodaContextInterfaceBase;
  using Proxy_ = SodaContextProxy;

  template <typename ImplRefTraits>
  using Stub_ = SodaContextStub<ImplRefTraits>;

  using RequestValidator_ = SodaContextRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kBindRecognizerMinVersion = 0,
  };
  virtual ~SodaContext() {}

  
  virtual void BindRecognizer(mojo::PendingReceiver<SodaRecognizer> receiver, mojo::PendingRemote<SodaRecognizerClient> client) = 0;
};

class SodaServiceProxy;

template <typename ImplRefTraits>
class SodaServiceStub;

class SodaServiceRequestValidator;


class  SodaService
    : public SodaServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SodaServiceInterfaceBase;
  using Proxy_ = SodaServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = SodaServiceStub<ImplRefTraits>;

  using RequestValidator_ = SodaServiceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kBindContextMinVersion = 0,
  };
  virtual ~SodaService() {}

  
  virtual void BindContext(mojo::PendingReceiver<SodaContext> context) = 0;
};

class SodaRecognizerProxy;

template <typename ImplRefTraits>
class SodaRecognizerStub;

class SodaRecognizerRequestValidator;


class  SodaRecognizer
    : public SodaRecognizerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SodaRecognizerInterfaceBase;
  using Proxy_ = SodaRecognizerProxy;

  template <typename ImplRefTraits>
  using Stub_ = SodaRecognizerStub<ImplRefTraits>;

  using RequestValidator_ = SodaRecognizerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSendAudioToSodaMinVersion = 0,
  };
  virtual ~SodaRecognizer() {}

  
  virtual void SendAudioToSoda(::media::mojom::AudioDataS16Ptr buffer) = 0;
};

class SodaRecognizerClientProxy;

template <typename ImplRefTraits>
class SodaRecognizerClientStub;

class SodaRecognizerClientRequestValidator;


class  SodaRecognizerClient
    : public SodaRecognizerClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SodaRecognizerClientInterfaceBase;
  using Proxy_ = SodaRecognizerClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = SodaRecognizerClientStub<ImplRefTraits>;

  using RequestValidator_ = SodaRecognizerClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSodaRecognitionEventMinVersion = 0,
  };
  virtual ~SodaRecognizerClient() {}

  
  virtual void OnSodaRecognitionEvent(const std::string& transcription) = 0;
};



class  SodaContextProxy
    : public SodaContext {
 public:
  using InterfaceType = SodaContext;

  explicit SodaContextProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void BindRecognizer(mojo::PendingReceiver<SodaRecognizer> receiver, mojo::PendingRemote<SodaRecognizerClient> client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SodaServiceProxy
    : public SodaService {
 public:
  using InterfaceType = SodaService;

  explicit SodaServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void BindContext(mojo::PendingReceiver<SodaContext> context) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SodaRecognizerProxy
    : public SodaRecognizer {
 public:
  using InterfaceType = SodaRecognizer;

  explicit SodaRecognizerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SendAudioToSoda(::media::mojom::AudioDataS16Ptr buffer) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  SodaRecognizerClientProxy
    : public SodaRecognizerClient {
 public:
  using InterfaceType = SodaRecognizerClient;

  explicit SodaRecognizerClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnSodaRecognitionEvent(const std::string& transcription) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  SodaContextStubDispatch {
 public:
  static bool Accept(SodaContext* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SodaContext* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SodaContext>>
class SodaContextStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SodaContextStub() {}
  ~SodaContextStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaContextStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaContextStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SodaServiceStubDispatch {
 public:
  static bool Accept(SodaService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SodaService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SodaService>>
class SodaServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SodaServiceStub() {}
  ~SodaServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SodaRecognizerStubDispatch {
 public:
  static bool Accept(SodaRecognizer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SodaRecognizer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SodaRecognizer>>
class SodaRecognizerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SodaRecognizerStub() {}
  ~SodaRecognizerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaRecognizerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaRecognizerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SodaRecognizerClientStubDispatch {
 public:
  static bool Accept(SodaRecognizerClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SodaRecognizerClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SodaRecognizerClient>>
class SodaRecognizerClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SodaRecognizerClientStub() {}
  ~SodaRecognizerClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaRecognizerClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SodaRecognizerClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SodaContextRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SodaServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SodaRecognizerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SodaRecognizerClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace media

namespace mojo {

}  // namespace mojo

#endif  // MEDIA_MOJO_MOJOM_SODA_SERVICE_MOJOM_H_