// services/device/public/mojom/nfc.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_NFC_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_NFC_MOJOM_BLINK_TEST_UTILS_H_

#include "services/device/public/mojom/nfc.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace device {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT NFCInterceptorForTesting : public NFC {
  virtual NFC* GetForwardingInterface() = 0;
  void SetClient(mojo::PendingRemote<NFCClient> client) override;
  void Push(NDEFMessagePtr message, NDEFWriteOptionsPtr options, PushCallback callback) override;
  void CancelPush(CancelPushCallback callback) override;
  void Watch(NDEFScanOptionsPtr options, uint32_t id, WatchCallback callback) override;
  void CancelWatch(uint32_t id, CancelWatchCallback callback) override;
  void CancelAllWatches(CancelAllWatchesCallback callback) override;
};
class BLINK_PLATFORM_EXPORT NFCAsyncWaiter {
 public:
  explicit NFCAsyncWaiter(NFC* proxy);
  ~NFCAsyncWaiter();
  void Push(
      NDEFMessagePtr message, NDEFWriteOptionsPtr options, NDEFErrorPtr* out_error);
  void CancelPush(
      NDEFErrorPtr* out_error);
  void Watch(
      NDEFScanOptionsPtr options, uint32_t id, NDEFErrorPtr* out_error);
  void CancelWatch(
      uint32_t id, NDEFErrorPtr* out_error);
  void CancelAllWatches(
      NDEFErrorPtr* out_error);

 private:
  NFC* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NFCAsyncWaiter);
};


class BLINK_PLATFORM_EXPORT NFCClientInterceptorForTesting : public NFCClient {
  virtual NFCClient* GetForwardingInterface() = 0;
  void OnWatch(const WTF::Vector<uint32_t>& watch_ids, const WTF::String& serial_number, NDEFMessagePtr message) override;
  void OnError(NDEFErrorPtr error) override;
};
class BLINK_PLATFORM_EXPORT NFCClientAsyncWaiter {
 public:
  explicit NFCClientAsyncWaiter(NFCClient* proxy);
  ~NFCClientAsyncWaiter();

 private:
  NFCClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NFCClientAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_NFC_MOJOM_BLINK_TEST_UTILS_H_