// services/viz/public/mojom/compositing/compositor_frame_metadata.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/viz/public/mojom/compositing/compositor_frame_metadata.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "services/viz/public/mojom/compositing/compositor_frame_metadata.mojom-params-data.h"
namespace viz {
namespace mojom {

namespace internal {


// static
bool CompositorFrameMetadata_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameMetadata_Data* object = static_cast<const CompositorFrameMetadata_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 120 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->root_scroll_offset, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->root_scroll_offset, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->scrollable_viewport_size, 4, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->scrollable_viewport_size, validation_context))
    return false;


  if (!::gfx::mojom::internal::ContentColorUsage_Data
        ::Validate(object->content_color_usage, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->latency_info, 9, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams latency_info_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->latency_info, validation_context,
                                         &latency_info_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->referenced_surfaces, 10, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams referenced_surfaces_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->referenced_surfaces, validation_context,
                                         &referenced_surfaces_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->deadline, 11, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->deadline, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->activation_dependencies, 12, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams activation_dependencies_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->activation_dependencies, validation_context,
                                         &activation_dependencies_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->begin_frame_ack, 13, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->begin_frame_ack, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->local_surface_id_allocation_time, 19, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->local_surface_id_allocation_time, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->preferred_frame_interval, validation_context))
    return false;


  if (!::gfx::mojom::internal::OverlayTransform_Data
        ::Validate(object->display_transform_hint, validation_context))
    return false;

  return true;
}

CompositorFrameMetadata_Data::CompositorFrameMetadata_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace viz