// third_party/blink/public/mojom/devtools/inspector_issue.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-params-data.h"
namespace blink {
namespace mojom {

std::ostream& operator<<(std::ostream& os, InspectorIssueCode value) {
  switch(value) {
    case InspectorIssueCode::kSameSiteCookieIssue:
      return os << "InspectorIssueCode::kSameSiteCookieIssue";
    default:
      return os << "Unknown InspectorIssueCode value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, SameSiteCookieExclusionReason value) {
  switch(value) {
    case SameSiteCookieExclusionReason::ExcludeSameSiteUnspecifiedTreatedAsLax:
      return os << "SameSiteCookieExclusionReason::ExcludeSameSiteUnspecifiedTreatedAsLax";
    case SameSiteCookieExclusionReason::ExcludeSameSiteNoneInsecure:
      return os << "SameSiteCookieExclusionReason::ExcludeSameSiteNoneInsecure";
    default:
      return os << "Unknown SameSiteCookieExclusionReason value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, SameSiteCookieWarningReason value) {
  switch(value) {
    case SameSiteCookieWarningReason::WarnSameSiteUnspecifiedCrossSiteContext:
      return os << "SameSiteCookieWarningReason::WarnSameSiteUnspecifiedCrossSiteContext";
    case SameSiteCookieWarningReason::WarnSameSiteNoneInsecure:
      return os << "SameSiteCookieWarningReason::WarnSameSiteNoneInsecure";
    case SameSiteCookieWarningReason::WarnSameSiteUnspecifiedLaxAllowUnsafe:
      return os << "SameSiteCookieWarningReason::WarnSameSiteUnspecifiedLaxAllowUnsafe";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlMethodUnsafe:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlMethodUnsafe";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlLax:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlLax";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlStrict:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeSecureUrlStrict";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlMethodUnsafe:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlMethodUnsafe";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlLax:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlLax";
    case SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlStrict:
      return os << "SameSiteCookieWarningReason::WarnSameSiteCrossSchemeInsecureUrlStrict";
    default:
      return os << "Unknown SameSiteCookieWarningReason value: " << static_cast<int32_t>(value);
  }
}

namespace internal {


// static
bool AffectedCookie_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AffectedCookie_Data* object = static_cast<const AffectedCookie_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 40 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->name, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams name_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams path_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->path, validation_context,
                                         &path_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->domain, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams domain_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->domain, validation_context,
                                         &domain_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->site_for_cookies, validation_context))
    return false;

  return true;
}

AffectedCookie_Data::AffectedCookie_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AffectedResources_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AffectedResources_Data* object = static_cast<const AffectedResources_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->cookies, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams cookies_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->cookies, validation_context,
                                         &cookies_validate_params)) {
    return false;
  }

  return true;
}

AffectedResources_Data::AffectedResources_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SameSiteCookieIssueDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const SameSiteCookieIssueDetails_Data* object = static_cast<const SameSiteCookieIssueDetails_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->exclusionReason, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams exclusionReason_validate_params(
      0, ::blink::mojom::internal::SameSiteCookieExclusionReason_Data::Validate);
  if (!mojo::internal::ValidateContainer(object->exclusionReason, validation_context,
                                         &exclusionReason_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->warningReason, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams warningReason_validate_params(
      0, ::blink::mojom::internal::SameSiteCookieWarningReason_Data::Validate);
  if (!mojo::internal::ValidateContainer(object->warningReason, validation_context,
                                         &warningReason_validate_params)) {
    return false;
  }

  return true;
}

SameSiteCookieIssueDetails_Data::SameSiteCookieIssueDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool InspectorIssueDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const InspectorIssueDetails_Data* object = static_cast<const InspectorIssueDetails_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->sameSiteCookieIssueDetails, validation_context))
    return false;

  return true;
}

InspectorIssueDetails_Data::InspectorIssueDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool InspectorIssueInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const InspectorIssueInfo_Data* object = static_cast<const InspectorIssueInfo_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 32 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }


  if (!::blink::mojom::internal::InspectorIssueCode_Data
        ::Validate(object->code, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->details, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->details, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->resources, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->resources, validation_context))
    return false;

  return true;
}

InspectorIssueInfo_Data::InspectorIssueInfo_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink