// third_party/blink/public/mojom/devtools/inspector_issue.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-params-data.h"
#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_INSPECTOR_ISSUE_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_INSPECTOR_ISSUE_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
AffectedCookie::AffectedCookie()
    : name(),
      path(),
      domain(),
      site_for_cookies() {}

AffectedCookie::AffectedCookie(
    const std::string& name_in,
    const std::string& path_in,
    const std::string& domain_in,
    const base::Optional<::GURL>& site_for_cookies_in)
    : name(std::move(name_in)),
      path(std::move(path_in)),
      domain(std::move(domain_in)),
      site_for_cookies(std::move(site_for_cookies_in)) {}

AffectedCookie::~AffectedCookie() = default;

bool AffectedCookie::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AffectedResources::AffectedResources()
    : cookies() {}

AffectedResources::AffectedResources(
    std::vector<AffectedCookiePtr> cookies_in)
    : cookies(std::move(cookies_in)) {}

AffectedResources::~AffectedResources() = default;

bool AffectedResources::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SameSiteCookieIssueDetails::SameSiteCookieIssueDetails()
    : exclusionReason(),
      warningReason() {}

SameSiteCookieIssueDetails::SameSiteCookieIssueDetails(
    std::vector<SameSiteCookieExclusionReason> exclusionReason_in,
    std::vector<SameSiteCookieWarningReason> warningReason_in)
    : exclusionReason(std::move(exclusionReason_in)),
      warningReason(std::move(warningReason_in)) {}

SameSiteCookieIssueDetails::~SameSiteCookieIssueDetails() = default;

bool SameSiteCookieIssueDetails::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
InspectorIssueDetails::InspectorIssueDetails()
    : sameSiteCookieIssueDetails() {}

InspectorIssueDetails::InspectorIssueDetails(
    SameSiteCookieIssueDetailsPtr sameSiteCookieIssueDetails_in)
    : sameSiteCookieIssueDetails(std::move(sameSiteCookieIssueDetails_in)) {}

InspectorIssueDetails::~InspectorIssueDetails() = default;

bool InspectorIssueDetails::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
InspectorIssueInfo::InspectorIssueInfo()
    : code(),
      details(),
      resources() {}

InspectorIssueInfo::InspectorIssueInfo(
    InspectorIssueCode code_in,
    InspectorIssueDetailsPtr details_in,
    AffectedResourcesPtr resources_in)
    : code(std::move(code_in)),
      details(std::move(details_in)),
      resources(std::move(resources_in)) {}

InspectorIssueInfo::~InspectorIssueInfo() = default;

bool InspectorIssueInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::AffectedCookie::DataView, ::blink::mojom::AffectedCookiePtr>::Read(
    ::blink::mojom::AffectedCookie::DataView input,
    ::blink::mojom::AffectedCookiePtr* output) {
  bool success = true;
  ::blink::mojom::AffectedCookiePtr result(::blink::mojom::AffectedCookie::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadPath(&result->path))
        success = false;
      if (success && !input.ReadDomain(&result->domain))
        success = false;
      if (success && !input.ReadSiteForCookies(&result->site_for_cookies))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::AffectedResources::DataView, ::blink::mojom::AffectedResourcesPtr>::Read(
    ::blink::mojom::AffectedResources::DataView input,
    ::blink::mojom::AffectedResourcesPtr* output) {
  bool success = true;
  ::blink::mojom::AffectedResourcesPtr result(::blink::mojom::AffectedResources::New());
  
      if (success && !input.ReadCookies(&result->cookies))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::SameSiteCookieIssueDetails::DataView, ::blink::mojom::SameSiteCookieIssueDetailsPtr>::Read(
    ::blink::mojom::SameSiteCookieIssueDetails::DataView input,
    ::blink::mojom::SameSiteCookieIssueDetailsPtr* output) {
  bool success = true;
  ::blink::mojom::SameSiteCookieIssueDetailsPtr result(::blink::mojom::SameSiteCookieIssueDetails::New());
  
      if (success && !input.ReadExclusionReason(&result->exclusionReason))
        success = false;
      if (success && !input.ReadWarningReason(&result->warningReason))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::InspectorIssueDetails::DataView, ::blink::mojom::InspectorIssueDetailsPtr>::Read(
    ::blink::mojom::InspectorIssueDetails::DataView input,
    ::blink::mojom::InspectorIssueDetailsPtr* output) {
  bool success = true;
  ::blink::mojom::InspectorIssueDetailsPtr result(::blink::mojom::InspectorIssueDetails::New());
  
      if (success && !input.ReadSameSiteCookieIssueDetails(&result->sameSiteCookieIssueDetails))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::InspectorIssueInfo::DataView, ::blink::mojom::InspectorIssueInfoPtr>::Read(
    ::blink::mojom::InspectorIssueInfo::DataView input,
    ::blink::mojom::InspectorIssueInfoPtr* output) {
  bool success = true;
  ::blink::mojom::InspectorIssueInfoPtr result(::blink::mojom::InspectorIssueInfo::New());
  
      if (success && !input.ReadCode(&result->code))
        success = false;
      if (success && !input.ReadDetails(&result->details))
        success = false;
      if (success && !input.ReadResources(&result->resources))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif