// third_party/blink/public/mojom/feature_policy/feature_policy.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy.mojom-shared.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy_feature.mojom.h"
#include "third_party/blink/public/mojom/feature_policy/policy_value.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/feature_policy/feature_policy.h"
#include "third_party/blink/public/common/feature_policy/policy_value.h"
#include "third_party/blink/public/common/frame/sandbox_flags.h"
#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {








class BLINK_COMMON_EXPORT ParsedFeaturePolicyDeclaration {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ParsedFeaturePolicyDeclaration, T>::value>;
  using DataView = ParsedFeaturePolicyDeclarationDataView;
  using Data_ = internal::ParsedFeaturePolicyDeclaration_Data;

  template <typename... Args>
  static ParsedFeaturePolicyDeclarationPtr New(Args&&... args) {
    return ParsedFeaturePolicyDeclarationPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ParsedFeaturePolicyDeclarationPtr From(const U& u) {
    return mojo::TypeConverter<ParsedFeaturePolicyDeclarationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ParsedFeaturePolicyDeclaration>::Convert(*this);
  }


  ParsedFeaturePolicyDeclaration();

  ParsedFeaturePolicyDeclaration(
      ::blink::mojom::FeaturePolicyFeature feature,
      const base::flat_map<::url::Origin, ::blink::PolicyValue>& values,
      const ::blink::PolicyValue& fallback_value,
      const ::blink::PolicyValue& opaque_value);

  ~ParsedFeaturePolicyDeclaration();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ParsedFeaturePolicyDeclarationPtr>
  ParsedFeaturePolicyDeclarationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ParsedFeaturePolicyDeclaration::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ParsedFeaturePolicyDeclaration::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ParsedFeaturePolicyDeclaration_UnserializedMessageContext<
            UserType, ParsedFeaturePolicyDeclaration::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ParsedFeaturePolicyDeclaration::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ParsedFeaturePolicyDeclaration::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ParsedFeaturePolicyDeclaration_UnserializedMessageContext<
            UserType, ParsedFeaturePolicyDeclaration::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ParsedFeaturePolicyDeclaration::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::blink::mojom::FeaturePolicyFeature feature;
  
  base::flat_map<::url::Origin, ::blink::PolicyValue> values;
  
  ::blink::PolicyValue fallback_value;
  
  ::blink::PolicyValue opaque_value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ParsedFeaturePolicyDeclarationPtr ParsedFeaturePolicyDeclaration::Clone() const {
  return New(
      mojo::Clone(feature),
      mojo::Clone(values),
      mojo::Clone(fallback_value),
      mojo::Clone(opaque_value)
  );
}

template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>*>
bool ParsedFeaturePolicyDeclaration::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->feature, other_struct.feature))
    return false;
  if (!mojo::Equals(this->values, other_struct.values))
    return false;
  if (!mojo::Equals(this->fallback_value, other_struct.fallback_value))
    return false;
  if (!mojo::Equals(this->opaque_value, other_struct.opaque_value))
    return false;
  return true;
}

template <typename T, ParsedFeaturePolicyDeclaration::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.feature < rhs.feature)
    return true;
  if (rhs.feature < lhs.feature)
    return false;
  if (lhs.values < rhs.values)
    return true;
  if (rhs.values < lhs.values)
    return false;
  if (lhs.fallback_value < rhs.fallback_value)
    return true;
  if (rhs.fallback_value < lhs.fallback_value)
    return false;
  if (lhs.opaque_value < rhs.opaque_value)
    return true;
  if (rhs.opaque_value < lhs.opaque_value)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::ParsedFeaturePolicyDeclaration::DataView,
                                         ::blink::mojom::ParsedFeaturePolicyDeclarationPtr> {
  static bool IsNull(const ::blink::mojom::ParsedFeaturePolicyDeclarationPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::ParsedFeaturePolicyDeclarationPtr* output) { output->reset(); }

  static decltype(::blink::mojom::ParsedFeaturePolicyDeclaration::feature) feature(
      const ::blink::mojom::ParsedFeaturePolicyDeclarationPtr& input) {
    return input->feature;
  }

  static const decltype(::blink::mojom::ParsedFeaturePolicyDeclaration::values)& values(
      const ::blink::mojom::ParsedFeaturePolicyDeclarationPtr& input) {
    return input->values;
  }

  static const decltype(::blink::mojom::ParsedFeaturePolicyDeclaration::fallback_value)& fallback_value(
      const ::blink::mojom::ParsedFeaturePolicyDeclarationPtr& input) {
    return input->fallback_value;
  }

  static const decltype(::blink::mojom::ParsedFeaturePolicyDeclaration::opaque_value)& opaque_value(
      const ::blink::mojom::ParsedFeaturePolicyDeclarationPtr& input) {
    return input->opaque_value;
  }

  static bool Read(::blink::mojom::ParsedFeaturePolicyDeclaration::DataView input, ::blink::mojom::ParsedFeaturePolicyDeclarationPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_H_