// third_party/blink/public/mojom/fetch/fetch_api_response.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FETCH_FETCH_API_RESPONSE_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FETCH_FETCH_API_RESPONSE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/fetch/fetch_api_response.mojom-shared.h"
#include "third_party/blink/public/mojom/fetch/fetch_api_response.mojom-blink-forward.h"
#include "mojo/public/mojom/base/time.mojom-blink.h"
#include "services/network/public/mojom/fetch_api.mojom-blink.h"
#include "services/network/public/mojom/content_security_policy.mojom-blink.h"
#include "third_party/blink/public/mojom/blob/serialized_blob.mojom-blink.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_error_type.mojom-blink.h"
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink {
namespace mojom {
namespace blink {








class PLATFORM_EXPORT FetchAPIResponse {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FetchAPIResponse, T>::value>;
  using DataView = FetchAPIResponseDataView;
  using Data_ = internal::FetchAPIResponse_Data;

  template <typename... Args>
  static FetchAPIResponsePtr New(Args&&... args) {
    return FetchAPIResponsePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FetchAPIResponsePtr From(const U& u) {
    return mojo::TypeConverter<FetchAPIResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FetchAPIResponse>::Convert(*this);
  }


  FetchAPIResponse();

  FetchAPIResponse(
      WTF::Vector<::blink::KURL> url_list,
      uint16_t status_code,
      const WTF::String& status_text,
      ::network::mojom::blink::FetchResponseType response_type,
      ::network::mojom::blink::FetchResponseSource response_source,
      const WTF::HashMap<WTF::String, WTF::String>& headers,
      const ::scoped_refptr<::blink::BlobDataHandle>& blob,
      ::blink::mojom::blink::ServiceWorkerResponseError error,
      ::base::Time response_time,
      const WTF::String& cache_storage_cache_name,
      WTF::Vector<WTF::String> cors_exposed_header_names,
      const ::scoped_refptr<::blink::BlobDataHandle>& side_data_blob,
      const ::scoped_refptr<::blink::BlobDataHandle>& side_data_blob_for_cache_put,
      WTF::Vector<::network::mojom::blink::ContentSecurityPolicyPtr> content_security_policy,
      bool loaded_with_credentials);

  ~FetchAPIResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FetchAPIResponsePtr>
  FetchAPIResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FetchAPIResponse::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FetchAPIResponse::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FetchAPIResponse::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FetchAPIResponse_UnserializedMessageContext<
            UserType, FetchAPIResponse::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FetchAPIResponse::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FetchAPIResponse::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FetchAPIResponse_UnserializedMessageContext<
            UserType, FetchAPIResponse::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FetchAPIResponse::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::Vector<::blink::KURL> url_list;
  
  uint16_t status_code;
  
  WTF::String status_text;
  
  ::network::mojom::blink::FetchResponseType response_type;
  
  ::network::mojom::blink::FetchResponseSource response_source;
  
  WTF::HashMap<WTF::String, WTF::String> headers;
  
  ::scoped_refptr<::blink::BlobDataHandle> blob;
  
  ::blink::mojom::blink::ServiceWorkerResponseError error;
  
  ::base::Time response_time;
  
  WTF::String cache_storage_cache_name;
  
  WTF::Vector<WTF::String> cors_exposed_header_names;
  
  ::scoped_refptr<::blink::BlobDataHandle> side_data_blob;
  
  ::scoped_refptr<::blink::BlobDataHandle> side_data_blob_for_cache_put;
  
  WTF::Vector<::network::mojom::blink::ContentSecurityPolicyPtr> content_security_policy;
  
  bool loaded_with_credentials;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(FetchAPIResponse);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FetchAPIResponse::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FetchAPIResponse::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FetchAPIResponse::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FetchAPIResponse::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FetchAPIResponsePtr FetchAPIResponse::Clone() const {
  return New(
      mojo::Clone(url_list),
      mojo::Clone(status_code),
      mojo::Clone(status_text),
      mojo::Clone(response_type),
      mojo::Clone(response_source),
      mojo::Clone(headers),
      mojo::Clone(blob),
      mojo::Clone(error),
      mojo::Clone(response_time),
      mojo::Clone(cache_storage_cache_name),
      mojo::Clone(cors_exposed_header_names),
      mojo::Clone(side_data_blob),
      mojo::Clone(side_data_blob_for_cache_put),
      mojo::Clone(content_security_policy),
      mojo::Clone(loaded_with_credentials)
  );
}

template <typename T, FetchAPIResponse::EnableIfSame<T>*>
bool FetchAPIResponse::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url_list, other_struct.url_list))
    return false;
  if (!mojo::Equals(this->status_code, other_struct.status_code))
    return false;
  if (!mojo::Equals(this->status_text, other_struct.status_text))
    return false;
  if (!mojo::Equals(this->response_type, other_struct.response_type))
    return false;
  if (!mojo::Equals(this->response_source, other_struct.response_source))
    return false;
  if (!mojo::Equals(this->headers, other_struct.headers))
    return false;
  if (!mojo::Equals(this->blob, other_struct.blob))
    return false;
  if (!mojo::Equals(this->error, other_struct.error))
    return false;
  if (!mojo::Equals(this->response_time, other_struct.response_time))
    return false;
  if (!mojo::Equals(this->cache_storage_cache_name, other_struct.cache_storage_cache_name))
    return false;
  if (!mojo::Equals(this->cors_exposed_header_names, other_struct.cors_exposed_header_names))
    return false;
  if (!mojo::Equals(this->side_data_blob, other_struct.side_data_blob))
    return false;
  if (!mojo::Equals(this->side_data_blob_for_cache_put, other_struct.side_data_blob_for_cache_put))
    return false;
  if (!mojo::Equals(this->content_security_policy, other_struct.content_security_policy))
    return false;
  if (!mojo::Equals(this->loaded_with_credentials, other_struct.loaded_with_credentials))
    return false;
  return true;
}

template <typename T, FetchAPIResponse::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.url_list < rhs.url_list)
    return true;
  if (rhs.url_list < lhs.url_list)
    return false;
  if (lhs.status_code < rhs.status_code)
    return true;
  if (rhs.status_code < lhs.status_code)
    return false;
  if (lhs.status_text < rhs.status_text)
    return true;
  if (rhs.status_text < lhs.status_text)
    return false;
  if (lhs.response_type < rhs.response_type)
    return true;
  if (rhs.response_type < lhs.response_type)
    return false;
  if (lhs.response_source < rhs.response_source)
    return true;
  if (rhs.response_source < lhs.response_source)
    return false;
  if (lhs.headers < rhs.headers)
    return true;
  if (rhs.headers < lhs.headers)
    return false;
  if (lhs.blob < rhs.blob)
    return true;
  if (rhs.blob < lhs.blob)
    return false;
  if (lhs.error < rhs.error)
    return true;
  if (rhs.error < lhs.error)
    return false;
  if (lhs.response_time < rhs.response_time)
    return true;
  if (rhs.response_time < lhs.response_time)
    return false;
  if (lhs.cache_storage_cache_name < rhs.cache_storage_cache_name)
    return true;
  if (rhs.cache_storage_cache_name < lhs.cache_storage_cache_name)
    return false;
  if (lhs.cors_exposed_header_names < rhs.cors_exposed_header_names)
    return true;
  if (rhs.cors_exposed_header_names < lhs.cors_exposed_header_names)
    return false;
  if (lhs.side_data_blob < rhs.side_data_blob)
    return true;
  if (rhs.side_data_blob < lhs.side_data_blob)
    return false;
  if (lhs.side_data_blob_for_cache_put < rhs.side_data_blob_for_cache_put)
    return true;
  if (rhs.side_data_blob_for_cache_put < lhs.side_data_blob_for_cache_put)
    return false;
  if (lhs.content_security_policy < rhs.content_security_policy)
    return true;
  if (rhs.content_security_policy < lhs.content_security_policy)
    return false;
  if (lhs.loaded_with_credentials < rhs.loaded_with_credentials)
    return true;
  if (rhs.loaded_with_credentials < lhs.loaded_with_credentials)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::FetchAPIResponse::DataView,
                                         ::blink::mojom::blink::FetchAPIResponsePtr> {
  static bool IsNull(const ::blink::mojom::blink::FetchAPIResponsePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::FetchAPIResponsePtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::url_list)& url_list(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->url_list;
  }

  static decltype(::blink::mojom::blink::FetchAPIResponse::status_code) status_code(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->status_code;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::status_text)& status_text(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->status_text;
  }

  static decltype(::blink::mojom::blink::FetchAPIResponse::response_type) response_type(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->response_type;
  }

  static decltype(::blink::mojom::blink::FetchAPIResponse::response_source) response_source(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->response_source;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::headers)& headers(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->headers;
  }

  static  decltype(::blink::mojom::blink::FetchAPIResponse::blob)& blob(
       ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->blob;
  }

  static decltype(::blink::mojom::blink::FetchAPIResponse::error) error(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->error;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::response_time)& response_time(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->response_time;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::cache_storage_cache_name)& cache_storage_cache_name(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->cache_storage_cache_name;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::cors_exposed_header_names)& cors_exposed_header_names(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->cors_exposed_header_names;
  }

  static  decltype(::blink::mojom::blink::FetchAPIResponse::side_data_blob)& side_data_blob(
       ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->side_data_blob;
  }

  static  decltype(::blink::mojom::blink::FetchAPIResponse::side_data_blob_for_cache_put)& side_data_blob_for_cache_put(
       ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->side_data_blob_for_cache_put;
  }

  static const decltype(::blink::mojom::blink::FetchAPIResponse::content_security_policy)& content_security_policy(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->content_security_policy;
  }

  static decltype(::blink::mojom::blink::FetchAPIResponse::loaded_with_credentials) loaded_with_credentials(
      const ::blink::mojom::blink::FetchAPIResponsePtr& input) {
    return input->loaded_with_credentials;
  }

  static bool Read(::blink::mojom::blink::FetchAPIResponse::DataView input, ::blink::mojom::blink::FetchAPIResponsePtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FETCH_FETCH_API_RESPONSE_MOJOM_BLINK_H_