// third_party/blink/public/mojom/frame/frame.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/frame/frame.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink {
namespace mojom {
namespace blink {


class PLATFORM_EXPORT LocalFrameHostInterceptorForTesting : public LocalFrameHost {
  virtual LocalFrameHost* GetForwardingInterface() = 0;
  void EnterFullscreen(::blink::mojom::blink::FullscreenOptionsPtr options, EnterFullscreenCallback callback) override;
  void ExitFullscreen() override;
  void FullscreenStateChanged(bool is_fullscreen) override;
  void RegisterProtocolHandler(const WTF::String& scheme, const ::blink::KURL& url, const ::WTF::String& title, bool user_gesture) override;
  void UnregisterProtocolHandler(const WTF::String& scheme, const ::blink::KURL& url, bool user_gesture) override;
  void DidDisplayInsecureContent() override;
  void DidContainInsecureFormAction() override;
  void DocumentAvailableInMainFrame(bool uses_temporary_zoom_level) override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void LifecycleStateChanged(::blink::mojom::blink::FrameLifecycleState state) override;
  void EvictFromBackForwardCache() override;
  void VisibilityChanged(::blink::mojom::blink::FrameVisibility visibility) override;
  void DidChangeThemeColor(const base::Optional<::SkColor>& theme_color) override;
  void DidFailLoadWithError(const ::blink::KURL& url, int32_t error_code) override;
  void DidFocusFrame() override;
  void DidAddContentSecurityPolicies(WTF::Vector<::network::mojom::blink::ContentSecurityPolicyPtr> policies) override;
  void EnforceInsecureRequestPolicy(::blink::mojom::blink::InsecureRequestPolicy policy_bitmap) override;
  void EnforceInsecureNavigationsSet(const WTF::Vector<uint32_t>& set) override;
  void DidChangeActiveSchedulerTrackedFeatures(uint64_t features_mask) override;
  void SuddenTerminationDisablerChanged(bool present, ::blink::mojom::blink::SuddenTerminationDisablerType disabler_type) override;
  void HadStickyUserActivationBeforeNavigationChanged(bool has_gesture) override;
  void ScrollRectToVisibleInParentFrame(const ::gfx::Rect& rect_to_scroll, ::blink::mojom::blink::ScrollIntoViewParamsPtr params) override;
  void BubbleLogicalScrollInParentFrame(::blink::mojom::blink::ScrollDirection direction, ::ui::ScrollGranularity granularity) override;
  void DidAccessInitialDocument() override;
  void DidBlockNavigation(const ::blink::KURL& blocked_url, const ::blink::KURL& initiator_url, ::blink::mojom::blink::NavigationBlockedReason reason) override;
  void DidChangeLoadProgress(double load_progress) override;
  void DidFinishLoad(const ::blink::KURL& validated_url) override;
  void DispatchLoad() override;
  void GoToEntryAtOffset(int32_t offset, bool has_user_gesture) override;
  void RenderFallbackContentInParentProcess() override;
  void UpdateTitle(const ::WTF::String& title, ::mojo_base::mojom::blink::TextDirection title_direction) override;
  void UpdateUserActivationState(::blink::mojom::blink::UserActivationUpdateType update_type) override;
  void HandleAccessibilityFindInPageResult(FindInPageResultAXParamsPtr params) override;
  void HandleAccessibilityFindInPageTermination() override;
  void DocumentOnLoadCompleted() override;
  void ForwardResourceTimingToParent(::blink::mojom::blink::ResourceTimingInfoPtr timing) override;
  void DidFinishDocumentLoad() override;
  void RunModalAlertDialog(const ::WTF::String& alert_message, RunModalAlertDialogCallback callback) override;
  void RunModalConfirmDialog(const ::WTF::String& alert_message, RunModalConfirmDialogCallback callback) override;
  void RunModalPromptDialog(const ::WTF::String& alert_message, const ::WTF::String& default_value, RunModalPromptDialogCallback callback) override;
  void RunBeforeUnloadConfirm(bool is_reload, RunBeforeUnloadConfirmCallback callback) override;
  void Are3DAPIsBlocked(Are3DAPIsBlockedCallback callback) override;
  void UpdateFaviconURL(WTF::Vector<::blink::mojom::blink::FaviconURLPtr> favicon_urls) override;
  void DownloadURL(DownloadURLParamsPtr params) override;
  void FocusedElementChanged(bool is_editable_element, const ::gfx::Rect& bounds_in_frame_widget) override;
};
class PLATFORM_EXPORT LocalFrameHostAsyncWaiter {
 public:
  explicit LocalFrameHostAsyncWaiter(LocalFrameHost* proxy);
  ~LocalFrameHostAsyncWaiter();
  void EnterFullscreen(
      ::blink::mojom::blink::FullscreenOptionsPtr options, bool* out_granted);
  void RunModalAlertDialog(
      const ::WTF::String& alert_message);
  void RunModalConfirmDialog(
      const ::WTF::String& alert_message, bool* out_success);
  void RunModalPromptDialog(
      const ::WTF::String& alert_message, const ::WTF::String& default_value, bool* out_success, ::WTF::String* out_result);
  void RunBeforeUnloadConfirm(
      bool is_reload, bool* out_success);
  void Are3DAPIsBlocked(
      bool* out_blocked);

 private:
  LocalFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameHostAsyncWaiter);
};


class PLATFORM_EXPORT LocalFrameInterceptorForTesting : public LocalFrame {
  virtual LocalFrame* GetForwardingInterface() = 0;
  void GetTextSurroundingSelection(uint32_t max_length, GetTextSurroundingSelectionCallback callback) override;
  void SendInterventionReport(const WTF::String& id, const WTF::String& message) override;
  void SetFrameOwnerProperties(::blink::mojom::blink::FrameOwnerPropertiesPtr properties) override;
  void NotifyUserActivation() override;
  void AddMessageToConsole(::blink::mojom::blink::ConsoleMessageLevel level, const WTF::String& message, bool discard_duplicates) override;
  void AddInspectorIssue(::blink::mojom::blink::InspectorIssueInfoPtr info) override;
  void CheckCompleted() override;
  void Collapse(bool collapsed) override;
  void EnableViewSourceMode() override;
  void Focus() override;
  void ClearFocusedElement() override;
  void GetResourceSnapshotForWebBundle(mojo::PendingReceiver<::data_decoder::mojom::blink::ResourceSnapshotForWebBundle> receiver) override;
  void CopyImageAt(const ::gfx::Point& window_point) override;
  void SaveImageAt(const ::gfx::Point& window_point) override;
  void ReportBlinkFeatureUsage(const WTF::Vector<::blink::mojom::blink::WebFeature>& features) override;
  void RenderFallbackContent() override;
  void BeforeUnload(bool is_reload, BeforeUnloadCallback callback) override;
  void MediaPlayerActionAt(const ::gfx::Point& location, ::blink::mojom::blink::MediaPlayerActionPtr action) override;
  void AdvanceFocusInForm(::blink::mojom::blink::FocusType focus_type) override;
  void ReportContentSecurityPolicyViolation(::network::mojom::blink::CSPViolationPtr violation) override;
  void DidUpdateFramePolicy(const ::blink::FramePolicy& frame_policy) override;
};
class PLATFORM_EXPORT LocalFrameAsyncWaiter {
 public:
  explicit LocalFrameAsyncWaiter(LocalFrame* proxy);
  ~LocalFrameAsyncWaiter();
  void GetTextSurroundingSelection(
      uint32_t max_length, ::WTF::String* out_content, uint32_t* out_start_offset, uint32_t* out_end_offset);
  void BeforeUnload(
      bool is_reload, bool* out_proceed, ::base::TimeTicks* out_before_unload_start_time, ::base::TimeTicks* out_before_unload_end_time);

 private:
  LocalFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameAsyncWaiter);
};


class PLATFORM_EXPORT RemoteFrameHostInterceptorForTesting : public RemoteFrameHost {
  virtual RemoteFrameHost* GetForwardingInterface() = 0;
  void SetInheritedEffectiveTouchAction(::cc::TouchAction touch_action) override;
  void UpdateRenderThrottlingStatus(bool is_throttled, bool subtree_throttled) override;
  void VisibilityChanged(::blink::mojom::blink::FrameVisibility visibility) override;
  void DidFocusFrame() override;
  void CheckCompleted() override;
  void CapturePaintPreviewOfCrossProcessSubframe(const ::gfx::Rect& clip_rect, const ::base::UnguessableToken& guid) override;
  void SetIsInert(bool inert) override;
};
class PLATFORM_EXPORT RemoteFrameHostAsyncWaiter {
 public:
  explicit RemoteFrameHostAsyncWaiter(RemoteFrameHost* proxy);
  ~RemoteFrameHostAsyncWaiter();

 private:
  RemoteFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameHostAsyncWaiter);
};


class PLATFORM_EXPORT RemoteFrameInterceptorForTesting : public RemoteFrame {
  virtual RemoteFrame* GetForwardingInterface() = 0;
  void WillEnterFullscreen() override;
  void AddReplicatedContentSecurityPolicies(WTF::Vector<::network::mojom::blink::ContentSecurityPolicyHeaderPtr> headers) override;
  void ResetReplicatedContentSecurityPolicy() override;
  void EnforceInsecureNavigationsSet(const WTF::Vector<uint32_t>& set) override;
  void SetFrameOwnerProperties(::blink::mojom::blink::FrameOwnerPropertiesPtr properties) override;
  void EnforceInsecureRequestPolicy(::blink::mojom::blink::InsecureRequestPolicy policy) override;
  void SetReplicatedOrigin(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, bool is_potentially_trustworthy_unique_origin) override;
  void SetReplicatedAdFrameType(::blink::mojom::blink::AdFrameType ad_frame_type) override;
  void DispatchLoadEventForFrameOwner() override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void Collapse(bool collapsed) override;
  void Focus() override;
  void SetHadStickyUserActivationBeforeNavigation(bool has_gesture) override;
  void BubbleLogicalScroll(::blink::mojom::blink::ScrollDirection direction, ::ui::ScrollGranularity granularity) override;
  void UpdateUserActivationState(::blink::mojom::blink::UserActivationUpdateType state_update_type) override;
  void SetEmbeddingToken(const ::base::UnguessableToken& embedding_token) override;
  void SetPageFocus(bool is_focused) override;
  void RenderFallbackContent() override;
  void AddResourceTimingFromChild(::blink::mojom::blink::ResourceTimingInfoPtr timing) override;
  void ScrollRectToVisible(const ::gfx::Rect& rect, ::blink::mojom::blink::ScrollIntoViewParamsPtr params) override;
  void DidStartLoading() override;
  void DidStopLoading() override;
  void IntrinsicSizingInfoOfChildChanged(::blink::mojom::blink::IntrinsicSizingInfoPtr sizing_info) override;
  void DidSetFramePolicyHeaders(::blink::mojom::blink::WebSandboxFlags sandbox_flags, const WTF::Vector<::blink::ParsedFeaturePolicyDeclaration>& parsed_feature_policy) override;
  void DidUpdateFramePolicy(const ::blink::FramePolicy& frame_policy) override;
};
class PLATFORM_EXPORT RemoteFrameAsyncWaiter {
 public:
  explicit RemoteFrameAsyncWaiter(RemoteFrame* proxy);
  ~RemoteFrameAsyncWaiter();

 private:
  RemoteFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameAsyncWaiter);
};


class PLATFORM_EXPORT LocalMainFrameInterceptorForTesting : public LocalMainFrame {
  virtual LocalMainFrame* GetForwardingInterface() = 0;
  void AnimateDoubleTapZoom(const ::gfx::Point& point, const ::gfx::Rect& rect) override;
  void SetScaleFactor(float scale) override;
  void ClosePage(ClosePageCallback callback) override;
  void PluginActionAt(const ::gfx::Point& location, PluginActionType action) override;
  void SetInitialFocus(bool reverse) override;
  void EnablePreferredSizeChangedMode() override;
  void ZoomToFindInPageRect(const ::gfx::Rect& rect_in_root_frame) override;
};
class PLATFORM_EXPORT LocalMainFrameAsyncWaiter {
 public:
  explicit LocalMainFrameAsyncWaiter(LocalMainFrame* proxy);
  ~LocalMainFrameAsyncWaiter();
  void ClosePage(
      );

 private:
  LocalMainFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalMainFrameAsyncWaiter);
};


class PLATFORM_EXPORT LocalMainFrameHostInterceptorForTesting : public LocalMainFrameHost {
  virtual LocalMainFrameHost* GetForwardingInterface() = 0;
  void ScaleFactorChanged(float scale) override;
  void ContentsPreferredSizeChanged(const ::gfx::Size& pref_size) override;
};
class PLATFORM_EXPORT LocalMainFrameHostAsyncWaiter {
 public:
  explicit LocalMainFrameHostAsyncWaiter(LocalMainFrameHost* proxy);
  ~LocalMainFrameHostAsyncWaiter();

 private:
  LocalMainFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalMainFrameHostAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_BLINK_TEST_UTILS_H_