// third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-shared.h"
#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class PreviewsResourceLoadingHintsReceiverProxy;

template <typename ImplRefTraits>
class PreviewsResourceLoadingHintsReceiverStub;

class PreviewsResourceLoadingHintsReceiverRequestValidator;


class BLINK_COMMON_EXPORT PreviewsResourceLoadingHintsReceiver
    : public PreviewsResourceLoadingHintsReceiverInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PreviewsResourceLoadingHintsReceiverInterfaceBase;
  using Proxy_ = PreviewsResourceLoadingHintsReceiverProxy;

  template <typename ImplRefTraits>
  using Stub_ = PreviewsResourceLoadingHintsReceiverStub<ImplRefTraits>;

  using RequestValidator_ = PreviewsResourceLoadingHintsReceiverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetResourceLoadingHintsMinVersion = 0,
    kSetCompressPublicImagesHintsMinVersion = 0,
  };
  virtual ~PreviewsResourceLoadingHintsReceiver() {}

  
  virtual void SetResourceLoadingHints(PreviewsResourceLoadingHintsPtr previews_resource_loading_hints) = 0;

  
  virtual void SetCompressPublicImagesHints(CompressPublicImagesHintsPtr images_hints) = 0;
};



class BLINK_COMMON_EXPORT PreviewsResourceLoadingHintsReceiverProxy
    : public PreviewsResourceLoadingHintsReceiver {
 public:
  using InterfaceType = PreviewsResourceLoadingHintsReceiver;

  explicit PreviewsResourceLoadingHintsReceiverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetResourceLoadingHints(PreviewsResourceLoadingHintsPtr previews_resource_loading_hints) final;
  
  void SetCompressPublicImagesHints(CompressPublicImagesHintsPtr images_hints) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT PreviewsResourceLoadingHintsReceiverStubDispatch {
 public:
  static bool Accept(PreviewsResourceLoadingHintsReceiver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PreviewsResourceLoadingHintsReceiver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PreviewsResourceLoadingHintsReceiver>>
class PreviewsResourceLoadingHintsReceiverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PreviewsResourceLoadingHintsReceiverStub() {}
  ~PreviewsResourceLoadingHintsReceiverStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PreviewsResourceLoadingHintsReceiverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PreviewsResourceLoadingHintsReceiverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PreviewsResourceLoadingHintsReceiverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};









class BLINK_COMMON_EXPORT PreviewsResourceLoadingHints {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PreviewsResourceLoadingHints, T>::value>;
  using DataView = PreviewsResourceLoadingHintsDataView;
  using Data_ = internal::PreviewsResourceLoadingHints_Data;

  template <typename... Args>
  static PreviewsResourceLoadingHintsPtr New(Args&&... args) {
    return PreviewsResourceLoadingHintsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PreviewsResourceLoadingHintsPtr From(const U& u) {
    return mojo::TypeConverter<PreviewsResourceLoadingHintsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PreviewsResourceLoadingHints>::Convert(*this);
  }


  PreviewsResourceLoadingHints();

  PreviewsResourceLoadingHints(
      int64_t ukm_source_id,
      std::vector<std::string> subresources_to_block);

  ~PreviewsResourceLoadingHints();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PreviewsResourceLoadingHintsPtr>
  PreviewsResourceLoadingHintsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PreviewsResourceLoadingHints::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PreviewsResourceLoadingHints::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PreviewsResourceLoadingHints_UnserializedMessageContext<
            UserType, PreviewsResourceLoadingHints::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PreviewsResourceLoadingHints::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PreviewsResourceLoadingHints::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PreviewsResourceLoadingHints_UnserializedMessageContext<
            UserType, PreviewsResourceLoadingHints::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PreviewsResourceLoadingHints::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int64_t ukm_source_id;
  
  std::vector<std::string> subresources_to_block;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT CompressPublicImagesHints {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CompressPublicImagesHints, T>::value>;
  using DataView = CompressPublicImagesHintsDataView;
  using Data_ = internal::CompressPublicImagesHints_Data;

  template <typename... Args>
  static CompressPublicImagesHintsPtr New(Args&&... args) {
    return CompressPublicImagesHintsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CompressPublicImagesHintsPtr From(const U& u) {
    return mojo::TypeConverter<CompressPublicImagesHintsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CompressPublicImagesHints>::Convert(*this);
  }


  CompressPublicImagesHints();

  explicit CompressPublicImagesHints(
      std::vector<std::string> image_urls);

  ~CompressPublicImagesHints();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CompressPublicImagesHintsPtr>
  CompressPublicImagesHintsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CompressPublicImagesHints::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CompressPublicImagesHints::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CompressPublicImagesHints::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CompressPublicImagesHints_UnserializedMessageContext<
            UserType, CompressPublicImagesHints::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CompressPublicImagesHints::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CompressPublicImagesHints::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CompressPublicImagesHints_UnserializedMessageContext<
            UserType, CompressPublicImagesHints::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CompressPublicImagesHints::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<std::string> image_urls;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CompressPublicImagesHints::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CompressPublicImagesHints::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CompressPublicImagesHints::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CompressPublicImagesHints::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PreviewsResourceLoadingHintsPtr PreviewsResourceLoadingHints::Clone() const {
  return New(
      mojo::Clone(ukm_source_id),
      mojo::Clone(subresources_to_block)
  );
}

template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>*>
bool PreviewsResourceLoadingHints::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->ukm_source_id, other_struct.ukm_source_id))
    return false;
  if (!mojo::Equals(this->subresources_to_block, other_struct.subresources_to_block))
    return false;
  return true;
}

template <typename T, PreviewsResourceLoadingHints::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.ukm_source_id < rhs.ukm_source_id)
    return true;
  if (rhs.ukm_source_id < lhs.ukm_source_id)
    return false;
  if (lhs.subresources_to_block < rhs.subresources_to_block)
    return true;
  if (rhs.subresources_to_block < lhs.subresources_to_block)
    return false;
  return false;
}
template <typename StructPtrType>
CompressPublicImagesHintsPtr CompressPublicImagesHints::Clone() const {
  return New(
      mojo::Clone(image_urls)
  );
}

template <typename T, CompressPublicImagesHints::EnableIfSame<T>*>
bool CompressPublicImagesHints::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->image_urls, other_struct.image_urls))
    return false;
  return true;
}

template <typename T, CompressPublicImagesHints::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.image_urls < rhs.image_urls)
    return true;
  if (rhs.image_urls < lhs.image_urls)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::PreviewsResourceLoadingHints::DataView,
                                         ::blink::mojom::PreviewsResourceLoadingHintsPtr> {
  static bool IsNull(const ::blink::mojom::PreviewsResourceLoadingHintsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::PreviewsResourceLoadingHintsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::PreviewsResourceLoadingHints::ukm_source_id) ukm_source_id(
      const ::blink::mojom::PreviewsResourceLoadingHintsPtr& input) {
    return input->ukm_source_id;
  }

  static const decltype(::blink::mojom::PreviewsResourceLoadingHints::subresources_to_block)& subresources_to_block(
      const ::blink::mojom::PreviewsResourceLoadingHintsPtr& input) {
    return input->subresources_to_block;
  }

  static bool Read(::blink::mojom::PreviewsResourceLoadingHints::DataView input, ::blink::mojom::PreviewsResourceLoadingHintsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::CompressPublicImagesHints::DataView,
                                         ::blink::mojom::CompressPublicImagesHintsPtr> {
  static bool IsNull(const ::blink::mojom::CompressPublicImagesHintsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::CompressPublicImagesHintsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::CompressPublicImagesHints::image_urls)& image_urls(
      const ::blink::mojom::CompressPublicImagesHintsPtr& input) {
    return input->image_urls;
  }

  static bool Read(::blink::mojom::CompressPublicImagesHints::DataView input, ::blink::mojom::CompressPublicImagesHintsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_H_