// third_party/blink/public/mojom/native_file_system/native_file_system_error.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_ERROR_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_ERROR_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/native_file_system/native_file_system_error.mojom-shared.h"
#include "third_party/blink/public/mojom/native_file_system/native_file_system_error.mojom-blink-forward.h"
#include "mojo/public/mojom/base/file_error.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/renderer/platform/platform_export.h"




namespace WTF {
struct blink_mojom_internal_NativeFileSystemStatus_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::NativeFileSystemStatus& value) {
    using utype = std::underlying_type<::blink::mojom::NativeFileSystemStatus>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::NativeFileSystemStatus& left, const ::blink::mojom::NativeFileSystemStatus& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::blink::mojom::NativeFileSystemStatus>
    : public GenericHashTraits<::blink::mojom::NativeFileSystemStatus> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::NativeFileSystemStatus& value) {
    return value == static_cast<::blink::mojom::NativeFileSystemStatus>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::NativeFileSystemStatus& slot, bool) {
    slot = static_cast<::blink::mojom::NativeFileSystemStatus>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::NativeFileSystemStatus& value) {
    return value == static_cast<::blink::mojom::NativeFileSystemStatus>(-1000001);
  }
};
}  // namespace WTF


namespace blink {
namespace mojom {
namespace blink {





class PLATFORM_EXPORT NativeFileSystemError {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NativeFileSystemError, T>::value>;
  using DataView = NativeFileSystemErrorDataView;
  using Data_ = internal::NativeFileSystemError_Data;

  template <typename... Args>
  static NativeFileSystemErrorPtr New(Args&&... args) {
    return NativeFileSystemErrorPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NativeFileSystemErrorPtr From(const U& u) {
    return mojo::TypeConverter<NativeFileSystemErrorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NativeFileSystemError>::Convert(*this);
  }


  NativeFileSystemError();

  NativeFileSystemError(
      NativeFileSystemStatus status,
      ::base::File::Error file_error,
      const WTF::String& message);

  ~NativeFileSystemError();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NativeFileSystemErrorPtr>
  NativeFileSystemErrorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NativeFileSystemError::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        NativeFileSystemError::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NativeFileSystemError::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NativeFileSystemError_UnserializedMessageContext<
            UserType, NativeFileSystemError::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<NativeFileSystemError::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return NativeFileSystemError::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NativeFileSystemError_UnserializedMessageContext<
            UserType, NativeFileSystemError::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NativeFileSystemError::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  NativeFileSystemStatus status;
  
  ::base::File::Error file_error;
  
  WTF::String message;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NativeFileSystemError::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NativeFileSystemError::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NativeFileSystemError::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NativeFileSystemError::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
NativeFileSystemErrorPtr NativeFileSystemError::Clone() const {
  return New(
      mojo::Clone(status),
      mojo::Clone(file_error),
      mojo::Clone(message)
  );
}

template <typename T, NativeFileSystemError::EnableIfSame<T>*>
bool NativeFileSystemError::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  if (!mojo::Equals(this->file_error, other_struct.file_error))
    return false;
  if (!mojo::Equals(this->message, other_struct.message))
    return false;
  return true;
}

template <typename T, NativeFileSystemError::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.status < rhs.status)
    return true;
  if (rhs.status < lhs.status)
    return false;
  if (lhs.file_error < rhs.file_error)
    return true;
  if (rhs.file_error < lhs.file_error)
    return false;
  if (lhs.message < rhs.message)
    return true;
  if (rhs.message < lhs.message)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::NativeFileSystemError::DataView,
                                         ::blink::mojom::blink::NativeFileSystemErrorPtr> {
  static bool IsNull(const ::blink::mojom::blink::NativeFileSystemErrorPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::NativeFileSystemErrorPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::NativeFileSystemError::status) status(
      const ::blink::mojom::blink::NativeFileSystemErrorPtr& input) {
    return input->status;
  }

  static decltype(::blink::mojom::blink::NativeFileSystemError::file_error) file_error(
      const ::blink::mojom::blink::NativeFileSystemErrorPtr& input) {
    return input->file_error;
  }

  static const decltype(::blink::mojom::blink::NativeFileSystemError::message)& message(
      const ::blink::mojom::blink::NativeFileSystemErrorPtr& input) {
    return input->message;
  }

  static bool Read(::blink::mojom::blink::NativeFileSystemError::DataView input, ::blink::mojom::blink::NativeFileSystemErrorPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_ERROR_MOJOM_BLINK_H_