// third_party/blink/public/mojom/native_file_system/native_file_system_file_writer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_FILE_WRITER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_FILE_WRITER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/native_file_system/native_file_system_file_writer.mojom-shared.h"
#include "third_party/blink/public/mojom/native_file_system/native_file_system_file_writer.mojom-forward.h"
#include "third_party/blink/public/mojom/blob/blob.mojom-forward.h"
#include "third_party/blink/public/mojom/native_file_system/native_file_system_error.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class NativeFileSystemFileWriterProxy;

template <typename ImplRefTraits>
class NativeFileSystemFileWriterStub;

class NativeFileSystemFileWriterRequestValidator;
class NativeFileSystemFileWriterResponseValidator;


class BLINK_COMMON_EXPORT NativeFileSystemFileWriter
    : public NativeFileSystemFileWriterInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = NativeFileSystemFileWriterInterfaceBase;
  using Proxy_ = NativeFileSystemFileWriterProxy;

  template <typename ImplRefTraits>
  using Stub_ = NativeFileSystemFileWriterStub<ImplRefTraits>;

  using RequestValidator_ = NativeFileSystemFileWriterRequestValidator;
  using ResponseValidator_ = NativeFileSystemFileWriterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kWriteMinVersion = 0,
    kWriteStreamMinVersion = 0,
    kTruncateMinVersion = 0,
    kCloseMinVersion = 0,
  };
  virtual ~NativeFileSystemFileWriter() {}


  using WriteCallback = base::OnceCallback<void(::blink::mojom::NativeFileSystemErrorPtr, uint64_t)>;
  
  virtual void Write(uint64_t offset, mojo::PendingRemote<::blink::mojom::Blob> data, WriteCallback callback) = 0;


  using WriteStreamCallback = base::OnceCallback<void(::blink::mojom::NativeFileSystemErrorPtr, uint64_t)>;
  
  virtual void WriteStream(uint64_t offset, mojo::ScopedDataPipeConsumerHandle stream, WriteStreamCallback callback) = 0;


  using TruncateCallback = base::OnceCallback<void(::blink::mojom::NativeFileSystemErrorPtr)>;
  
  virtual void Truncate(uint64_t length, TruncateCallback callback) = 0;


  using CloseCallback = base::OnceCallback<void(::blink::mojom::NativeFileSystemErrorPtr)>;
  
  virtual void Close(CloseCallback callback) = 0;
};



class BLINK_COMMON_EXPORT NativeFileSystemFileWriterProxy
    : public NativeFileSystemFileWriter {
 public:
  using InterfaceType = NativeFileSystemFileWriter;

  explicit NativeFileSystemFileWriterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Write(uint64_t offset, mojo::PendingRemote<::blink::mojom::Blob> data, WriteCallback callback) final;
  
  void WriteStream(uint64_t offset, mojo::ScopedDataPipeConsumerHandle stream, WriteStreamCallback callback) final;
  
  void Truncate(uint64_t length, TruncateCallback callback) final;
  
  void Close(CloseCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT NativeFileSystemFileWriterStubDispatch {
 public:
  static bool Accept(NativeFileSystemFileWriter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NativeFileSystemFileWriter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NativeFileSystemFileWriter>>
class NativeFileSystemFileWriterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NativeFileSystemFileWriterStub() {}
  ~NativeFileSystemFileWriterStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeFileSystemFileWriterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeFileSystemFileWriterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT NativeFileSystemFileWriterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT NativeFileSystemFileWriterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_FILE_SYSTEM_NATIVE_FILE_SYSTEM_FILE_WRITER_MOJOM_H_