// third_party/blink/public/mojom/picture_in_picture/picture_in_picture.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PICTURE_IN_PICTURE_PICTURE_IN_PICTURE_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PICTURE_IN_PICTURE_PICTURE_IN_PICTURE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/picture_in_picture/picture_in_picture.mojom-shared.h"
#include "third_party/blink/public/mojom/picture_in_picture/picture_in_picture.mojom-blink-forward.h"
#include "services/viz/public/mojom/compositing/surface_id.mojom-blink-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink {
namespace mojom {
namespace blink {

class PictureInPictureSessionObserverProxy;

template <typename ImplRefTraits>
class PictureInPictureSessionObserverStub;

class PictureInPictureSessionObserverRequestValidator;


class PLATFORM_EXPORT PictureInPictureSessionObserver
    : public PictureInPictureSessionObserverInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PictureInPictureSessionObserverInterfaceBase;
  using Proxy_ = PictureInPictureSessionObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = PictureInPictureSessionObserverStub<ImplRefTraits>;

  using RequestValidator_ = PictureInPictureSessionObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnWindowSizeChangedMinVersion = 0,
    kOnStoppedMinVersion = 0,
  };
  virtual ~PictureInPictureSessionObserver() {}

  
  virtual void OnWindowSizeChanged(const ::gfx::Size& size) = 0;

  
  virtual void OnStopped() = 0;
};

class PictureInPictureSessionProxy;

template <typename ImplRefTraits>
class PictureInPictureSessionStub;

class PictureInPictureSessionRequestValidator;
class PictureInPictureSessionResponseValidator;


class PLATFORM_EXPORT PictureInPictureSession
    : public PictureInPictureSessionInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PictureInPictureSessionInterfaceBase;
  using Proxy_ = PictureInPictureSessionProxy;

  template <typename ImplRefTraits>
  using Stub_ = PictureInPictureSessionStub<ImplRefTraits>;

  using RequestValidator_ = PictureInPictureSessionRequestValidator;
  using ResponseValidator_ = PictureInPictureSessionResponseValidator;
  enum MethodMinVersions : uint32_t {
    kUpdateMinVersion = 0,
    kStopMinVersion = 0,
  };
  virtual ~PictureInPictureSession() {}

  
  virtual void Update(uint32_t player_id, const base::Optional<::viz::SurfaceId>& surface_id, const ::gfx::Size& natural_size, bool show_play_pause_button) = 0;


  using StopCallback = base::OnceCallback<void()>;
  
  virtual void Stop(StopCallback callback) = 0;
};

class PictureInPictureServiceProxy;

template <typename ImplRefTraits>
class PictureInPictureServiceStub;

class PictureInPictureServiceRequestValidator;
class PictureInPictureServiceResponseValidator;


class PLATFORM_EXPORT PictureInPictureService
    : public PictureInPictureServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PictureInPictureServiceInterfaceBase;
  using Proxy_ = PictureInPictureServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = PictureInPictureServiceStub<ImplRefTraits>;

  using RequestValidator_ = PictureInPictureServiceRequestValidator;
  using ResponseValidator_ = PictureInPictureServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kStartSessionMinVersion = 0,
  };
  virtual ~PictureInPictureService() {}


  using StartSessionCallback = base::OnceCallback<void(mojo::PendingRemote<PictureInPictureSession>, const ::gfx::Size&)>;
  
  virtual void StartSession(uint32_t player_id, const base::Optional<::viz::SurfaceId>& surface_id, const ::gfx::Size& natural_size, bool show_play_pause_button, mojo::PendingRemote<PictureInPictureSessionObserver> observer, StartSessionCallback callback) = 0;
};



class PLATFORM_EXPORT PictureInPictureSessionObserverProxy
    : public PictureInPictureSessionObserver {
 public:
  using InterfaceType = PictureInPictureSessionObserver;

  explicit PictureInPictureSessionObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnWindowSizeChanged(const ::gfx::Size& size) final;
  
  void OnStopped() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT PictureInPictureSessionProxy
    : public PictureInPictureSession {
 public:
  using InterfaceType = PictureInPictureSession;

  explicit PictureInPictureSessionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Update(uint32_t player_id, const base::Optional<::viz::SurfaceId>& surface_id, const ::gfx::Size& natural_size, bool show_play_pause_button) final;
  
  void Stop(StopCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT PictureInPictureServiceProxy
    : public PictureInPictureService {
 public:
  using InterfaceType = PictureInPictureService;

  explicit PictureInPictureServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void StartSession(uint32_t player_id, const base::Optional<::viz::SurfaceId>& surface_id, const ::gfx::Size& natural_size, bool show_play_pause_button, mojo::PendingRemote<PictureInPictureSessionObserver> observer, StartSessionCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT PictureInPictureSessionObserverStubDispatch {
 public:
  static bool Accept(PictureInPictureSessionObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PictureInPictureSessionObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PictureInPictureSessionObserver>>
class PictureInPictureSessionObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PictureInPictureSessionObserverStub() {}
  ~PictureInPictureSessionObserverStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureSessionObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureSessionObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT PictureInPictureSessionStubDispatch {
 public:
  static bool Accept(PictureInPictureSession* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PictureInPictureSession* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PictureInPictureSession>>
class PictureInPictureSessionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PictureInPictureSessionStub() {}
  ~PictureInPictureSessionStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureSessionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureSessionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT PictureInPictureServiceStubDispatch {
 public:
  static bool Accept(PictureInPictureService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PictureInPictureService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PictureInPictureService>>
class PictureInPictureServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PictureInPictureServiceStub() {}
  ~PictureInPictureServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PictureInPictureServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT PictureInPictureSessionObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT PictureInPictureSessionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT PictureInPictureServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT PictureInPictureSessionResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT PictureInPictureServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PICTURE_IN_PICTURE_PICTURE_IN_PICTURE_MOJOM_BLINK_H_