// third_party/blink/public/mojom/prerender/prerender.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/prerender/prerender.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/prerender/prerender.mojom-params-data.h"
#include "third_party/blink/public/mojom/prerender/prerender.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/prerender/prerender.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRERENDER_PRERENDER_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRERENDER_PRERENDER_MOJOM_JUMBO_H_
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#endif
namespace blink {
namespace mojom {
PrerenderAttributes::PrerenderAttributes()
    : url(),
      rel_types(),
      referrer(),
      initiator_origin(),
      view_size() {}

PrerenderAttributes::PrerenderAttributes(
    const ::GURL& url_in,
    uint32_t rel_types_in,
    ::blink::mojom::ReferrerPtr referrer_in,
    const ::url::Origin& initiator_origin_in,
    const ::gfx::Size& view_size_in)
    : url(std::move(url_in)),
      rel_types(std::move(rel_types_in)),
      referrer(std::move(referrer_in)),
      initiator_origin(std::move(initiator_origin_in)),
      view_size(std::move(view_size_in)) {}

PrerenderAttributes::~PrerenderAttributes() = default;

bool PrerenderAttributes::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char PrerenderHandleClient::Name_[] = "blink.mojom.PrerenderHandleClient";

PrerenderHandleClientProxy::PrerenderHandleClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PrerenderHandleClientProxy::OnPrerenderStart(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandleClient::OnPrerenderStart");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandleClient_OnPrerenderStart_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandleClient_OnPrerenderStart_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandleClient::Name_);
  message.set_method_name("OnPrerenderStart");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PrerenderHandleClientProxy::OnPrerenderStopLoading(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandleClient::OnPrerenderStopLoading");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandleClient_OnPrerenderStopLoading_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandleClient_OnPrerenderStopLoading_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandleClient::Name_);
  message.set_method_name("OnPrerenderStopLoading");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PrerenderHandleClientProxy::OnPrerenderDomContentLoaded(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandleClient::OnPrerenderDomContentLoaded");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandleClient_OnPrerenderDomContentLoaded_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandleClient_OnPrerenderDomContentLoaded_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandleClient::Name_);
  message.set_method_name("OnPrerenderDomContentLoaded");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PrerenderHandleClientProxy::OnPrerenderStop(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandleClient::OnPrerenderStop");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandleClient_OnPrerenderStop_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandleClient_OnPrerenderStop_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandleClient::Name_);
  message.set_method_name("OnPrerenderStop");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PrerenderHandleClientStubDispatch::Accept(
    PrerenderHandleClient* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPrerenderHandleClient_OnPrerenderStart_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStart",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStart");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandleClient_OnPrerenderStart_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandleClient_OnPrerenderStart_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandleClient_OnPrerenderStart_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandleClient::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnPrerenderStart();
      return true;
    }
    case internal::kPrerenderHandleClient_OnPrerenderStopLoading_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStopLoading",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStopLoading");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandleClient_OnPrerenderStopLoading_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandleClient_OnPrerenderStopLoading_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandleClient_OnPrerenderStopLoading_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandleClient::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnPrerenderStopLoading();
      return true;
    }
    case internal::kPrerenderHandleClient_OnPrerenderDomContentLoaded_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderDomContentLoaded",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderDomContentLoaded");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandleClient_OnPrerenderDomContentLoaded_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandleClient_OnPrerenderDomContentLoaded_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandleClient_OnPrerenderDomContentLoaded_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandleClient::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnPrerenderDomContentLoaded();
      return true;
    }
    case internal::kPrerenderHandleClient_OnPrerenderStop_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStop",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandleClient::OnPrerenderStop");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandleClient_OnPrerenderStop_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandleClient_OnPrerenderStop_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandleClient_OnPrerenderStop_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandleClient::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnPrerenderStop();
      return true;
    }
  }
  return false;
}

// static
bool PrerenderHandleClientStubDispatch::AcceptWithResponder(
    PrerenderHandleClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPrerenderHandleClient_OnPrerenderStart_Name: {
      break;
    }
    case internal::kPrerenderHandleClient_OnPrerenderStopLoading_Name: {
      break;
    }
    case internal::kPrerenderHandleClient_OnPrerenderDomContentLoaded_Name: {
      break;
    }
    case internal::kPrerenderHandleClient_OnPrerenderStop_Name: {
      break;
    }
  }
  return false;
}


static const mojo::internal::GenericValidationInfo kPrerenderHandleClientValidationInfo[] = {
    {&internal::PrerenderHandleClient_OnPrerenderStart_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PrerenderHandleClient_OnPrerenderStopLoading_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PrerenderHandleClient_OnPrerenderDomContentLoaded_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PrerenderHandleClient_OnPrerenderStop_Params_Data::Validate,
     nullptr /* no response */},
};

bool PrerenderHandleClientRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::blink::mojom::PrerenderHandleClient::Name_;
  return mojo::internal::ValidateRequestGenericPacked(message, name, kPrerenderHandleClientValidationInfo);
}

const char PrerenderHandle::Name_[] = "blink.mojom.PrerenderHandle";

PrerenderHandleProxy::PrerenderHandleProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PrerenderHandleProxy::Cancel(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandle::Cancel");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandle_Cancel_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandle_Cancel_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandle::Name_);
  message.set_method_name("Cancel");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PrerenderHandleProxy::Abandon(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderHandle::Abandon");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderHandle_Abandon_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderHandle_Abandon_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderHandle::Name_);
  message.set_method_name("Abandon");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PrerenderHandleStubDispatch::Accept(
    PrerenderHandle* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPrerenderHandle_Cancel_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandle::Cancel",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandle::Cancel");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandle_Cancel_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandle_Cancel_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandle_Cancel_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandle::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Cancel();
      return true;
    }
    case internal::kPrerenderHandle_Abandon_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderHandle::Abandon",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderHandle::Abandon");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderHandle_Abandon_Params_Data* params =
          reinterpret_cast<internal::PrerenderHandle_Abandon_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderHandle_Abandon_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderHandle::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Abandon();
      return true;
    }
  }
  return false;
}

// static
bool PrerenderHandleStubDispatch::AcceptWithResponder(
    PrerenderHandle* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPrerenderHandle_Cancel_Name: {
      break;
    }
    case internal::kPrerenderHandle_Abandon_Name: {
      break;
    }
  }
  return false;
}


static const mojo::internal::GenericValidationInfo kPrerenderHandleValidationInfo[] = {
    {&internal::PrerenderHandle_Cancel_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PrerenderHandle_Abandon_Params_Data::Validate,
     nullptr /* no response */},
};

bool PrerenderHandleRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::blink::mojom::PrerenderHandle::Name_;
  return mojo::internal::ValidateRequestGenericPacked(message, name, kPrerenderHandleValidationInfo);
}

const char PrerenderProcessor::Name_[] = "blink.mojom.PrerenderProcessor";

PrerenderProcessorProxy::PrerenderProcessorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PrerenderProcessorProxy::AddPrerender(
    PrerenderAttributesPtr in_prerender_attribute, mojo::PendingRemote<PrerenderHandleClient> in_prerender_handle_client, mojo::PendingReceiver<PrerenderHandle> in_prerender_handle) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PrerenderProcessor::AddPrerender");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPrerenderProcessor_AddPrerender_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PrerenderProcessor_AddPrerender_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->prerender_attribute)::BaseType::BufferWriter
      prerender_attribute_writer;
  mojo::internal::Serialize<::blink::mojom::PrerenderAttributesDataView>(
      in_prerender_attribute, buffer, &prerender_attribute_writer, &serialization_context);
  params->prerender_attribute.Set(
      prerender_attribute_writer.is_null() ? nullptr : prerender_attribute_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->prerender_attribute.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null prerender_attribute in PrerenderProcessor.AddPrerender request");
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::PrerenderHandleClientInterfaceBase>>(
      in_prerender_handle_client, &params->prerender_handle_client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->prerender_handle_client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid prerender_handle_client in PrerenderProcessor.AddPrerender request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::blink::mojom::PrerenderHandleInterfaceBase>>(
      in_prerender_handle, &params->prerender_handle, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->prerender_handle),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid prerender_handle in PrerenderProcessor.AddPrerender request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PrerenderProcessor::Name_);
  message.set_method_name("AddPrerender");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PrerenderProcessorStubDispatch::Accept(
    PrerenderProcessor* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPrerenderProcessor_AddPrerender_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PrerenderProcessor::AddPrerender",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PrerenderProcessor::AddPrerender");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PrerenderProcessor_AddPrerender_Params_Data* params =
          reinterpret_cast<internal::PrerenderProcessor_AddPrerender_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PrerenderAttributesPtr p_prerender_attribute{};
      mojo::PendingRemote<PrerenderHandleClient> p_prerender_handle_client{};
      mojo::PendingReceiver<PrerenderHandle> p_prerender_handle{};
      PrerenderProcessor_AddPrerender_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadPrerenderAttribute(&p_prerender_attribute))
        success = false;
      if (success) {
        p_prerender_handle_client =
            input_data_view.TakePrerenderHandleClient<decltype(p_prerender_handle_client)>();
      }
      if (success) {
        p_prerender_handle =
            input_data_view.TakePrerenderHandle<decltype(p_prerender_handle)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PrerenderProcessor::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->AddPrerender(
std::move(p_prerender_attribute), 
std::move(p_prerender_handle_client), 
std::move(p_prerender_handle));
      return true;
    }
  }
  return false;
}

// static
bool PrerenderProcessorStubDispatch::AcceptWithResponder(
    PrerenderProcessor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPrerenderProcessor_AddPrerender_Name: {
      break;
    }
  }
  return false;
}


static const mojo::internal::GenericValidationInfo kPrerenderProcessorValidationInfo[] = {
    {&internal::PrerenderProcessor_AddPrerender_Params_Data::Validate,
     nullptr /* no response */},
};

bool PrerenderProcessorRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::blink::mojom::PrerenderProcessor::Name_;
  return mojo::internal::ValidateRequestGenericPacked(message, name, kPrerenderProcessorValidationInfo);
}

}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::PrerenderAttributes::DataView, ::blink::mojom::PrerenderAttributesPtr>::Read(
    ::blink::mojom::PrerenderAttributes::DataView input,
    ::blink::mojom::PrerenderAttributesPtr* output) {
  bool success = true;
  ::blink::mojom::PrerenderAttributesPtr result(::blink::mojom::PrerenderAttributes::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success)
        result->rel_types = input.rel_types();
      if (success && !input.ReadReferrer(&result->referrer))
        success = false;
      if (success && !input.ReadInitiatorOrigin(&result->initiator_origin))
        success = false;
      if (success && !input.ReadViewSize(&result->view_size))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif