// third_party/blink/public/mojom/prerender/prerender.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRERENDER_PRERENDER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRERENDER_PRERENDER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/prerender/prerender.mojom-shared.h"
#include "third_party/blink/public/mojom/prerender/prerender.mojom-forward.h"
#include "third_party/blink/public/mojom/referrer.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class PrerenderHandleClientProxy;

template <typename ImplRefTraits>
class PrerenderHandleClientStub;

class PrerenderHandleClientRequestValidator;


class BLINK_COMMON_EXPORT PrerenderHandleClient
    : public PrerenderHandleClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PrerenderHandleClientInterfaceBase;
  using Proxy_ = PrerenderHandleClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = PrerenderHandleClientStub<ImplRefTraits>;

  using RequestValidator_ = PrerenderHandleClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnPrerenderStartMinVersion = 0,
    kOnPrerenderStopLoadingMinVersion = 0,
    kOnPrerenderDomContentLoadedMinVersion = 0,
    kOnPrerenderStopMinVersion = 0,
  };
  virtual ~PrerenderHandleClient() {}

  
  virtual void OnPrerenderStart() = 0;

  
  virtual void OnPrerenderStopLoading() = 0;

  
  virtual void OnPrerenderDomContentLoaded() = 0;

  
  virtual void OnPrerenderStop() = 0;
};

class PrerenderHandleProxy;

template <typename ImplRefTraits>
class PrerenderHandleStub;

class PrerenderHandleRequestValidator;


class BLINK_COMMON_EXPORT PrerenderHandle
    : public PrerenderHandleInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PrerenderHandleInterfaceBase;
  using Proxy_ = PrerenderHandleProxy;

  template <typename ImplRefTraits>
  using Stub_ = PrerenderHandleStub<ImplRefTraits>;

  using RequestValidator_ = PrerenderHandleRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCancelMinVersion = 0,
    kAbandonMinVersion = 0,
  };
  virtual ~PrerenderHandle() {}

  
  virtual void Cancel() = 0;

  
  virtual void Abandon() = 0;
};

class PrerenderProcessorProxy;

template <typename ImplRefTraits>
class PrerenderProcessorStub;

class PrerenderProcessorRequestValidator;


class BLINK_COMMON_EXPORT PrerenderProcessor
    : public PrerenderProcessorInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PrerenderProcessorInterfaceBase;
  using Proxy_ = PrerenderProcessorProxy;

  template <typename ImplRefTraits>
  using Stub_ = PrerenderProcessorStub<ImplRefTraits>;

  using RequestValidator_ = PrerenderProcessorRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAddPrerenderMinVersion = 0,
  };
  virtual ~PrerenderProcessor() {}

  
  virtual void AddPrerender(PrerenderAttributesPtr prerender_attribute, mojo::PendingRemote<PrerenderHandleClient> prerender_handle_client, mojo::PendingReceiver<PrerenderHandle> prerender_handle) = 0;
};



class BLINK_COMMON_EXPORT PrerenderHandleClientProxy
    : public PrerenderHandleClient {
 public:
  using InterfaceType = PrerenderHandleClient;

  explicit PrerenderHandleClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnPrerenderStart() final;
  
  void OnPrerenderStopLoading() final;
  
  void OnPrerenderDomContentLoaded() final;
  
  void OnPrerenderStop() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT PrerenderHandleProxy
    : public PrerenderHandle {
 public:
  using InterfaceType = PrerenderHandle;

  explicit PrerenderHandleProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Cancel() final;
  
  void Abandon() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT PrerenderProcessorProxy
    : public PrerenderProcessor {
 public:
  using InterfaceType = PrerenderProcessor;

  explicit PrerenderProcessorProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddPrerender(PrerenderAttributesPtr prerender_attribute, mojo::PendingRemote<PrerenderHandleClient> prerender_handle_client, mojo::PendingReceiver<PrerenderHandle> prerender_handle) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT PrerenderHandleClientStubDispatch {
 public:
  static bool Accept(PrerenderHandleClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PrerenderHandleClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PrerenderHandleClient>>
class PrerenderHandleClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PrerenderHandleClientStub() {}
  ~PrerenderHandleClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderHandleClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderHandleClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PrerenderHandleStubDispatch {
 public:
  static bool Accept(PrerenderHandle* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PrerenderHandle* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PrerenderHandle>>
class PrerenderHandleStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PrerenderHandleStub() {}
  ~PrerenderHandleStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderHandleStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderHandleStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PrerenderProcessorStubDispatch {
 public:
  static bool Accept(PrerenderProcessor* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PrerenderProcessor* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PrerenderProcessor>>
class PrerenderProcessorStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PrerenderProcessorStub() {}
  ~PrerenderProcessorStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderProcessorStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PrerenderProcessorStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PrerenderHandleClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT PrerenderHandleRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT PrerenderProcessorRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT PrerenderAttributes {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PrerenderAttributes, T>::value>;
  using DataView = PrerenderAttributesDataView;
  using Data_ = internal::PrerenderAttributes_Data;

  template <typename... Args>
  static PrerenderAttributesPtr New(Args&&... args) {
    return PrerenderAttributesPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PrerenderAttributesPtr From(const U& u) {
    return mojo::TypeConverter<PrerenderAttributesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PrerenderAttributes>::Convert(*this);
  }


  PrerenderAttributes();

  PrerenderAttributes(
      const ::GURL& url,
      uint32_t rel_types,
      ::blink::mojom::ReferrerPtr referrer,
      const ::url::Origin& initiator_origin,
      const ::gfx::Size& view_size);

  ~PrerenderAttributes();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PrerenderAttributesPtr>
  PrerenderAttributesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PrerenderAttributes::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PrerenderAttributes::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PrerenderAttributes::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PrerenderAttributes_UnserializedMessageContext<
            UserType, PrerenderAttributes::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PrerenderAttributes::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PrerenderAttributes::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PrerenderAttributes_UnserializedMessageContext<
            UserType, PrerenderAttributes::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PrerenderAttributes::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::GURL url;
  
  uint32_t rel_types;
  
  ::blink::mojom::ReferrerPtr referrer;
  
  ::url::Origin initiator_origin;
  
  ::gfx::Size view_size;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PrerenderAttributes);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PrerenderAttributes::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PrerenderAttributes::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PrerenderAttributes::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PrerenderAttributes::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PrerenderAttributesPtr PrerenderAttributes::Clone() const {
  return New(
      mojo::Clone(url),
      mojo::Clone(rel_types),
      mojo::Clone(referrer),
      mojo::Clone(initiator_origin),
      mojo::Clone(view_size)
  );
}

template <typename T, PrerenderAttributes::EnableIfSame<T>*>
bool PrerenderAttributes::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->rel_types, other_struct.rel_types))
    return false;
  if (!mojo::Equals(this->referrer, other_struct.referrer))
    return false;
  if (!mojo::Equals(this->initiator_origin, other_struct.initiator_origin))
    return false;
  if (!mojo::Equals(this->view_size, other_struct.view_size))
    return false;
  return true;
}

template <typename T, PrerenderAttributes::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.rel_types < rhs.rel_types)
    return true;
  if (rhs.rel_types < lhs.rel_types)
    return false;
  if (lhs.referrer < rhs.referrer)
    return true;
  if (rhs.referrer < lhs.referrer)
    return false;
  if (lhs.initiator_origin < rhs.initiator_origin)
    return true;
  if (rhs.initiator_origin < lhs.initiator_origin)
    return false;
  if (lhs.view_size < rhs.view_size)
    return true;
  if (rhs.view_size < lhs.view_size)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::PrerenderAttributes::DataView,
                                         ::blink::mojom::PrerenderAttributesPtr> {
  static bool IsNull(const ::blink::mojom::PrerenderAttributesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::PrerenderAttributesPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::PrerenderAttributes::url)& url(
      const ::blink::mojom::PrerenderAttributesPtr& input) {
    return input->url;
  }

  static decltype(::blink::mojom::PrerenderAttributes::rel_types) rel_types(
      const ::blink::mojom::PrerenderAttributesPtr& input) {
    return input->rel_types;
  }

  static const decltype(::blink::mojom::PrerenderAttributes::referrer)& referrer(
      const ::blink::mojom::PrerenderAttributesPtr& input) {
    return input->referrer;
  }

  static const decltype(::blink::mojom::PrerenderAttributes::initiator_origin)& initiator_origin(
      const ::blink::mojom::PrerenderAttributesPtr& input) {
    return input->initiator_origin;
  }

  static const decltype(::blink::mojom::PrerenderAttributes::view_size)& view_size(
      const ::blink::mojom::PrerenderAttributesPtr& input) {
    return input->view_size;
  }

  static bool Read(::blink::mojom::PrerenderAttributes::DataView input, ::blink::mojom::PrerenderAttributesPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRERENDER_PRERENDER_MOJOM_H_