// ui/display/mojom/display_mode.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_DISPLAY_MOJOM_DISPLAY_MODE_MOJOM_H_
#define UI_DISPLAY_MOJOM_DISPLAY_MODE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/display/mojom/display_mode.mojom-shared.h"
#include "ui/display/mojom/display_mode.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>




#include "ui/display/types/display_mode.h"




namespace display {
namespace mojom {








class  DisplayMode {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DisplayMode, T>::value>;
  using DataView = DisplayModeDataView;
  using Data_ = internal::DisplayMode_Data;

  template <typename... Args>
  static DisplayModePtr New(Args&&... args) {
    return DisplayModePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DisplayModePtr From(const U& u) {
    return mojo::TypeConverter<DisplayModePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DisplayMode>::Convert(*this);
  }


  DisplayMode();

  DisplayMode(
      const ::gfx::Size& size,
      bool is_interlaced,
      float refresh_rate);

  ~DisplayMode();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DisplayModePtr>
  DisplayModePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DisplayMode::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DisplayMode::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DisplayMode::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DisplayMode_UnserializedMessageContext<
            UserType, DisplayMode::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<DisplayMode::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DisplayMode::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DisplayMode_UnserializedMessageContext<
            UserType, DisplayMode::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DisplayMode::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::gfx::Size size;
  
  bool is_interlaced;
  
  float refresh_rate;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DisplayMode::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DisplayMode::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DisplayMode::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DisplayMode::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
DisplayModePtr DisplayMode::Clone() const {
  return New(
      mojo::Clone(size),
      mojo::Clone(is_interlaced),
      mojo::Clone(refresh_rate)
  );
}

template <typename T, DisplayMode::EnableIfSame<T>*>
bool DisplayMode::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  if (!mojo::Equals(this->is_interlaced, other_struct.is_interlaced))
    return false;
  if (!mojo::Equals(this->refresh_rate, other_struct.refresh_rate))
    return false;
  return true;
}

template <typename T, DisplayMode::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  if (lhs.is_interlaced < rhs.is_interlaced)
    return true;
  if (rhs.is_interlaced < lhs.is_interlaced)
    return false;
  if (lhs.refresh_rate < rhs.refresh_rate)
    return true;
  if (rhs.refresh_rate < lhs.refresh_rate)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace display

namespace mojo {


template <>
struct  StructTraits<::display::mojom::DisplayMode::DataView,
                                         ::display::mojom::DisplayModePtr> {
  static bool IsNull(const ::display::mojom::DisplayModePtr& input) { return !input; }
  static void SetToNull(::display::mojom::DisplayModePtr* output) { output->reset(); }

  static const decltype(::display::mojom::DisplayMode::size)& size(
      const ::display::mojom::DisplayModePtr& input) {
    return input->size;
  }

  static decltype(::display::mojom::DisplayMode::is_interlaced) is_interlaced(
      const ::display::mojom::DisplayModePtr& input) {
    return input->is_interlaced;
  }

  static decltype(::display::mojom::DisplayMode::refresh_rate) refresh_rate(
      const ::display::mojom::DisplayModePtr& input) {
    return input->refresh_rate;
  }

  static bool Read(::display::mojom::DisplayMode::DataView input, ::display::mojom::DisplayModePtr* output);
};

}  // namespace mojo

#endif  // UI_DISPLAY_MOJOM_DISPLAY_MODE_MOJOM_H_